// direct3d.h : header file
//


#pragma pack(1)
////////////////////////////////////////////////////////////////////////////
// DirectX 7
struct IDirectDraw7;
struct IDirect3D7;
struct IDirectDrawSurface7;
struct IDirect3DDevice7;
struct IDirectDrawClipper;
struct DDSURFACEDESC2;
struct DDBLTFX;
struct DDSCAPS2;
struct D3DRECT;

typedef float D3DVALUE;





///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
struct _tiddata
{
	DWORD _tid; //thread ID
	HANDLE _thandle; //thread handle	
	int _terrno; //errno value
	DWORD _tdoserrno; //_doserrno value
	DWORD _fpds; //Floating Point data segment
	DWORD _holdrand; //rand() seed value
	char* _token; //ptr to strtok() token
	wchar_t* _wtoken; // ptr to wcstok() token
	BYTE* _mtoken; //ptr to _mbstok() token
	// following pointers get malloc'd at runtime
	char* _errmsg; //ptr to strerror()/_strerror() buff
	char* _namebuf0; //ptr to tmpnam() buffer
	wchar_t* _wnamebuf0; //ptr to _wtmpnam() buffer
	char* _namebuf1; //ptr to tmpfile() buffer
	wchar_t* _wnamebuf1; //ptr to _wtmpfile() buffer
	char* _asctimebuf; //ptr to asctime() buffer
	wchar_t* _wasctimebuf; //ptr to _wasctime() buffer
	void* _gmtimebuf; //ptr to gmtime() structure
	char* _cvtbuf; //ptr to ecvt()/fcvt buffer
	// following fields are needed by _beginthread code
	void* _initaddr; //initial user thread address
	void* _initarg; //initial user thread argument
	// following three fields are needed to support signal handling and runtime errors
	void* _pxcptacttab; //ptr to exception-action table
	void* _tpxcptinfoptrs; //ptr to exception info pointers
	int _tfpecode; //float point exception code
	// following field is needed by NLG routines
	DWORD _NLG_dwCode;
	//Per-Thread data needed by C++ Exception Handling
	void* _terminate; //terminate() routine
	void* _unexpected; //unexpected() routine
	void* _translator; //S.E. translator
	void* _curexception; //current exception
	void* _curcontext; //current exception context
};

struct DDSCAPS2
{
    DWORD       dwCaps;         // capabilities of surface wanted
    DWORD       dwCaps2;
    DWORD       dwCaps3;
    DWORD       dwCaps4;
};
struct DDSCAPS
{ 
    DWORD dwCaps; 
};

struct Version // DWORD GetVersion(VOID)
{
	BYTE nBuildNumber;
	BYTE nTypeOS;
	BYTE nMinorVerOS;
	BYTE nMajorVerOS;
};

struct D3DVIEWPORT7
{
	DWORD dwX;
	DWORD dwY;
	DWORD dwWidth;
	DWORD dwHeight;
	float dvMinZ;
	float dvMaxZ;
};
struct D3POINT // =12
{
	float x;
	float y;
	float z;
};
struct D2POINT // =8
{
	float x;
	float y;
};
struct D3DRECT
{
	LONG x1; 
	LONG y1; 
	LONG x2; 
	LONG y2; 
};

struct D3DVERTEX //0x20 =32
{ 
	D3DVALUE x; 
	D3DVALUE y; 
	D3DVALUE z; 
	D3DVALUE nx; 
	D3DVALUE ny; 
	D3DVALUE nz; 
	D3DVALUE tu; 
	D3DVALUE tv; 
};
typedef DWORD D3DCOLOR;
struct D3DLVERTEX//0x20 =32
{ 
	D3DVALUE x; 
	D3DVALUE y; 
	D3DVALUE z; 
	DWORD dwReserved; 
	D3DCOLOR color; 
	D3DCOLOR specular; 
	D3DVALUE tu; 
	D3DVALUE tv; 
};
struct D3DTLVERTEX//0x20 =32
{ 
	D3DVALUE sx; 
	D3DVALUE sy; 
	D3DVALUE sz; 
	D3DVALUE rhw; 
	D3DCOLOR color; 
	D3DCOLOR specular; 
	D3DVALUE tu; 
	D3DVALUE tv; 
};
struct D3DVECTOR//0xC =12
{ 
	D3DVALUE x; 
	D3DVALUE y; 
	D3DVALUE z; 
};
struct D3DPRIMCAPS
{ 
    DWORD dwSize;               //Size of structure
    DWORD dwMiscCaps;           //Miscellaneous capabilities
    DWORD dwRasterCaps;         //Raster capabilities
    DWORD dwZCmpCaps;           //Z-comparison capabilities
    DWORD dwSrcBlendCaps;       //Source-blending capabilities
    DWORD dwDestBlendCaps;      //Destination-blending capa bilities
    DWORD dwAlphaCmpCaps;       //Alpha-test-comparison capabilities
    DWORD dwShadeCaps;          //Shading capabilities
    DWORD dwTextureCaps;        //Texture capabilities
    DWORD dwTextureFilterCaps;  //Texture-filtering capabilities
    DWORD dwTextureBlendCaps;   //Texture-blending capabilities
    DWORD dwTextureAddressCaps; //Texture-addressing capabilities
    DWORD dwStippleWidth;       //Stipple width
    DWORD dwStippleHeight;      //Stipple height
};
struct D3DDEVICEDESC7 //0xEC =236
{
    DWORD       dwDevCaps;   
    D3DPRIMCAPS dpcLineCaps; 
    D3DPRIMCAPS dpcTriCaps;  
    DWORD       dwDeviceRenderBitDepth;  
    DWORD       dwDeviceZBufferBitDepth; 
    DWORD       dwMinTextureWidth, dwMinTextureHeight;
    DWORD       dwMaxTextureWidth, dwMaxTextureHeight;
    DWORD       dwMaxTextureRepeat;
    DWORD       dwMaxTextureAspectRatio;
    DWORD       dwMaxAnisotropy;
    float	    dvGuardBandLeft;
    float       dvGuardBandTop;
    float       dvGuardBandRight;
    float       dvGuardBandBottom;
    float       dvExtentsAdjust;
    DWORD       dwStencilCaps;
    DWORD       dwFVFCaps;
    DWORD       dwTextureOpCaps;
    WORD        wMaxTextureBlendStages;
    WORD        wMaxSimultaneousTextures;
    DWORD       dwMaxActiveLights;
    float       dvMaxVertexW;
    GUID        deviceGUID;
    WORD        wMaxUserClipPlanes;
    WORD        wMaxVertexBlendMatrices;
    DWORD       dwVertexProcessingCaps;
    DWORD       dwReserved1;
    DWORD       dwReserved2;
    DWORD       dwReserved3;
    DWORD       dwReserved4;
};
struct DDCAPS_DX7//0x17C
{
	DWORD dwSize;
	DWORD dwCaps;
	DWORD dwCaps2;
	DWORD dwCKeyCaps;
	DWORD dwFXCaps;
	DWORD dwFXAlphaCaps;
	DWORD dwPalCaps;
	DWORD dwSVCaps;
	DWORD dwAlphaBltConstBitDepths;
	DWORD dwAlphaBltPixelBitDepths;
	DWORD dwAlphaBltSurfaceBitDepths;
	DWORD dwAlphaOverlayConstBitDepths;
	DWORD dwAlphaOverlayPixelBitDepths;
	DWORD dwAlphaOverlaySurfaceBitDepths;
	DWORD dwZBufferBitDepths;
	DWORD dwVidMemTotal;
	DWORD dwVidMemFree;
	DWORD dwMaxVisibleOverlays;
	DWORD dwCurrVisibleOverlays;
	DWORD dwNumFourCCCodes;
	DWORD dwAlignBoundarySrc;
	DWORD dwAlignSizeSrc;
	DWORD dwAlignBoundaryDest;
	DWORD dwAlignSizeDest;
	DWORD dwAlignStrideAlign;
	DWORD dwRops[8];
	DDSCAPS ddsOldCaps;
	DWORD dwMinOverlayStretch;
	DWORD dwMaxOverlayStretch;
	DWORD dwMinLiveVideoStretch;
	DWORD dwMaxLiveVideoStretch;
	DWORD dwMinHwCodecStretch;
	DWORD dwMaxHwCodecStretch;
	DWORD dwReserved1;
	DWORD dwReserved2;
	DWORD dwReserved3;
	DWORD dwSVBCaps;
	DWORD dwSVBCKeyCaps;
	DWORD dwSVBFXCaps;
	DWORD dwSVBRops[8];
	DWORD dwVSBCaps;
	DWORD dwVSBCKeyCaps;
	DWORD dwVSBFXCaps;
	DWORD dwVSBRops[8];
	DWORD dwSSBCaps;
	DWORD dwSSBCKeyCaps;
	DWORD dwSSBFXCaps;
	DWORD dwSSBRops[8];
	DWORD dwMaxVideoPorts;
	DWORD dwCurrVideoPorts;
	DWORD dwSVBCaps2;
	DWORD dwNLVBCaps;
	DWORD dwNLVBCaps2;
	DWORD dwNLVBCKeyCaps;
	DWORD dwNLVBFXCaps;
	DWORD dwNLVBRops[8];
	DDSCAPS2 ddsCaps;
};


// WaitForVerticalBlank
#define DDWAITVB_BLOCKBEGIN         0x00000001
#define DDWAITVB_BLOCKBEGINEVENT    0x00000002
#define DDWAITVB_BLOCKEND           0x00000004


// Flexible vertex format bits
//
#define D3DFVF_RESERVED0        0x001
#define D3DFVF_POSITION_MASK    0x00E
#define D3DFVF_XYZ              0x002
#define D3DFVF_XYZRHW           0x004
#define D3DFVF_XYZB1            0x006
#define D3DFVF_XYZB2            0x008
#define D3DFVF_XYZB3            0x00A
#define D3DFVF_XYZB4            0x00C
#define D3DFVF_XYZB5            0x00E
#define D3DFVF_NORMAL           0x010
#define D3DFVF_RESERVED1        0x020
#define D3DFVF_DIFFUSE          0x040
#define D3DFVF_SPECULAR         0x080
#define D3DFVF_TEXCOUNT_MASK    0xF00
#define D3DFVF_TEX0             0x000
#define D3DFVF_TEX1             0x100
#define D3DFVF_TEX2             0x200
#define D3DFVF_TEX3             0x300
#define D3DFVF_TEX4             0x400
#define D3DFVF_TEX5             0x500
#define D3DFVF_TEX6             0x600
#define D3DFVF_TEX7             0x700
#define D3DFVF_TEX8             0x800
#define D3DFVF_RESERVED2        0xF000  // 4 reserved bits
#define D3DFVF_VERTEX ( D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1 )
#define D3DFVF_LVERTEX ( D3DFVF_XYZ | D3DFVF_RESERVED1 | D3DFVF_DIFFUSE | \
                         D3DFVF_SPECULAR | D3DFVF_TEX1 )
#define D3DFVF_TLVERTEX ( D3DFVF_XYZRHW | D3DFVF_DIFFUSE | D3DFVF_SPECULAR | \
                          D3DFVF_TEX1 )


#define D3DTA_SELECTMASK        0x0000000f  // mask for arg selector
#define D3DTA_DIFFUSE           0x00000000  // select diffuse color
#define D3DTA_CURRENT           0x00000001  // select result of previous stage
#define D3DTA_TEXTURE           0x00000002  // select texture color
#define D3DTA_TFACTOR           0x00000003  // select RENDERSTATE_TEXTUREFACTOR
#define D3DTA_SPECULAR          0x00000004  // select specular color
#define D3DTA_COMPLEMENT        0x00000010  // take 1.0 - x
#define D3DTA_ALPHAREPLICATE    0x00000020  // replicate alpha to color components

enum D3DTEXTURESTAGESTATETYPE
{ 
	D3DTSS_COLOROP        = 1,  
	D3DTSS_COLORARG1      = 2,  
	D3DTSS_COLORARG2      = 3,  
	D3DTSS_ALPHAOP        = 4,  
	D3DTSS_ALPHAARG1      = 5,  
	D3DTSS_ALPHAARG2      = 6,  
	D3DTSS_BUMPENVMAT00   = 7,  
	D3DTSS_BUMPENVMAT01   = 8,  
	D3DTSS_BUMPENVMAT10   = 9,  
	D3DTSS_BUMPENVMAT11   = 10, 
	D3DTSS_TEXCOORDINDEX  = 11, 
	D3DTSS_ADDRESS        = 12, 
	D3DTSS_ADDRESSU       = 13, 
	D3DTSS_ADDRESSV       = 14, 
	D3DTSS_BORDERCOLOR    = 15, 
	D3DTSS_MAGFILTER      = 16, 
	D3DTSS_MINFILTER      = 17, 
	D3DTSS_MIPFILTER      = 18, 
	D3DTSS_MIPMAPLODBIAS  = 19, 
	D3DTSS_MAXMIPLEVEL    = 20, 
	D3DTSS_MAXANISOTROPY  = 21, 
	D3DTSS_BUMPENVLSCALE  = 22, 
	D3DTSS_BUMPENVLOFFSET = 23, 
	D3DTSS_TEXTURETRANSFORMFLAGS = 24,
	D3DTSS_FORCE_DWORD   = 0x7fffffff,
}; 

enum D3DTEXTUREMINFILTER
{
	D3DTFN_POINT        = 1,    // nearest
	D3DTFN_LINEAR       = 2,    // linear interpolation
	D3DTFN_ANISOTROPIC  = 3,    //
	D3DTFN_FORCE_DWORD  = 0x7fffffff,   // force 32-bit size enum
};

enum D3DTEXTUREMAGFILTER
{
	D3DTFG_POINT        = 1,    // nearest
	D3DTFG_LINEAR       = 2,    // linear interpolation
	D3DTFG_FLATCUBIC    = 3,    // cubic
	D3DTFG_GAUSSIANCUBIC = 4,   // different cubic kernel
	D3DTFG_ANISOTROPIC  = 5,    //
	D3DTFG_FORCE_DWORD  = 0x7fffffff,   // force 32-bit size enum
};

enum D3DTEXTUREOP
{
	// Control
	D3DTOP_DISABLE    = 1,      // disables stage
	D3DTOP_SELECTARG1 = 2,      // the default
	D3DTOP_SELECTARG2 = 3,

	// Modulate
	D3DTOP_MODULATE   = 4,      // multiply args together
	D3DTOP_MODULATE2X = 5,      // multiply and  1 bit
	D3DTOP_MODULATE4X = 6,      // multiply and  2 bits

	// Add
	D3DTOP_ADD          =  7,   // add arguments together
	D3DTOP_ADDSIGNED    =  8,   // add with -0.5 bias
	D3DTOP_ADDSIGNED2X  =  9,   // as above but left  1 bit
	D3DTOP_SUBTRACT     = 10,   // Arg1 - Arg2, with no saturation
	D3DTOP_ADDSMOOTH    = 11,   // add 2 args, subtract product
	// Arg1 + Arg2 - Arg1*Arg2
	// = Arg1 + (1-Arg1)*Arg2

	// Linear alpha blend: Arg1*(Alpha) + Arg2*(1-Alpha)
	D3DTOP_BLENDDIFFUSEALPHA    = 12, // iterated alpha
	D3DTOP_BLENDTEXTUREALPHA    = 13, // texture alpha
	D3DTOP_BLENDFACTORALPHA     = 14, // alpha from D3DRENDERSTATE_TEXTUREFACTOR

	// Linear alpha blend with pre-multiplied arg1 input: Arg1 + Arg2*(1-Alpha)
	D3DTOP_BLENDTEXTUREALPHAPM  = 15, // texture alpha
	D3DTOP_BLENDCURRENTALPHA    = 16, // by alpha of current color

	// Specular mapping
	D3DTOP_PREMODULATE            = 17,     // modulate with next texture before use

	// COLOROP only
	D3DTOP_MODULATEALPHA_ADDCOLOR = 18,     // Arg1.RGB + Arg1.A*Arg2.RGB
	D3DTOP_MODULATECOLOR_ADDALPHA = 19,     // Arg1.RGB*Arg2.RGB + Arg1.A
	D3DTOP_MODULATEINVALPHA_ADDCOLOR = 20,  // (1-Arg1.A)*Arg2.RGB + Arg1.RGB
	D3DTOP_MODULATEINVCOLOR_ADDALPHA = 21,  // (1-Arg1.RGB)*Arg2.RGB + Arg1.A

	// Bump mapping
	D3DTOP_BUMPENVMAP           = 22, // per pixel env map perturbation
	D3DTOP_BUMPENVMAPLUMINANCE  = 23, // with luminance channel

	// This can do either diffuse or specular bump mapping with correct input.
	// Performs the function (Arg1.R*Arg2.R + Arg1.G*Arg2.G + Arg1.B*Arg2.B)
	// where each component has been scaled and offset to make it signed.
	// The result is replicated into all four (including alpha) channels.
	// This is a valid COLOROP only.
	D3DTOP_DOTPRODUCT3          = 24,

	D3DTOP_FORCE_DWORD = 0x7fffffff,
};

enum D3DTEXTUREMIPFILTER
{
    D3DTFP_NONE         = 1,    // mipmapping disabled (use MAG filter)
    D3DTFP_POINT        = 2,    // nearest
    D3DTFP_LINEAR       = 3,    // linear interpolation
    D3DTFP_FORCE_DWORD  = 0x7fffffff,   // force 32-bit size enum
};

enum D3DFILLMODE
{ 
    D3DFILL_POINT     = 1, 
    D3DFILL_WIREFRAME = 2, 
    D3DFILL_SOLID     = 3, 
    D3DFILL_FORCE_DWORD   = 0x7fffffff, 
}; 

enum D3DCULL
{ 
    D3DCULL_NONE = 1, 
    D3DCULL_CW   = 2, 
    D3DCULL_CCW  = 3, 
    D3DCULL_FORCE_DWORD   = 0x7fffffff, 
}; 

enum D3DBLEND
{ 
    D3DBLEND_ZERO            = 1, 
    D3DBLEND_ONE             = 2, 
    D3DBLEND_SRCCOLOR        = 3, 
    D3DBLEND_INVSRCCOLOR     = 4, 
    D3DBLEND_SRCALPHA        = 5, 
    D3DBLEND_INVSRCALPHA     = 6, 
    D3DBLEND_DESTALPHA       = 7, 
    D3DBLEND_INVDESTALPHA    = 8, 
    D3DBLEND_DESTCOLOR       = 9, 
    D3DBLEND_INVDESTCOLOR    = 10, 
    D3DBLEND_SRCALPHASAT     = 11, 
    D3DBLEND_BOTHSRCALPHA    = 12, 
    D3DBLEND_BOTHINVSRCALPHA = 13, 
    D3DBLEND_FORCE_DWORD   = 0x7fffffff, 
}; 


enum D3DCMPFUNC
{ 
    D3DCMP_NEVER        = 1, 
    D3DCMP_LESS         = 2, 
    D3DCMP_EQUAL        = 3, 
    D3DCMP_LESSEQUAL    = 4, 
    D3DCMP_GREATER      = 5, 
    D3DCMP_NOTEQUAL     = 6, 
    D3DCMP_GREATEREQUAL = 7, 
    D3DCMP_ALWAYS       = 8, 
    D3DCMP_FORCE_DWORD   = 0x7fffffff, 
}; 


enum D3DSHADEMODE
{ 
    D3DSHADE_FLAT         = 1, 
    D3DSHADE_GOURAUD      = 2, 
    D3DSHADE_PHONG        = 3, 
    D3DSHADE_FORCE_DWORD  = 0x7fffffff, 
}; 

enum D3DRENDERSTATETYPE
{ 
    D3DRENDERSTATE_ANTIALIAS          = 2,    //Antialiasing mode 
    D3DRENDERSTATE_TEXTUREPERSPECTIVE = 4,    //Perspective correction
    D3DRENDERSTATE_ZENABLE            = 7,    //Enable z test 
    D3DRENDERSTATE_FILLMODE           = 8,    //Fill mode 
    D3DRENDERSTATE_SHADEMODE          = 9,    //Shade mode 
    D3DRENDERSTATE_LINEPATTERN        = 10,   //Line pattern 
    D3DRENDERSTATE_ZWRITEENABLE       = 14,   //Enable z writes
    D3DRENDERSTATE_ALPHATESTENABLE    = 15,   //Enable alpha tests 
    D3DRENDERSTATE_LASTPIXEL          = 16,   //Draw last pixel in a line 
    D3DRENDERSTATE_SRCBLEND           = 19,   //Blend factor for source 
    D3DRENDERSTATE_DESTBLEND          = 20,   //Blend factor for destination 
    D3DRENDERSTATE_CULLMODE           = 22,   //Back-face culling mode 
    D3DRENDERSTATE_ZFUNC              = 23,   //Z-comparison function 
    D3DRENDERSTATE_ALPHAREF           = 24,   //Reference alpha value 
    D3DRENDERSTATE_ALPHAFUNC          = 25,   //Alpha-comparison function 
    D3DRENDERSTATE_DITHERENABLE       = 26,   //Enable dithering 
    D3DRENDERSTATE_ALPHABLENDENABLE   = 27,   //Enable alpha blending 
    D3DRENDERSTATE_FOGENABLE          = 28,   //Enable fog 
    D3DRENDERSTATE_SPECULARENABLE     = 29,   //Enable specular highlights 
    D3DRENDERSTATE_ZVISIBLE           = 30,   //Enable z-checking 
    D3DRENDERSTATE_STIPPLEDALPHA      = 33,   //Enable stippled alpha 
    D3DRENDERSTATE_FOGCOLOR           = 34,   //Fog color 
    D3DRENDERSTATE_FOGTABLEMODE       = 35,   //Fog mode 
    D3DRENDERSTATE_FOGTABLESTART      = 36,   //Fog table start (same as D3DRENDERSTATE_FOGSTART)
    D3DRENDERSTATE_FOGTABLEEND        = 37,   //Fog table end (same as D3DRENDERSTATE_FOGEND)
    D3DRENDERSTATE_FOGTABLEDENSITY    = 38,   //Fog table density (same as D3DRENDERSTATE_FOGDENSITY)
    D3DRENDERSTATE_FOGSTART           = 36,   //Fog start (for both vertex and pixel fog) 
    D3DRENDERSTATE_FOGEND             = 37,   //Fog end (for both vertex and pixel fog)   
    D3DRENDERSTATE_FOGDENSITY         = 38,   //Fog density (for both vertex and pixel fog)
    D3DRENDERSTATE_EDGEANTIALIAS      = 40,   //Antialias edges 
    D3DRENDERSTATE_COLORKEYENABLE     = 41,   //Enable color-key transparency 
    D3DRENDERSTATE_ZBIAS              = 47,   //Z-bias 
    D3DRENDERSTATE_RANGEFOGENABLE     = 48,   //Enables range-based fog 
    D3DRENDERSTATE_STENCILENABLE      = 52,   //Enable or disable stenciling 
    D3DRENDERSTATE_STENCILFAIL        = 53,   //Stencil operation 
    D3DRENDERSTATE_STENCILZFAIL       = 54,   //Stencil operation 
    D3DRENDERSTATE_STENCILPASS        = 55,   //Stencil operation 
    D3DRENDERSTATE_STENCILFUNC        = 56,   //Stencil comparison function 
    D3DRENDERSTATE_STENCILREF         = 57,   //Reference value for stencil test 
    D3DRENDERSTATE_STENCILMASK        = 58,   //Mask value used in stencil test 
    D3DRENDERSTATE_STENCILWRITEMASK   = 59,   //Stencil buffer write mask 
    D3DRENDERSTATE_TEXTUREFACTOR      = 60,   //Texture factor 
    D3DRENDERSTATE_WRAP0              = 128,  //Wrap flags for 1st texture coord set 
       // Wrap render states 1 through 6 omitted here.
    D3DRENDERSTATE_WRAP7              = 135,  //Wrap flags for last texture coord set 
    D3DRENDERSTATE_CLIPPING            = 136, //Enable or disable primitive clipping 
    D3DRENDERSTATE_LIGHTING            = 137, //Enable or disable lighting 
    D3DRENDERSTATE_EXTENTS             = 138, //Enable or disable updating screen extents 
    D3DRENDERSTATE_AMBIENT             = 139, //Ambient color for scene 
    D3DRENDERSTATE_FOGVERTEXMODE       = 140, //Fog mode for vertex fog 
    D3DRENDERSTATE_COLORVERTEX         = 141, //Enable or disable per-vertex color 
    D3DRENDERSTATE_LOCALVIEWER         = 142, //Enable or disable perspective specular highlights  
    D3DRENDERSTATE_NORMALIZENORMALS    = 143, //Enable automatic normalization of vertex normals 
    D3DRENDERSTATE_COLORKEYBLENDENABLE = 144, //Enable or disable alpha-blended color keying
    D3DRENDERSTATE_DIFFUSEMATERIALSOURCE  = 145, //Location for per-vertex diffuse color 
    D3DRENDERSTATE_SPECULARMATERIALSOURCE = 146, //Location for per-vertex specular color 
    D3DRENDERSTATE_AMBIENTMATERIALSOURCE  = 147, //Location for per-vertex ambient color 
    D3DRENDERSTATE_EMISSIVEMATERIALSOURCE = 148, //Location for per-vertex emissive color 
    D3DRENDERSTATE_VERTEXBLEND              = 151, //Multi-matrix vertex blending mode
    D3DRENDERSTATE_CLIPPLANEENABLE          = 152, //Enable one or more user-defined clipping planes
    D3DRENDERSTATE_FORCE_DWORD        = 0x7fffffff, 
}; 


enum D3DTRANSFORMSTATETYPE
{ 
	D3DTRANSFORMSTATE_WORLD        = 1,  
	D3DTRANSFORMSTATE_VIEW         = 2,  
	D3DTRANSFORMSTATE_PROJECTION   = 3,  
	D3DTRANSFORMSTATE_WORLD1       = 4, 
	D3DTRANSFORMSTATE_WORLD2       = 5, 
	D3DTRANSFORMSTATE_WORLD3       = 6, 
	D3DTRANSFORMSTATE_TEXTURE0     = 16, 
	D3DTRANSFORMSTATE_TEXTURE1     = 17, 
	D3DTRANSFORMSTATE_TEXTURE2     = 18, 
	D3DTRANSFORMSTATE_TEXTURE3     = 19, 
	D3DTRANSFORMSTATE_TEXTURE4     = 20, 
	D3DTRANSFORMSTATE_TEXTURE5     = 21, 
	D3DTRANSFORMSTATE_TEXTURE6     = 22, 
	D3DTRANSFORMSTATE_TEXTURE7     = 23, 
	D3DTRANSFORMSTATE_FORCE_DWORD  = 0x7fffffff, 
};
enum D3DPRIMITIVETYPE
{ 
	D3DPT_POINTLIST     = 1, 
	D3DPT_LINELIST      = 2, 
	D3DPT_LINESTRIP     = 3, 
	D3DPT_TRIANGLELIST  = 4, 
	D3DPT_TRIANGLESTRIP = 5, 
	D3DPT_TRIANGLEFAN   = 6,
	D3DPT_FORCE_DWORD   = 0x7fffffff, 
};

#define D3DCLIP_LEFT                0x00000001L
#define D3DCLIP_RIGHT               0x00000002L
#define D3DCLIP_TOP                 0x00000004L
#define D3DCLIP_BOTTOM              0x00000008L
#define D3DCLIP_FRONT               0x00000010L
#define D3DCLIP_BACK                0x00000020L
#define D3DCLIP_GEN0                0x00000040L
#define D3DCLIP_GEN1                0x00000080L
#define D3DCLIP_GEN2                0x00000100L
#define D3DCLIP_GEN3                0x00000200L
#define D3DCLIP_GEN4                0x00000400L
#define D3DCLIP_GEN5                0x00000800L

/*
 * Values for d3d status.
 */
#define D3DSTATUS_CLIPUNIONLEFT         D3DCLIP_LEFT
#define D3DSTATUS_CLIPUNIONRIGHT        D3DCLIP_RIGHT
#define D3DSTATUS_CLIPUNIONTOP          D3DCLIP_TOP
#define D3DSTATUS_CLIPUNIONBOTTOM       D3DCLIP_BOTTOM
#define D3DSTATUS_CLIPUNIONFRONT        D3DCLIP_FRONT
#define D3DSTATUS_CLIPUNIONBACK         D3DCLIP_BACK
#define D3DSTATUS_CLIPUNIONGEN0         D3DCLIP_GEN0
#define D3DSTATUS_CLIPUNIONGEN1         D3DCLIP_GEN1
#define D3DSTATUS_CLIPUNIONGEN2         D3DCLIP_GEN2
#define D3DSTATUS_CLIPUNIONGEN3         D3DCLIP_GEN3
#define D3DSTATUS_CLIPUNIONGEN4         D3DCLIP_GEN4
#define D3DSTATUS_CLIPUNIONGEN5         D3DCLIP_GEN5

#define D3DSTATUS_CLIPINTERSECTIONLEFT      0x00001000L
#define D3DSTATUS_CLIPINTERSECTIONRIGHT     0x00002000L
#define D3DSTATUS_CLIPINTERSECTIONTOP       0x00004000L
#define D3DSTATUS_CLIPINTERSECTIONBOTTOM    0x00008000L
#define D3DSTATUS_CLIPINTERSECTIONFRONT     0x00010000L
#define D3DSTATUS_CLIPINTERSECTIONBACK      0x00020000L
#define D3DSTATUS_CLIPINTERSECTIONGEN0      0x00040000L
#define D3DSTATUS_CLIPINTERSECTIONGEN1      0x00080000L
#define D3DSTATUS_CLIPINTERSECTIONGEN2      0x00100000L
#define D3DSTATUS_CLIPINTERSECTIONGEN3      0x00200000L
#define D3DSTATUS_CLIPINTERSECTIONGEN4      0x00400000L
#define D3DSTATUS_CLIPINTERSECTIONGEN5      0x00800000L
#define D3DSTATUS_ZNOTVISIBLE               0x01000000L
/* Do not use 0x80000000 for any status flags in future as it is reserved */

#define D3DSTATUS_CLIPUNIONALL  (       \
        D3DSTATUS_CLIPUNIONLEFT |   \
        D3DSTATUS_CLIPUNIONRIGHT    |   \
        D3DSTATUS_CLIPUNIONTOP  |   \
        D3DSTATUS_CLIPUNIONBOTTOM   |   \
        D3DSTATUS_CLIPUNIONFRONT    |   \
        D3DSTATUS_CLIPUNIONBACK |   \
        D3DSTATUS_CLIPUNIONGEN0 |   \
        D3DSTATUS_CLIPUNIONGEN1 |   \
        D3DSTATUS_CLIPUNIONGEN2 |   \
        D3DSTATUS_CLIPUNIONGEN3 |   \
        D3DSTATUS_CLIPUNIONGEN4 |   \
        D3DSTATUS_CLIPUNIONGEN5     \
        )

#define D3DSTATUS_CLIPINTERSECTIONALL   (       \
        D3DSTATUS_CLIPINTERSECTIONLEFT  |   \
        D3DSTATUS_CLIPINTERSECTIONRIGHT |   \
        D3DSTATUS_CLIPINTERSECTIONTOP   |   \
        D3DSTATUS_CLIPINTERSECTIONBOTTOM    |   \
        D3DSTATUS_CLIPINTERSECTIONFRONT |   \
        D3DSTATUS_CLIPINTERSECTIONBACK  |   \
        D3DSTATUS_CLIPINTERSECTIONGEN0  |   \
        D3DSTATUS_CLIPINTERSECTIONGEN1  |   \
        D3DSTATUS_CLIPINTERSECTIONGEN2  |   \
        D3DSTATUS_CLIPINTERSECTIONGEN3  |   \
        D3DSTATUS_CLIPINTERSECTIONGEN4  |   \
        D3DSTATUS_CLIPINTERSECTIONGEN5      \
        )

#define D3DSTATUS_DEFAULT   (           \
        D3DSTATUS_CLIPINTERSECTIONALL   |   \
        D3DSTATUS_ZNOTVISIBLE)




struct D4DVECTOR // =16
{ 
	D3DVALUE _1, _2, _3, _4; 
};
struct D3DMATRIX // 0x40 =64  16*4
{
	D4DVECTOR _1;
	D4DVECTOR _2;
	D4DVECTOR _3;
	D4DVECTOR _4;
};
struct D3DMATRIXMINOR
{ 
	D3DVALUE _11, _12, _13; 
	D3DVALUE _21, _22, _23; 
	D3DVALUE _31, _32, _33; 
};

#define D3DDP_MAXTEXCOORD 8
struct D3DDP_PTRSTRIDE
{
	LPVOID lpvData;
	DWORD  dwStride;
};
struct D3DDRAWPRIMITIVESTRIDEDDATA // =96
{
	D3DDP_PTRSTRIDE position;
	D3DDP_PTRSTRIDE normal;
	D3DDP_PTRSTRIDE diffuse;
	D3DDP_PTRSTRIDE specular;
	D3DDP_PTRSTRIDE textureCoords[D3DDP_MAXTEXCOORD];
};


struct DDCOLORKEY
{
    DWORD       dwColorSpaceLowValue;   // low boundary of color space that is to be treated as Color Key, inclusive
    DWORD       dwColorSpaceHighValue;  // high boundary of color space that is to be treated as Color Key, inclusive
};

struct DDPIXELFORMAT
{
    DWORD       dwSize;                 // size of structure
    DWORD       dwFlags;                // pixel format flags
    DWORD       dwFourCC;               // (FOURCC code)
    union
    {
        DWORD   dwRGBBitCount;          // how many bits per pixel
        DWORD   dwYUVBitCount;          // how many bits per pixel
        DWORD   dwZBufferBitDepth;      // how many total bits/pixel in z buffer (including any stencil bits)
        DWORD   dwAlphaBitDepth;        // how many bits for alpha channels
        DWORD   dwLuminanceBitCount;    // how many bits per pixel
        DWORD   dwBumpBitCount;         // how many bits per "buxel", total
    };
    union
    {
        DWORD   dwRBitMask;             // mask for red bit
        DWORD   dwYBitMask;             // mask for Y bits
        DWORD   dwStencilBitDepth;      // how many stencil bits (note: dwZBufferBitDepth-dwStencilBitDepth is total Z-only bits)
        DWORD   dwLuminanceBitMask;     // mask for luminance bits
        DWORD   dwBumpDuBitMask;        // mask for bump map U delta bits
    };
    union
    {
        DWORD   dwGBitMask;             // mask for green bits
        DWORD   dwUBitMask;             // mask for U bits
        DWORD   dwZBitMask;             // mask for Z bits
        DWORD   dwBumpDvBitMask;        // mask for bump map V delta bits
    };
    union
    {
        DWORD   dwBBitMask;             // mask for blue bits
        DWORD   dwVBitMask;             // mask for V bits
        DWORD   dwStencilBitMask;       // mask for stencil bits
        DWORD   dwBumpLuminanceBitMask; // mask for luminance in bump map
    };
    union
    {
        DWORD   dwRGBAlphaBitMask;      // mask for alpha channel
        DWORD   dwYUVAlphaBitMask;      // mask for alpha channel
        DWORD   dwLuminanceAlphaBitMask;// mask for alpha channel
        DWORD   dwRGBZBitMask;          // mask for Z channel
        DWORD   dwYUVZBitMask;          // mask for Z channel
    };
};



struct DDSURFACEDESC2
{
	DWORD               dwSize;                 // size of the DDSURFACEDESC structure
	DWORD               dwFlags;                // determines what fields are valid
	DWORD               dwHeight;               // height of surface to be created
	DWORD               dwWidth;                // width of input surface
	union
	{
		LONG            lPitch;                 // distance to start of next line (return value only)
		DWORD           dwLinearSize;           // Formless late-allocated optimized surface size
	};
	DWORD               dwBackBufferCount;      // number of back buffers requested
	union
	{
		DWORD           dwMipMapCount;          // number of mip-map levels requestde dwZBufferBitDepth removed, use ddpfPixelFormat one instead
		DWORD           dwRefreshRate;          // refresh rate (used when display mode is described)
		DWORD           dwSrcVBHandle;          // The source used in VB::Optimize
	};
	DWORD               dwAlphaBitDepth;        // depth of alpha buffer requested
	DWORD               dwReserved;             // reserved
	LPVOID              lpSurface;              // pointer to the associated surface memory
	union
	{
		DDCOLORKEY      ddckCKDestOverlay;      // color key for destination overlay use
		DWORD           dwEmptyFaceColor;       // Physical color for empty cubemap faces
	};
	DDCOLORKEY          ddckCKDestBlt;          // color key for destination blt use
	DDCOLORKEY          ddckCKSrcOverlay;       // color key for source overlay use
	DDCOLORKEY          ddckCKSrcBlt;           // color key for source blt use
	union
	{
		DDPIXELFORMAT   ddpfPixelFormat;        // pixel format description of the surface
		DWORD           dwFVF;                  // vertex format description of vertex buffers
	};
	DDSCAPS2            ddsCaps;                // direct draw surface capabilities
	DWORD               dwTextureStage;         // stage in multitexture cascade
};

struct D3DCLIPSTATUS
{
    DWORD dwFlags; 
    DWORD dwStatus; 
    float minx, maxx; 
    float miny, maxy; 
    float minz, maxz; 
};

#define D3DCLIPSTATUS_STATUS        0x00000001L
#define D3DCLIPSTATUS_EXTENTS2      0x00000002L
#define D3DCLIPSTATUS_EXTENTS3      0x00000004L

struct D3DCOLORVALUE
{
    D3DVALUE r;
    D3DVALUE g;
    D3DVALUE b;
    D3DVALUE a;
};

struct D3DMATERIAL7
{
    D3DCOLORVALUE   diffuse;        /* Diffuse color RGBA */
    D3DCOLORVALUE   ambient;        /* Ambient color RGB */
    D3DCOLORVALUE   specular;       /* Specular 'shininess' */
    D3DCOLORVALUE   emissive;       /* Emissive color RGB */
    D3DVALUE        power;          /* Sharpness if specular highlight */
};

enum D3DLIGHTTYPE
{
    D3DLIGHT_POINT          = 1,
    D3DLIGHT_SPOT           = 2,
    D3DLIGHT_DIRECTIONAL    = 3,
    D3DLIGHT_GLSPOT         = 5,
    D3DLIGHT_FORCE_DWORD    = 0x7fffffff, /* force 32-bit size enum */
};


struct D3DLIGHT7
{
    D3DLIGHTTYPE    dltType;            /* Type of light source */
    D3DCOLORVALUE   dcvDiffuse;         /* Diffuse color of light */
    D3DCOLORVALUE   dcvSpecular;        /* Specular color of light */
    D3DCOLORVALUE   dcvAmbient;         /* Ambient color of light */
    D3DVECTOR       dvPosition;         /* Position in world space */
    D3DVECTOR       dvDirection;        /* Direction in world space */
    D3DVALUE        dvRange;            /* Cutoff range */
    D3DVALUE        dvFalloff;          /* Falloff */
    D3DVALUE        dvAttenuation0;     /* Constant attenuation */
    D3DVALUE        dvAttenuation1;     /* Linear attenuation */
    D3DVALUE        dvAttenuation2;     /* Quadratic attenuation */
    D3DVALUE        dvTheta;            /* Inner angle of spotlight cone */
    D3DVALUE        dvPhi;              /* Outer angle of spotlight cone */
};


struct IDirectDraw7
{
	HRESULT (__stdcall *QueryInterface)(IDirectDraw7** ddraw, IID* iid, void** ppvObject);
	void* AddRef;//) (THIS)  PURE;
	HRESULT (__stdcall *Release)(IDirectDraw7** ddraw);
	void* Compact;//)(THIS) PURE;
	HRESULT (__stdcall *CreateClipper)(IDirectDraw7** ddraw, DWORD dwFlags, IDirectDrawClipper** lplpDDClipper, IUnknown* pUnkOuter);
	void* CreatePalette;//)(THIS_ DWORD, LPPALETTEENTRY, LPDIRECTDRAWPALETTE FAR*, IUnknown FAR * ) PURE;
	HRESULT (__stdcall *CreateSurface)(IDirectDraw7** ddraw, DDSURFACEDESC2* lpDDSurfaceDesc2, IDirectDrawSurface7*** lplpDDSurface, void* pIUnknown);
	void* DuplicateSurface;//)( THIS_ LPDIRECTDRAWSURFACE7, LPDIRECTDRAWSURFACE7 FAR * ) PURE;
	void* EnumDisplayModes;//)( THIS_ DWORD, LPDDSURFACEDESC2, LPVOID, LPDDENUMMODESCALLBACK2 ) PURE;
	void* EnumSurfaces;//)(THIS_ DWORD, LPDDSURFACEDESC2, LPVOID,LPDDENUMSURFACESCALLBACK7 ) PURE;
	void* FlipToGDISurface;//)(THIS) PURE;
	void* GetCaps;//)( THIS_ LPDDCAPS, LPDDCAPS) PURE;
	void* GetDisplayMode;//)( THIS_ LPDDSURFACEDESC2) PURE;
	void* GetFourCCCodes;//)(THIS_  LPDWORD, LPDWORD ) PURE;
	void* GetGDISurface;//)(THIS_ LPDIRECTDRAWSURFACE7 FAR *) PURE;
	void* GetMonitorFrequency;//)(THIS_ LPDWORD) PURE;
	void* GetScanLine;//)(THIS_ LPDWORD) PURE;
	void* GetVerticalBlankStatus;//)(THIS_ LPBOOL ) PURE;
	void* Initialize;//)(THIS_ GUID FAR *) PURE;
	void* RestoreDisplayMode;//)(THIS) PURE;
	HRESULT (__stdcall *SetCooperativeLevel)(IDirectDraw7** ddraw, HWND hWnd, DWORD dwFlags);
	HRESULT (__stdcall *SetDisplayMode)(IDirectDraw7** ddraw, DWORD dwWidth, DWORD dwHeight, DWORD dwBPP, DWORD dwRefreshRate, DWORD dwFlags);
	HRESULT (__stdcall *WaitForVerticalBlank)(IDirectDraw7** ddraw, DWORD dwFlags, HANDLE hEvent);
	void* GetAvailableVidMem;//)(THIS_ LPDDSCAPS2, LPDWORD, LPDWORD) PURE;
	void* GetSurfaceFromDC;//) (THIS_ HDC, LPDIRECTDRAWSURFACE7 *) PURE;
	HRESULT (__stdcall *RestoreAllSurfaces)(IDirectDraw7** ddraw);//)(THIS) PURE;
	void* TestCooperativeLevel;//)(THIS) PURE;
	void* GetDeviceIdentifier;//)(THIS_ LPDDDEVICEIDENTIFIER2, DWORD ) PURE;
	void* StartModeTest;//)(THIS_ LPSIZE, DWORD, DWORD ) PURE;
	void* EvaluateMode;//)(THIS_ DWORD, DWORD * ) PURE;
};

struct IDirectDrawSurface7
{
	HRESULT (__stdcall *QueryInterface)(IDirectDrawSurface7** surf, IID* iid, void** ppvObject);
	void* AddRef;//) (THIS)  PURE;
	HRESULT (__stdcall *Release)(IDirectDrawSurface7** surf);//) (THIS) PURE;
	HRESULT (__stdcall *AddAttachedSurface)(IDirectDrawSurface7** surf, IDirectDrawSurface7** lpDDSAttachedSurface);//)(THIS_ LPDIRECTDRAWSURFACE) PURE;
	void* AddOverlayDirtyRect;//)(THIS_ LPRECT) PURE;
	HRESULT (__stdcall *Blt)(IDirectDrawSurface7** surf, RECT* lpDestRect, IDirectDrawSurface7** lpDDSrcSurface, RECT* lpSrcRect, DWORD dwFlags, DDBLTFX* lpDDBltFx);
	void* BltBatch;//)(THIS_ LPDDBLTBATCH, DWORD, DWORD ) PURE;
	void* BltFast;//)(THIS_ DWORD,DWORD,LPDIRECTDRAWSURFACE, LPRECT,DWORD) PURE;
	void* DeleteAttachedSurface;//)(THIS_ DWORD,LPDIRECTDRAWSURFACE) PURE;
	HRESULT (__stdcall *EnumAttachedSurfaces)(LPVOID lpContext, HRESULT (__stdcall lpEnumSurfacesCallback)(IDirectDrawSurface7** lpDDSurface, DDSURFACEDESC2* lpDDSurfaceDesc, LPVOID lpContext));
	void* EnumOverlayZOrders;//)(THIS_ DWORD,LPVOID,LPDDENUMSURFACESCALLBACK) PURE;
	HRESULT (__stdcall *Flip)(IDirectDrawSurface7** surf, IDirectDrawSurface7** lpDDSurfaceTargetOverride, DWORD dwFlags);
	HRESULT (__stdcall *GetAttachedSurface)(IDirectDrawSurface7** surf, DDSCAPS2* lpDDSCaps, IDirectDrawSurface7*** lplpDDAttachedSurface);
	HRESULT (__stdcall *GetBltStatus)(DWORD dwFlags);
	void* GetCaps;//)(THIS_ LPDDSCAPS) PURE;
	void* GetClipper;//)(THIS_ LPDIRECTDRAWCLIPPER FAR*) PURE;
	void* GetColorKey;//)(THIS_ DWORD, LPDDCOLORKEY) PURE;
	HRESULT (__stdcall *GetDC)(IDirectDrawSurface7** surf, HDC* lphDC);
	HRESULT (__stdcall *GetFlipStatus)(DWORD dwFlags);
	void* GetOverlayPosition;//)(THIS_ LPLONG, LPLONG ) PURE; CP_ACP
	void* GetPalette;//)(THIS_ LPDIRECTDRAWPALETTE FAR*) PURE;
	HRESULT (__stdcall *GetPixelFormat)(IDirectDrawSurface7** surf, DDPIXELFORMAT* lpDDPixelFormat);
	HRESULT (__stdcall *GetSurfaceDesc)(IDirectDrawSurface7** surf, DDSURFACEDESC2* lpDDSurfaceDesc);
	void* Initialize;//)(THIS_ LPDIRECTDRAW, LPDDSURFACEDESC) PURE;
	HRESULT (__stdcall *IsLost)(IDirectDrawSurface7** surf);
	HRESULT (__stdcall *Lock)(IDirectDrawSurface7** surf, RECT* lpDestRect, DDSURFACEDESC2* lpDDSurfaceDesc, DWORD dwFlags, HANDLE hEvent);
	HRESULT (__stdcall *ReleaseDC)(IDirectDrawSurface7** surf, HDC lphDC);
	HRESULT (__stdcall *Restore)(IDirectDrawSurface7** surf);//)(THIS) PURE;
	HRESULT (__stdcall *SetClipper)(IDirectDrawSurface7** surf, IDirectDrawClipper** lpDDClipper);
	void* SetColorKey;//)(THIS_ DWORD, LPDDCOLORKEY) PURE;
	void* SetOverlayPosition;//)(THIS_ LONG, LONG ) PURE;
	void* SetPalette;//)(THIS_ LPDIRECTDRAWPALETTE) PURE;
	HRESULT (__stdcall *Unlock)(IDirectDrawSurface7** surf, RECT* lpRect);
	void* UpdateOverlay;//)(THIS_ LPRECT, LPDIRECTDRAWSURFACE,LPRECT,DWORD, LPDDOVERLAYFX) PURE;
	void* UpdateOverlayDisplay;//)(THIS_ DWORD) PURE;
	void* UpdateOverlayZOrder;//)(THIS_ DWORD, LPDIRECTDRAWSURFACE) PURE;
    HRESULT (__stdcall *GetDDInterface)(IDirectDrawSurface7** surf, IDirectDraw7*** lplpDD);
    void* PageLock;//)(THIS_ DWORD) PURE;
    void* PageUnlock;//)(THIS_ DWORD) PURE;
    void* SetSurfaceDesc;//)(THIS_ LPDDSURFACEDESC2, DWORD) PURE;
    void* SetPrivateData;//)(THIS_ REFGUID, LPVOID, DWORD, DWORD) PURE;
    void* GetPrivateData;//)(THIS_ REFGUID, LPVOID, LPDWORD) PURE;
    void* FreePrivateData;//)(THIS_ REFGUID) PURE;
    void* GetUniquenessValue;//)(THIS_ LPDWORD) PURE;
    void* ChangeUniquenessValue;//)(THIS) PURE;
    void* SetPriority;//)(THIS_ DWORD) PURE;
    void* GetPriority;//)(THIS_ LPDWORD) PURE;
    void* SetLOD;//)(THIS_ DWORD) PURE;
    void* GetLOD;//)(THIS_ LPDWORD) PURE;
};

struct IDirect3D7
{
	void* QueryInterface;//)(THIS_ REFIID riid, LPVOID * ppvObj) PURE;
	void* AddRef;//)(THIS) PURE;
	void* Release;//)(THIS) PURE;
	void* EnumDevices;//)(THIS_ LPD3DENUMDEVICESCALLBACK7,LPVOID) PURE;
	HRESULT (__stdcall *CreateDevice)(IDirect3D7** d3d, IID* rclsid, IDirectDrawSurface7* lpDDS, IDirect3DDevice7*** lplpD3DDevice);
	void* CreateVertexBuffer;//)(THIS_ LPD3DVERTEXBUFFERDESC,LPDIRECT3DVERTEXBUFFER7*,DWORD) PURE;
	HRESULT (__stdcall *EnumZBufferFormats)(IDirect3D7** d3d, IID* riidDevice, void* lpEnumCallback, void* lpContext);
	void* EvictManagedTextures;//)(THIS) PURE; CALLBACK 
};


struct IDirect3DDevice7
{
	void* QueryInterface;//)(THIS_ REFIID riid, LPVOID * ppvObj) PURE;
	void* AddRef;//)(THIS) PURE;
	void* Release;//)(THIS) PURE;
	void* GetCaps;//)(THIS_ LPD3DDEVICEDESC7) PURE;
	HRESULT (__stdcall *EnumTextureFormats)(IDirect3DDevice7** device, HRESULT (__stdcall *lpd3dEnumPixelProc)(DDPIXELFORMAT* lpDDPixFmt, LPVOID lpContext), LPVOID lpArg);
	HRESULT (__stdcall *BeginScene)(IDirect3DDevice7** device);
	HRESULT (__stdcall *EndScene)(IDirect3DDevice7** device);//)(THIS) PURE;
	HRESULT (__stdcall *GetDirect3D)(IDirect3DDevice7** device, IDirect3D7*** lplpD3D);
	HRESULT (__stdcall *SetRenderTarget)(IDirect3DDevice7** device, IDirectDrawSurface7** lpNewRenderTarget, DWORD dwFlags);
	HRESULT (__stdcall *GetRenderTarget)(IDirect3DDevice7** device, IDirectDrawSurface7*** lplpRenderTarget);
	HRESULT (__stdcall *Clear)(IDirect3DDevice7** device, DWORD dwCount, D3DRECT* lpRects, DWORD dwFlags, DWORD dwColor, int dvZ, DWORD dwStencil);
	HRESULT (__stdcall *SetTransform)(IDirect3DDevice7** device, D3DTRANSFORMSTATETYPE dwTransformStateType, D3DMATRIX* lpD3DMatrix);
	HRESULT (__stdcall *GetTransform)(IDirect3DDevice7** device, D3DTRANSFORMSTATETYPE dwTransformStateType, D3DMATRIX* lpD3DMatrix);
	HRESULT (__stdcall *SetViewport)(IDirect3DDevice7** device, D3DVIEWPORT7* lpViewport);
	void* MultiplyTransform;//)(THIS_ D3DTRANSFORMSTATETYPE,LPD3DMATRIX) PURE;
	HRESULT (__stdcall *GetViewport)(IDirect3DDevice7** device, D3DVIEWPORT7* lpViewport);
	HRESULT (__stdcall *SetMaterial)(IDirect3DDevice7** device, D3DMATERIAL7* lpMaterial);
	void* GetMaterial;//)(THIS_ LPD3DMATERIAL7) PURE;
	HRESULT (__stdcall *SetLight)(IDirect3DDevice7** device, DWORD dwLightIndex, D3DLIGHT7* lpLight);
	void* GetLight;//)(THIS_ DWORD,LPD3DLIGHT7) PURE;
	HRESULT (__stdcall *SetRenderState)(IDirect3DDevice7** device, D3DRENDERSTATETYPE dwRenderStateType, DWORD dwRenderState);
	HRESULT (__stdcall *GetRenderState)(IDirect3DDevice7** device, D3DRENDERSTATETYPE dwRenderStateType, DWORD* lpdwRenderState);
	void* BeginStateBlock;//)(THIS) PURE;
	void* EndStateBlock;//)(THIS_ LPDWORD) PURE;
	void* PreLoad;//)(THIS_ LPDIRECTDRAWSURFACE7) PURE;
	HRESULT (__stdcall *DrawPrimitive)(IDirect3DDevice7** device, int dptPrimitiveType, DWORD dwVertexTypeDesc, void* lpvVertices, DWORD dwVertexCount, DWORD dwFlags);
	HRESULT (__stdcall *DrawIndexedPrimitive)(IDirect3DDevice7** device, int d3dptPrimitiveType, DWORD dwVertexTypeDesc, LPVOID lpvVertices, DWORD dwVertexCount, LPWORD lpwIndices, DWORD dwIndexCount, DWORD dwFlags);
	HRESULT (__stdcall *SetClipStatus)(IDirect3DDevice7** device, D3DCLIPSTATUS* lpD3DClipStatus);
	HRESULT (__stdcall *GetClipStatus)(IDirect3DDevice7** device, D3DCLIPSTATUS* lpD3DClipStatus);
	void* DrawPrimitiveStrided;//)(THIS_ D3DPRIMITIVETYPE,DWORD,LPD3DDRAWPRIMITIVESTRIDEDDATA,DWORD,DWORD) PURE;
	HRESULT (__stdcall *DrawIndexedPrimitiveStrided)(IDirect3DDevice7** device, D3DPRIMITIVETYPE d3dptPrimitiveType, DWORD dwVertexTypeDesc, D3DDRAWPRIMITIVESTRIDEDDATA* lpVertexArray, DWORD dwVertexCount, LPWORD lpwIndices, DWORD dwIndexCount, DWORD dwFlags);
	void* DrawPrimitiveVB;//)(THIS_ D3DPRIMITIVETYPE,LPDIRECT3DVERTEXBUFFER7,DWORD,DWORD,DWORD) PURE;
	void* DrawIndexedPrimitiveVB;//)(THIS_ D3DPRIMITIVETYPE,LPDIRECT3DVERTEXBUFFER7,DWORD,DWORD,LPWORD,DWORD,DWORD) PURE;
	void* ComputeSphereVisibility;//)(THIS_ LPD3DVECTOR,LPD3DVALUE,DWORD,DWORD,LPDWORD) PURE;
	void* GetTexture;//)(THIS_ DWORD,LPDIRECTDRAWSURFACE7 *) PURE;
	HRESULT (__stdcall *SetTexture)(IDirect3DDevice7** device, int nStage, IDirectDrawSurface7** surface);
	HRESULT (__stdcall *GetTextureStageState)(IDirect3DDevice7** device, DWORD dwStage, D3DTEXTURESTAGESTATETYPE dwState, DWORD* lpdwValue);
	HRESULT (__stdcall *SetTextureStageState)(IDirect3DDevice7** device, DWORD dwStage, D3DTEXTURESTAGESTATETYPE dwState, DWORD dwValue);
	void* ValidateDevice;//)(THIS_ LPDWORD) PURE;
	void* ApplyStateBlock;//)(THIS_ DWORD) PURE;
	void* CaptureStateBlock;//)(THIS_ DWORD) PURE;
	void* DeleteStateBlock;//)(THIS_ DWORD) PURE;
	void* CreateStateBlock;//)(THIS_ D3DSTATEBLOCKTYPE,LPDWORD) PURE;
	void* Load;//)(THIS_ LPDIRECTDRAWSURFACE7,LPPOINT,LPDIRECTDRAWSURFACE7,LPRECT,DWORD) PURE;
	HRESULT (__stdcall *LightEnable)(IDirect3DDevice7** device, DWORD dwLightIndex, BOOL bEnable);
	void* GetLightEnable;//)(THIS_ DWORD,BOOL*) PURE;
	void* SetClipPlane;//)(THIS_ DWORD,D3DVALUE*) PURE;
	void* GetClipPlane;//)(THIS_ DWORD,D3DVALUE*) PURE;
	void* GetInfo;//)(THIS_ DWORD,LPVOID,DWORD) PURE;
};

struct IDirectDrawClipper
{
    void* QueryInterface;//(THIS_ REFIID riid, LPVOID FAR * ppvObj) PURE;
    void* AddRef;//(THIS)  PURE;
    HRESULT (__stdcall *Release)(IDirectDrawClipper** clip);
    void* GetClipList;//(THIS_ LPRECT, LPRGNDATA, LPDWORD) PURE;
    void* GetHWnd;//(THIS_ HWND FAR *) PURE;
    void* Initialize;//(THIS_ LPDIRECTDRAW, DWORD) PURE;
    void* IsClipListChanged;//(THIS_ BOOL FAR *) PURE;
    void* SetClipList;//(THIS_ LPRGNDATA,DWORD) PURE;
    HRESULT (__stdcall *SetHWnd)(IDirectDrawClipper** clip, DWORD dwFlags, HWND hWnd);
}; 

struct IDirect3DVertexBuffer7
{
    void* QueryInterface;//)(THIS_ REFIID riid, LPVOID * ppvObj) PURE;
    void* AddRef;//)(THIS) PURE;
    void* Release;//)(THIS) PURE;
    void* Lock;//)(THIS_ DWORD,LPVOID*,LPDWORD) PURE;
    void* Unlock;//)(THIS) PURE;
    void* ProcessVertices;//)(THIS_ DWORD,DWORD,DWORD,LPDIRECT3DVERTEXBUFFER7,DWORD,LPDIRECT3DDEVICE7,DWORD) PURE;
    void* GetVertexBufferDesc;//)(THIS_ LPD3DVERTEXBUFFERDESC) PURE;
    void* Optimize;//)(THIS_ LPDIRECT3DDEVICE7,DWORD) PURE;
    void* ProcessVerticesStrided;//)(THIS_ DWORD,DWORD,DWORD,LPD3DDRAWPRIMITIVESTRIDEDDATA,DWORD,LPDIRECT3DDEVICE7,DWORD) PURE;
};


////////////////////////////////////////////////////////////////////////////
#pragma pack()

