

//---------------------------------------------------------------------- eEventType
enum eEventType
{
	EVT_IDLE_MESSAGE = 0,
	EVT_MOUSE_MOVE = 1,
	EVT_MOUSE_BUTTON_DOWN = 2,
	EVT_MOUSE_BUTTON_UP = 3,
	EVT_KEY = 4,
	EVT_UI_MSG = 5,
	EVT_AM_MSG = 6,
	EVT_AM_CREATURE_MSG = 7,
	EVT_FX = 8,
	EVT_ARROW = 9,
	EVT_NETWORK = 10,
	EVT_PROFILE = 11,
	EVT_IME = 12,
};
//---------------------------------------------------------------------- eEventSubType
enum eEventSubType
{
	EST_NONE = 0,
	EST_UI_BASE = 16,
	EST_UI_STRING = 17,
	EST_AM_ENGINE = 32,
	EST_AM_TRIGGER = 33,
	EST_AM_OBJECT = 34,
	EST_AM_CREATURE = 35,
	EST_AM_WEATHER = 36,
	EST_AM_CONSOLE = 37,
	EST_AM_PROFILE = 38,
	EST_IME_OCAND = 39,
	EST_IME_SCOMP = 40,
	EST_IME_ECOMP = 41,
	EST_IME_COMP = 42,
	EST_IME_CCAND = 43,
	EST_IME_UCAND = 44,
	EST_IME_CHAR = 45,
};


//---------------------------------------------------------------------- 0= EVT_IDLE_MESSAGE
//---------------------------------------------------------------------- 1= EVT_MOUSE_MOVE
//---------------------------------------------------------------------- 2= EVT_MOUSE_BUTTON_DOWN
//---------------------------------------------------------------------- 3= EVT_MOUSE_BUTTON_UP
enum cEventMouseButtonType //btype
{
	LEFT = 0x0,
	CENTER = 0x1,
	RIGHT = 0x2,
	WHEEL = 0x3,
};
//---------------------------------------------------------------------- 4= EVT_KEY
//---------------------------------------------------------------------- 5= EVT_UI_MSG, 16= EST_UI_BASE
//---------------------------------------------------------------------- 5= EVT_UI_MSG, 17= EST_UI_STRING
enum eEventUI
{
	UI_ENDTHREAD = 0x1,
	UI_RUNTHREAD = 0x2,
	UI_MENU_MAIN = 0x3,
	UI_MENU_ENGINE = 0x4,
	UI_MENU_MOVIEMODE = 0x5,
	UI_MENU_FADEMODE = 0x6,
	UI_MENU_CLOSEHELP = 0x7,
	UI_CTRL_FOCUS = 0x10,
	UI_CTRL_SETFLAGS = 0x11,
	UI_CTRL_RESETFLAGS = 0x12,
	UI_CTRL_FLIPFLAGS = 0x13,
	UI_CTRL_NEXT = 0x14,
	UI_CTRL_PREV = 0x15,
	UI_CTRL_SETVALUE = 0x16,
	UI_CTRL_SETTEXTURE = 0x17,
	UI_DIARY = 0x20,
	UI_MINIMAP = 0x21,
	UI_OVERVIEWMAP = 0x22,
	UI_CHEST = 0x23,
	UI_SET_ALPHA = 0x24,
	UI_GENERIC_STRING = 0x25,
	UI_CONSOLE_STRING = 0x26,
	UI_MENUMGR_STRING = 0x27,
	UI_HERO_TYPE = 0x28,
	UI_HERO_INFO = 0x29,
	UI_TELEPORT = 0x2A,
	UI_TASKBAR_CMD = 0x2B,
	UI_EQUIPMENT_DO = 0x2C,
	UI_ACTIVEHERO = 0x2D,
	UI_MERCHANT = 0x2E,
	UI_COMBOMASTER = 0x2F,
	UI_BLACKSMITH = 0x30,
	UI_ESCMENU = 0x31,
	UI_TABCONTROL = 0x32,
	UI_NETWORK_CHAT = 0x33,
	UI_SONIC_FX = 0x34,
	UI_VAMPIRE_FX = 0x35,
	UI_NETWORK = 0x36,
	UI_MAINMENU = 0x37,
	UI_LISTBOX = 0x38,
	UI_BUSYDLG = 0x39,
	UI_BUSYREPLY = 0x3A,
	UI_UPDATE_PROFILESTR = 0x3B,
	UI_SETTEXT = 0x3C,
	UI_DO_KEY = 0x3D,
	UI_DEMO_END = 0x3E,
	UI_CACHE_MODELS = 0x3F,
};
//---------------------------------------------------------------------- 6= EVT_AM_MSG, 32= EST_AM_ENGINE
enum eEventEngine
{
	EE_INVALID = 0x0,
	EE_SET_ACTIVECREATURE = 0x1,
	EE_SET_ACTIVESPELL = 0x2,
	EE_SET_ACTIVESMOVE = 0x3,
	EE_SET_ACTIVECOMBO = 0x4,
	EE_TRIGGER = 0x5,
	EE_DISPLAY_DIGIT = 0x6,
	EE_RENDER_ONCE = 0x7,
	EE_KEY_TOKEYRING = 0x8,
	EE_END_SIMULATION = 0x9,
	EE_FRAME_NOFLIP = 0xA,
	EE_DISPLAY_TEXT = 0xB,
	EE_OBSERVER = 0xC,
	EE_VIEW = 0xD,
	EE_CONSOLE = 0xE,
	EE_SAVEGAME = 0xF,
	EE_SETFIGHTMODE = 0x10,
	EE_TELEPORT = 0x11,
	EE_RENDERING = 0x12,
	EE_SETMODE = 0x13,
	EE_DROPITEM = 0x14,
	EE_CHANGEHERO = 0x15,
	EE_USEPORTAL = 0x16,
	EE_USEPOTION = 0x17,
	EE_LIGHTENABLE = 0x18,
	EE_GRNSEQUENCELOAD = 0x19,
	EE_JUDGEMENT_DAY = 0x1A,
};
//---------------------------------------------------------------------- 6= EVT_AM_MSG, 33= EST_AM_TRIGGER
//---------------------------------------------------------------------- 6= EVT_AM_MSG, 34= EST_AM_OBJECT
enum eEventObject//eST
{
	CMD_NONE = 0x0,
	CMD_OPEN = 0x1,
	CMD_CLOSE = 0x2,
	CMD_CHEST = 0x3,
	CMD_ON_RIGHTCLICK = 0x10,
	CMD_ON_LEFTCLICK = 0x11,
	CMD_RESERVED1 = 0x12,
	CMD_PLAY_ANIMATION = 0x20,
	CMD_STATE_TOGGLE = 0x21,
	CMD_O3D_CHANGEFACING = 0x40,
	CMD_O3D_CHANGEFACING_VECTOR = 0x41,
	CMD_DESTROYED = 0x42,
	CMD_RELOADMODEL = 0x43,
	CMD_NET_LOOSE_WEAPON = 0x44,
};
//---------------------------------------------------------------------- 6= EVT_AM_MSG, 36= EST_AM_WEATHER
enum eWeatherType //cWeatherManager.currentWeather
{
  WEATHER_NONE = 0x0,
  WEATHER_RESET = 0x1,
  WEATHER_RAIN = 0x2,//0x0001, 0x0004
  WEATHER_FOG = 0x3,//0x0002
  WEATHER_GROUNDFOG = 0x4,
  WEATHER_SNOW = 0x5,//0x0010
  WEATHER_RESERVED = 0x6,
  WEATHER_QUAKE = 0x7,//0x0080
  WEATHER_NIGHT = 0x8,//0x0020
  WEATHER_FLASH_ONCE = 0x9,//0x0100
  WEATHER_ENTERSECTOR = 0xA,
  WEATHER_EXITSECTOR = 0xB,
  WEATHER_STOMP = 0xC,//0x0200
};
//---------------------------------------------------------------------- 6= EVT_AM_MSG, 37= EST_AM_CONSOLE
enum eEventConsole
{
	EEC_EXEC = 0x0,
	EEC_CLOSED = 0x1,
};
//---------------------------------------------------------------------- 7= EVT_AM_CREATURE_MSG
enum eEventCreature//eCST
{
	ACTION_NULL = 0x0,
	ACTION_RESET = 0x1,
	ACTION_SET_MOTION_TYPE = 0x2,
	ACTION_PUSHBACK = 0x3,
	ACTION_MOVE_TO = 0x4,
	ACTION_DAMAGE = 0x5,
	ACTION_HEALING = 0x6,
	ACTION_INTERACT = 0x7,
	ACTION_SETPOSITION = 0x8,
	ACTION_SUDDEN_DEATH = 0x9,
	ACTION_USEITEM = 0x10,
	ACTION_FIGHT = 0x100,
	ACTION_MOUNT_HORSE = 0x101,
	ACTION_MORPH = 0x102,
	ACTION_TALK = 0x103,
	ACTION_MAGIC_ABLE = 0x104,
	ACTION_SPELL_CAST = 0x105,
	ACTION_ALLIANCE_DEFAULT = 0x106,
	ACTION_WEAPON_CHANGED = 0x107,
	ACTION_ANIMATION = 0x108,
	ACTION_SET_SFX_DATA = 0x109,
	ACTION_UPD_SFX_DATA2 = 0x10A,
	ACTION_FOLLOW = 0x10B,
	ACTION_TALKTO = 0x10C,
	ACTION_EXPERIENCE = 0x10D,
	ACTION_GOLD = 0x10E,
	ACTION_RESTORE = 0x10F,
	ACTION_LOOSEHEAD = 0x110,
	ACTION_INVENTORY = 0x111,
	ACTION_LOOSEWEAPON = 0x112,
	ACTION_AUTO_COLLECT = 0x113,
	ACTION_SLOT_CHANGE = 0x114,
	ACTION_VAMPIRE_MODE = 0x115,
	ACTION_WHISTLE_HORSE = 0x116,
	ACTION_NET_START_MOVE = 0x200,
	ACTION_NET_UPDATE_MOVE = 0x201,
	ACTION_NET_SET_MOTIONTYPE = 0x202,
	ACTION_NET_END_MOVE = 0x203,
	ACTION_NET_BOW_ENTER = 0x204,
	ACTION_NET_BATTLE_ENTER = 0x205,
	ACTION_NET_DAMAGE = 0x206,
	ACTION_NET_SPELL_CAST = 0x207,
	ACTION_NET_DEAD = 0x208,
	ACTION_NET_MOUNT_HORSE = 0x209,
	ACTION_NET_DISMOUNT_HORSE = 0x20A,
	ACTION_NET_PICKUP = 0x20B,
	ACTION_NET_PICKUP_SUCCESS = 0x20C,
	ACTION_NET_PICKUP_NOSUCCESS = 0x20D,
	ACTION_NET_LOOSE_WEAPON_STATS = 0x20E,
	ACTION_NET_OPENCHEST_SUCCESS = 0x20F,
	ACTION_NET_TALK_ENTER = 0x210,
	ACTION_NET_TALK_EXIT = 0x211,
	ACTION_NET_SPECIALMOVE = 0x212,
	ACTION_NET_PUSHBACK = 0x213,
	ACTION_NET_EXPERIENCE = 0x214,
};
//---------------------------------------------------------------------- 8= EVT_FX
enum eEventFX
{
	FXT_NONE = 0x0,
	FXT_FIRESTRIKE = 0x1,
	FXT_TELEPORT_OUT = 0x2,
	FXT_TELEPORT_IN = 0x3,
	FXT_BIGSUMMON = 0x4,
	FXT_SHIELDED = 0x5,
	FXT_TEMPTEX = 0x6,
	FXT_SMOKE = 0x7,
	FXT_BLEED = 0x8,
	FXT_BODYPARTS = 0x9,
	FXT_PARADE = 0xA,
	FXT_FIREBALL = 0xB,
	FXT_PUZZLE_SOLVED = 0xC,
	FXT_PUZZLE_SOLVED_V = 0xD,
	FXT_PENTAGRAMMKILLER = 0xE,
	FXT_SUPERFLUID = 0xF,
	FXT_HEALING = 0x10,
	FXT_KUGELBLITZ = 0x11,
	FXT_GOBLINIMPACT = 0x12,
	FXT_TORCHSMOKE = 0x13,
	FXT_BURNING_BONE = 0x14,
	FXT_BOSSDEATH = 0x15,
	FXT_FIRE_CIRCLE = 0x16,
	FXT_CAST_SPELL = 0x17,
	FXT_GROUND_POISON = 0x18,
	FXT_PLONG = 0x19,
	FXT_EXPLOSION = 0x1A,
	FXT_MAGICMARKER = 0x1B,
	FXT_MAGICFIRE = 0x1C,
	FXT_MAGICGIFT = 0x1D,
	FXT_MAGICFADE = 0x1E,
	FXT_LIGHTNING_STRIKE = 0x1F,
	FXT_FREEZE = 0x20,
	FXT_RAILGUN = 0x21,
	FXT_STARGATE = 0x22,
	FXT_HOLYLIGHT = 0x23,
	FXT_GROUNDSYMBOL = 0x24,
	FXT_HOLYCONVERT = 0x25,
	FXT_ARROWTRAIL = 0x26,
	FXT_CLOUD = 0x27,
	FXT_CIRCLEOFFEAR = 0x28,
	FXT_HOLYWALL = 0x29,
	FXT_NETGATE = 0x2A,
	FXT_BURNINGLIGHT = 0x2B,
	FXT_MAGLITE = 0x2C,
	FXT_CRUSADERSTRENGTH = 0x2D,
	FXT_HOLYSHIELD = 0x2E,
	FXT_HELLFIRE = 0x2F,
	FXT_FIRESKIN = 0x30,
	FXT_STONED = 0x31,
	FXT_METEOR = 0x32,
	FXT_MAGICWHIP = 0x33,
	FXT_SPEEDUP = 0x34,
	FXT_TWISTER = 0x35,
	FXT_ELEMENTSTONE = 0x36,
	FXT_WINDSTRIKE = 0x37,
	FXT_DWARFMAGIC = 0x38,
	FXT_MAGICSHIELD = 0x39,
	FXT_MANAREGEN = 0x3A,
	FXT_HPREGEN = 0x3B,
	FXT_MAGICSTREAK = 0x3C,
	FXT_FLASH = 0x3D,
	FXT_STEAM = 0x3E,
	FXT_ICEBULLETS = 0x3F,
	FXT_CIRCLEOFICE = 0x40,
	FXT_GLAD_SM_CAST = 0x41,
	FXT_GLAD_SM_HIT = 0x42,
	FXT_SERA_SM_CAST = 0x43,
	FXT_SERA_SM_HIT = 0x44,
	FXT_CHANGELING = 0x45,
	FXT_HIGHSPEED = 0x46,
	FXT_BUBBLETRAP = 0x47,
	FXT_KILLERPLANTS = 0x48,
	FXT_PLANTCAGE = 0x49,
	FXT_LOSTSOULS = 0x4A,
	FXT_NATUREHEALING = 0x4B,
	FXT_DRAGONFIRE = 0x4C,
	FXT_BUBBLEPRISON = 0x4D,
	FXT_MAGICPRISON = 0x4E,
	FXT_ARACATTACK = 0x4F,
	FXT_GENERIC = 0x50,
	FXT_BEHERRSCHUNG = 0x51,
	FXT_MAGICWORMS = 0x52,
	FXT_ZEITKONTROLLE = 0x53,
	FXT_ELVE_SM_CAST = 0x54,
	FXT_ELVE_SM_HIT = 0x55,
	FXT_VAMP_SM_CAST = 0x56,
	FXT_VAMP_SM_HIT = 0x57,
	FXT_DARK_SM_CAST = 0x58,
	FXT_DARK_SM_HIT = 0x59,
	FXT_LIVE_UNDEAD = 0x5A,
	FXT_BALL = 0x5B,
	FXT_BATTLEFOG = 0x5C,
	FXT_SOULCATCHER = 0x5D,
	FXT_MAGIEUMLEITUNG = 0x5E,
	FXT_CONFUSION = 0x5F,
	FXT_FREEZE_IMPACT = 0x60,
	FXT_BUTTERFLY = 0x61,
	FXT_KNOCKOUT = 0x62,
	FXT_BFG = 0x63,
	FXT_LAVABURST = 0x64,
	FXT_SMALLFIRE = 0x65,
	FXT_SPIDERPUKE = 0x66,
	FXT_FERNUMLEITUNG = 0x67,
	FXT_HARDHITBOW = 0x68,
	FXT_CHANGELING_CAST = 0x69,
	FXT_TRAP01 = 0x6A,
	FXT_TRAP01_PARENT = 0x6B,
	FXT_TRAP02_PARENT = 0x6C,
	FXT_TRAP02_PILL = 0x6D,
	FXT_TRAP02_GHOST = 0x6E,
	FXT_TRAP03_PARENT = 0x6F,
	FXT_TRAP03_LASER = 0x70,
	FXT_TRAP04_FIRE = 0x71,
	FXT_LASERBEAM = 0x72,
	FXT_BATSIGNAL = 0x73,
	FXT_BLOODPUDDLE = 0x74,
	FXT_FLYINGSKULL = 0x75,
	FXT_BUBBLETRAP_EXPLO = 0x76,
	FXT_BLOODPUDDLE_BIG = 0x77,
	FXT_BLOODFONTAIN = 0x78,
	FXT_LASERBEAM_IMPACT = 0x79,
	FXT_DAEMONFIRE = 0x7A,
	FXT_FORGEELEM = 0x7B,
	FXT_FORGEBEAM = 0x7C,
	FXT_BIG_DEMON_ILLUSION = 0x7D,
	FXT_BIG_DEMON_SUMMON = 0x7E,
	FXT_BIG_DEMON_DEATH = 0x7F,
	FXT_SHADDAR_PENTA = 0x80,
	FXT_SHADDAR_SLAVE = 0x81,
	FXT_SHADDAR_MAGIC = 0x82,
	FXT_DRAGON_GROUNDFIRE = 0x83,
	FXT_REANIMATE = 0x84,
};
//---------------------------------------------------------------------- 9= EVT_ARROW
//---------------------------------------------------------------------- 10= EVT_NETWORK
enum eEventNetworkType
{
	NW_INVALID = 0x32,
	NW_TIMERCHECK = 0x33,
	NW_KILL_SERVER = 0x34,

	NW_GAMESERVER_LAUNCH = 0x115,//0x35
	NW_GAMESERVER_CONNECT = 0x116,//0x36
	NW_GAMESERVER_DISCONNECT = 0x117,//0x37
	NW_GAMESERVER_TERMINATE = 0x1D6,
	
	NW_NETWORK_PLAYER_CHARACTER = 0x38,
	
	NW_SESSION_CLIENT_JOINS = 0x39,
	NW_SESSION_CLIENT_LEAVES = 0x3A,
	NW_SESSION_KICK_PLAYER = 0x157,//0x3B
	NW_SESSION_REQ_REFS = 0x3C,
	NW_SESSION_REQ_TRIGGER = 0x3D,
	NW_SESSION_RELEASE_REFS = 0x3E,
	NW_SESSION_TRANSFER_HOST = 0x3F,
	NW_SESSION_LOCK = 0x40,
	NW_SESSION_UNLOCK = 0x41,
	
	NW_TEAM_INVITE = 0x42,
	NW_TEAM_JOIN = 0x43,
	NW_TEAM_LEAVE = 0x44,
	
	NW_GAME_START = 0x45,
	NW_GAME_STARTED = 0x46,
	
	NW_PAUSE_ENABLE = 0x47,
	NW_PAUSE_DISABLE = 0x48,
	
	NW_OBJECT_CREATE = 0x49,
	NW_OBJECT_CREATE_POS = 0x4A,
	NW_OBJECT_UPDATE = 0x4B,
	NW_OBJECT_UPDATE_POS = 0x4C,
	NW_OBJECT_UPDATE_POS_CHECK = 0x4D,
	NW_OBJECT_UPDATE_POS_RESPAWN = 0x4E,
	NW_OBJECT_DESTROY = 0x4F,
	NW_OBJECT_SUICIDE = 0x50,
	NW_OBJECT_DESTROY_EXIT = 0x51,
	NW_OBJECT_REQ_CHANGE_OWNER = 0x52,
	NW_OBJECT_CHANGE_OWNER = 0x53,
	NW_OBJECT_CREATEANIMATION = 0x54,
	NW_OBJECT_SET_TRIGGER = 0x55,
	
	NW_CREATURE_EQUIP = 0x56,
	NW_CREATURE_UNEQUIP = 0x57,
	NW_CREATURE_UPDATE_FIGHTMODE = 0x58,
	NW_CREATURE_UPDATE_DLG = 0x59,
	NW_CREATURE_UPDATE_DATA = 0x5A,
	NW_CREATURE_UPDATE_VAL = 0x5B,
	NW_CREATURE_SETBONUS = 0x5C,
	NW_CREATURE_TALK_ENTER = 0x5D,
	NW_CREATURE_TALK_EXIT = 0x5E,
	NW_CREATURE_TALK_TEXTID = 0x5F,
	NW_CREATURE_SPECIALMOVE = 0x60,
	NW_CREATURE_SLEEP = 0x61,
	NW_CREATURE_EXPERIENCE = 0x62,
	NW_CREATURE_HEALTH = 0x63,
	NW_CREATURE_SETHIRELING = 0x64,
	NW_CREATURE_UNSETHIRELING = 0x65,
	NW_CREATURE_INVENTORY = 0x66,
	
	NW_MOVE_START = 0x67,
	NW_MOVE_UPDATE = 0x68,
	NW_MOVE_END = 0x69,
	NW_MOVE_FORCE_IDLE = 0x6A,
	NW_MOVE_SET_IDLE = 0x6B,
	
	NW_HORSE_MOUNT = 0x6C,
	NW_HORSE_DISMOUNT = 0x6D,
	
	NW_FIGHT_BOW_ENTER = 0x6E,
	NW_FIGHT_BATTLE_ENTER = 0x6F,
	NW_FIGHT_ENEMY_SPOTTED = 0x70,
	NW_FIGHT_DAMAGE = 0x71,
	NW_FIGHT_DEAD = 0x72,
	NW_FIGHT_PUSHBACK = 0x73,
	NW_FIGHT_PUSHBACK_END = 0x74,
	
	NW_WEAPON_LOOSE = 0x75,
	NW_FLY_STOP = 0x76,
	
	NW_ITEM_MOUSE = 0x77,
	NW_ITEM_SETITEM = 0x78,
	NW_ITEM_DELITEM = 0x79,
	NW_ITEM_PICKUP = 0x7A,
	NW_ITEM_PICKUP_SUCCESS = 0x7B,
	NW_ITEM_DROP = 0x7C,
	
	NW_MAGIC_SPELL_CAST = 0x7D,
	NW_MAGIC_SPELL_EXPLODE = 0x7E,
	NW_MAGIC_SPELL_NOTIFY = 0x7F,
	NW_MAGIC_SPELL_CAST_CONT = 0x80,
	NW_MAGIC_REDIRECTION = 0x81,
	
	NW_FX_UPDATE = 0x82,
	NW_FX_BURNINGBONE = 0x83,
	NW_FX_WEATHER = 0x84,
	NW_FX_PUZZLESOLVED = 0x85,
	NW_FX_PUZZLESOLVED_V = 0x86,
	NW_FX_LOCAL_CREATE = 0x87,
	
	NW_SECTORS_ENTEREXIT = 0x88,
	NW_CHEST_OPEN = 0x89,
	NW_CHEST_OPEN_SUCCESS = 0x8A,
	NW_CHEST_CLOSE = 0x8B,
	NW_DOOR_OPEN = 0x8C,
	NW_DOOR_CLOSE = 0x8D,
	
	NW_TRIGGER_CREATE = 0x8E,
	NW_TRIGGER_SETSTATE = 0x8F,
	NW_TRIGGER_RESETSTATE = 0x90,
	NW_TRIGGER_FULL_LIST_REQUEST = 0x91,
	NW_TRIGGER_FULL_LIST1 = 0x92,
	NW_TRIGGER_FULL_LIST2 = 0x93,
	NW_TRIGGER_FULL_LIST3 = 0x94,
	NW_TRIGGER_FULL_LIST4 = 0x95,
	NW_TRIGGER_INSERT_TRGNAMENUMREF = 0x96,
	NW_TRIGGER_REMOVE_TRGNAMENUMREF = 0x97,
	NW_TRIGGER_INSERT_QUEST = 0x98,
	NW_TRIGGER_UPDATE_QUEST = 0x99,
	NW_TRIGGER_UPDATE_QUESTENTRY = 0x9A,
	NW_TRIGGER_UPDATE_QUESTDB = 0x9B,
	NW_TRIGGER_UPDATE_QUESTMETA = 0x9C,
	NW_TRIGGER_UPDATE_QUESTPOOL = 0x9D,
	NW_TRIGGER_CLEAR_QUEST = 0x9E,
	NW_TRIGGER_INSERTUPDATE_DEFS = 0x9F,
	NW_TRIGGER_REMOVE_DEFS = 0xA0,
	NW_TRIGGER_INSERT_DEATH = 0xA1,
	NW_TRIGGER_REMOVE_DEATH = 0xA2,
	NW_TRIGGER_SETBASETRIGGER = 0xA3,
	NW_TRIGGER_UPDATE_FUNKS = 0xA4,
	NW_TRIGGER_INSERT_VARIS = 0xA5,
	NW_TRIGGER_UPDATE_VARIS = 0xA6,
	NW_TRIGGER_INSERT_REGION = 0xA7,
	NW_TRIGGER_UPDATE_DLGS = 0xA8,
	NW_TRIGGER_INSERT_MAPICON = 0xA9,
	NW_TRIGGER_ACTUALQUESTS_FULL = 0xAA,
	NW_TRIGGER_ACTUALQUESTS_UPDATE = 0xAB,
	NW_TRIGGER_SETUP_TALKTO = 0xAC,
	NW_TRIGGER_INSERT_ATTRACTOR = 0xAD,
	NW_TRIGGER_PATCH = 0xAE,
	NW_TRIGGER_MOVEOVER = 0xAF,
	NW_TRIGGER_ACTIVECREATURE = 0xB0,
	NW_TRIGGER_MORPH = 0xB1,
	NW_TRIGGER_INSERT_MOUSEOVER = 0xB2,
	NW_TRIGGER_INSERT_SPAWNRENEW = 0xB3,
	
	NW_NPC_SETSTATE = 0xB4,
	NW_NPC_IDLE_ANIMATION = 0xB5,
	NW_SECTOR_DELETEAREA = 0xB6,
	
	NW_TIMER_SETTIMER = 0xB7,
	NW_TIMER_DELTIMER = 0xB8,
	NW_TIMER_TIMERUP = 0xB9,
	
	NW_CHARACTER_SAVEGAME = 0xBA,
	NW_NETWORK_LAST = 0xBB,
	NW_NETWORK_MAX = 0xFF,
};
//---------------------------------------------------------------------- 11= EVT_PROFILE, 38= EST_AM_PROFILE
//---------------------------------------------------------------------- 12= EVT_IME



//---------------------------------------------------------------------- 
enum SoundEvent
{
	SEVT_NONE = 0x0,
	SEVT_ENEMY = 0x1,
	SEVT_SECTOR_CHANGE = 0x2,
	SEVT_CALENDAR = 0x3,
	SEVT_VIEWPOS = 0x4,
	SEVT_WEAPON_WOOSH = 0x5,
	SEVT_CREATURE = 0x6,
	SEVT_UPGRADE = 0x7,
	SEVT_USERMESSAGE = 0x8,
	SEVT_USER_FX = 0x9,
	SEVT_DOOR = 0xA,
	SEVT_SFX = 0xB,
	SEVT_SYSTEM = 0xC,
	SEVT_STATIC_FX = 0xD,
	SEVT_MENU = 0xE,
};


//---------------------------------------------------------------------- 
//---------------------------------------------------------------------- 
//---------------------------------------------------------------------- 
//---------------------------------------------------------------------- 
//---------------------------------------------------------------------- 
//---------------------------------------------------------------------- 
//---------------------------------------------------------------------- 
//---------------------------------------------------------------------- 
//---------------------------------------------------------------------- 
//---------------------------------------------------------------------- 
//---------------------------------------------------------------------- 
//---------------------------------------------------------------------- 







enum eMouseDragType
{
	MDT_INVALID = 0x0,
	MDT_REFERENT = 0x1,
	MDT_SPELL = 0x2,
	MDT_SPECIALMOVE = 0x3,
	MDT_COMBO = 0x4,
	MDT_FORGE = 0x5,
};




