// ff.h : header file
//

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#pragma pack(1)


struct Signature //0x4
{
	char str[3];
	BYTE ver;
};

//---------------------------------------------------------------------- SND: sound.pak
// PAK\sound.pak, PAK\snd\LNG_sound.pak
//----------------------------------------------------------------------
struct SoundPak_hdr //0x100 =256
{
	Signature sig; // SND
	DWORD dwCount;
	DWORD dwLang;
	BYTE _0[244];
};
struct SoundPak_chunk
{
	DWORD dwTypeID;
	DWORD dwOffset;
	DWORD dwCompressedSize;
};

//---------------------------------------------------------------------- OBJ: Static.PAK
// World\Static.PAK
//----------------------------------------------------------------------
struct StaticPak_hdr //0x100 =256
{
	Signature sig; // OBJ
	DWORD dwCount;
	DWORD dw2;
	DWORD dw3;
	BYTE _0[240];
};
struct StaticPak_chunk
{
	DWORD dwHeaderType;
	DWORD dwOffset;
	DWORD dwEntSize;
};
// ent: sObjectStatic


//---------------------------------------------------------------------- MIX: mixed.pak
// PAK\mixed.pak
//----------------------------------------------------------------------
struct MixedPak_Hdr //0x100 =256
{
	Signature sig; // MIX
	DWORD dwItemCount;
	BYTE _0[248];
};
struct MixedPak_Ent //=12
{
	DWORD dwNumTextures;
	DWORD dwOffset;
	DWORD dwSize;
};


//---------------------------------------------------------------------- CIF: creature.pak
// PAK\creature.pak
//----------------------------------------------------------------------
struct CreaturePak_Hdr //0x100 =256
{
	Signature sig; // CIF
	DWORD dwItemCount;
	DWORD dw2;
	BYTE _0[244];
};


//---------------------------------------------------------------------- WPN: weapon.pak
// PAK\weapon.pak
// items= 4883, total= 6094
//----------------------------------------------------------------------
struct WeaponPak_Hdr //0x100 =256
{
	Signature sig; // WPN
	DWORD dwItemCount;
	BYTE _0[248];
};






/*
[============================================]
Creatures.pak
[============================================]

ID	CIF
Type	BYTE (0)
ItemNum	LONG
UNKNOWN	LONG

Items start at 256, all items are 64 in length

[============================================]
weapons.pak
[============================================]

ID	WPN
Version	BYTE (8)
ItemNum	LONG
UNKNOWN	LONG

Items start at 256, all items are 322 in length

[============================================]
texture.pak
[============================================]

ID	TEX
Type	BYTE (3)
ItemNum	LONG (Reserved! Not all used (demo)!)
UNKNOWN LONG

Items information starts at 256,

Item information:

Type/Unknown	LONG
Offset		LONG
Size		LONG

The textures are in principle 16-bit RGB encoded, uncompressed TGA files with their headers 

stripped from them, replaced by a new custom header of 80 bytes in size, while the image 

data is compressed using ZLib. The new header is as follows:

ItemName	STRING of 32 bytes
X Size 		WORD (16-bit) of the number of pixels in X direction
Y Size 		WORD (16-bit) of the number of pixels in Y direction
UNKNOWN		LONG
TRAIL		40 BYTES of 0's (reserved space?)

The size in the Item information header refers to the Compressed Size 
of the ZLib-compressed data segment (that follows right after the above mentioned custom 

header).To obtain the size of the uncompressed data segment you should calculate:
xsize * ysize * 2 (as each pixel is 16-bit, i.e. 2 bytes). 
The images are upside down as well, so you should flip them vertically. 
Note also that the palette is not saved, so actual colours in the game may be
different. 

You should insert a standard Targa header before the uncompressed image data, in order to 

view them and edit them. 

Targa header:

   BYTE  idlength; 		(0)
   BYTE  colourmaptype;		(0)
   BYTE  datatypecode;		(2)
   WORD  colourmaporigin;	(0)
   WORD  colourmaplength;	(0)
   BYTE  colourmapdepth;	(0)
   WORD  int x_origin;		(0)
   WORD  int y_origin;		(0)
   WORD  width;			(X Size)
   WORD  height;		(Y Size)
   BYTE  bitsperpixel;		(16)
   BYTE  imagedescriptor;	(0)

[============================================]
Items.pak
[============================================]

ID	ITM
Type	BYTE (5)
ItemNum	LONG (Reserved! Not all used (demo)!)

Items information starts at 256,

Type	LONG (0 has no name, 2 has a 32-byte string at position 56 of the item data)
OFFSET 	LONG
SIZE	LONG

Note that the string in Type 2 items refers to a model in models.pak. 


[============================================]
Models.pak
[============================================]

ID	ITM
Type	BYTE (3)
ItemNum	LONG (Reserved! Not all used (demo)!)
UNKNOWN	LONG (multiple, don't know)

Items information starts at 256, 

Type	LONG 
OFFSET 	LONG
SIZE	LONG

Each item (go to the offset of the item to see it!) has its own header, that starts with 

the filename (32-byte string). 
I don't what it's all about, but the models were made using
RAD's Game Tools' 3D Studio Max. 
*/


struct TexturePak_FileHdr // 256
{
	BYTE sig[3]; // TEX
	BYTE version;
	DWORD dwEntries;
	DWORD dwRnd1;
	DWORD dwRnd2;
	DWORD dw2;
	DWORD dwRnd3;
	BYTE _0[232];
};
struct TextureTmp_FileHdr // 256
{
	BYTE sig[3]; // TEL
	BYTE version;
	DWORD dw1;
	DWORD dwSizePak0;
	DWORD dwRnd;
	DWORD dwRnd2;
	DWORD dwSizePaksAll;
	DWORD dw3;
	BYTE _0[228];
};
struct TexturePak_FileInf // 12
{
	DWORD dwTypeID;
	DWORD dwOffset;
	DWORD dwCompressedSize;
};


struct SaveGame_Hdr //0x100 =256
{
	char sig[3]; // AMS
	BYTE ver;
	DWORD nSections;
	DWORD savedescLoka;
	DWORD uniqueID[2];
	DWORD dwHeroType;
	DWORD dwHeroColor;
	DWORD nLangNo;
	DWORD nTypeOS;
	DWORD nGameType;
	DWORD nVer;
	DWORD isNetworkGame;
	DWORD ver18; //18
	DWORD dwSectorCount;
	DWORD dwTriggersCount;
	DWORD world_count;//???
	DWORD _unk1;
	DWORD timestamp;
	DWORD game_year;
	DWORD game_month;
	DWORD game_day;
	DWORD game_hours;
	DWORD game_minutes;
	DWORD real_year;
	DWORD real_month;
	DWORD real_day;
	DWORD real_dayofweek;
	DWORD real_hour;
	DWORD real_minute;
	DWORD real_second;
	DWORD real_milliseconds;
	DWORD dwSig; //0xBAADF00D
	DWORD isHardcore;
	DWORD dwDifficulty;
	DWORD bronze;
	DWORD silver;
	DWORD gold;
	DWORD platinum;
	DWORD niobe;
	BYTE _unk2[72];
	DWORD hash0;
	DWORD hash1;
	DWORD hash2;
	DWORD hash3;
	DWORD hash4;//(DWORD)(rand() * 0.000030518509 * 9998.0 + 1.0)
	DWORD hash5;
	DWORD _unk3;
};
struct SaveGame_Section //0x0C =12
{
	DWORD dwType;
	DWORD dwOffset;
	DWORD dwSize;
};
enum SaveGame_SectionType
{
	SGST_NORMAL =0x7F,
	SGST_80_ENGINE = 0x80,
	SGST_81_TRIGGERS = 0x81,
	SGST_82_VIEWS = 0x82,
	SGST_83_DESCRIPTION = 0x83,
	SGST_8B_CALENDAR = 0x8B,
	SGST_8D_INVENTORY = 0x8D,
	SGST_8E_ITEMS = 0x8E,
	SGST_91_SCRIPTS = 0x91,
	SGST_92_WEATHER = 0x92,
	SGST_93_PICTURE = 0x93,
	SGST_94_BLOOD = 0x94,
	SGST_95_DATETIME = 0x95,
	SGST_96_PARTICLES = 0x96,
	SGST_98_MOUSE = 0x98,
	SGST_99_REGIONS = 0x99,
	SGST_9A_TEAM = 0x9A,
	SGST_9B_STATS = 0x9B,
	SGST_9C_DIVISIBLE = 0x9C,
	SGST_9D_EMPTY = 0x9D,
	SGST_A0_ITEMS_COMPRESS = 0xA0,
	SGST_A1_SCRIPTS_COMPRESS = 0xA1,
	SGST_A2_PARTICLES_COMPRESS = 0xA2,
	SGST_C0_HERO = 0xC0,
	SGST_C1_INVENTORY = 0xC1,
	SGST_C2 = 0xC2,
	SGST_C3_HERO = 0xC3,
	SGST_C4_STATS = 0xC4,
	SGST_C6_INVENTORY = 0xC6,
	SGST_C7 = 0xC7,
	SGST_C8 = 0xC8,
	SGST_CA = 0xCA,
	SGST_CB = 0xCB,
	SGST_CC_SHADOW = 0xCC,
	SGST_CD = 0xCD,
	SGST_CE = 0xCE,

	SGST_ADDITIONAL =0xDF,
	SGST_E0_DESCRIPTION = 0xE0,
	SGST_E1_REGION_KILL = 0xE1,
};

struct SectionCompress
{
	SaveGame_SectionType from;
	SaveGame_SectionType to;
};

struct SaveHero_Hdr //0x100 =256
{
	char sig[3]; // AMH
	BYTE ver;
	DWORD nSections;
	DWORD nHeroSize;
	DWORD _0[4];
	DWORD nLangNo;
	DWORD nTypeOS;
	DWORD n2;
	DWORD nVersion;
	DWORD _1[53];
};


struct s444_header
{
	char tag[3];
	char bpp;
	DWORD width;
	DWORD height;
	DWORD reserved;
};


struct TGA_FILE_HEADER // =18
{
	BYTE ID_Length;
	BYTE Color_Map_Type;
	BYTE Image_Type;
	WORD First_Entry_Index;
	WORD Color_Map_Length;
	BYTE Color_Map_Entry_Size;
	WORD X_Origin_Image;
	WORD Y_Origin_Image;
	WORD Image_Width;
	WORD Image_Height;
	BYTE Pixel_Depth;
	BYTE Image_Descriptor;
};










////////////////////////////////////////////////////////////////////////////
#pragma pack()
