// granny.h : header file
//



#pragma pack(1)
////////////////////////////////////////////////////////////////////////////
struct D3DMATRIX;


enum Granny_AnimationParameter //GAP
{
	GAP_BEGIN = 0x0,
	GAP_END = 0x1,
	GAP_SPEED = 0x2,
	GAP_LOOPCOUNT = 0x3,
	GAP_WEIGHT = 0x4,
	GAP_EASEINWEIGHT = 0x5,
	GAP_EASEINDURATION = 0x6,
	GAP_EASEOUTWEIGHT = 0x7,
	GAP_EASEOUTDURATION = 0x8,
};


typedef DWORD HGRANNY;

struct Debuger //0x34 =52
{
	DWORD _01;
	DWORD dwErrCount;
	DWORD dwLastResult;
	DWORD dwLastError;
	DWORD dwNumberOfCalls;
	DWORD dwNumberOfErrors;
	DWORD dwFlags;
	char* szErrorCodeTable;
	FILE* file;
	DWORD dwAllDataSize;
	DWORD _11;
	DWORD _12;
	DWORD _13;
	DWORD _14;
	DWORD _15;
	DWORD _16;
	DWORD _17;
};

struct TypeInfoEntr
{
	char* szType;
	DWORD dwSize;
	DWORD dwInOut;
};

struct TypeInfo
{
	Debuger* pDebuger;
	char* szFunction;
	DWORD dwCounter;
	TypeInfoEntr tie[16];
};

struct Filesytem // =24
{
	void* pfnFilesytem;
	HGRANNY hGranny;
	int (__stdcall *pfnOpenFileCallback)(int, char *szFileName, HGRANNY *pFile);
	int (__stdcall *pfnCloseFileCallback)(int, HGRANNY hFile);
	int (__stdcall *pfnSeekFileCallback)(int, HGRANNY hFile, LONG lDistanceToMove);
	int (__stdcall *pfnReadFileCallback)(int, HGRANNY hFile, DWORD nNumberOfBytesToRead, LPVOID lpBuffer);
};

struct GrannyObject // =
{
	DWORD _1;
	DWORD _2;
	DWORD _3;
	BYTE _0[100];
};

struct GrannyObjectBuf // =12
{
	GrannyObject* buf;
	GrannyObject* start;
	GrannyObject* end;
};

struct GrannyObjectManager //0x270 =624
{
	void* pFunc;
	DWORD t0;
	DWORD t1; //1.0 / Frequency.QuadPart
	DWORD t2;

	DWORD dwFlags;
	BYTE obj1[4];
	BYTE obj2[4];
	BYTE obj3[20];
	BYTE obj4[20];
	BYTE obj5[4];
	BYTE obj6[20];
	BYTE obj7[4];
	BYTE obj8[4];
	BYTE obj9[4];
	BYTE _0[20];
	GrannyObjectBuf gob1;
	GrannyObjectBuf gob2;
	GrannyObjectBuf gob3;
	GrannyObjectBuf gob4;
	GrannyObjectBuf gob5;
	BYTE _1[440];
};


//----------------------------------------------------------------------------------------------------------

struct Seq
{
	float f11;
	float f12;
	float f13;
	float f21;
	float f22;
	float f23;
};
struct GPoint // =12
{
	float x;
	float y;
	float z;
};

struct HMODEL
{
	DWORD hGrannyModelF;
	DWORD hGrannyModelS;
};
struct HSEQUENCE
{
	DWORD hGrannySequenceF;
	DWORD hGrannySequenceS;
};
struct HPOSE
{
	DWORD hGrannyPoseF;
	DWORD hGrannyPoseS;
};
struct HANIMATION
{
	DWORD hGrannyAnimationF;
	DWORD hGrannyAnimationS;
};
struct HRENDERINGLOCK
{
	DWORD hGrannyRenderingLockF;
	DWORD hGrannyRenderingLockS;
};
struct HINTERSECTIONLOCK
{
	DWORD hGrannyIntersectionLockF;
	DWORD hGrannyIntersectionLockS;
};
struct HCONTROL
{
	DWORD hGrannyControlF;
	DWORD hGrannyControlS;
	DWORD hGrannyControlT;
};

struct HINTERSECTION // =40
{
	float Location[3];
	float Normal[3];
	DWORD Side0Type;
	void* Side0;
	DWORD Side1Type;
	void* Side1;
};

typedef DWORD ANIMATIONPARAMETER;
typedef DWORD DEGREESOFFREEDOM;
typedef void* EXTENSIONPOINTER;
typedef DWORD PREFERENCE;
typedef DWORD RENDERINGSTATEPRESENT;
typedef DWORD TEXTUREFORMAT;
typedef DWORD TRANSFORMOPERATION;
typedef DWORD TRANSFORMSTATEPRESENT;

struct HNEWTEXTURE //0x2C =44
{
	HNEWTEXTURE* thiz;
	char* szTgaName;
	DWORD dw1;
	DWORD dw2;
	DWORD dwTexFormat;
	DWORD dwWidth;
	DWORD dwHeight;
	DWORD dwDepth;
	DWORD dwPitch;
	DWORD dwAttachedSurfaceSize;
	BYTE* pTex;
};


struct H_D3DDP_PTRSTRIDE
{
	LPVOID lpvData;
	DWORD  dwStride;
};
struct H_D3DDRAWPRIMITIVESTRIDEDDATA // =96
{
	H_D3DDP_PTRSTRIDE position;
	H_D3DDP_PTRSTRIDE normal;
	H_D3DDP_PTRSTRIDE diffuse;
	H_D3DDP_PTRSTRIDE specular;
	H_D3DDP_PTRSTRIDE textureCoords[8];
};
struct GRANNYRENDERINGARRAY
{
	DWORD LoadArray;
	DWORD Type;
	DWORD Width;
	DWORD Count;
	DWORD StrideInBytes;
	void* Elements;
};
struct HRENDERINGSTATE //0xCC =204
{
	HRENDERINGLOCK rlock;
	HNEWTEXTURE* pNewTex;
	HANDLE hObject;
	RENDERINGSTATEPRESENT StatePresent;
	BOOL TextureIsNew;
	DWORD TextureCookie;
	BOOL LoadTransform;
	D3DMATRIX* pMatTransform;
	D3DMATRIX* pMatMeshIsNew;
	D3DMATRIX* pMatWorld;
	GRANNYRENDERINGARRAY Vertices;
	GRANNYRENDERINGARRAY DiffuseColors;
	GRANNYRENDERINGARRAY SpecularColors;
	GRANNYRENDERINGARRAY TextureCoordinates;
	GRANNYRENDERINGARRAY Normals;
	GRANNYRENDERINGARRAY Indices;
	DWORD SourceBlendingFactor;
	DWORD DestinationBlendingFactor;
	DWORD Reserved_TextureBlendingMode;
	DWORD Reserved_TextureUnit;
};
struct HTRANSFORMSTATE //0xDC =220
{
	HSEQUENCE Sequence;
	DWORD BoneIndex;
	DWORD StatePresent;
	char* Name;
	char* FileName;
	char* Description;
	DWORD ParentBoneIndex;
	float Position[3];
	float OrientationM[3][3];
	float OrientationQ[4];
	float ScaleShearM[3][3];
	float OrientationScaleShearM[3][3];
	float RadialExtent;
	float ABBMinimum[3];
	float ABBMaximum[3];
	float OBBCenter[3];
	float OBBExtents[3];
};



typedef int (__stdcall *CLOSEFILECALLBACK)(int, HGRANNY);
typedef int (__stdcall *OPENFILECALLBACK)(int, char*, HGRANNY*);
typedef int (__stdcall *READFILECALLBACK)(int, HGRANNY, DWORD, LPVOID);
typedef int (__stdcall *SEEKFILECALLBACK)(int, HGRANNY, LONG);


struct GrannySequenceBuf // =12
{
	HSEQUENCE* buf;
	HSEQUENCE* start;
	HSEQUENCE* end;
};

struct PoseBoneScaleShear
{
	float _0[9];
};


#define _HCONTROL(ctrl)			ctrl.hGrannyControlF, ctrl.hGrannyControlS, ctrl.hGrannyControlT
#define _HMODEL(mod)			mod.hGrannyModelS, mod.hGrannyModelF
#define _HANIMATION(anim)		anim.hGrannyAnimationF, anim.hGrannyAnimationS
#define _HSEQUENCE(seq)			seq.hGrannySequenceF, seq.hGrannySequenceS
#define _HPOSE(pos)				pos.hGrannyPoseF, pos.hGrannyPoseS
#define _HRENDERINGLOCK(rck)	rck.hGrannyRenderingLockF, rck.hGrannyRenderingLockS

#define _PCONTROL(ctrl)			ctrl->hGrannyControlF, ctrl->hGrannyControlS, ctrl->hGrannyControlT
#define _PMODEL(mod)			mod->hGrannyModelS, mod->hGrannyModelF
#define _PANIMATION(anim)		anim->hGrannyAnimationF, anim->hGrannyAnimationS
#define _PSEQUENCE(seq)			seq->hGrannySequenceF, seq->hGrannySequenceS
#define _PPOSE(pos)				pos->hGrannyPoseF, pos->hGrannyPoseS
#define _PRENDERINGLOCK(rck)	rck->hGrannyRenderingLockF, rck->hGrannyRenderingLockS

/*
granny                                  HGRANNY
granny_animation						HANIMATION	
granny_animation_parameter              ANIMATIONPARAMETER
granny_bool                             BOOL
granny_close_file_callback              CLOSEFILECALLBACK
granny_control                          HCONTROL
granny_degrees_of_freedom               DEGREESOFFREEDOM
granny_extension_pointer                EXTENSIONPOINTER
granny_intersection                     HINTERSECTION
granny_intersection_lock                HINTERSECTIONLOCK
granny_model                            HMODEL
granny_new_texture                      HNEWTEXTURE
granny_open_file_callback               OPENFILECALLBACK
granny_pose                             HPOSE
granny_preference                       PREFERENCE
granny_read_file_callback               READFILECALLBACK
granny_real32                           float
granny_real32_array                     float*
granny_real64                           double
granny_rendering_lock                   HRENDERINGLOCK
granny_rendering_state                  HRENDERINGSTATE
granny_rendering_state_present          RENDERINGSTATEPRESENT
granny_result                           DWORD
granny_seek_file_callback               SEEKFILECALLBACK
granny_sequence                         HSEQUENCE
granny_string                           char*
granny_texture_format                   TEXTUREFORMAT
granny_transform_operation              TRANSFORMOPERATION
granny_transform_state                  HTRANSFORMSTATE
granny_transform_state_present          TRANSFORMSTATEPRESENT
granny_uint32                           DWORD
granny_uint8                            BYTE
granny_user_data_index                  DWORD

*/

struct HeaderMDL
{
	char header[3];
	BYTE version;
	DWORD dwNumberOfFiles;
	DWORD dwFirstMotion;
	DWORD dwRand1;
	DWORD dwGrannyModelChunkSize;
	DWORD dwOffsetSTAFFle;
	DWORD dwRand2;
	BYTE _0[228];
};

struct EntryMDL
{
	DWORD dwFileType;// 64 = Model, 65 = Motion
	DWORD dwOffset;
	DWORD dwSize;// Must be corrected, see note below
};

// If type == 64 (Models), TRUE_SIZE = (SIZE + 1194) / 2
// For type == 65 (Motions), SIZE don't have to be changed


// MTG_
enum MotionTypeGroup
{
	MTG_NULL,
	MTG_ATTACK,
	MTG_CAST,
	MTG_COMMON,
	MTG_DEFEND,
	MTG_DYING,
	MTG_FIDLE,
	MTG_FUN_IDLE,
	MTG_FWALK,
	MTG_HORSE,
	MTG_IDLE,
	MTG_RUN,
	MTG_SPECIAL,
	MTG_WALK
};
// MTS_
enum MotionTypeSub
{
	MTS_NULL,
	MTS_ATTACK_1H,
	MTS_ATTACK_2H,
	MTS_ATTACK_ARC,
	MTS_ATTACK_AX,
	MTS_ATTACK_BH,
	MTS_ATTACK_CROSSBOW,
	MTS_ATTACK_DAGGER,
	MTS_ATTACK_PISTOLE,
	MTS_ATTACK_SPECIAL,
	MTS_ATTACK_STAFF,
	MTS_ATTACK_SWORD_1H,
	MTS_ATTACK_SWORD_2H,
	MTS_ATTACK_THROW,
	MTS_ATTACK_WEAPON,
	MTS_ATTACK_WHIP,
	MTS_COMMON_PISTOLE,
	MTS_HIT,
	MTS_HORSE_ATTACK,
	MTS_SPECIAL_HHIT,
	MTS_SPECIAL_MGEG,
	MTS_SPECIAL_MULTI,
	MTS_SPECIAL_PISTOLE,
	MTS_TALK
};

struct MotionInfo
{
	int nType;		// MOTION_
	int nGroup;		// MTG_
	int nSub;		// MTS_
	char szType[32];
};


////////////////////////////////////////////////////////////////////////////
#pragma pack()

