// tincat2.h : header file
//

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#pragma pack(1)

enum eTinCatAPIState
{
	TCS_CLASS_INITIALIZED,
	TCS_CALLBACKS_SET,
	TCS_CONNECTED,
	TCS_NETWORK_INITIALIZED,
	TCS_UNDEFINED_4,
	TCS_UNDEFINED_5,
	TCS_UNDEFINED_6,
	TCS_UNDEFINED_7,
	TCS_UNDEFINED_8,
	TCS_UNDEFINED_9,
	TCS_UNDEFINED_10,
	TCS_UNDEFINED_11,
	TCS_UNDEFINED_12,
	TCS_UNDEFINED_13,
	TCS_UNDEFINED_14,
	TCS_UNDEFINED_15,
	TCS_UNDEFINED_16,
	TCS_UNDEFINED_17,
	TCS_UNDEFINED_18,
	TCS_UNDEFINED_19,
	TCS_UNDEFINED_20,
	TCS_UNDEFINED_21,
	TCS_UNDEFINED_22,
	TCS_UNDEFINED_23,
	TCS_UNDEFINED_24,
	TCS_UNDEFINED_25,
	TCS_UNDEFINED_26,
	TCS_UNDEFINED_27,
	TCS_UNDEFINED_28,
	TCS_UNDEFINED_29,
	TCS_UNDEFINED_30,
	TCS_UNDEFINED_31,
};
enum eTinCatAPIErr
{
	ERR_DEBUG,
	ERR_MESSAGE,
	ERR_INFO,
	ERR_WARNING,
	ERR_ERROR,
	ERR_FAILURE,
	ERR_8 = 8,
	ERR_FAILED = 16,
	ERR_64 = 64,
};

struct TinCatAPI;
struct TinCatValue;

struct TinCatAPI_func
{
	void* TINAPI_Free;
	void* FreeAny;
	void* TINAPI_Init;
	void* TINAPI_Removing;
	void* TINAPI_RegisterCallbacks;
	void* TINAPI_10006AA0;
	void* TINAPI_GetNeterrorStr;
	void* TINAPI_10006AC0;
	void* TINAPI_10006AD0;
	void* TINAPI_10007D10;
	void* TINAPI_MessagePollCount_Get;
	void* TINAPI_MessagePollCount_Set;
	void* TINAPI_SetDefValues;
	void* TINAPI_GetDefValues;
	void* TINAPI_NetworkService_Init;
	void* TINAPI_NetwirkService_Remove;
	void* TINAPI_NetworkService_IncomingConnections_Start;
	void* TINAPI_NetworkService_IncomingConnections_Stop;
	void* TINAPI_LOG_Enable;
	void* TINAPI_LOG_Disable;
	void* TINAPI_10007F20;
	void* TINAPI_GetLogDir;
	void* TINAPI_10006B00;
	void* TINAPI_Mode_UserMaxHandling_Get;
	void* TINAPI_Mode_UserMaxHandling_Set;
	void* TINAPI_10006B10;
	void* TINAPI_10006B20;
	void* TINAPI_10006B30;
	void* TINAPI_ConnectToIP;
	void* TINAPI_ConnectToHostname;
	void* TINAPI_ConnectToIP2;
	void* TINAPI_ConnectAsyncToHostname;
	void* TINAPI_100074C0;
	void* TINAPI_Disconnect;
	void* TINAPI_Send_Notify;
	void* TINAPI_100074E0;
	void* TINAPI_10007500;
	void* TINAPI_Send_Data;
	void* TINAPI_10007530;
	void* TINAPI_Send_DataToGroup;
	void* TINAPI_10007570;
	void* TINAPI_SendFile;
	void* TINAPI_Send_Ping;
	void* TINUSR_UserGetIP;
	void* TINAPI_UserLogOut;
	void* TINUSR_User_SendQueue_Clear;
	void* TINUSR_User_SendQueue_GetCount;
	void* TINUSR_User_CustomData_Attach;
	void* TINUSR_User_CustomData_Get;
	void* TINUSR_User_CustomData_Clear;
	void* TINUSR_User_LogNoteText_Attach;
	void* TINUSR_User_LogNoteText_Get;
	void* TINUSR_User_LogNoteText_Clear;
	void* TINUSR_User_GetConnectedCount;
	void* TINUSR_User_GetMax;
	void* TINUSR_User_SetMax;
	void* TINUSR_User_LogOutALL;
	void* TINAPI_10006F30;
	void* TINAPI_10006F60;
	void* TINAPI_BCast_Enable;
	void* TINAPI_10006F80;
	void* TINAPI_BCast_Client_UpdateList;
	void* TINAPI_10006F90;
	void* TINAPI_10006FF0;
	void* TINAPI_10007060;
};
struct TinCatValue_func
{
	void* TINVALUE_Free;
	void* FreeAny;
	void* TINVALUE_InitDefaults;
	void* TINVALUE_SetVars;
	void* TINVALUE_Get_port;
	void* TINVALUE_PortCheck;
	void* TINVALUE_Get_v01;
	void* TINVALUE_Get_usr_max;
	void* TINVALUE_Set_usr_max;
	void* TINVALUE_Get_v23;
	void* TINVALUE_Get_v24;
	void* TINVALUE_Drv_SetWriterTiming;
	void* TINVALUE_Get_drv_writer_sleep;
	void* TINVALUE_Drv_SetReaderTiming;
	void* TINVALUE_Get_drv_reader_sleep;
	void* TINVALUE_Drv_SetServerLoopTiming;
	void* TINVALUE_Get_drv_serverloop_sleep;
	void* TINVALUE_Set_srv_sendlogonrequest;
	void* TINVALUE_Get_srv_sendlogonrequest;
	void* TINVALUE_Set_usr_logoncheck;
	void* TINVALUE_Get_usr_logoncheck;
	void* TINVALUE_Set_srv_checkdeadcon;
	void* TINVALUE_Get_srv_checkdeadcon;
	void* TINVALUE_Set_srv_sendalive;
	void* TINVALUE_Get_srv_sendalive;
	void* TINVALUE_Get_drv_disable_nagle;
	void* TINVALUE_Set_drv_disable_nagle;
	void* TINVALUE_Get_buf_rw;
	void* TINVALUE_Get_buf_writeblock;
	void* TINVALUE_Get_thrd_exit;
	void* TINVALUE_Get_drv_removetime;
	void* TINVALUE_Get_v30;
	void* TINVALUE_Get_v31;
};

struct tcHandle
{
	DWORD state;
	DWORD handle;
};
struct tcOpen
{
	DWORD state;
	DWORD flag;
};
struct tcErrWSA
{
	DWORD herr;
	DWORD error;
	char str[60];
};

struct tcMUTX // =8
{
	DWORD flags;
	HANDLE hMutex;
};
struct tc8388608 //0x800000 =8388608
{
	BYTE _0[8388608];
};
struct tcLOG //0x1A8 =424
{
	DWORD flags;
	tcMUTX* p_Mutex8;
	DWORD _01;
	DWORD _02;
	DWORD fflags;
	char* szLogFile;
	WORD hLogFile;
	BYTE _1[386];
	tc8388608* p_tc8388608;
	BYTE _2[8];
};

struct tcTNSCONTROL //0xC =12
{
	void* pFunc;
	DWORD trilib_required;
	tcLOG* syslog;
};


struct tcPTRARY //0x18 =
{
	void* pFunc;
	BYTE _0[20];
};

struct tcGROUPCTRL;
struct tcGROUP;
struct GROUPCTRL_func
{
	char* (__thiscall* CreateNewGroup)(tcGROUPCTRL*,char*,short,DWORD);
	char* (__thiscall* InsertGroup)(tcGROUPCTRL*,tcGROUP*);
	char* (__thiscall* DeleteGroup)(tcGROUPCTRL*,tcGROUP*,short);
	char* (__thiscall* DeleteGroup2)(tcGROUPCTRL*,int,short);
	char* (__thiscall* SearchGroup)(tcGROUPCTRL*,tcGROUP*);
	char* (__thiscall* SearchGroup2)(tcGROUPCTRL*,DWORD);
	char* (__thiscall* JoinGroup)(tcGROUPCTRL*,int,DWORD);
	char* (__thiscall* LeaveGroup)(tcGROUPCTRL*,int,DWORD);
	char* (__thiscall* GetFirstGroup)(tcGROUPCTRL*);
	char* (__thiscall* GetNextGroup)(tcGROUPCTRL*);
	char* (__thiscall* SendDataToGroup)(tcGROUPCTRL*,struct netdrv_ctrl*,DWORD,DWORD,void *,int);
};
struct tcGROUPCTRL
{
	GROUPCTRL_func* pFunc;
	BYTE _0[12];
};
struct DNameNode
{
	BYTE _0[32];
};
struct tcQListMTX //0x14 =20
{
	BYTE _0[16];
	tcMUTX* mux;
};
struct tcCondata;
struct tcNetDriver;
struct tcData // 0x48 =72
{
	DWORD flags;
	void* besig;// tcBESIG
	HANDLE hThread;
	DWORD dwThreadId;
	tcNetDriver* drvReaderThread;
	BYTE _111[4];
	tcCondata* self1;
	BYTE _114[4];
	tcNetDriver* drvWriterThread;
	BYTE _112[4];
	tcCondata* self2;
	DWORD _113;
	void* p0;
	BYTE _12[4];
	void* EventCtrlData;
	BYTE _2[12];
};
struct tcCondata //0x6C =108
{
	tcMUTX* mux;
	BYTE _01[32];
	tcData data;
};
struct tcDriver // 0xEC =236
{
	tcData data;
	BYTE _32[48];
	BYTE _33[40];
	DWORD dwStackSize_ClientReader;
	DWORD dwStackSize_ClientWriter;
	DWORD dwStackSize_LoopThread;
	BYTE _43[4];
	DNameNode* dname;
	void* userList;// tcUserList;
	void* beid;// tcBEID
	void* call;// tcCALL
	tcLOG* log01;
	tcLOG* log02;
	tcLOG* log03;
	void* net;// tcNET
	BYTE _1[12];
	TinCatAPI* pTinCat;
	tcGROUPCTRL* grpctrl;
	BYTE _2[8];
};
struct tcNetDriver // 0xF8 =248
{
	DWORD flag;
	tcQListMTX* qmtx;
	tcMUTX* mut;
	tcDriver drv;
};
struct tcSYSTEMTIME //0x10 =16
{
	WORD wYear;
	WORD wMonth;
	WORD wDay;
	WORD wHour;
	WORD wMinute;
	WORD wSecond;
	WORD wMilliseconds;
	WORD _0;
};
struct tcTIME // =20
{
	void* pFunc;
	tcSYSTEMTIME m_st;//16
};
struct tc48 //0x30 =48
{
	tcTIME time;
	BOOL isValid;
	DWORD dwTimeStampLo;
	DWORD dwTimeStampHi;
	DWORD dwDateTime;
	tcNetDriver* pNetDriver;
	TinCatAPI* pTinCat;
	DWORD _09;
};
struct tcPROGFLOWNET //0x58 =88
{
	void* pFunc;
	DWORD flags;
	DWORD _01;// tcSTATUS
	DWORD _02;
	DWORD _03;
	DWORD _04;
	DWORD _05;
	DWORD _06;
	DWORD _07;
	DWORD _08;
	tc48 m_tc48;
};

struct TinCatAPI //0x4F4 =1268
{
	TinCatAPI_func* pFunc;
	BYTE _0[4];
	tcTNSCONTROL* tnsc;
	char* szLogDir;
	BOOL isCreateDirectory;
	BYTE _31[16];
	eTinCatAPIState State;
	BYTE _32[4];
	tcNetDriver* netdrv;
	BYTE _33[4];
	tcPROGFLOWNET* pNet;
	BYTE _4[4];
	TinCatValue* p_DefValues;
	TinCatValue* p_RegValues;
	BYTE _5[20];
	BYTE _6[1180]; //DNameNode
};


struct TinCatValue //0x84 =132
{
	TinCatValue_func* pFunc;
	DWORD port;
	DWORD v01;
	DWORD thrd_exit;
	DWORD srv_newconnect;
	DWORD srv_sendlogonrequest;
	DWORD srv_sendlogofftimeout;
	DWORD srv_waitforflags;
	DWORD srv_checkdeadcon;
	DWORD srv_checkdeadcalltime;
	DWORD srv_sendalive;
	DWORD usr_initnew;
	DWORD usr_remove;
	DWORD usr_logoncheck;
	DWORD usr_logofftimeout;
	DWORD drv_reader_sleep;
	DWORD drv_reader_sleep_activate;
	DWORD drv_writer_sleep;
	DWORD drv_writer_sleep_activate;
	DWORD drv_serverloop_sleep;
	DWORD drv_serverloop_sleep_activate;
	DWORD drv_disable_nagle;
	DWORD buf_rw;
	DWORD buf_writeblock;
	DWORD v23;
	DWORD v24;
	DWORD usr_max;
	DWORD v26;
	DWORD v27;
	DWORD v28;
	DWORD drv_removetime;
	DWORD v30;
	DWORD v31;
};


//cons  ??0-@@IAE@XZ
//dest	??1-@@IAE@XZ






////////////////////////////////////////////////////////////////////////////
#pragma pack()
