
#include "../../../defs.h"
#include "../../mod_defs.h"
#include "../../mod_functions.h"
#include "../../mod_variables.h"
////////////////////////////////////////////////////////////////////////////

char g_StringTmp[4];
DWORD gx1 = 0, gy1 = 0, gz1 = 0, gx2 = 0, gy2 = 0, gz2 = 0;

//------------------------------------------------------------------------------------
void Console_PrintA(LPSTR aFormat, ...)
{
	if(strlen(aFormat) <= 0) return;

	LPSTR aString = new char[65536];
	memset(aString, 0, 65536);
	va_list vaArgs;

	va_start(vaArgs, aFormat);
	vsprintf(aString, aFormat, vaArgs);
	va_end(vaArgs);

	cEventUI_String evt;
	g_StringTmp[0] = 0;
	EventUI_String_Init(&evt, UI_CONSOLE_STRING, "UI_WND_CONSOLE", g_StringTmp, aString);
	cKernel* ker = Kernel_Create();
	Kernel_ReceiveEvent(ker, (cEvent*)&evt, 1, 0);
	EventUI2_Destr((cEventUI2*)&evt);

	delete[] aString;
}


//----------------------------------------------------------------------
DWORD g_nnnn = 1, g_iiii = 0, g_mmmm = 100;
float g_ffff = 0.0;


//----------------------------------------------------------------------
DWORD g_K = 0;
double g_dK = 0.0;
//----------------------------------------------------------------------
//
//----------------------------------------------------------------------
BOOL _IsNumCommand(LPSTR szCmdLine, char nCmd)
{
	return szCmdLine[0] == nCmd && (szCmdLine[1] == '-' || is_char(szCmdLine[1], CCM_SPACE) || is_char(szCmdLine[1], CCM_DIGIT));
}
BOOL _IsStrCommand(LPSTR szCmdLine, char nCmd)
{
	return szCmdLine[0] == nCmd && (szCmdLine[1] == '-' || is_char(szCmdLine[1], CCM_SPACE) || is_char(szCmdLine[1], CCM_WORD));
}


//----------------------------------------------------------------------
//
//----------------------------------------------------------------------
int __fastcall TheConsole(FileRam* pFs, int nRez)
{
	int rez = nRez & 0x000000FF;
	char szCmdLine[64];
	int size = pFs->dwFileSize;
	if(size > 63) size = 63;
	strncpy(szCmdLine, (char*)pFs->pBuffer, size);
	szCmdLine[size] = 0;

	//----------------------------------------------------------------------------------------------------------------------- pure
	// Version of pureHD                                               pure
	//----------------------------------------------------------------------
	if(strstr(szCmdLine, "pure"))
	{
		Console_PrintA("\\cFF00A000version of pureHD \\wFF80F000%s", DLL_VERSION);
		rez = 2;// !!!
	}
	//----------------------------------------------------------------------------------------------------------------------- goto
	// Goto                                                        goto X Y
	//----------------------------------------------------------------------
	if(strstr(szCmdLine, "goto"))
	{
		cCreature* pCreat = cObjectManager_GetHero(*g_ObjectManager);
		DWORD x2 = pCreat->_obj.wpos.x;
		DWORD y2 = pCreat->_obj.wpos.y;
		DWORD z2 = pCreat->_obj.wpos.z;
		BOOL is = FALSE;

		char* p0 = szCmdLine + 4;
		skip_spaces(p0);
		if(is_char(p0[0], CCM_DIGIT))
		{
			gx1 = __strtoul(p0);
			skip_spaces(p0);
			if(is_char(p0[0], CCM_DIGIT))
				gy1 = __strtoul(p0);
			skip_spaces(p0);
			if(is_char(p0[0], CCM_DIGIT))
				gz1 = __strtoul(p0);
			gx1 = (DWORD)((double)gx1 * Q5366563 + 0.5);
			gy1 = (DWORD)((double)gy1 * Q5366563 + 0.5);
			is = TRUE;
		}
		if(is && gx1 && gy1)
		{
			gx2 = x2;
			gy2 = y2;
			gz2 = z2;
//			Creature_Teleport(pCreat, (DWORD)((double)gx1 / Q5366563), (DWORD)((double)gy1 / Q5366563), gz1, 1);
			pCreat->_obj.wpos.x = gx1;
			pCreat->_obj.wpos.y = gy1;
			pCreat->_obj.wpos.z = gz1;
		}
		Console_PrintA("\\cFF80F000Teleport: %d %d", gx1, gy1);
		rez = 2;// !!!
	}
	else
	//----------------------------------------------------------------------------------------------------------------------- time
	// Time                                                      time H M S
	//----------------------------------------------------------------------
	if(strstr(szCmdLine, "time"))
	{
		BOOL is = FALSE;
		int hh = 0, mm = 0, ss = 0, tf = 1;

		char* p0 = szCmdLine + 4;
		skip_spaces(p0);
		if(is_char(p0[0], CCM_DIGIT))
		{
			hh = __strtoul(p0);
			skip_spaces(p0);
			if(is_char(p0[0], CCM_DIGIT))
				mm = __strtoul(p0);
			skip_spaces(p0);
			if(is_char(p0[0], CCM_DIGIT))
				ss = __strtoul(p0);
			is = TRUE;
		}
//		if(is)
		{
			cCalendar* cal = cCalendar_Instance();
			cal->time.hours = hh;
			cal->time.minutes = mm;
			cal->time.seconds = ss;
			cal->time.miliseconds = 0;
			cal->timeFactor = (float)tf * 24.0;
		}
		rez = 1;
	}
	else
	//----------------------------------------------------------------------------------------------------------------------- k
	// Test command                                                    k N1
	//----------------------------------------------------------------------
	if(_IsNumCommand(szCmdLine, 'k') || _IsStrCommand(szCmdLine, 'k'))
	{
		char* p0 = szCmdLine + 1;
		skip_spaces(p0);
//		g_K = __hextoul(p0);
		g_K = __strtol(p0);
		g_iiii = g_K;
//		g_dK = __strtod(p0);
		g_ffff = g_dK;


		//ToDo


		rez = 1;
	}
	
	//----------------------------------------------------------------------
	if(rez == 1)
		Console_PrintA("\\wFF00A000OK");
	if(rez == 2) rez = 1;

	//--------------------------------------------
	cFileRam_Destructor(pFs);
	return rez;
}
//----------------------------------------------------------------------
NAKED_FUNC(dw325844, TheConsole_STUB)
{
	call TheConsole
	END_FUNC(dw325844)
}


//----------------------------------------------------------------------
// GAME_VERSION
//----------------------------------------------------------------------
void __stdcall GetVersion_stub(STR_A* str1)
{
	STRA_create(str1);
	STRA_sprintf(str1, GAME_VERSION);
}
DWORD dw121234;
void __NAKED __GetVersion_stub()
{
	__asm
	{
		pop dw121234
		push esi
		call GetVersion_stub;
		jmp dw121234
	}
}
/**/


//----------------------------------------------------------------------
void Install_Console()
{
#ifdef CONSOLE_STUB
	SetNops(R8(Sacred, 00616593), 6); // off /?
	SetNops(R8(Sacred, 006165B7), 6); // off ?
	SetBytes(R8(Sacred, 00616C1A), "8A 44 24 0F 8B D0");
	FillBYTE(R8(Sacred, 00616C25), 0x90, 16);
	call_ref(R8(Sacred, 00616C20), (DWORD)TheConsole_STUB);
#endif

#ifdef NOWIN_NOMOVIE
	SetBytes(R8(Sacred, 00815A4D), "90 90"); // win
	SetBytes(R8(Sacred, 00815A7E), "90 90"); // nomovie
#endif

	SetNops(R8(Sacred, 006AE800), 0x006AE87E - 0x006AE800);
	call_ref(R8(Sacred, 006AE800), (DWORD)__GetVersion_stub);
	SetStringA(R8(Sacred, 009DF524), "\\cFFE0A000pureHD %s", TRUE);

	// version pos
	SetWORD(R8(Sacred, 00759307), SCX - 32);//x
	SetWORD(R8(Sacred, 0075930F), SCY - 22);//y	
	
	// tooltip patch
	SetBytes(R8(Sacred, 0075AD60), "68 01 00 00 00");//UI_Manager::TooltipCreate
	SetBytes(R8(Sacred, 0075ACF8), "68 01 00 00 00");
	SetBytes(R8(Sacred, 0075AD5B), "68 01 00 00 00");
	SetBytes(R8(Sacred, 0075ACF3), "68 01 00 00 00");



}

















