
#include "../../../defs.h"
#include "../../mod_defs.h"
#include "../../mod_functions.h"
////////////////////////////////////////////////////////////////////////////

void Conv_Mouse2World(cWorldView2* wview, int x, int y, cWorldPosition* pos, BOOL isTile)
{
	D3POINT car;
	D3POINT iso;

	car.x = (float)(x - SCX2) * wview->viewFactor + (float)wview->wxx;
	car.y = (float)(y - SCY2) * wview->viewFactor + (float)wview->wyy;
	car.z = 0;
	Conv_Car2Iso(&iso, &car);
	pos->x = (int)iso.x;
	pos->y = (int)iso.y;
	pos->z = 0;
	if(isTile)
		Conv_Iso2Tile(pos, pos);
}
//----------------------------------------------------------------------
void Conv_World2Mouse(cWorldView2* wview, cWorldPosition* pos, BOOL isTile, int* x, int* y)
{
	D3POINT iso = { (float)pos->x, (float)pos->y, (float)pos->z };
	if(isTile)
	{
		iso.x = iso.x * (float)Q5366563 + 0.5;
		iso.y = iso.y * (float)Q5366563 + 0.5;
	}
	D3POINT car;
	Conv_Iso2Car(&car, &iso);
	*x = (int)((float)(car.x - wview->wxx) / wview->viewFactor) + SCX2;
	*y = (int)((float)(car.y - wview->wyy) / wview->viewFactor) + SCY2;
}
//----------------------------------------------------------------------
void Conv_World2Over(cWorldView2* wview, cWorldPosition* pos, BOOL isTile, int vx, int vy, int vcx, int vcy, int* x, int* y)
{
	D3POINT iso = { (float)pos->x, (float)pos->y, (float)pos->z };
	if(isTile)
	{
		iso.x = iso.x * (float)Q5366563 + 0.5;
		iso.y = iso.y * (float)Q5366563 + 0.5;
	}
	D3POINT car;
	Conv_Iso2Car(&car, &iso);
	*x = (int)((float)(car.x - wview->wxx) / 12.0) + vcx / 2 + vx;
	*y = (int)((float)(car.y - wview->wyy) / 12.0) + vcy / 2 + vy;
}



