
#include "../../../defs.h"
#include "../../mod_defs.h"
#include "../../mod_functions.h"
#include "../../mod_variables.h"
////////////////////////////////////////////////////////////////////////////

SettingsConfig g_scfg;
char g_value[256];
cRectangle g_rect;
cPosition g_pos;
cInt2 g_int2;


//------------------------------------------------------------------------
BOOL Cfg_IsParameter(char* buff, char* key)
{
	char* p0 = strstr(buff, key);
	return (p0 != NULL);
}
//------------------------------------------------------------------------
int Cfg_GetInteger(char* buff, char* key, int def)
{
	if(!Cfg_IsParameter(buff, key)) return def;
	char* p0 = strstr(buff, key);
	if(p0)
	{
		p0 += strlen(key);
		skip_spaces(p0);
		if(*p0 == ':') p0++;
		skip_spaces(p0);
		return __strtol(p0);
	}
	return 0;
}
//------------------------------------------------------------------------
DWORD Cfg_GetHex(char* buff, char* key, DWORD def)
{
	if(!Cfg_IsParameter(buff, key)) return def;
	char* p0 = strstr(buff, key);
	if(p0)
	{
		p0 += strlen(key);
		skip_spaces(p0);
		if(*p0 == ':') p0++;
		skip_spaces(p0);
		return __hextoul(p0);
	}
	return 0;
}


//------------------------------------------------------------------------
SettingsConfig::SettingsConfig()
{
	memset(&g_rect, 0, sizeof(cRectangle));
	memset(&g_pos, 0, sizeof(cPosition));
	memset(&g_int2, 0, sizeof(cInt2));
}

//------------------------------------------------------------------------
SettingsConfig::~SettingsConfig()
{
}

//------------------------------------------------------------------------
int SettingsConfig::GetInteger(char* szParam, int nDef)
{
	int v = 0;
	STR_A param, value;
	STRA_create(&param);
	STRA_sprintf(&param, szParam);
	cConfigFile_GetValue(g_ConfigFile, &value, &param);
	if(value.pStr == value.pEnd)
	{
		cConfigFile_SetValue(g_ConfigFile, &param, nDef);
		v = nDef;
	}
	else
	{
		v = atoi(value.pStr);
		STRA_free(&value);
	}
	STRA_free(&param);
	return v;
}
//------------------------------------------------------------------------
char* SettingsConfig::GetString(char* szParam, char* szDef)
{
	g_value[0] = 0;
	STR_A param, value;
	STRA_create(&param);
	STRA_sprintf(&param, szParam);
	cConfigFile_GetValue(g_ConfigFile, &value, &param);
	if(value.pStr == value.pEnd)
	{
		STR_A v;
		STRA_create(&v);
		STRA_sprintf(&v, szDef);
		cConfigFile_SetString(g_ConfigFile, &param, &v);
		strcpy(g_value, szDef);
		STRA_free(&v);
	}
	else
	{
		strcpy(g_value, value.pStr);
		STRA_free(&value);
	}
	STRA_free(&param);
	return g_value;
}
//------------------------------------------------------------------------
cRectangle* SettingsConfig::GetRectangle(char* szParam)
{
	GetString(szParam, "");
	char* p0 = g_value;
	if(*p0)
	{
		sscanf(p0, "%d, %d, %d, %d", &g_rect.x, &g_rect.y, &g_rect.cx, &g_rect.cy);
		return &g_rect;
	}
	return NULL;
}
//------------------------------------------------------------------------
cPosition* SettingsConfig::GetPosition(char* szParam)
{
	GetString(szParam, "");
	char* p0 = g_value;
	if(*p0)
	{
		sscanf(p0, "%d, %d, %d", &g_pos.activate, &g_pos.x, &g_pos.y);
		return &g_pos;
	}
	return NULL;
}
//------------------------------------------------------------------------
cInt2* SettingsConfig::GetInt2(char* szParam)
{
	GetString(szParam, "");
	char* p0 = g_value;
	if(*p0)
	{
		sscanf(p0, "%d, %d", &g_int2.n1, &g_int2.n2);
		return &g_int2;
	}
	return NULL;
}
void SettingsConfig::SetInt2(char* szParam, cInt2* i2)
{
	char str[16];
	sprintf(str, "%d, %d", i2->n1, i2->n2);
	SetString(szParam, str);
}
//------------------------------------------------------------------------
void SettingsConfig::SetInteger(char* szParam, int n)
{
	STR_A param;
	STRA_create(&param);
	STRA_sprintf(&param, szParam);
	cConfigFile_SetValue(g_ConfigFile, &param, n);
	STRA_free(&param);
}
//------------------------------------------------------------------------
void SettingsConfig::SetString(char* szParam, char* szStr)
{
	STR_A param, value;
	STRA_create(&param);
	STRA_create(&value);
	STRA_sprintf(&param, szParam);
	STRA_sprintf(&value, szStr);
	cConfigFile_SetString(g_ConfigFile, &param, &value);
	STRA_free(&param);
	STRA_free(&value);
}

//------------------------------------------------------------------------
// 
//------------------------------------------------------------------------
void __stdcall SettingsConfigBeg()
{
	cConfigFile_Default();
	g_scfg.SetInteger("COMPAT_VIDEO", 1);
	g_scfg.SetInteger("GFX32", 1);
	g_scfg.SetInteger("NETWORK_SPEEDSETTINGS", 1);

	// LANGUAGE
	char* szLang = g_scfg.GetString("LANGUAGE", "");
	*g_nLangNo = g_res.nLangText = GetLanguageNo(szLang);
}
//------------------------------------------------------------------------
DWORD dw373hfh;
void __NAKED SettingsConfigBeg_STUB()
{
	__asm
	{
		pop dw373hfh
		call SettingsConfigBeg
		jmp dw373hfh
	}
}
//------------------------------------------------------------------------
void __stdcall SettingsConfigEnd(STR_W* pDest, int)
{

	//ToDo

	//--------------------------------------------------
	STRW_constructor(pDest, 0);
}
//------------------------------------------------------------------------
DWORD dw7fhryry;
void __NAKED SettingsConfigEnd_STUB()
{
	__asm
	{
		pop dw7fhryry
		push ecx
		call SettingsConfigEnd
		jmp dw7fhryry
	}
}


//------------------------------------------------------------------------
// 
//------------------------------------------------------------------------
void Install_SettingsConfig()
{
	call_ref(R8(Sacred, 00816FC1), (DWORD)SettingsConfigBeg_STUB);
	call_ref(R8(Sacred, 0081726F), (DWORD)SettingsConfigEnd_STUB);

}




//------------------------------------------------------------------------
void PostVirtualKey(BYTE bVirtualKey)
{
	BYTE state[256];
	::GetKeyboardState(state);
//	Log_Msg("  GetKeyboardState: %08X\n", state[bVirtualKey]);

	if(state[bVirtualKey])
	{
		INPUT input;
		memset(&input, 0, sizeof(INPUT));
		input.type = INPUT_KEYBOARD;
		input.ki.wVk = bVirtualKey;
		input.ki.dwFlags = KEYEVENTF_EXTENDEDKEY;
		::SendInput(1, &input, sizeof(INPUT));
		input.ki.dwFlags = KEYEVENTF_EXTENDEDKEY | KEYEVENTF_KEYUP;
		::SendInput(1, &input, sizeof(INPUT));
	}
}
void PostScanKey(BYTE bVirtualKey, BYTE bScanDown, BYTE bScanUp)
{
	BYTE state[256];
	::GetKeyboardState(state);
//	Log_Msg("  GetKeyboardState: %08X\n", state[bVirtualKey]);

	if(state[bVirtualKey])
	{
		INPUT input;
		memset(&input, 0, sizeof(INPUT));
		input.type = INPUT_KEYBOARD;
		input.ki.wScan = bScanDown;
		input.ki.dwFlags = 8;
		::SendInput(1, &input, sizeof(INPUT));
		input.ki.wScan = bScanUp;
		input.ki.dwFlags = 8 | KEYEVENTF_KEYUP;
		::SendInput(1, &input, sizeof(INPUT));
	}
}
