
#include "../../../defs.h"
#include "../../mod_defs.h"
#include "../../mod_functions.h"
#include "../../mod_variables.h"
////////////////////////////////////////////////////////////////////////////


char* g_aString;
wchar_t* g_wString;

//------------------------------------------------------------------------------------------------------------ GetUiTGA
//
//----------------------------------------------------------------------
UiTGA* GetUiTGA(int id)
{
	return (UiTGA*)((DWORD)g_UiTGA_0000 + id * sizeof(UiTGA));
}
//------------------------------------------------------------------------------------------------------------ DrawIcon
//
//----------------------------------------------------------------------
void DrawIcon(int x1, int y1, int nID, float dx, float dy, DWORD color)
{
	UiTGA* ui = GetUiTGA(nID);
	crTexture* ri = cResourceMgr_GetResource(*g_ResourceMgr, ui->dwItem, 0);
	if(ri)
	{
		IDirect3DDevice7** device = (*g_dxDriver7)->device;
		(*device)->SetTexture(device, 0, ri->surf);
		Direct_DrawIcons(*g_dxDriver7,
			x1, y1, x1 + (int)(dx * (float)ui->fcx + 0.5), y1 + (int)(dy * (float)ui->fcy + 0.5),
			color, 0, ui->uv.u0, ui->uv.v0, ui->uv.u1, ui->uv.v1);
	}
}
//------------------------------------------------------------------------------------------------------------ DrawImage
//
//----------------------------------------------------------------------
void DrawImage(int x1, int y1, int icx, int icy, float u0, float v0, float u1, float v1, LPSTR szName)
{
	cTextureLoader* pTp = cTextureLoader_Instance();
	DWORD dwItem = cTextureLoader_GetTextureID(pTp, szName);
	crTexture* ri = cResourceMgr_GetResource(*g_ResourceMgr, dwItem, 0);
	if(ri)
	{
		IDirect3DDevice7** device = (*g_dxDriver7)->device;
		(*device)->SetTexture(device, 0, ri->surf);
		Direct_DrawIcons(*g_dxDriver7, x1, y1, x1 + icx, y1 + icy, 0xFFFFFFFF, 0, u0, v0, u1, v1);
	}
}
//------------------------------------------------------------------------------------------------------------ DrawCross
//
//----------------------------------------------------------------------
void DrawCross(int x, int y, int dd, DWORD color, BOOL isShadow)
{
	int kx1 = x - dd;
	int kx2 = x + dd;
	int ky1 = y - dd;
	int ky2 = y + dd;
	if(isShadow)
	{
		Direct_DrawLine(*g_dxDriver7, kx1+1, ky1, kx2+1, ky2, 0xFF000000);
		Direct_DrawLine(*g_dxDriver7, kx1+1, ky2, kx2+1, ky1, 0xFF000000);
	}
	Direct_DrawLine(*g_dxDriver7, kx1, ky1, kx2, ky2, color);
	Direct_DrawLine(*g_dxDriver7, kx1, ky2, kx2, ky1, color);
}

//------------------------------------------------------------------------------------------------------------ SetUI_Info
//
//----------------------------------------------------------------------
void SetUI_Info(cRectangle* uinf, int x, int y, int cx, int cy)
{
	uinf->x = x;
	uinf->y = y;
	uinf->cx = cx;
	uinf->cy = cy;
}
//------------------------------------------------------------------------------------------------------------ PrintW
// Color in text: "\\cAARRGGBB" -   , "\\wAARRGGBB" -  
//----------------------------------------------------------------------
int PrintW(int x, int y, int nFont, DWORD dwColor, wchar_t* wFormat, ...)
{
	if(wcslen(wFormat) <= 0) return FALSE;

	g_wString[0] = 0;
	va_list vaArgs;

	va_start(vaArgs, wFormat);
	vswprintf(g_wString, wFormat, vaArgs);
	va_end(vaArgs);

	cRectangle uiinf = { x, y, 0, 0 };

	cFontMgr* pFonts = Fonts_Create();
	cFontTTF2* tex = Fonts_GetFont(pFonts, nFont);
	cFontTTF2_DrawTextW(tex, (*g_dxDriver7)->device, &uiinf, g_wString, dwColor, 0);

	return TRUE;
}
//----------------------------------------------------------------------
void PrintRoundW(int x, int y, int ccx, int ccy, float angle, float f0, int nFont, DWORD dwColor, WCHAR* wFormat, ...)
{
	if(wcslen(wFormat) <= 0) return;

	g_wString[0] = 0;
	va_list vaArgs;

	va_start(vaArgs, wFormat);
	vswprintf(g_wString, wFormat, vaArgs);
	va_end(vaArgs);

	cRectangle uiinf = { x, y, ccx, ccy };

	cFontMgr* pFonts = Fonts_Create();
	cFontTTF2* tex = Fonts_GetFont(pFonts, nFont);

	cFontTTF2_QueryStatus(tex, FS_SET_04, 0, f0);
	cFontTTF2_QueryStatus(tex, FS_SET_ANGLE, 0, angle);
	cFontTTF2_DrawTextW(tex, (*g_dxDriver7)->device, &uiinf, g_wString, dwColor, 0x020);
}
//------------------------------------------------------------------------------------------------------------ PrintA
//
//----------------------------------------------------------------------
BOOL PrintA(int x, int y, int nFont, DWORD dwColor, LPSTR aFormat, ...)
{
	if(strlen(aFormat) <= 0) return FALSE;

	g_aString[0] = 0;
	va_list vaArgs;

	va_start(vaArgs, aFormat);
	vsprintf(g_aString, aFormat, vaArgs);
	va_end(vaArgs);

	cRectangle uiinf = { x, y, 0, 0 };

	cFontMgr* pFonts = Fonts_Create();
	cFontTTF2* tex = Fonts_GetFont(pFonts, nFont);
	cFontTTF2_DrawTextA(tex, (*g_dxDriver7)->device, &uiinf, g_aString, dwColor, 0);

	return TRUE;
}
//------------------------------------------------------------------------------------------------------------ GetTextDim
//
//----------------------------------------------------------------------
void GetTextDim(int nFont, wchar_t* pText, SIZE* pDim)
{
	cFontMgr* fnt = Fonts_Create();
	cFontTTF2* pTex = Fonts_GetFont(fnt, nFont);
	pDim->cx = cFontTTF2_GetTextWidthW(pTex, pText);
	pDim->cy = cFontTTF2_GetCharHeight(pTex, 0);
}


//------------------------------------------------------------------------------------------------------------ WorldView2_GetView
//
//----------------------------------------------------------------------
cWorldView2* WorldView2_GetView()
{
//	cEngine* eng = *g_Engine;
//	if(eng) return eng->wview[eng->nWorldView];
//	return NULL;

	cEngine* eng = *g_Engine;
	if(!eng)
	{
		::MessageBox(NULL, "!cEngine", "WorldView2_GetView", MB_OK);
		return NULL;
	}
	if(eng)
	{
		cWorldView2* wv = eng->wview[eng->nWorldView];
		if(wv) return wv;
	}
	::MessageBox(NULL, "!cWorldView2", "WorldView2_GetView", MB_OK);
	return NULL;
}

//------------------------------------------------------------------------------------------------------------ IsInRect
//
//----------------------------------------------------------------------
BOOL IsInRect(int x, int y, int vx, int vy, int vcx, int vcy)
{
	return (x >= vx && x <= vx + vcx && y >= vy && y <= vy + vcy);
}




















