
#include "../../../defs.h"
#include "../../mod_defs.h"
#include "../../mod_functions.h"
#include "../../mod_variables.h"
////////////////////////////////////////////////////////////////////////////

TextResource g_res;
cResourceLoader gres;
BOOL g_isLoadGame = FALSE;
char g_res_path[260];
BOOL added_res = FALSE;
wchar_t g_UserName[64];

//------------------------------------------------------------------------
char* g_langAB[] =
{
//    1     2     3     4     5     6     7     8     9    10    11
	"US", "DE", "FR", "SP", "IT", "PL", "HU", "JP", "VC", "RU", "CZ"
};
//------------------------------------------------------------------------
void _change_text_lang()
{
	g_Loader->pEnts = 0;
	cResourceLoader_Destructor(g_Loader);
	cResourceLoader_Constructor(g_Loader);
	g_Loader->dwSize = gres.dwSize;
	g_Loader->pEnts = gres.pEnts;

	cScriptLoader_Shutdown();
	cScriptLoader_Instance();
	
	ITEM* it = cNetworkManager_Instance();
	if(*g_isNetworkGame)
	{
		cNetworkManager_PlayerDataName(it);
	}
	else
	{
		STR_W wstr1;
		STRW_create(&wstr1);
		STRW_sprintf(&wstr1, g_UserName);
		cScriptLoader_Instance();
		cScriptLoader_SetResourceText(9983 + it->nIeID, wstr1);
	}
}
//------------------------------------------------------------------------
DWORD _get_file_size(FILE* f)
{
	DWORD v2 = ftell(f);
	fseek(f, 0, 2);
	DWORD size = ftell(f);
	fseek(f, v2, 0);
	return size;
}
//------------------------------------------------------------------------
int GetLanguageNo(char* szLangAbbr)
{
	for(int i=0; i<11; i++)
	{
		if(_stricmp(szLangAbbr, g_langAB[i]) == 0) return i;
	}
	return -1;
}
//------------------------------------------------------------------------
TextResource::TextResource()
{
	nLangText = 0;
	g_UserName[0] = 0;

	char sz[260];
	PATHELEMENTS pes;
	::GetModuleFileName(NULL, sz, 260);
	_EcxSplitPath(sz, &pes);
	
	m_ResRoot.Format("%s%sscripts", pes.szDrive, pes.szDir);
	m_nResRootLen = m_ResRoot.GetLength();
	memset(g_res_path, 0, 260);
}
//------------------------------------------------------------------------
TextResource::~TextResource()
{
}
//------------------------------------------------------------------------
BYTE* _load_global_res(char* path, DWORD* size, BOOL isHeapAlloc)
{
	FILE* f = fopen(path, "r+b");
	*size = _get_file_size(f);
	BYTE* buff = NULL;
	if(isHeapAlloc)
		buff = Heap_Alloc(*size, 1);
	else
		buff = new BYTE[*size];
	fread(buff, 1, *size, f);
	fclose(f);
	return buff;
}
//------------------------------------------------------------------------
BOOL CALLBACK ResEnumProc(LPCSTR szFolderPath, int nItem, WIN32_FIND_DATA* pwfd, void* lpParam)
{
	if(added_res) return 0;

	BYTE* buff = NULL;
	char dir[260], fil[260], path[260];
	sprintf(path, "%s\\%s", szFolderPath, pwfd->cFileName);
	strcpy(fil, pwfd->cFileName);
	dir[0] = 0;
	if(g_res.m_nResRootLen < strlen(szFolderPath)) strcpy(dir, szFolderPath + g_res.m_nResRootLen + 1);

	BOOL is1 = (_stricmp(dir, g_langAB[g_res.nLangText]) == 0);
	BOOL isName = (_stricmp(pwfd->cFileName, "global.res") == 0);
	added_res = is1 && isName;
	int prior = 1;

	if(added_res)
	{
		// Validation
		DWORD size = 0;
		buff = _load_global_res(path, &size, FALSE);
		if(!buff) return 0;
		if(size < 4) { prior = 0; goto INVALID; };

		Entries* es = (Entries*)buff;
		if(es->dwEntries)
		{
			int ets = sizeof(Entrie) * es->dwEntries;
			if(size < ets) { prior = 0; goto INVALID; };
			if(size - ets <= 4) { prior = 0; goto INVALID; };
			Entrie* et = es->ent;
			et = &es->ent[es->dwEntries - 1];
			added_res = prior;
			strcpy(g_res_path, path);
		}
	}

INVALID:
	if(buff) delete [] buff;
	return 0;
}

//------------------------------------------------------------------------
int TextResource::EnumFiles(LPCSTR szRootFolder, PFN_ENUMFILESPROC pfnEnumFilesProc, void* lpParam)
{	
	// Root
	EString strPath = szRootFolder;
	strPath += "\\*.*";

	WIN32_FIND_DATA wfd;
	HANDLE hFile;

	// Find first file
	if((hFile = ::FindFirstFile((LPCSTR)strPath, &wfd)) != INVALID_HANDLE_VALUE)
	{
		// Find files
		do
		{
			// Is file finded
			if(!(wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
			{
				// Call user function
				if(pfnEnumFilesProc != NULL) pfnEnumFilesProc(szRootFolder, 0, &wfd, lpParam);
			}
			// Is directory finded
			else
			{
				// Is directory not ..
				if(*wfd.cFileName != '.')
				{
					EString strRootFolder;
					strRootFolder.Format("%s\\%s", szRootFolder, wfd.cFileName);

					// Recursive call
					EnumFiles((LPCSTR)strRootFolder, pfnEnumFilesProc, lpParam);
				}
			}
		}
		while(::FindNextFile(hFile, &wfd));
	}
	// End find
	::FindClose(hFile);
	return 0;
}

//------------------------------------------------------------------------
void __stdcall TheTextResource(cResourceLoader* pGlobRes, char* szResPath)
{
	BYTE* buff;
	DWORD size = 0;
	memset(&gres, 0, sizeof(cResourceLoader));
	added_res = 0;

	g_res.EnumFiles(g_res.m_ResRoot, ResEnumProc, NULL);

	if(added_res)
	{
		buff = _load_global_res(g_res_path, &size, TRUE);
		if(buff)
		{
			Entries* es = (Entries*)buff;
			gres.dwSize = size;
			gres.pEnts = (Entries*)buff;
		}
	}

	if(added_res)
	{
		*g_nLangNo = g_res.nLangText;
		_change_text_lang();
		Log_Msg("LANGUAGE: %s\n", g_langAB[g_res.nLangText]);
		Log_Msg("path: %s\n", g_res_path);
	}
}
//------------------------------------------------------------------------
NAKED_FUNC(dw839982098, TextResource_STUB)
{
	push ecx
	call TheTextResource
	END_FUNC(dw839982098)
}


//------------------------------------------------------------------------
// 
//------------------------------------------------------------------------
void Install_TextResource()
{
	call_ref(R8(Sacred, 0081701B), (DWORD)TextResource_STUB);//fnWinMain
}


