

#include <stdio.h>
#include <stdarg.h>
#include <string.h>

#include "../defs.h"
#include "error.h"
////////////////////////////////////////////////////////////////////////////


//----------------------------------------------------------------------
DWORD g_isActiveLogFile = 1;
static char szLogFile[MAX_PATH] = "";
static BOOL isLogInit = FALSE;
//----------------------------------------------------------------------
DWORD g_isActiveLogServFile = 1;
static char szLogServFile[MAX_PATH] = "";
static BOOL isLogServInit = FALSE;

//----------------------------------------------------------------------
void Log_Initialize()
{
	if(isLogInit) return;
	strcat(szLogFile, LOG_FILE);
	
	FILE* fLog = fopen(szLogFile, "w");
	if(fLog != NULL)
    {
	    fclose(fLog);
	    isLogInit = TRUE;
	}
}

//----------------------------------------------------------------------
void Log_Box(LPCSTR pszFormat, ...)
{
	char buffer[300];
	va_list args;
	va_start(args, pszFormat);
	vsprintf(buffer, pszFormat, args);
	va_end(args);
	Log_Msg(buffer);
	::MessageBox(NULL, buffer, "Info", MB_OK);
}

//----------------------------------------------------------------------
void Log_Msg(LPCSTR pszFormat, ...)
{
	if(!g_isActiveLogFile) return;
	if(!isLogInit) Log_Initialize();

	if(isLogInit)
	{
		va_list args;
		va_start(args, pszFormat);

		FILE* fDebug = fopen(szLogFile, "a");

		if(fDebug != NULL)
		{
			vfprintf(fDebug, pszFormat, args);
			fclose(fDebug);
		}
		else
			isLogInit = FALSE;

		va_end(args);
	}
}

//----------------------------------------------------------------------
void Log_Assert(BOOL isCondition, LPSTR pszLocation, LPSTR pszMessage, int nLine)
{
	if(isCondition)
	{
		Log_Msg("Assertion fail at line %d of %s : %s\n", nLine, pszLocation, pszMessage);
		exit(1);
	}
}


