/*=================================================================
	File created by Yohann NICOLAS.

	Modification of code in memory functions.

=================================================================*/

#include "../defs.h"
#include "ModifMemory.h"
//#include "d2functions.h"



DWORD GetBYTE(DWORD dwPos, BYTE* pVal)
{
	if(::IsBadReadPtr((void*)dwPos, 1))
	{
		Log_Box("ERROR : Read BYTE at %08X", dwPos);
		exit(1);
	}
	*pVal = *(BYTE*)dwPos;
	return dwPos + 1;
}
DWORD GetWORD(DWORD dwPos, WORD* pVal)
{
	if(::IsBadReadPtr((void*)dwPos, 2))
	{
		Log_Box("ERROR : Read WORD at %08X", dwPos);
		exit(1);
	}
	*pVal = *(WORD*)dwPos;
	return dwPos + 2;
}
DWORD GetDWORD(DWORD dwPos, DWORD* pVal)
{
	if(::IsBadReadPtr((void*)dwPos, 4))
	{
		Log_Box("ERROR : Read DWORD at %08X", dwPos);
		exit(1);
	}
	*pVal = *(DWORD*)dwPos;
	return dwPos + 4;
}

DWORD SetBYTE(DWORD dwPos, BYTE nVal)
{
	if(::IsBadWritePtr((void*)dwPos, 1))
	{
		Log_Box("ERROR : Write BYTE to %08X", dwPos);
		exit(1);
	}
	*(BYTE*)dwPos = nVal;
	return dwPos + 1;
}
DWORD SetWORD(DWORD dwPos, WORD nVal)
{
	if(::IsBadWritePtr((void*)dwPos, 2))
	{
		Log_Box("ERROR : Write WORD to %08X", dwPos);
		exit(1);
	}
	*(WORD*)dwPos = nVal;
	return dwPos + 2;
}
DWORD SetDWORD(DWORD dwPos, DWORD nVal)
{
	if(::IsBadWritePtr((void*)dwPos, 4))
	{
		Log_Box("ERROR : Write DWORD to %08X", dwPos);
		exit(1);
	}
	*(DWORD*)dwPos = nVal;
	return dwPos + 4;
}
DWORD SetFLOAT(DWORD dwPos, float nVal)
{
	if(::IsBadWritePtr((void*)dwPos, 4))
	{
		Log_Box("ERROR : Write FLOAT to %08X", dwPos);
		exit(1);
	}
	*(float*)dwPos = nVal;
	return dwPos + 4;
}
DWORD SetDOUBLE(DWORD dwPos, double nVal)
{
	if(::IsBadWritePtr((void*)dwPos, 8))
	{
		Log_Box("ERROR : Write DOUBLE to %08X", dwPos);
		exit(1);
	}
	*(double*)dwPos = nVal;
	return dwPos + 8;
}
DWORD FillBYTE(DWORD dwPos, BYTE nVal, int nCount)
{
	for(int i=0; i<nCount; i++)
		dwPos = SetBYTE(dwPos, nVal);
	return dwPos;
}
DWORD SetBytes(DWORD dwPos, LPSTR szValStr)
{
	char* buf = szValStr;
	while(1)
	{
		skip_spaces(buf);
		if(is_eot(buf)) break;
		BYTE n = __hextoul(buf);
		dwPos = SetBYTE(dwPos, n);
	}
	return dwPos;
}
DWORD SetNops(DWORD dwPos, int nCount)
{
	return FillBYTE(dwPos, 0x90, nCount);
}
DWORD SetStringA(DWORD dwPos, LPSTR str, BOOL isSetNull)
{
	for(int i=0; i<strlen(str); i++)
		dwPos = SetBYTE(dwPos, (BYTE)str[i]);
	if(isSetNull) dwPos = SetBYTE(dwPos, 0);
	return dwPos;
}
/*
DWORD SetRectangle(DWORD dwPos, cRectangle* rc)
{
	dwPos = SetDWORD(dwPos, rc->x);
	dwPos = SetDWORD(dwPos, rc->y);
	dwPos = SetWORD(dwPos, rc->cx);
	dwPos = SetWORD(dwPos, rc->cy);
	return dwPos;
}
*/
DWORD SetRectangle(DWORD dwPos, int nX, int nY, WORD wCx, WORD wCy)
{
	dwPos = SetDWORD(dwPos, nX);
	dwPos = SetDWORD(dwPos, nY);
	dwPos = SetWORD(dwPos, wCx);
	dwPos = SetWORD(dwPos, wCy);
	return dwPos;
}


// yy yy yy yy yy -> E8 xx xx xx xx
void call_ref(DWORD dwAddr, DWORD dwRef, int nCount)
{
	DWORD dwPos = dwAddr;
	dwPos = SetBYTE(dwPos, 0xE8);
	dwPos = SetDWORD(dwPos, dwRef - dwPos - 4);
	if(nCount) SetNops(dwPos, nCount);
}
// yy yy yy yy yy yy (FF 15 xx xx xx xx) -> E8 xx xx xx xx 90
void call_dsf(DWORD dwAddr, DWORD dwRef)
{
	call_ref(dwAddr, dwRef);
	SetBYTE(dwAddr + 5, 0x90);
}
// jmp xx xx xx xx
// j(c) xx xx xx xx
void jmp_near_ref(DWORD dwAddr, DWORD dwRef, BYTE nCond)
{
	DWORD dwPos = dwAddr;
	BYTE nCommand = (nCond > _j) ? 0x0F : 0xE9;
	dwPos = SetBYTE(dwPos, nCommand);
	if(nCond > _j) dwPos = SetBYTE(dwPos, nCond);
	dwPos = SetDWORD(dwPos, dwRef - dwPos - 4);
}
// jmp xx
// j(c) xx
void jmp_short_ref(DWORD dwAddr, DWORD dwRef, BYTE nCond)
{
	DWORD dwPos = dwAddr;
	BYTE nCommand = (nCond > _j) ? nCond - 0x10 : 0xEB;
	dwPos = SetBYTE(dwPos, nCommand);
	dwPos = SetBYTE(dwPos, (BYTE)(dwRef - dwPos - 1));
}

