// ModifMemory.h : header file
//

#ifndef __MODIFMEMORY_H__
#define __MODIFMEMORY_H__
#pragma once
////////////////////////////////////////////////////////////////////////////


DWORD GetBYTE(DWORD dwPos, BYTE* pVal);
DWORD GetWORD(DWORD dwPos, WORD* pVal);
DWORD GetDWORD(DWORD dwPos, DWORD* pVal);

DWORD SetBYTE(DWORD dwPos, BYTE nVal);
DWORD SetWORD(DWORD dwPos, WORD nVal);
DWORD SetDWORD(DWORD dwPos, DWORD nVal);
DWORD SetFLOAT(DWORD dwPos, float nVal);
DWORD SetDOUBLE(DWORD dwPos, double nVal);

DWORD FillBYTE(DWORD dwPos, BYTE nVal, int nCount);
DWORD SetBytes(DWORD dwPos, LPSTR szValStr);

DWORD SetNops(DWORD dwPos, int nCount = 5);
DWORD SetStringA(DWORD dwPos, LPSTR str, BOOL isSetNull);
//DWORD SetRectangle(DWORD dwPos, cRectangle* rc);
DWORD SetRectangle(DWORD dwPos, int nX, int nY, WORD wCx, WORD wCy);



					//-------+-------------+----+-------------+-------------------------------------------+----------------+
					//       | near        |    | short       |                                           |                |
					//-------+-------------+----+-------------+-------------------------------------------+----------------+
#define _j   0x00	// E9    | jmp         | EB | jmp         |                         |                |
#define _jo  0x80	// 0F 80 | jo          | 70 | jo          |                           | OF=1           |
#define _jno 0x81	// 0F 81 | jno         | 71 | jno         |                            | OF=0           |
#define _jb  0x82	// 0F 82 | jc/jnae/jb  | 72 | jc/jnae/jb  |  /    / | CF=1           |
#define _jnb 0x83	// 0F 83 | jnc/jae/jnb | 73 | jnc/jae/jnb |  /  /    | CF=0           |
#define _jz  0x84	// 0F 84 | jz/je       | 74 | jz/je       |                               | ZF=1           |
#define _jnz 0x85	// 0F 85 | jnz/jne     | 75 | jnz/jne     |                           | ZF=0           |
#define _jbe 0x86	// 0F 86 | jna/jbe     | 76 | jna/jbe     |  /                      | CF=1  ZF=1  |
#define _ja  0x87	// 0F 87 | ja/jnbe     | 77 | ja/jnbe     | /                       | CF=0  ZF=0    |
#define _js  0x88	// 0F 88 | js          | 78 | js          |   1                              | SF=1           |
#define _jns 0x89	// 0F 89 | jns         | 79 | jns         |   0                              | SF=0           |
#define _jp  0x8A	// 0F 8A | jp          | 7A | jp          |                    | PF=1           |
#define _jnp 0x8B	// 0F 8B | jnp         | 7B | jnp         |                  | PF=0           |
#define _jl  0x8C	// 0F 8C | jl/jnge     | 7C | jl/jnge     | /                   | SF?OF          |
#define _jge 0x8D	// 0F 8D | jge/jnl     | 7D | jge/jnl     |   /                 | SF=OF          |
#define _jle 0x8E	// 0F 8E | jle/jng     | 7E | jle/jng     |   /                 | ZF=1  SF?OF |
#define _jg  0x8F	// 0F 8F | jg/jnle     | 7F | jg/jnle     | /                   | ZF=0  SF=OF   |
					//       |             | E3 | jcxz/jecxz  |  cx/ecx                | cx/ecx=0       |
					//-------+-------------+----+-------------+-------------------------------------------+----------------+
					// E8    | call        |
					// FF15  | call ds:    |
					//-------+-------------+
#define _jecxz 0xE3
#define _jnae _jb
#define _jc   _jb
#define _jnc  _jnb
#define _jae  _jnb
#define _je   _jz
#define _jne  _jnz
#define _jna  _jbe
#define _jnbe _ja
#define _jnge _jl
#define _jnl  _jge
#define _jng  _jle
#define _jnle _jg

void jmp_near_ref(DWORD dwAddr, DWORD dwRef, BYTE nCond = _j);
void jmp_short_ref(DWORD dwAddr, DWORD dwRef, BYTE nCond = _j);
void call_ref(DWORD dwAddr, DWORD dwRef, int nCount = 0);
void call_dsf(DWORD dwAddr, DWORD dwRef);














extern void* currentMemoryPos;


DWORD mem_seek(DWORD newPos);
void memt_byte(BYTE old, BYTE val);
void memt_dword(DWORD old, DWORD val);
void memt_ref4(DWORD old, DWORD ref);
void memj_ref4(DWORD old, DWORD ref);
void memc_ref4(DWORD old, DWORD ref);
void memd_ref4(DWORD old, DWORD ref);

#define MEMT_DWORD(O, R) memt_dword((DWORD)(O), (DWORD)(R))
#define MEMT_REF4(O, R) memt_ref4((DWORD)(O), (DWORD)(R))
//CALL <JMP.&D2gfx.#10047>
#define MEMJ_REF4(O, R) memj_ref4((DWORD)(O), (DWORD)(R))
//CALL D2Common.6FD5F500
#define MEMC_REF4(O, R) memc_ref4((DWORD)(O), (DWORD)(R))
//CALL DWORD PTR DS:[<&USER32.GetKeyState>]
#define MEMD_REF4(O, R) memd_ref4((DWORD)(O), (DWORD)(R))


void patchMemory1(BYTE value);
void patchMemory4(DWORD value);
BYTE getMemory1(LPVOID mempos);
DWORD getMemory4(LPVOID mempos);
bool testIfAlreadySet(DWORD current, DWORD wanted);
void testMemory4(DWORD old, DWORD found);


////////////////////////////////////////////////////////////////////////////
#endif // __MODIFMEMORY_H__

