#include "stdafx.h"

#include "resource.h"
#include "defs.h"
#include "Mod/mod_libraries.h"
#include "Mod/mod_variables.h"
#include "Mod/mod_functions.h"
#include "Mod/Game/Patch/patch.h"

//----------------------------------------------------------------------
DWORD g_dwVersion;
char g_module_path[260];
char g_capture_path[260];
HMODULE g_hInstance;

//----------------------------------------------------------------------
DWORD g_dwVersionServ;
char g_path_tmp[260];
HANDLE g_hBmpPHD = NULL;

//----------------------------------------------------------------------
char* GetModulePath()
{
	PATHELEMENTS pes;
	::GetModuleFileName(NULL, g_path_tmp, 260);
	_EcxSplitPath(g_path_tmp, &pes);
	sprintf(g_path_tmp, "%s%s", pes.szDrive, pes.szDir);
	return g_path_tmp;
}


//----------------------------------------------------------------------
BOOL WINAPI DllMain(HMODULE hInstance, DWORD reason, VOID* reserved)
{
	switch(reason)
	{
		case DLL_PROCESS_ATTACH:
		{
			g_hInstance = hInstance;
			return TRUE;
		}
		case DLL_PROCESS_DETACH:
		{
			return TRUE;
		}
	}
	return TRUE;
}


//----------------------------------------------------------------------
// 
//----------------------------------------------------------------------
void GlobalBuffers_Alloc()
{
	g_wszBufferService = new wchar_t[8192];
	g_szBufferService = new char[8192];

	g_aString = new char[65536];
	g_wString = new wchar_t[65536];

}
void GlobalBuffers_Free()
{
	delete [] g_wszBufferService;
	delete [] g_szBufferService;

	delete [] g_aString;
	delete [] g_wString;

}

//----------------------------------------------------------------------
// 
//----------------------------------------------------------------------
extern "C" DWORD __stdcall Imp01(LPSTR lpModuleName)
{
	g_dwVersion = ::GetVersion();

	//------------------------------------------------
	::GetModuleFileName(NULL, g_capture_path, 260);
	strcpy(g_module_path, GetModulePath());

	//------------------------------------------------
	g_hBmpPHD = ::LoadImage(g_hInstance, (LPCTSTR)BMP_PUREHD, 0, 0, 0, LR_CREATEDIBSECTION);

	//------------------------------------------------ HD1366
	sprintf(g_capture_path, "%s%s", g_module_path, "Settings.cfg");
	FILE* f = fopen(g_capture_path, "rt");
	if(f)
	{
		int size = _get_file_size(f);
		char* buff = new char[size + 1];
		fread(buff, 1, size, f);
		buff[size] = 0;

		g_scx = Cfg_GetInteger(buff, "WINDOW_WIDTH", 1366);
		g_scy = Cfg_GetInteger(buff, "WINDOW_HEIGHT", 768);
		
		delete [] buff;
		fclose(f);

		Log_Msg("WINDOW_WIDTH: %d\n", g_scx);
		Log_Msg("WINDOW_HEIGHT: %d\n", g_scy);
	}

	if(g_scx < 1024) g_scx = 1024;
	if(g_scy < 720) g_scy = 720;
	if(g_scx > 1920) g_scx = 1920;
	if(g_scy > 1080) g_scy = 1080;

//	g_scx = 1024;
//	g_scy = 720;


	//------------------------------------------------ create Capture folder
	sprintf(g_capture_path, "%s%s", g_module_path, "Capture");
	if(!_EcxIsDirectoryExist(g_capture_path))
		::CreateDirectory(g_capture_path, NULL);

	//------------------------------------------------
	PATHELEMENTS pes;
	::GetModuleFileName(NULL, g_capture_path, 260);
	_EcxSplitPath(g_capture_path, &pes);
	sprintf(GetGameLibStr(0), "%s.exe", pes.szFile);
//	Log_Msg("%s\n", GetGameLibStr(0));
//	Log_Msg("%s\n", GetGameLibStr(1));
//	Log_Msg("%s\n", GetGameLibStr(2));

	//------------------------------------------------
	static BOOL isInstalled = FALSE;
	if(isInstalled) return NULL;
	isInstalled = TRUE;

	//------------------------------------------------
	_Lib_LoadGameLibraries();
	if(!InitGameVariables()) return NULL;
	if(!InitGameFunctions()) return NULL;

	//------------------------------------------------
	_Lib_HookGameLibraries(TRUE);
	GlobalBuffers_Alloc();

	//------------------------------------------------
	Install_ScreenDimensions(g_scx, g_scy);
	Install_Errors();
	Install_SettingsConfig();
	Install_TextResource();
	Install_HD1366();//-30
	Install_UI();//-40
	Install_Event();
	Install_Console();
	Install_SysInfo();//-30
	Install_OnXXX();

	
	//------------------------------------------------
	_Lib_UnhookGameLibraries(TRUE);
	return g_dwVersion;
}

//----------------------------------------------------------------------
// 
//----------------------------------------------------------------------
extern "C" void __stdcall Imp02()
{
	GlobalBuffers_Free();
	_Lib_FreeGameLibraries();

	if(g_hBmpPHD) ::DeleteObject(g_hBmpPHD);
}

