// struct.h : header file
//

#include <stdio.h>


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#include "enum.h"
#include "enum-event.h"
#include "enum-types.h"
#include "mss.h"
#include "sfx.h"
#include "granny.h"
#include "direct3d.h"
#include "virtual.h"
#include "ff.h"
#include "tincat2.h"
#include "xml.h"

#pragma pack(1)
////////////////////////////////////////////////////////////////////////////
#define __thiscall
struct InterpretSQW;
struct cMSS;
struct User;
struct cCreature;
struct Granny;
struct GrannyModelManager;
struct cUI_NetGranny;
struct cCreatureHero;
struct cFontTTF2;
struct cObject;
struct Scripter;
struct FileRam;
struct cEventUI2;
struct Event3;
struct cEventKey;
struct cWorld;
struct cWorldView2;
struct sWeaponInfo;
struct UI_Window;
struct sUI_TabControl;
struct cUI_Tooltip;
struct Inventory;
struct cInventoryEntry;
// DirectX 7
struct IDirectDraw7;
struct IDirect3D7;
struct IDirectDrawSurface7;
struct IDirect3DDevice7;
struct DDSURFACEDESC2;
struct DDBLTFX;
struct DDSCAPS2;
struct D3DRECT;
struct D3DMATRIX;
struct FontFS;
struct UiTGA;
struct cSector;
struct crTexture;
struct cSectorEnvironment;
struct ResItemFunc;
struct cFileMemoryMapped;
struct cDxDevice;
struct dxDriver7;
struct cSubject;
struct cMagicEntry;
struct cKernelListener;


//----------------------------------------------------------------------
//    (binary search tree, BST)
//----------------------------------------------------------------------
struct BST_pair
{
	DWORD key;
	DWORD ptr;
};
struct BST_base //0x18 =24
{
	DWORD data;
	BST_base* parent;
	BST_base* left;
	BST_base* right;
};
struct BST_node //0x18 =24
{
	BST_base base;
	BST_pair value;
};
struct BST_result
{
	BST_node* node;
	BOOL res;
};
struct BST_iterator
{
	BST_node* lower;
	BST_node* upper;
};
struct BST_tree //0xC =12
{
	BST_node* root;
	DWORD node_count;
	DWORD key_compare;
};
struct BST//0xC
{
	BST_node* m_data;
};
//----------------------------------------------------------------------


struct UI_names
{
	char oldName[32];
	char newName[32];
};

struct cWorldPosition//16
{
	DWORD map;
	int x;
	int y;
	DWORD z;
};

struct cMutex
{
	CRITICAL_SECTION cs;
};

struct cDX7RenderState// =8
{
	IDirect3DDevice7** device;
	DWORD curStates;
};

// formal structures
struct SBuffer//0xC =12
{
	char* buf;
	char* end;
	char* aft;
};
struct stru16//0x10 =16
{
	DWORD _0[4];
};
struct stru8
{
	DWORD dw1;
	DWORD dw2;
};
struct stru8_vector//0xC =12
{
	stru8* buf;
	stru8* end;
	stru8* aft;
};

struct SortSP
{
	int x;
	int y;
	int gr;
	int isEnemy;
	int dt;
	int flags;
	int Group;
	eItemType type;
	DWORD Weapon;
	DWORD Shield;
	DWORD Armor;
};
struct SortSP_vector//0xC =12
{
	SortSP* buf;
	SortSP* end;
	SortSP* aft;
};

struct sEnemySetup
{
	eItemType e[20];
	int eu;
	int su;
	int w;
	int wc;
	int s;
	int sc;
	int a;
	int ac;
	int dmg;
	DWORD Res;
	DWORD Spell[10];
};
struct sEnemySetup_vector//0xC =12
{
	sEnemySetup* buf;
	sEnemySetup* end;
	sEnemySetup* aft;
};

struct TypePrio
{
	eItemType type;
	DWORD level;
	BOOL isEnemy;
};

struct cWalkMap
{
	char sig[4];
	int map_size;
	int pack_size;
	int tx0;
	int tx1;
	int ty0;
	int ty1;
	char sig2[4];
	BYTE* map;
};


struct cTeamMgr //0x4C =76
{
	char byTeamID[16];
	char byInviter[16];
	char byInvited[16];
	WORD wIgnoreChatBitmask;
	BYTE _0[18];
	DWORD _1;
	DWORD _2;
};



struct DWORD_vector// =12
{
	DWORD* buf;
	DWORD* end;
	DWORD* aft;
};

struct STR_W // =12
{
	wchar_t* pStr;
	wchar_t* pEnd;
	wchar_t* pAft;
};
struct STR_A // =12
{
	char* pStr;
	char* pEnd;
	char* pAft;
};

struct TooltipBuf
{
	cUI_Tooltip** pBeg;
	cUI_Tooltip** pEnd;
	cUI_Tooltip** pAft;
};


struct TexUV // =16
{
	float u0;
	float v0;
	float u1;
	float v1;
};
struct sUV // =8
{
	float u;
	float v;
};
struct Vertex1 //0x20 =32
{
	float x; // screen position
	float y; // screen position
	float z; // Z-buffer depth
	float rhw; // reciprocal homogeneous W
	DWORD dwDiffuseRGBA; // diffuse color
	DWORD dwSpecularRGBA; // specular color
	float u; // texture coordinates
	float v; // texture coordinates
};

struct Square // =128  32*4
{
	Vertex1 v[4];
};

struct VersionInf//0x44
{
	DWORD isInitSystemParams;
	DWORD dwForegroundLockTimeout;
	BYTE isScreenSaveActive;
	BYTE isPowerOffActive;
	WORD isStickyKeys;
	STICKYKEYS StickyKeys;
	DWORD isToggKeys;
	TOGGLEKEYS ToggKeys;
	DWORD isFilterKeys;
	FILTERKEYS FilterKeys;
	DWORD dwVersion1;
	DWORD dwVersion2;
};

struct sSaveInfoData
{
	WORD fxFlags;
	WORD fxFire;
	WORD fxGift;
	WORD fxGlow;
	DWORD reserved;
};
struct sSaveInfo
{
	DWORD hLvl;
	DWORD hType;
	char hName[128];
	DWORD numTypes;
	DWORD types[24];
	char gameLevs[7];
	char gameHardcore;
	DWORD reserved[6];
	sSaveInfoData fxTypes[24];
};

struct sDamageParams
{
	eItemType type;
	DWORD Wref;
	DWORD Aref;
	WORD dmgPhysical;
	WORD dmgFire;
	WORD dmgMagical;
	WORD dmgPoison;
	DWORD res1;
	DWORD res2;
	float multip;
};

struct GameEnd
{
	WORD dwFlags;
	DWORD _2;
	HWND hWnd;
};

struct cLogWindow // 0x24 =36
{
	void* vfptr;
	HINSTANCE m_hInstance;
	HWND m_hParentWnd;
	HWND m_hWnd;
	HWND m_hLogWindow;
	HMODULE m_Module;
	FILE* logFp;
	int sizeX;
	int sizeY;
};

struct sSpellEntry//0x16 =22
{
	eSType type;
	WORD spellid;
	char spelllevel[2];
	WORD flags;
	float timerMax;
	float timerFactor;
	float timer;
};
struct sSpellEntry_vector// =12
{
	sSpellEntry* buf;
	sSpellEntry* end;
	sSpellEntry* aft;
};



struct cSpell
{
	DWORD dwClass;
	DWORD dwSpell;
	DWORD dwValue;
};

struct cSpell_vector // =12
{
	cSpell* buf;
	cSpell* end;
	cSpell* aft;
};


/////////////////////////////////////////////////////////////////////////////////


struct WndImmFunc
{
	void* fncWndImm_Free;
	void* fncWndImm_ret1;
	void* fncWndImm_nullsub;
	void* fncWndImm_ReleaseContext;
	void* fncWndImm_SelectCandidateStr;
	void* fncWndImm_SetCompositionStringW;
	void* fncWndImm_CompositionStr_Clear;
	void* fncWndImm_CloseCandidateList;
	void* fncWndImm_SetCompStrAsResultStr;
	void* fncWndImm_80BA30;
	void* fncWndImm_OpenCloseIME;
	void* fncWndImm_IsOpen;
	void* fncWndImm_590FF0;
	void* fncWndImm_80BCC0;
	void* null;
};

struct WndImm // 0xBC
{
	WndImmFunc* pFuncTable;
	BYTE _q0[4];
	STR_W composition_string;
	DWORD dwPos;
	STR_W reading_string;
	DWORD dwFlag;
	STR_W result_string;
	STR_W result_reading_string;
	BYTE list[32];
	HWND hWnd;
	BYTE _010[8];
	DWORD dwImmProperty;
	BYTE _0110[1];
	BYTE isOpen;
	BYTE _a0[2];
	STR_W attribute;
	STR_W clause;
	STR_W read_clause;
	STR_W read_attribute;
	STR_W result_clause;
	STR_W result_read_clause;
};



///////////////////////////////////////////////////////////////////////////////// events - begin
struct cEvent // =4
{
	AVcEvent* pFunc;
};
//----------------------------------------------------------------------
// 0.0, cEventIdle << cEvent
//----------------------------------------------------------------------
struct cEventIdle // =4
{
	AVcEventIdle* pFunc;
};
//---------------------------------------------------------------------- WM_MOUSEMOVE
// 1.0, cEventMouseMove << cEvent
//----------------------------------------------------------------------
struct cEventMouseMove //0x14 =20
{
	AVcEventMouseMove* pFunc;
	POINT pt1;
	POINT pt2;
};
//----------------------------------------------------------------------
// 2.0, cEventMouseButtonDown << EventMouseButton << cEvent
//----------------------------------------------------------------------
struct cEventMouseButtonDown //0x14 =20
{
	AVcEventMouseButtonDown* pFunc;
	cEventMouseButtonType dwEvent;
	POINT pt;
	WORD wDeltaWheel;
	WORD isDbClk;
};
//----------------------------------------------------------------------
// 3.0, cEventMouseButtonUp << EventMouseButton << cEvent
//----------------------------------------------------------------------
struct cEventMouseButtonUp //0x14 =20
{
	AVcEventMouseButtonUp* pFunc;
	cEventMouseButtonType dwEvent;
	POINT pt;
	WORD wDeltaWheel;
	WORD isDbClk;
};
//----------------------------------------------------------------------
// 4.0, cEventKey << cEvent
//----------------------------------------------------------------------
struct cEventKey // 0xC =12 /keybrd
{
	AVcEventKey* pFunc;
	WORD dwEvent;
	WORD wVirtKey1;
	WORD wVirtKey2;
	WORD wControl;
};
struct EventKeyInfo
{
	cEventKey* pEventKey;
	UINT nMsg;
	DWORD isActive;
};
//----------------------------------------------------------------------
// 5.16, cEventUI2 << cEvent
//----------------------------------------------------------------------
struct cEventUI_sr
{
	char sender[32];
	char receiver[32];
};
struct cEventUI2 // 0x74 =116
{
	AVcEventUI2* pFunc;
	eEventUI dwEvent;
	DWORD dw02;
	eBusyType busy_type;
	DWORD dwPortalsFlag;
	DWORD dwStringID;
	int params1;
	int params2;
	int params3;
	int params4;
	cEventUI_sr sr;
	STR_W wstr;
};
//----------------------------------------------------------------------
// 5.17, cEventUI_String << cEventUI2 << cEvent
//----------------------------------------------------------------------
struct cEventUI_String // 0x174 =372
{
	AVcEventUI_String* pFunc;
	eEventUI dwEvent;
	DWORD dw02;
	DWORD dw03;
	DWORD dw04;
	DWORD dwStringID;
	DWORD dw06;
	DWORD dw07;
	DWORD dw08;
	DWORD dw09;
	cEventUI_sr sr;
	STR_W wstr;
	char szText[256];
};
//----------------------------------------------------------------------
// 6.32, EVT_AM_MSG.EST_AM_ENGINE, cEventEngine << cEvent
//----------------------------------------------------------------------
struct cEventEngine // 0x24 =36
{
	AVcEventEngine* pFunc;
	eEventEngine dwEvent;
	DWORD dw2;
	DWORD dw3;
	DWORD dw4;
	DWORD dw5;
	DWORD dw6;
	DWORD dw7;
	char* string;
};
//----------------------------------------------------------------------
// 6.33, cEventTrigger
//----------------------------------------------------------------------
struct cEventTrigger // 0x10 =16
{
	AVcEventTrigger* pFunc;
	DWORD trigger;
	DWORD state;
	DWORD set;
};
//----------------------------------------------------------------------
// 6.34, cEventObject
//----------------------------------------------------------------------
struct cEventObject // 0x48 =72
{
	AVcEventObject* pFunc;
	eEventObject est;
	DWORD refSender;
	DWORD refReceiver;
	DWORD params[14];
};
//----------------------------------------------------------------------
// 6.36, cEventWeather
//----------------------------------------------------------------------
struct cEventWeather // 0x2C =44
{
	AVcEventWeather* pFunc;
	DWORD flags;
	eWeatherType wst;
	DWORD params[8];
};
//----------------------------------------------------------------------
// 6.37, cEventConsole << cEvent
//----------------------------------------------------------------------
struct cEventConsole // 0x208 =520
{
	AVcEventConsole* pFunc;
	DWORD dwEvent;
	char szCommand[512];
};
//----------------------------------------------------------------------
// 7.35, cEventCreature << cEvent
//----------------------------------------------------------------------
struct cEventCreature // 0x44 =68
{
	AVcEventCreature* pFunc;
	eEventCreature cst;
	DWORD refSender;
	DWORD refReceiver;
	DWORD targetRef;
	DWORD params[12];
};
//----------------------------------------------------------------------
// 8.0, cEventFX
//----------------------------------------------------------------------
struct sEventFXData
{
	DWORD spellLevel;
	DWORD param1;
	D3DVECTOR vec1;
	D3DVECTOR vec2;
	float DmgBonusMa;
	float DmgBonusGi;
	float DmgBonusFe;
	float DmgBonusPh;
	float BonusMa;
	cMagicEntry* magicEntry;
};
struct cEventFX // 0x7C =124
{
	AVcEventFX* pFunc;
	DWORD fxtype;
	DWORD casterref;
	DWORD destref;
	cWorldPosition wpos;
	D3DVECTOR pos3d;
	D3DVECTOR direction;
	DWORD param1;
	DWORD param2;
	sEventFXData fxData;
	DWORD nwData;
};
//----------------------------------------------------------------------
// 9.0, cEventArrow
//----------------------------------------------------------------------
struct cEventArrow //0x5C
{
	AVcEventArrow* pFunc;
	DWORD arrowType;
	DWORD bowType;
	DWORD action;
	DWORD senderRef;
	DWORD targetRef;
	DWORD bowRef;
	D3DVECTOR position;
	D3DVECTOR orientation;
	float speed;
	DWORD smLevel;
	DWORD params[8];
};
//----------------------------------------------------------------------
// 10.0, cEventNetwork
//----------------------------------------------------------------------
struct cEventNetwork //0x6C
{
	AVcEventNetwork* pFunc;
	eEventNetworkType msgType;
	DWORD params[13];
	STR_W wsSessionName;
	STR_W wsPassword;
	STR_W wsUserName;
	DWORD wNumMaxPlayers;
	DWORD byGameMode;
	DWORD byDifficulty;
};
//----------------------------------------------------------------------
// 11.38, cEventProfile
//----------------------------------------------------------------------
struct cEventProfile //0x248
{
	AVcEventProfile* pFunc;
	BYTE _0[580];
};
//----------------------------------------------------------------------
// 12.0, cEventIME
//----------------------------------------------------------------------
struct cEventIME //0x68 =104
{
	AVcEventIME* pFunc;
	eEventSubType m_subType;
	BYTE m_IMData[56];//NA2dLib::tagTypeIMData
	BYTE m_IMCandidateData[32];//NA2dLib::tagTypeIMCandidateData
	WORD m_key;
	WORD m_code;
	WORD m_modifier;
	WORD m_keydown;
};
//----------------------------------------------------------------------
struct cEventFactory
{
	BYTE _0;
};


/*
cEventEngine =6.32

dwEvent = 1; EE_SET_ACTIVECREATURE
dw2 = cCreature._obj.self;

dwEvent = 6; EE_DISPLAY_DIGIT
dw2 = 0xFFFFFF20;
dw3 = cCreature.iso.x;
dw4 = cCreature.iso.y;
dw5 = 1071; //TexTGA
dw6 = data;

dwEvent = 11; EE_DISPLAY_TEXT
dw2 = 16;
dw3 = 3; 0x80000003;
dw4 = string: UI_REGION_ANCARIA | UI_REGION_FINALBATTLE;
dw5 = color;

dwEvent = 15; EE_SAVEGAME
dw2 = mode=1,2,3; mode=1- eng->savegameid = dw3; mode=2- ; mode=3- cEngine::CaptureInternal; //GAMEnn.pak
dw3 = savegameid
dw4 = savedescLoka;
dw5 = 1 is cEngine::CaptureInternal
dw6 = 0 is save_descr
dw8 = descr; //char*

dwEvent = 17; EE_TELEPORT
dw3 = cWorldPosition.x; //tile
dw4 = cWorldPosition.y; //tile

dwEvent = 18; EE_RENDERING
dw2 = 1;

dwEvent = 19; EE_SETMODE
dw2 = command: 1=MOVIEMODE+,2=EFLAG_INMODE_OBSERVER,3=MOVIEMODE,4=setFadeMode,5=CaptureInternal
dw3 = param1: 1;
dw4 = param2: 0;

dwEvent = 22; EE_USEPORTAL
dw2 = nTeleportNo; // 0-14: Anc; 15-21: Und;

dwEvent = 23; EE_USEPOTION
dw2 = count;
dw3 = dwEvent == 0;
dw4 = dwEvent == 2;

dwEvent = 24; EE_LIGHTENABLE
dw2 = 1;

dwEvent = 26; EE_JUDGEMENT_DAY
dw2 = cRegionInfo.dwRegionID;
dw3 = cRegionInfo.dwKillCurr;
dw4 = cRegionInfo.dwKillMax;

*/

/*
cEventCreature =7.35
  
dwType = ACTION_AUTO_COLLECT; //PickUp
dw3 = ITEM.nIeID;

cst = ACTION_SPELL_CAST;
targetRef = cCreature->_obj.dwObjID; || sEnemyList[0].ref;
params[0] = cCreature->_obj.wpos.map;
params[1] = cCreature->_obj.wpos.x;
params[2] = cCreature->_obj.wpos.y;
params[6] = isMove; // spellID >= 1000;
params[7] = spellID;
params[8] = cCreature->_obj.wpos.z;

cst = ACTION_FIGHT;
params[0] = sEnemyList[0].ref;



*/


///////////////////////////////////////////////////////////////////////////////// events - end



struct TypeDescriptor
{
	void* pVFTable; // vtable of type_info class
	void* spare; // used to keep the demangled name returned by type_info::name()
	char name[1]; // mangled type name
};

/////////////////////////////////////////////////////////////////////////////////















struct TimedEvent //0x10 =16
{
	DWORD system;
	DWORD event;
	__int64 nextTimeNotified;
};
struct Vector_TimedEvent //=12
{
	TimedEvent* buf;
	TimedEvent* end;
	TimedEvent* aft;
};
struct cKernelListenerVtbl
{
  char (__thiscall *ReceiveEvent)(cKernelListener*, cEvent*);
};
struct cKernelListener
{
	cKernelListenerVtbl* vfptr;
};
struct Vector_KernelListener //=12
{
	cKernelListener** buf;
	cKernelListener** end;
	cKernelListener** aft;
};


struct cKernel //0x70 =112
{
	DWORD eventsHandled;
	DWORD eventsHandledT;
	cMutex listenersLock;
	Vector_KernelListener listeners;
	DWORD timedEventsQueued;
	cMutex timedEventsLock;
	Vector_TimedEvent newTimedEvents;

	cEventKey* evt4_Beg;
	cEventKey* evt4_End1;
	cEventKey* evt4_End2;

	Vector_TimedEvent timedEvents;//priority_queue
	DWORD dw16;
};

// fnCon_Engine <= 00619B94:sub_618410 <= 00808BB2:fncKernel_ReceiveEvent <= 006AE3A2:sub_6AE0F0 <= 00757A1B:sub_757530
// <= 00618A49:sub_618410 <= 00808990:fncKernel_Update <= 0060F449:sub_60F420 <= 0060E9BA:fncEngine_ThreadFuncA

//---------------------------------------
struct FileRamFunc
{
	void (__thiscall *cFileRam_vecDelDtor)(FileRam* pFs, BYTE isHeapFree);
	DWORD (__thiscall *cFileRam_Read)(FileRam* pFs, void* pDestBuff, DWORD dwCount);
	DWORD (__thiscall *cFileRam_Write)(FileRam* pFs, void* pSrc, DWORD dwCount);
	void (__thiscall *cFileRam_Seek)(FileRam* pFs, int nPos);
	DWORD (__thiscall *cFileRam_GetSize)(FileRam* pFs);
	DWORD (__thiscall *cFileRam_Tell)(FileRam* pFs);
	void (__thiscall *cFileRam_AsyncRead)(FileRam* pFs, void *pDestBuff, DWORD dwCount, void (__cdecl *pFn)(int, int), int a5);
	void (__thiscall *cFileRam_AsyncWrite)(FileRam* pFs, void *pSrc, DWORD dwCount, void (__cdecl *pFn)(int, int), int a5);
};

//---------------------------------------
struct FileDisk //0x08 =8
{
	FileRamFunc* pFunc;
	FILE* file;
};

//---------------------------------------
struct FileRam //0x18 =24
{
	FileRamFunc* pFunc;
	DWORD dwDataSize;
	DWORD dwFileSize;
	DWORD dwPosition;
	BYTE* pBuffer;
	DWORD dwFlags;
};

//---------------------------------------
struct cTextToken //0x10 =16
{
	int nType;
	STR_A str;
};
//---------------------------------------
struct FileScriptBuffer //0x18 =24 
{
	cTextToken sb;
	Scripter* pScr;
	LPSTR pBuffer;
};
//---------------------------------------
struct FileScript //0x20 =32
{
	FileDisk file;
	FileScriptBuffer fsb;
};


//------------------------------------------------------------------------------------------- cTextTokenizer
struct cTextTokenizer //0x1C =28
{
	DWORD line;
	cTextToken NextToken;
	FileScript* Stream;
	BOOL IgnoredWhiteSpace;
};

//---------------------------------------
struct Scripter_Credits //0xBC =188
{
	cTextTokenizer base;

	STR_A s00;
	DWORD dw1;

	BYTE _a[8];
	cTextToken sb1;
	STR_A s02;
	BYTE _b[4];
	STR_A s01;
	BYTE _d[4];
	STR_A s03;
	BYTE _e[4];
	cTextToken sb4;
	cTextToken sb5;
	cTextToken sb3;
	cTextToken sb2;
	BYTE _c[8];
};
//---------------------------------------
struct Scripter_Chart //0xC8 =200
{
	cTextTokenizer base;

	FileRam ram;//24
	cWorldPosition coord;
	cEventUI2 evt;//116
	cTextToken sb;
	
};
//---------------------------------------
struct Scripter_Script //0x24 =36
{
	cTextTokenizer base;

	BYTE _0[8];
	
};
//---------------------------------------
struct ScriptData
{
	char* _01[4];//4

	cWorldPosition coord;

	DWORD _09[4];//4

	char* _13[7];
	DWORD _20[7];

	char* _27[8];//8
	DWORD _35[8];//8
};

struct ScripterK //0xE8 =232
{
	cTextTokenizer base;

	BYTE _0[8];
	BYTE nLenSk;
	BYTE _1[3];
	FileRam ram;

	ScriptData cmd;
};

struct ScriptSys //0x860 =2144
{
	BYTE _00[20];
	FILE* file;
	BYTE _01[16];
	STR_A code;
	DWORD dwOMO;
	BYTE _02[32];
	char szFunction[64];
	DWORD dwPos1;
	DWORD dwPos2;
	BYTE _03[40];
	ScripterK SCK;
	BYTE _1[180];
	char szFile[764];

	WORD cmd;
	BYTE _3[2];
	BYTE exp;
	DWORD dwFuncCount;
	BYTE dat;
	char sz[758];
};


struct sTuerDef
{
	DWORD sTDpos;
	DWORD x;
	DWORD y;
	DWORD z;
	char CanWalk;
	char IsOpen;
};

struct cPatchIso //0x20 = 32
{
	DWORD patchid;
	DWORD sobj;
	DWORD wobj;
	DWORD tobj;
	char heightKch[4];
	BYTE color[4];
	char smthX;
	char smthY;
	char smthZ;
	char smthW;
	char relX;
	char relY;
	BYTE flags;
	BYTE someTypeId;
};

struct KeyxSectorSub
{
	DWORD field_0;
	DWORD fileOffset;
	DWORD size;
};

struct FileMemoryMapped
{
	void* cFile_memoryMapped_vtable;
	DWORD flags;
	char filePath[256];
	HANDLE fileHandle;
	HANDLE fileMapping;
	void *mapView;
	DWORD special_filePointer;
	DWORD fileSize;
};

struct cAnimalSpawn
{
	DWORD type;
	DWORD quote;
};
struct cMonsterSpawn
{
	DWORD type;
	DWORD quote;
};
struct cSectorWeather//0x1C =28
{
	WORD type;
	DWORD time[2];
	DWORD duration[2];
	BYTE intensity[2];
	DWORD params[2];
};

struct cSectorEnvironment //0x100 =256
{
	DWORD flags;
	BYTE environmentValid;
	cSectorWeather environment[4];
	BYTE animalsValid;
	cAnimalSpawn animals[4];
	WORD animalMinNum;
	WORD animalMaxNum;
	BYTE unused1[20];
	BYTE monsterValid;
	cMonsterSpawn monster[4];
	WORD monsterMinNum;
	WORD monsterMaxNum;
	WORD monsterMinLevel;
	WORD monsterMaxLevel;
	BYTE nAreaID;
	BYTE unused[23];
	DWORD musicID;
	DWORD osSoundProfile;
	BYTE waterTypeA;
	BYTE waterTypeB;
	BYTE reserved[7];
};

struct SectorsKeyxHdr // 0x100 =256
{
	char sig[3];
	BYTE ver;
	DWORD dwCount;
	DWORD dw1;
	DWORD dw2;
	DWORD wxx;
	DWORD wyy;
	BYTE _1[232];
};
struct SectorsKeyx // 0x300 =768
{
	char name[32];
	BYTE _0[4];
	DWORD dwSectorID;
	BYTE _1[20];
	DWORD somethingX;
	DWORD somethingY;
	DWORD sectorWidth;
	DWORD sectorHeight;
	BYTE _20[396];
	BYTE natureType;
	BYTE _21[16];
	cSectorEnvironment area;
	BYTE _4[23];
};

struct sAreaMove//0x4C =76
{
	WORD x;
	WORD y;
	WORD z;
	WORD x1;
	WORD y1;
	WORD undef;
	char name[64];
};
struct sAreaMove_vector
{
	sAreaMove* buf;
	sAreaMove* start;
	sAreaMove* end;
};
struct sFile_chunk
{
  DWORD type;
  DWORD pos;
  DWORD size;
};
struct sSectorChunk
{
	char sectorName[32];
	DWORD clientID;
	DWORD serverID;
	DWORD serverRevisionID;
	WORD surround[8];
	int von_x;
	int von_y;
	int bis_x;
	int bis_y;
	sFile_chunk lvlChunks[32];
	DWORD flags;
	DWORD surround2[2];
	char natureType;
	SYSTEMTIME timeOfLastMod;
	char pad[23];
//	BYTE _0[256];
};

struct sSaveSpawn
{
	DWORD type;
	DWORD Ver;
	DWORD Flag;
	DWORD W;
	DWORD S;
	DWORD A;
	char Lvl;
	char pad[3];
	WORD group;
	WORD more;
	cWorldPosition p;
};
struct sSaveSpawn_victor// =12
{
	sSaveSpawn* buf;
	sSaveSpawn* end;
	sSaveSpawn* aft;
};
struct cHeightLevel
{
	int x;
	int y;
	WORD w;
	WORD h;
	sFile_chunk data;
	sFile_chunk xdata;
};
struct cSectorVtbl
{
	void* (__thiscall *vecDelDtor)(cSector*, DWORD);
};
struct cSector //0x5AC =1452
{
	cSectorVtbl* vfptr;
	DWORD surround[8];
	DWORD sectorIndex;
	DWORD sectorID;
	BYTE natureType;
	BYTE reserved;
	WORD flags;
	DWORD xflags;
	DWORD von_x;//somethingX;
	DWORD von_y;//somethingY;
	DWORD bis_x;//sectorWidth;
	DWORD bis_y;//sectorHeight;
	DWORD poff_x;//minpX;
	DWORD poff_y;//minpY;
	char name[32];
	cPatchIso* patches;
	DWORD numHeights;
	cHeightLevel* heights;
	cPatchIso* heightInfo[64];
	DWORD minimap; //
	cSectorEnvironment* area;
	BYTE shadows[128];
	BYTE enemies[4];
	sAreaMove_vector vAreaMove;
	sSectorChunk sectorChunks;
	sFile_chunk lvlChunks[32];
	cFileMemoryMapped* worldPak;
	DWORD unzipSize;
	char* zipPtr;
	DWORD TimeStampSpawn;
	sSaveSpawn_victor vSaveSpawn;
};

struct Sector_vector// =12
{
	cSector** buf;
	cSector** end;
	cSector** aft;
};



struct cFileVtbl
{
	void *(__thiscall *Free)(cFile*, DWORD);
	DWORD (__thiscall *Read)(cFile*, void*, DWORD);
	DWORD (__thiscall *Write)(cFile*, const void*, DWORD);
	DWORD (__thiscall *Seek)(cFile*, DWORD);
	DWORD (__thiscall *Size)(cFile*);
	DWORD (__thiscall *Tell)(cFile*);
	char (__thiscall *AsyncRead)(cFile*, void*, DWORD, void (__cdecl *)(DWORD, void*), void*);
	char (__thiscall *AsyncWrite)(cFile*, const void*, DWORD, void (__cdecl *)(DWORD, void*), void*);
};
struct cFile
{
	cFileVtbl* vfptr;
};
struct cFileMemoryMapped // 0x11C =284
{
	cFile base;
	DWORD flags;
	char fname[256];
	HANDLE fileH;
	HANDLE fileM;
	BYTE* fileP;
	DWORD offset;
	DWORD bs;
};

struct cObserver
{
	void* vfptr;//cObserverVtbl
};
struct cObserver_vector
{
	cObserver* buf;
	cObserver* end;
	cObserver* aft;
};
struct cSubjectVtbl
{
	void *(__thiscall *vecDelDtor)(cSubject*, DWORD);
	void (__thiscall *attach)(cSubject*, cObserver*);
	void (__thiscall *detach)(cSubject*, cObserver*);
	void (__thiscall *notify)(cSubject*);
};
struct cSubject
{
	cSubjectVtbl* vfptr;
	cObserver_vector observers;
};
struct cPatchSharedIso
{
	char name[32];
	DWORD texture;
	WORD subtexture;
	WORD reserved1;
	DWORD flags;
	WORD type;
	char frames;
	char frame1;
	char frame2;
	char reserved2[15];
};
struct cPatchSharedIso_vector
{
	cPatchSharedIso* buf;
	cPatchSharedIso* end;
	cPatchSharedIso* aft;
};
struct cTrigger
{
	DWORD self;
	WORD flags;
	DWORD Referent;
	WORD state;
	DWORD param;
};
struct cTrigger_vector
{
	cTrigger* buf;
	cTrigger* end;
	cTrigger* aft;
};
struct cAnimals
{
	eItemType type;
	eMotionType motion;
	HSEQUENCE Sequence;
	HCONTROL grnControl;
	DWORD flags;
	float timedSound;
	float playingSound;
	float lifeTime;
	int viewX;
	int viewY;
};
struct cPatchPosition//0x10
{
	DWORD map;
	DWORD x;
	DWORD y;
	DWORD z;
};
struct cPatchPosition_vector// =12
{
	cPatchPosition* buf;
	cPatchPosition* end;
	cPatchPosition* aft;
};
struct cAnimation2D
{
	char flags;
	char miniTime;
	WORD miniFrames;
	DWORD texid;
	DWORD texidAni[8];
	float curFrame;
	int cx;
	int cy;
	cPatchPosition patchpos;
	DWORD startFrame;
	D3DTLVERTEX tlrect[4];
	float facing;
};
//-------------
struct sTransitionStatic
{
	DWORD self;
	DWORD type;
	DWORD flags;
	DWORD next_item;
};
struct sTransStatHlp
{
	sTransitionStatic Trans;
	DWORD Frame;
};
struct sTransStatHlp_pair
{
	DWORD first;
	sTransStatHlp second;//<TYPE>
};
struct sTransStatHlp_tree_node
{
	BST_base base;
	sTransStatHlp_pair _M_value_field;
};
struct sTransStatHlp_alloc_proxy
{
	sTransStatHlp_tree_node* _M_data;//BST_tree_node<sTransStatHlp>
};
struct sTransStatHlp_tree_base//0x4
{
	sTransStatHlp_alloc_proxy _M_header;
};
struct sTransStatHlp_tree//0xC
{
	sTransStatHlp_tree_base base;
	DWORD _M_node_count;
	DWORD _M_key_compare;
};
struct sTransStatHlp_map//0xC
{
	sTransStatHlp_tree _M_t;
};
//---------
struct sObjectWorldPosition
{
	WORD map;
	int x;
	int y;
	char z;
};
union cObjectQ
{
	short quality;
	int quantity;
	int content;
};
struct sObjectStatic
{
	DWORD self;
	DWORD type;
	DWORD flags; // eObjectStaticFlags
	sObjectWorldPosition wpos;
	cObjectQ q;
	DWORD container;
	DWORD next_item;
	short anchorOffX;
	short anchorOffY;
	DWORD trigger;
	WORD triggerState;
	char heightLevelID;
	char miniObjU;
	char miniObjV;
	char miniObjS;
	char miniTime;
	char miniFrames;
	char layer;
	char triggerInit;
	char fxVisibleStates;
	char reserved1;
	char brightness;
	char reserved[8];
};
struct sObjStatHlp
{
	sObjectStatic Obj;
	DWORD Frame;
};
struct sObjStatHlp_pair
{
	DWORD first;
	sObjStatHlp second;//<TYPE>
};
struct sObjStatHlp_tree_node
{
	BST_base base;
	sObjStatHlp_pair _M_value_field;
};	
struct sObjStatHlp_alloc_proxy
{
	sObjStatHlp_tree_node* _M_data;//BST_tree_node<sransStatHlp>
};
struct sObjStatHlp_tree_base//0x4
{
	sObjStatHlp_alloc_proxy _M_header;
};
struct sObjStatHlp_tree//0xC
{
	sObjStatHlp_tree_base base;
	DWORD _M_node_count;
	DWORD _M_key_compare;
};
struct sObjStatHlp_map//0xC
{
	sObjStatHlp_tree _M_t;
};
//---------
struct cPath
{
	void* vfptr;//cPathVtbl
	cWorld* subject;
};
struct cPathFloodfill
{
	cPath base;
};
struct cPathFloodfill_sDuppel
{
	BYTE x;
	BYTE y;
};


struct cWorld //0xDE68 =56936
{
	cSubject subj;	
	STR_W s1;
	char worldDir[256];
	cFileMemoryMapped worldPak;//(g_compressedWorld) ? ".\WORLD\SECTORS.WLDX" : ".\WORLD\SECTORS.WLD"
	FILE* staticPak;// ".\WORLD\STATIC.PAK"
	FILE* transitionPak;// ".\WORLD\FLOOR.PAK"
	Sector_vector sector;
	SBuffer tilesBuff;
	cPatchSharedIso_vector patchShared;
	cPathFloodfill* pathFinding;
	cTrigger_vector triggers;
	DWORD dwFirstFreeTrigger;
	DWORD dwLastFreeTrigger;
	DWORD defaultViewPosX;
	DWORD defaultViewPosY;
	BYTE sectorLookup[32768];
	DWORD sectorsize;
	DWORD count; // elem in STATIC.PAK, FLOOR.PAK
	cAnimals animals[8];
	cAnimation2D anims2d[64];
	DWORD fogOfWar;
	DWORD_vector vSectorCach;
	BYTE CleardSectores[100][100];
	cSectorEnvironment* envArray;
	sObjStatHlp_map mapReferentToStaticObj;//
	sTransStatHlp_map mapReferentToTransitionStatic;//
};



struct ItDate
{
	DWORD year;
	WORD month;
	WORD day;
	WORD hour;
	WORD min;
	WORD fr;
};

struct cLobbyChecksumBlock //0x58 =88
{
	DWORD dwPreviewCheckSum[3];
	DWORD dwFullCheckSum[3];
};
struct cPlayer //0x2E2 =738
{
	DWORD dwIP;
	DWORD dwCharacter;
	DWORD dwVersion;
	int nLobby_PermID;
	DWORD dwLobby_Slot;
	char byName[160];
	WORD wNameLength;
	sSaveInfo oPreviewSave;
};
struct sCalendarData //0x10 =16
{
	int year;
	WORD month;
	WORD day;
	WORD hours;
	WORD minutes;
	DWORD seconds;
};
struct sWeatherData //0x24 =36
{
	DWORD currentWeather;
	int sollAnzRainParticles;
	int sollFogColor;
	int sollGroundfogColor;
	int sollAnzSnowFlakes;
	float quakeStrength;
	float stompStrength;
	int doSingleFlash;
	float lavaBurstTimer;
};
struct cVARS //0x31DC =12764
{
	char bInited;
	char bIsMultiplayer;
	char bHost;
	char bStartGame;
	char bDisableTimeOut;
	char bRefsRequested;
	char bExitRequested;
	char bExitAllowed;
	char bJoinButtonPressed;
	char byPausingPlayer;
	DWORD dwExitRequestedTime;
	char bGameServerLaunched;
	char bGameServerLaunchFailed;
	void* hGameServerProcess;
	HWND* hGameServerWindow;
	char bIngame;
	char bReserved;
	int nCurrentChannel;
	DWORD dwCurrentChannelFlags;
	DWORD dwLobbyAddress;
	DWORD dwLastLobbyAction;
	cLobbyChecksumBlock oLobbyChecksum;
	WORD wListenPort;
DWORD dwCharacter;
	eSpeedSettings dwSpeedSettings;
	char bPasswordApproved;
	char bReserved2;
	cPlayer oPlayerData[17];
	WORD wSelectedSlot;
	WORD wReceiveLag;
	sCalendarData oCalendarCache;
	sWeatherData oWeatherCache;
	char bCalendarDataAvailable;
	char bWeatherDataAvailable;
	char bCharSaveAvailable;
	char byStartupEvent;
	DWORD dwTimerCheckID;
	DWORD dwHeroHealth;
	char byReserved;
	char byGameMode;
	WORD wNumMaxPlayers;
	DWORD dwSaveTimer;
};
struct cVARS2 //0x1C =28
{
	DWORD hInitExitThread;
	char byInitExitThreadFlag;
	char bLobbyInit;
	void* hInitEvent;
	void* hExitEvent;
	void* hInitExitKillEvent;
	void* hLobbyLoginEvent;
	void* hUpdateMutex;
	char bLobbyGame;
	char bReserved;
};
struct SacredEDTM // 0x14 =20
{
	HANDLE hMutex;
	DWORD dw1;
	DWORD isNetworkGame;
	void* pSacred_EDTM;
	DWORD dw3;
};
struct ITEM // 0x3AD0 =15056
{
	char bInited;
	char bIsMultiplayer;
	char bHost;
	char bStartGame;

	BYTE _00[16];
	int nIeID;
	DWORD dwDeltaTime0;
	BYTE isStartGameServer;
	BYTE _x06;
	BYTE _x07;
	BYTE _x08;
	HANDLE hGameServerProcess;
	HWND* hGameServerWindow;
	BYTE _y1[24];
	DWORD dwPort;
	DWORD dwCharacter;
	BYTE _y2[14192];

//	cVARS vars;//12768
//	cVARS2 vars2;
//	BYTE _00[1472];

	DWORD hslot;
	BYTE _z0[4];
	DWORD isDate;
	ItDate itDate;
	BYTE _z11[54];
	DWORD dwDeltaTime1;
	DWORD dwDeltaTime2;
	BYTE _z12[4];
	SacredEDTM edtm;
	STR_W wsSessionName;
	STR_W wsPlayerName;
	STR_W wsPassword;
	STR_W wsPlayerDataName[17];
	STR_W wstr32[17];
	STR_A sLobbyName;
	STR_W wsLobbyPassword;
	STR_A sLobbyCDKey;
	STR_W wsLobbyPlayerName;
	STR_W wsLobbyCharacterName;
	STR_W wsLobbyFullPlayerName;
	STR_W wsLobbyOldPassword;
	FileRam* pFileRam;
	FileRam file_ram;
	TooltipBuf tool01;
	TooltipBuf tool02;
	TooltipBuf tool03;
	TooltipBuf tool04;
	BYTE _b00[4];
	TooltipBuf tool05;
	TooltipBuf tool06;
	TooltipBuf tool07;
	TooltipBuf tool08;
	TooltipBuf tool09;
	TooltipBuf tool10;
};

struct cRectangle// =12
{
	int x;
	int y;
	WORD cx;
	WORD cy;
};
struct cPosition
{
	BOOL init;
	BOOL activate;
	int x;
	int y;
};
struct cInt2
{
	BOOL init;
	int n1;
	int n2;
};
struct FactorArr
{
	float* arr;
	int steps;
	float speed;
};

struct cCommand;
struct cCommandVtbl
{
	void *(__thiscall *vecDelDtor)(cCommand*, DWORD);
	void (__thiscall *Execute)(cCommand*);
};
struct cCommand
{
	cCommandVtbl* vtbl;
};
struct cCommand_ArmaPlay
{
	cCommand base;
	DWORD loadsavegame;
	DWORD savegameid;
};
struct cCommand_Event
{
	cCommand base;
	cEventUI2* theEvent;
};
struct cEventUI2_vector//0xC =12
{
	cEventUI2** buf;
	cEventUI2** end;
	cEventUI2** aft;
};
struct cCommand_MultiEvent
{
	cCommand base;
	cEventUI2_vector theEvents;
};


struct BaseCtrl //0x74 =116
{
	STR_W wstr; //12
	DWORD flags;
	DWORD argb;
	DWORD sound[2];
	DWORD tooltip;
	cRectangle rect;//12
	char name[32];
	cUI_Control* parent;
	TexUV uv1;
	TexUV uv2;
	DWORD tooltipFade;
};

struct UI_StringInterface //
{
	AVcUI_StringInterface* pFunc;
	BaseCtrl base;
};


struct cUI_Control //0x78 =120
{
	AVcUI_Control* vftbl;
	BaseCtrl base;//=116
	DWORD teStatic;//----
};

struct cUI_Static //0x7C =124
{
	AVcUI_Static* vftbl;
	BaseCtrl base;//=116
	DWORD teStatic;
};

struct cUI_Button //0xBC =188
{
	AVcUI_Button2* pFunc;
	BaseCtrl base;//=116
	DWORD iPushed;
	DWORD iReleased;
	DWORD tePushed;
	DWORD teReleased;
	cCommand* onPush;
	cCommand* onRelease;
	eUITextureDef tePushedX[2];
	eUITextureDef teReleasX[2];
	DWORD nFont;
	DWORD nStrID;
	DWORD dwColor1;
	DWORD dwColor2;
	WORD textOffset[2];
	DWORD dwTgaID;
	float fxTime;
};

struct UI_Button_vector//0xC =12
{
	cUI_Button** buf;
	cUI_Button** end;
	cUI_Button** aft;
};

struct cUI_RadioButton //0x8C =140
{
	AVcUI_Button2* pFunc;
	BaseCtrl base;//=116
	DWORD forceActive;
	DWORD activeButton;
	UI_Button_vector radioButtons;
};

struct cUI_Scrollbar //0x284 =644
{
	AVcUI_Scrollbar* pFunc;
	BaseCtrl base;//=116
	cRectangle sliderRect;
	DWORD sliderTex;
	DWORD numElements;
	DWORD curElement;
	DWORD lastClick;
	cUI_Control sbCtrl[2];
	cUI_Control sbSlider;
	cUI_Control sbArrow;
};

struct sComboEntry
{
	WORD comboType;
	eSType type[4];
	WORD level[4];
	float timerMax;
	float timerFactor;
	float timer;
};
struct sComboEntry_vector// =12
{
	sComboEntry* buf;
	sComboEntry* end;
	sComboEntry* aft;
};
struct cComboEntry
{
	STR_W textW;
	DWORD param;
	DWORD color;
	DWORD texid;
	float uvs[4];
};
struct cComboEntry_vector// =12
{
	cComboEntry* buf;
	cComboEntry* end;
	cComboEntry* aft;
};
struct cUI_Combobox //0x158 =344
{
	AVcUI_Static* pFunc;
	BaseCtrl base;//=116
	cComboEntry_vector cbEntries;
	WORD cbSelection;
	WORD fontid;
	cUI_Button btnCombo;
	DWORD mouseOverItem;
	DWORD comboflags;
	cUI_Scrollbar* scroll;
	DWORD dwHeight;
	DWORD dwWidth;
};

struct sUI_TabControl_BaseFn
{
	void* sub_7296E0;
	void* sub_6A5A10;
	void* sub_6A5B60;
	void* sub_6A5C80;
	void* sub_727E40;
	void* fnsUI_TabControl_Draw;
	void* sub_7320E0;
	void* sub_732050;
	void* sub_729A40;
	void* sub_727DD0;
	void* loc_7324B0;
	void* sub_732460;
};

struct cUI_TabPage
{
	DWORD resname;
	cRectangle rr;
	cUI_Control* rider;
	UI_Window* wnd;
};
struct cUI_TabPage_vector// =12
{
	cUI_TabPage* buf;
	cUI_TabPage* end;
	cUI_TabPage* aft;
};
struct cUI_TabControl
{
	void* pFunc;
	BaseCtrl base;//=116
	cUI_TabPage_vector pages;
	WORD active;
	WORD maxwidth;
	DWORD maxheight;
	DWORD fxTexID;
	__int64 fxTime;
};

struct cUI_TabSheet//0x80 =128
{
	void* pFunc;
	BaseCtrl base;//=116
	cUI_TabControl* tabs;
	DWORD fontid;
};

struct SUIBase// =12
{
	UI_Window* buf;
	UI_Window* end;
	UI_Window* aft;
};

struct UI_Control_vector// =12
{
	cUI_Control** buf;
	cUI_Control** end;
	cUI_Control** aft;
};

struct UI_Window //0x154 340
{
	AVcUI_Window* vfptr;
	BaseCtrl base;//116
	UI_Control_vector controls;
	UI_Control_vector tabOrder;
	UI_Control_vector text64;
	D3DTLVERTEX tlVert[4];//32
	DWORD texIDback[4];
	DWORD texIDfore[10];

};

struct sListBoxIcon
{
	DWORD tid;
	float uvs[4];
	DWORD uiID;
};
struct sListBoxIcon_vector//0xC =12
{
	sListBoxIcon* buf;
	sListBoxIcon* end;
	sListBoxIcon* aft;
};
struct sListboxEntry//0x24
{
	STR_W textW;
	DWORD param;
	DWORD param2;
	DWORD argb;
	sListBoxIcon_vector icons;
};
struct sListboxEntry_vector
{
	sListboxEntry* buf;
	sListboxEntry* end;
	sListboxEntry* aft;
};

struct cUI_Listbox //0xB0 =176
{
	AVcUI_Listbox* pFunc;
	BaseCtrl base;//=116
	cUI_Scrollbar* scrollbar;
	sListboxEntry_vector lbEntries;//12
	DWORD lbTop;
	DWORD lbActive;
	WORD fontID;
	WORD lbFlags;
	WORD fontH;
	WORD w2;
	DWORD argbDefault;
	DWORD argbActive;
	DWORD argbMouse;
	WORD historyMax;
	BYTE u2[2];
	DWORD clearMemoryP0;
	DWORD dw1;
};

struct WCSTR_vector//0xC =12
{
	wchar_t* buf;
	wchar_t* end;
	wchar_t* aft;
};
struct EditCandidate //0x20 =32
{
	WCSTR_vector candidates;
	int candidateIndex;
	DWORD pageStart;
	DWORD pageSize;
	int selected;
	EA2dIMCandidateStyle style;
};
struct cUI_EditControl//0x4F0 =1264
{
	cUI_Control ctrl;//124
	eUITextureDef teLR[2];
	wchar_t textW[512];
	WORD maxChars;
	WORD tx;
	WORD ty;
	WORD fontid;
	DWORD textColor;
	DWORD blinkState;
	float blinkCount;
	int textOffset[2];
	DWORD bNoDots;
	DWORD fontFlags;
	WORD textStart;
	WORD textCursor;
	char isIMEEnabled;
	char m_composing;
	BYTE _2[2];
	DWORD currCursor;
	EditCandidate currCandidates;
	STR_A m_compositionString;
	int m_composingStart;
	int m_composingLength;
	int m_compositionCursor;
	int is;
};
struct cUI_DigitEdit 
{
	cUI_EditControl base;
	eUITextureDef arrowTDL;
	eUITextureDef arrowTDR;
	cUI_Static decArrow;
	cUI_Static incArrow;
	int min;
	int max;
};

struct TB_ButtonFX//0x10
{
	BYTE burning;
	BYTE unk[7];
	__int64 startTime;
};
struct Compass //
{
	DWORD flags;
	DWORD argb;
	int px;
	int py;
	int radius;
	float sonarEffectRadius;
	DWORD sonarEffectOn;
};
struct cUI_Taskbar2 //0xD98  =3480
{
	UI_Window wnd;
	DWORD activeCreature;
	DWORD activeInventory;
	DWORD xnumSlots;
	cUI_TabSheet* tabSheet;
	cUI_Control* ddItems[5];
	cUI_Control* ddSpells[5];
	cUI_Button levelUp;//188
	UI_Control_vector tbLine;
	DWORD inventoryVisible;
	cUI_Button potions[5];
	cUI_Button potionNone[5];
	cUI_Control pframeL;
	cUI_Control pframeR;
	DWORD diskTexID;
	DWORD alphaTexID;
	DWORD glowTexID	;
	DWORD buttonFXTexID;
	TB_ButtonFX fxSpells;
	Compass compass[4];
	BYTE _b3[24];
	D3DTLVERTEX compassVertRed[4];
	D3DTLVERTEX compassVertBig[4];
	D3DTLVERTEX compassBox[4];
	D3DTLVERTEX daynightVert[4];
	D2POINT daynightBox[4];
	D2POINT pt[5];
};


struct sUI_WND_INVENTORY_BaseFn
{
	void* sub_6C6B30;
	void* sub_6A5A10;
	void* sub_6A5B60;
	void* sub_6A5C80;
	void* sub_6C62A0;
	void* fnsUI_WND_INVENTORY_DrawChest;
	void* sub_7320E0;
	void* sub_732050;
	void* sub_6A5D40;
	void* sub_6C5B30;
	void* loc_7324B0;
	void* sub_7247A0;
	void* nullsub_65;
	void* sub_724650;
	void* sub_724640;
	void* sub_727B30;
	void* sub_727B40;
};


struct cUI_Inventory //0x218 =536
{
	UI_Window wnd; //340
	cUI_TabSheet* pTabsSheet;
	cUI_Button autosort;
	BYTE _01[4];
};

struct sUI_TABPAGE_ITEMS // 0x15C =348
{
	UI_Window wnd; //340
	DWORD dwTtemID;
	DWORD wIeID;
};

struct sRenderInfoX // 0x14 =20
{
	DWORD Ref;
	HSEQUENCE Sequence;
	WORD w;
	WORD h;
	WORD type;
	WORD subType;
};

struct cUI_Equipment // 0x594 =1428
{
	UI_Window wnd; //340
	eItemType currentType;
	WORD currentSlotSystem;
	WORD tooltipHandle;
	cUI_Static* stat_UI_SLOT_HELMET;
	cUI_Static* stat_UI_SLOT_ARMOR;
	cUI_Static* stat_UI_SLOT_BELT;
	cUI_Static* stat_UI_SLOT_BOOTS;
	cUI_Static* stat_UI_SLOT_GLOVES;
	cUI_Static* stat_UI_SLOT_BRACERS;
	cUI_Static* stat_UI_SLOT_AMULET1;
	cUI_Static* stat_UI_SLOT_AMULET2;
	cUI_Static* stat_UI_SLOT_RING1;
	cUI_Static* stat_UI_SLOT_RING2;
	cUI_Static* stat_UI_SLOT_RING3;
	cUI_Static* stat_UI_SLOT_RING4;
	cUI_Static* stat_UI_SLOT_13;
	cUI_Static* stat_UI_SLOT_14;
	cUI_Static* stat_UI_SLOT_CANON;
	cUI_Static* stat_UI_SLOT_SHOULDER;
	cUI_Static* stat_UI_SLOT_GREAVES;
	cUI_Static* stat_UI_SLOT_WINGS;
	BYTE _0000001[56];
	cUI_Static background;//124
	cUI_Button btn;
	BYTE _tete[36];
	BYTE _0100[2];
	WORD wArnor;
	BYTE _0101[18];
	WORD wBelt;
	BYTE _x00[18];
	WORD wBoots;
	BYTE _x0100[18];
	WORD wGlove;
	BYTE _x0101[18];
	WORD wBracers;
	BYTE _x011[18];
	WORD wAmulet1;
	BYTE _x10[18];
	WORD wAmulet2;
	BYTE _x11[18];
	WORD wRing1;
	BYTE _01101[18];
	WORD wRing2;
	BYTE _q00[18];
	WORD wRing3;
	BYTE _q01[18];
	WORD wRing4;
	BYTE _q10[58];
	WORD wCanon;
	BYTE _q11[18];
	WORD wShoulder;
	BYTE _y00[18];
	WORD wGreaves;
	BYTE _y01[18];
	WORD wWings;
	BYTE _y1[280];
};

struct sUI_WND_BLACKSMITH //=2044=
{
	UI_Window wnd; //340
	cInventoryEntry* pIe;
	BYTE _01[1700];
};

struct sUI_WND_MERCHANT //=476=
{
	UI_Window wnd; //340
	BYTE _0[136];
};

struct cShadowMatrix
{
	float mapx;
	float mapy;
	DWORD flags;
};

struct cUI_Megamap //0xC071C =788252
{
	UI_Window wnd; //340
	cShadowMatrix shadowMatrix[65536];//786432
	DWORD xflags;
	cRectangle validRect;//12
	int heroX;
	int heroY;
	int ltopX;
	int ltopY;
	DWORD mapTex[8][8];
	DWORD mapHid[8][8];
	DWORD mapSector;
	BYTE _0[192];
	int oldMx;
	int oldMy;
	cUI_Control taskbarL;//124
	cUI_Control taskbarR;
	cRectangle mtbRect;
	cUI_Button mtbB1;//188
	cUI_Button mtbB3;
	DWORD showMiniMap;
	int userX;
	int userY;
	eMouseDragType oldDD;
	DWORD mouse_dirnw_ID;
	WORD w01;
	WORD w02;
	DWORD mouse_dirn_ID;
	WORD w03;
	WORD w04;
	DWORD mouse_dirne_ID;
	WORD w05;
	WORD w06;
	DWORD mouse_dirw_ID;
	WORD w07;
	WORD w08;
	DWORD unk_ID;
	WORD w09;
	WORD w10;
	DWORD mouse_dire_ID;
	WORD w11;
	WORD w12;
	DWORD mouse_dirsw_ID;
	WORD w13;
	WORD w14;
	DWORD mouse_dirs_ID;
	WORD w15;
	WORD w16;
	DWORD mouse_dirse_ID;
	WORD w17;
	WORD w18;
	DWORD mouse_pushpin_ID;
	WORD w19;
	WORD w20;
};

struct cUI_OverviewMap //=352=
{
	UI_Window wnd; //340
	int iHeroX;
	int iHeroY;
	char alpha;
	char doDots;
	WORD tooltipHandle;
};


struct sMercenaryWnd //0x194 =404
{
	int Ref;
	cUI_Control portrait; //124
	cUI_Control horseRide; //124
	cUI_Control* pStat[7];
	cUI_Control stat3; 
};

struct sUI_WND_MERC //0x944 =2372
{
	UI_Window wnd; //340
	sMercenaryWnd mom[5];
	float oldLife01;
	float sonarEffectRadius;
	float sonarEffectOn;
};


struct cUI_StatisticsChar //0xF88 =3976
{
	UI_Window wnd; //340
	cUI_Button btnLock;//188
	cUI_Button btnClose;
	cUI_Button btnSP[8];
	cUI_Button btnST[8];
	cUI_Control background;//124
	cUI_Control background2;
	DWORD skillNew;
};

struct sUI_WND_CONSOLE //0x23F4 =9204
{
	UI_Window wnd; //340
	FontFS* pFontFS;
	BYTE text1[4096];
	BYTE text2[512][8];
	BYTE _02[516];
	Square vert;
	cRectangle inf1;//12
	cRectangle inf2;//12
};

struct cUI_IndexEntry
{
	DWORD flags;
	DWORD resid;
	DWORD page;
	DWORD userdata;
	eUITextureDef gfx;
};
struct cUI_IndexEntry_vector
{
	cUI_IndexEntry* buf;
	cUI_IndexEntry* end;
	cUI_IndexEntry* aft;
};
struct cUI_Index
{
	DWORD headerid;
	DWORD activeIndex;
	DWORD overideText;
	DWORD overidePage;
	cUI_IndexEntry_vector entries;
};
struct cUI_Index_vector
{
	cUI_Index* buf;
	cUI_Index* end;
	cUI_Index* aft;
};

struct cUI_Page
{
	DWORD header;//dwStrID;
	DWORD text;//dwDescrID;
	DWORD xtext[10];
	eUITextureDef gfx;//DWORD dwUiTGA;
	DWORD itemType;//nQuestItemPak;
	DWORD wxx;
	DWORD wyy;
};
struct cUI_Page_vector
{
	cUI_Page* buf;
	cUI_Page* end;
	cUI_Page* aft;
};

struct cUI_Book //0xA24 =2596
{
	UI_Window wnd; //340
	DWORD _0;
	WORD fontHdr;
	WORD fontText;
	WORD fontMed;
	WORD activeChapter;
	WORD activePage;
	WORD activeIndex;
	WORD numPage;
	WORD bookType;
	cUI_Button btnChapter[7]; //188
	cUI_Button btnBrowse[2][2]; //188
	cUI_Index_vector indexPage[7];
	cUI_Page_vector bookPages[7];
};

struct cUI_Book_vector
{
	cUI_Book** buf;
	cUI_Book** end;
	cUI_Book** aft;
};

struct cUI_Diary //0x7B4 =1972
{
	UI_Window wnd; //340
	WORD heroLevel;
	WORD fontid;
	cUI_Control stat1; //124
	cUI_Control stat2; //124
	cUI_Control stat3; //124
	cUI_Control stat4; //124
	cUI_Control stat5; //124
	cUI_Control stat6; //124
	cUI_Control stat7; //124
	cUI_Control stat8; //124
	cUI_Control tab[4]; //124
	cUI_Control exitMenu; //124
	WORD activeTab;
	WORD n3;
	cUI_Book_vector vBook;
};

struct UI_StaticText64 //0x9C =156
{
	AVcUI_StaticText64* pFunc;
	BaseCtrl base;
	DWORD teStatic;
	DWORD clr1;
	DWORD clr2;
	int nTextID;
	STR_W str;
	DWORD fontid;
	cCommand* onClick;
};

struct STxt64// =12
{
	UI_StaticText64* buf;
	UI_StaticText64* end;
	UI_StaticText64* aft;
};

struct cUI_EscMenu //0x224 =548
{
	UI_Window wnd;
	WORD selected;
	WORD busy_type;
	STxt64 texts;
	DWORD bCanClose;
	cUI_Button exitButton;
};

struct sUI_WND_PURCHASE //=392=
{
	UI_Window wnd; //340
	BYTE _0[52];
};


struct cUI_Master //0x1DC =476
{
	UI_Window wnd; //340
	cUI_TabSheet* tabSheet;
	cUI_Control mrPortrait;
	DWORD masterLevel;
	DWORD masterRef;
};

struct cMouseDragDrop//20
{
	WORD type;
	WORD subtype;
	DWORD params[4];
};

struct sMasterEntry
{
	cUI_Static background;
	cUI_Static nextArrow;
	cUI_Static button;
	cMouseDragDrop mdd;
};
struct cUI_MasterCombo //0x900 =2304
{
	UI_Window wnd; //340
	sMasterEntry combos[4];
	DWORD masterLevel;
	cMouseDragDrop holdComboMdd;
	cUI_Static holdCombo;
	cUI_Static holdCombo2;
	cUI_Static makeCombo;
};

struct sLottoEntry//0x114 =276
{
	cUI_Control background;//124
	cUI_Control button;
	cMouseDragDrop mdd;
	HSEQUENCE cache;//8
};
struct eItemType_vector
{
	eItemType* buf;
	eItemType* end;
	eItemType* aft;
};
struct cUI_MasterLotto //0x844 =2116
{
	UI_Window wnd; //340
	sLottoEntry lotto[4];
	cUI_Control arrow[2];
	sLottoEntry ugen;
	DWORD upgradeRef;
	eItemType upgradeSel;
	eItemType_vector allUpgrade;
	float timer;
	cUI_Control makeLotto;
};

struct cSaveGame //0x310 =784
{
	char* captureMini;
	char file[256];
	wchar_t date[128];
	char userdesc[256];
	DWORD argb;
	DWORD type;
	DWORD ver;
};
struct cSaveGame_vector//0xC =12
{
	cSaveGame* buf;
	cSaveGame* end;
	cSaveGame* aft;
};
struct cUI_Savegame //0x826C =33388
{
	UI_Window wnd; //340
	WORD inSaveMode;
	WORD selSlot;
	WORD focusid;
	BYTE _012[2];
	cSaveGame_vector savegames;
	cSaveGame quicksave;
	cUI_Scrollbar scrollbar;//644
	cRectangle minipic[4];
	cRectangle saveslot[4];
	eSaveState state;
	eSaveState oldState;
	cUI_Button btnLoad;//188
	cUI_Button btnSave;//188
	cUI_Button btnErase;//188
	cUI_Button btnBack;//188
	cUI_EditControl editsRO[4][3];//[1264]x12
	cUI_EditControl editsRW[4][3];//[1264]x12
	cUI_Control stat1; //124
	cUI_Control stat2; //124
	cUI_Control stat3; //124
	STR_A str1;
	STR_A str2;
	STR_A str3;
};

struct cUI_Options //0x1B8 =440
{
	UI_Window wnd; //340
	DWORD ingame;
	cUI_Button* btnCancel;
	cUI_Button* btnMain;
	cUI_Button* cbDetail[3];
	cUI_Button* cbCollect[3];
	cUI_Button* cbCollectAnim;
	cUI_Button* cbNet[2];
	cUI_Button* cbFollow;
	cUI_Button* cbViolence;
	cUI_Button* cb3DSound;
	cUI_Button* cbSoundQuality[3];
	cUI_Button* cbExploreMap;
	cUI_Button* cbSutoSave;
	cUI_Button* cbFsaaFilter;
	cUI_Scrollbar* hsSound[4];
};

struct sUI_WND_CHEST //=348=
{
	UI_Window wnd; //340
	BYTE _0[4];
	cInventoryEntry* pIe;
};

struct cUI_Horse //0x3C4 =964
{
	UI_Window wnd; //340
	DWORD horseRef;
	DWORD mercRef;
	DWORD price;
	DWORD hcres;
	DWORD restext;
	eHorseClass horseClass;
	DWORD healcost;
	UI_StaticText64 buttons[3];//3*156
	cUI_Control portrait;//124
	DWORD status;
};

struct cUI_NetworkInfo //0x25A0 =9632
{
	UI_Window wnd; //340
	eNetInfoMode mode;
	char state[16][4];
	cUI_Control ctrl[64];
	cUI_Control* transbg;
	cUI_EditControl editChat;
	DWORD id_UI_TOOLTIP_ZZZ;
	DWORD id_UI_NET_INGAME_TEAM_INFO;
	DWORD id_UI_NET_INGAME_CHAT_INFO;
	DWORD id_UI_NET_INGAME_IGNORE_INFO;
	char bShowInfo;
	char bShowChat;
	BYTE _3[2];
};

struct sNetPortrait//0x200 =512
{
	DWORD ref;
	cUI_Control portrait;//124
	cUI_Control potion;
	cUI_Control healthDown;
	cUI_Control healthUp;
	cRectangle full;//12
};
struct cUI_NetPortrait //0x1154 =4436 cUI_NetPortrait
{
	UI_Window wnd; //340
	sNetPortrait netPlayers[8];
};

struct cUI_Frame//0xE0 =224
{
	AVcUI_Window* vfptr;
	BaseCtrl base;//116
	WORD command;
	BYTE _0[2];
	DWORD id[12];
	DWORD id2[9];
	UI_Control_vector ctrl;
	DWORD flag;
};

struct cUI_Character //0x460 =1120
{
	UI_Window wnd; //340
	STR_W modelNames[8];
	cUI_NetGranny* modelWnd[8];
	WORD fontid;
	BYTE modelNr;
	BYTE modelNr_old;
	BYTE modelHili;
	BYTE _101112[3];
	DWORD firstTime; 
	cUI_Control bgfx[2];
	int lightID;
	int lightID2;
	cUI_Control* pStones[8];
	cUI_Combobox* cbxDifficulty;
	float fov;
	float alpha;
	float distance;
	D3DMATRIX viewMat;
	D3DMATRIX projMat;
	UICharState state;
	UICharState oldState;

	cUI_Button* btnAccept;
	cUI_Button* btnBack;
	cUI_Button* btnToggle;
	cUI_Frame* frameDescription;//
	cUI_Frame* frameDep;//
	BYTE _00111a[4];
	cUI_Control* c1;
	cUI_Button* btnHardcore;
	cUI_Button* b2;
	cUI_EditControl* editName;
	cUI_EditControl* editNameRO;
	cUI_Button* b1;
	BYTE reloadModels;
	float lastTimeRendered;
	char bLanMode;
	BYTE _011[18];
	D3DMATRIX matView;
	D3DMATRIX matProj;
};

struct Dlg1056
{
	BYTE _0[12];
	BYTE isShow;
	BYTE b12;
	WORD w2;
	cUI_Control* ctrl;
	BYTE _1[4];
	STR_A str;
	BYTE _n[256];
};


struct sUiModels //=80
{
	eItemType modeltype;
	DWORD weapontype;
	DWORD shieldtype;
	DWORD armortype;
	DWORD bootstype;
	DWORD helmettype;
	DWORD glovestype;
	DWORD belttype;
	DWORD wingstype;
	float posX;
	float posY;
	float posZ;
	float angle;
	float lightPosX;
	float lightPosY;
	float lightPosZ;
	float screenX;
	float screenY;
	float screenW;
	float screenH;
};
struct sUI_modelInfo
{
	eItemType modeltype;
	sSaveInfo itemInfo;
	float posX;
	float posY;
	float posZ;
	float angle;
};
struct WORD_vector//0xC =12
{
	WORD* buf;
	WORD* end;
	WORD* aft;
};
struct sUI_modelSeq
{
	HSEQUENCE Sequence;
	HSEQUENCE SeqItems[20];
	int nPak;
	WORD_vector SeqSysList[19];
	HANIMATION SequenceMotion;
	HCONTROL SequenceControl;
};

struct sNetProfileInfo
{
	DWORD pid;
	STR_W account;
	sSaveInfo profile;
};
struct sNetProfileInfo_vector//0xC =12
{
	sNetProfileInfo* buf;
	sNetProfileInfo* end;
	sNetProfileInfo* aft;
};

struct cUI_NetGranny //0x634  =1588
{
	//window
	AVcUI_NetGranny* pFunc;
	BaseCtrl base;//116
	UI_Control_vector controls;
	UI_Control_vector tabOrder;
	D3DTLVERTEX tlVert[4];//32
	DWORD texIDback[4];
	DWORD texIDfore[10];
	BYTE _0[12];
	
	sUI_modelSeq model;
//	HSEQUENCE seq[21];
//	int nPak;
//	SBuffer sss[19];//228
//	HANIMATION hAnimation;
//	HCONTROL hControl;

	sUI_modelInfo info;
	DWORD activePid;
	BYTE bForceReload;
	BYTE bPerspective;
	BYTE bViewport;
	BYTE bMovingLight;
	DWORD a1;
	DWORD a2;
	float fov;
	float alpha; // -0.059203625
	float distance; // 100.0
	D3DMATRIX matView;
	D3DMATRIX mat2;
	D3DMATRIX matPerspective;
	D3DRECT viewport;
	int lightID;
	int lightID2;
	float lightRot;
	float scaleFactor;
};

struct sUI_WND_CUBE //=464=
{
	UI_Window wnd; //340
	BYTE _0[124];
};

struct sTextLine
{
	DWORD fontid;
	float ttl;
	float tal;
	DWORD argb;
	STR_W str;
};
struct sTextLine_vector// =12
{
	sTextLine* buf;
	sTextLine* end;
	sTextLine* aft;
};
struct cUI_TextLines //0x194 =404
{
	UI_Window wnd; //340
	float scrollDelay;
	DWORD textLineTop;
	sTextLine_vector textlines;
	sTextLine_vector questlines;
	DWORD chat_lines;
	DWORD flag;
	DWORD fx_multiTexBase06;
	DWORD fx_multiTexGlow02;
	float tex0offsetU;
	float tex0offsetV;
	float tex1offsetU;
	float tex1offsetV;
};

struct cUI_Trade //0xBC8 =3016
{
	UI_Window wnd; //340
	cUI_Control ctr1;
	cUI_Control ctr2;//124
	cUI_Control ctr3;
	cUI_Control ctr4;
	cUI_Control ctr5;
	cUI_Control ctr6;
	cUI_Control ctr7;
	cUI_EditControl edt;
	DWORD dw12;
	DWORD dw13;
	cUI_Control ctr10;
	cUI_Control ctr11;
	DWORD dw22;
	DWORD dw23;
	cUI_Control ctr8;
	cUI_Control ctr9;
	DWORD invid;
	DWORD dw2;
	DWORD dw3;
	DWORD flag;
	DWORD dw5;
	cInventoryEntry* ie26;
	cInventoryEntry* ie27;
	cUI_TextLines* lin;
};

struct sCreditEntry//0x10 =16
{
	STR_A text;
	DWORD argb;
};
struct sCreditEntry_vector//0xC =12
{
	sCreditEntry* buf;
	sCreditEntry* end;
	sCreditEntry* aft;
};
struct cUI_MainMenu //0x250 =592
{
	UI_Window wnd; //340
	eUiMainState state;
	UI_Control_vector defCtrl;
	UI_Control_vector netCtrl;
	UI_Control_vector xtrCtrl;
	DWORD creditsY;
	sCreditEntry_vector theCredits;
	cUI_Button creditsBack;//188
	DWORD bFirstFrame;
	float lastTimeRendered;
};




struct cUI_BusyDlg //0x644 =1604
{
	UI_Window wnd; //340
	eBusyType type;
	cRectangle busyRect;
	DWORD busyText;
	DWORD busyTitle;
	DWORD busyFont;
	DWORD portals;
	DWORD dots;
	float dotsTimer;
	cUI_Button btnCancel; //188
	cUI_Button btnOk; //188
	eBusyReaction onCancel;
	eBusyReaction onOk;
	BYTE _02[16];
	cUI_Listbox busy_listbox;
	cUI_Scrollbar scrollbar;//644
	DWORD dw1;
};

struct ttButtons //0x14 =20
{
	DWORD textid;//nStrID;
	DWORD callback;//nFlag;
	cRectangle rect;
};

struct cUI_Tooltip //0x21E0 =8672
{
	UI_Window wnd; //340
	DWORD ttflags;//dwFlags;
	WORD fontHandle;//nFont;
	WORD btnLineCount;
	char fullMessage[4096];
	STR_W fullMessageW;//wstr1;
	char message[4096];
	STR_W messageW;//wstr2;
	int headerid;//nStrNpcID;
	int textid;//nStrTextID;
	ttButtons btnResource[4];//btn_inf[4];
	int dlgCallbackID;//nWorkFunktion;
	DWORD Referent;//dwWeapArmID;
	DWORD frameOnce;//dwCD69D0;
	float timer;
//	eUITextureDef ttgfx;//dwTgaID;
	DWORD ttgfx;//dwTgaID;
};

struct sUI_TABPAGE_COMBOS //0x174 =372
{
	UI_Window wnd; //340
	BYTE _0[32];
};


struct cUI_Spells
{
	WORD flags;
	WORD level;
	WORD x;
	WORD y;
	DWORD type;
	DWORD hotkey;
};

struct cUI_Spells_vector// =12
{
	cUI_Spells* buf;
	cUI_Spells* end;
	cUI_Spells* aft;
};


struct cUI_SpellTab //0x2E4 =740
{
	UI_Window wnd; //340
	DWORD xflags;
	cUI_Control backgroundL;
	cUI_Control backgroundM;
	cUI_Control backgroundR;
	cUI_Spells_vector skillbox;
	eItemType bgtype;
	BYTE vampireForm;
	BYTE forceVampire;
	BYTE _01;
	BYTE _02;
	DWORD fxTexID;
};

struct sUI_TAB_STATS //0x160 =352
{
	UI_Window wnd; //340
	BYTE _0[12];
};



struct sUI_TABPAGE_WEAPONS //0x470 =1136
{
	UI_Window wnd; //340
	int nInventoryEntry;
	BYTE _0[640];
	WORD wTool;
	BYTE _1[150];
};



struct sUI_WND_NETACCOUNT1 // =14412
{
	UI_Window wnd; //340
	BYTE _0[14072];
};
struct sUI_WND_NETACCOUNT2 // =16564
{
	UI_Window wnd; //340
	BYTE _0[16224];
};

struct sNetProfile
{
	cUI_EditControl prfName;
	cUI_EditControl prfNick;
	cUI_EditControl prfClan;
	cUI_EditControl prfUrl;
	cUI_EditControl prfICQ;
	cUI_EditControl prfEmail;
	cUI_Button btnEmailShow;
	cUI_EditControl prfText;
	cUI_EditControl prf01;
	cUI_EditControl prf02;
};
struct cUI_NetLobby //0x88A4 =34980
{
	UI_Window wnd; //340
	eNetLobbyState state0;
	eNetLobbyState state1;
	BYTE _0[12];
	eNetLobbyState state;
	eNetLobbyState prevState;
	DWORD bNetwork_GameLogout;
	cUI_Listbox lbxChannels;
	cUI_Listbox lbxGames;
	cUI_Listbox lbxPlayers;
	cUI_Listbox lbxChat;
	cUI_EditControl editChannels[9];
	cUI_EditControl editChat;
	cUI_EditControl gameName;
	cUI_EditControl gamePwd;
	cUI_EditControl editSearch;
	cUI_Button btnCenter;
	cUI_Button btnRight;
	cUI_Button btnBack;
	cUI_Button btnSearch;
	cUI_Button btnProfile;
	cUI_Button btnProfile2;
	cUI_Scrollbar scrollLobby;
	cUI_Scrollbar scrollChat;
	cUI_Scrollbar scrollPlayer;
	UI_StaticText64 channelsHdr;
	cUI_NetGranny *netCharSelf;
	cUI_NetGranny *netCharOther;
	cUI_Combobox cbxGameType;
	cUI_Combobox cbxDifficulty;
	cUI_Combobox cbx03;
	cUI_DigitEdit deMaxPlayers;
	cUI_Static stat01;
	sNetProfile profile;
};

struct sUI_WND_NETPASSWORD // =5772
{
	UI_Window wnd; //340
	BYTE _0[5432];
};

struct cUI_NetLan //0x51B8 =20920
{
	UI_Window wnd; //340
	eNetLanState state;
	BYTE bNetwork_GameLogout;
	BYTE _02;
	BYTE _03;
	BYTE _04;
	cUI_EditControl editChannels[9];
	cUI_EditControl editChat;//1264
	cUI_EditControl gameName;//1264
	cUI_EditControl gamePwd;//1264
	cUI_Listbox lbxGames;//176
	cUI_Listbox lbxPlayers;//176
	cUI_Listbox lbxChat;//176
	cUI_Scrollbar scrollLobby;//644
	cUI_Scrollbar scrollChat;//644
	cUI_Scrollbar scrollPlayer;//644
	cUI_Button btnCenter;//188
	cUI_Button btnRight;//188
	cUI_Button btnBack;//188
	UI_StaticText64 channelsHdr;//156
	cUI_Combobox cbxGameType;//344
	cUI_Combobox cbxDifficulty;//344
	cUI_EditControl deMaxPlayers;//1264 cUI_DigitEdit
	BYTE _2[264];
	cUI_NetGranny* netCharSelf;
	cUI_NetGranny* netCharOther;
};

struct sUI_WND_NETTEST // =3320
{
	UI_Window wnd; //340
	BYTE _0[2980];
};


struct cUI_Network //0x178 =376
{
	UI_Window wnd; //340
	eNetGuiMode mode;
	eNetGuiState state;
	sUI_WND_NETACCOUNT1* ui_wnd_netaccount1;
	sUI_WND_NETACCOUNT2* ui_wnd_netaccount2;
	cUI_NetLobby* ui_wnd_netlobby;
	sUI_WND_NETPASSWORD* ui_wnd_netpassword;
	cUI_NetLan* ui_wnd_netlan;
	cUI_Character* ui_character;
	sUI_WND_NETTEST* ui_wnd_nettest;
};



/*
struct xxxxx // =
{
	UI_Window wnd; //340
	BYTE _0[yyyyyy];
};

*/

struct ObjIII
{
	cObject* pObjectArr;
	cObject* pObjectLast;
	DWORD _2;
};


struct cGuiconfig
{
	xmlDoc* doc;
	xmlNode* node;
	xmlNode* children;
	BYTE _31;
	BYTE isInitDialog;
	BYTE _33;
	BYTE _34;
	cUI_Frame* frame;
	DWORD _5;
	STR_A str;
};

struct cUI_Manager_Taskbar
{
	DWORD heroType;
	cUI_Taskbar2* ui_wnd_taskbar;
	cUI_Inventory* ui_wnd_inventory;
	cUI_Equipment* ui_wnd_equipment;
	sUI_WND_BLACKSMITH* ui_wnd_blacksmith;
	sUI_WND_MERCHANT* ui_wnd_merchant;
	cUI_Megamap* ui_wnd_megamap;
	cUI_OverviewMap* ui_wnd_overviewmap;
	sUI_WND_MERC* ui_wnd_merc;
	cUI_StatisticsChar* ui_wnd_stats_char;
	sUI_WND_CONSOLE* ui_wnd_console;
	cUI_Diary* ui_wnd_book;
	cUI_Savegame* ui_wnd_savegame;		// 4
	cUI_EscMenu* ui_wnd_escmenu;
	sUI_WND_PURCHASE* ui_wnd_purchase;
	cUI_Master* ui_wnd_master;
	cUI_Options* ui_wnd_options;	// 3
	sUI_WND_CHEST* ui_wnd_chest;
	cUI_Horse* ui_wnd_horse;
	cUI_NetworkInfo* ui_wnd_netinfo;
	cUI_NetPortrait* ui_wnd_netportrait;
	cUI_Character* ui_character;		// 2
	sUI_WND_CUBE* ui_wnd_cube;
	cUI_Trade* ui_wnd_trade;
};
struct cUI_Manager_MainMenu
{
	cUI_MainMenu* ui_mainmenu;			// 1
	cUI_Character* ui_character2;		// 2
	cUI_Options* ui_wnd_options2;		// 3
	cUI_Savegame* ui_wnd_savegame2;		// 4
	cUI_Network* ui_wnd_network;		// 5
};
struct sMovieMode
{
	float time;
};

struct cUI_Manager //0x2F4 =756
{
	AVcUI_Manager* pFunc;
	cUI_Combobox* imeCombobox;
	DWORD dwFlag;
	HANDLE thread_id;
	cMutex mutex;
	DWORD thread_status;
	DWORD loadingSmooth;
	DWORD loadingStatus;
	char loadingText[32];
	WORD defaultTooltip;
	WORD tooltips[16];
	BYTE w2[2];
	sMovieMode moviemode;
	cUI_Manager_Taskbar taskbar;
	DWORD dwStrID;
	WORD wData;
	WORD wMonsCat;
	DWORD dwTypeCL;
	BYTE _11[16];
	DWORD resPh;
	DWORD resFe;
	DWORD resMa;
	DWORD resGi;
	DWORD _121;
	DWORD _122;
	DWORD trade_heroNameID;
	cRectangle trade_RenderFromRect; //12
	BYTE _2[4];
	TooltipBuf tool; //12
	cUI_Manager_MainMenu mainmenu;
	cUI_BusyDlg* ui_busydlg;
	cUI_Control* edit_control;
	cUI_TextLines ui_wnd_textlines; //404
	eUIDemoState demoState;
	DWORD dw02;
	DWORD dw03;
	DWORD dw04;
	DWORD dwToolFont3;
};

struct float2// =8
{
	float v1;
	float v2;
};

// 0060D9B0; cEngine* __cdecl fncEngine_Create(DWORD dwFlags)
// 0060AEC0; cEngine* __thiscall fncEngine_Init(cEngine* pEng, DWORD dwFlags)
struct cDialogDamageEntry// 0x30 =48
{
	DWORD resid;
	int digit;
	DWORD flags;
	int wpx;
	int wpy;
	float x;
	float y;
	float dx;
	float dy;
	float dc;
	DWORD color;
	float totalElapsed;
};

struct sLoadingStatus
{
	float loadingSmooth;
	int loadingStatus;
	char text[64];
};
struct sEngineInfo
{
	DWORD eiflags;
	float timer1;
	float timer2;
	float timer3;
};
struct cEngine // 0x1CC =460
{
	AVcEngine* pFunc;
	cWorld* pWorld;
	cWorldView2* wview[16];
	WORD nWorldView;
	BYTE nGameFlag;
	BYTE simThread_status;
	DWORD renderThread_id;
	DWORD simThread_id;
	DWORD dwFlag;
	WORD activeSpellType;
	WORD activeSpell;
	WORD activePlayer;
	WORD _und1;
	DWORD fadeDelta;
	DWORD fadeColor;
	WORD savegameid;
	char savedesc[64];
	WORD _und2;
	DWORD savedescLoka;
	float dtRender;
	float dtSim;
	float dtSim2;
	cDialogDamageEntry* engclr[32];
	DWORD activeCreature;
	DWORD consoleInput;
	DWORD profileGraph;
	sEngineInfo EInfo;
	sLoadingStatus loadState;
	char* captureScreen;
	char* captureMini;
	DWORD uniqueID[2];
	cMutex mutex;
	DWORD _1;
};

/*
struct CEngine
{
	cEngine_vtable *vtable;
	CWorld *world;
	CWorldView0 *worldViewPtrList[16];
	__int16 worldViewCount;
	__int16 rendererInitialized;
	int hRenderThread;
	int field_50;
	int flags_54;
	int field_58;
	int field_5C;
	_BYTE gap60[8];
	__int16 field_68;
	_BYTE gap6A[66];
	int field_AC;
	float float_B0;
	_BYTE gapB4[4];
	int field_B8;
	int field_BC;
	_BYTE gapC0[124];
	int playerObjectId;
	int field_140;
	int field_144;
	int field_148;
	_BYTE gap14C[12];
	float loadingProgress;
	int field_15C;
	char stringBuff;
	_BYTE gap161[35];
	int field_184;
	_BYTE gap188[24];
	int field_1A0;
	int field_1A4;
	float float_rand;
	float float_rand2;
	CRITICAL_SECTION critSection;
	char field_1C8;
	_BYTE gap1C9[2];
	char field_1CB;
};
*/
//	char* szConComm;

struct cGCclassVars
{
	void* vptr;
	void *hWSAEvent;
	DWORD hReceiveThread;
	void *hReceiveMutex;
	void *hReceiveKillEvent;
	DWORD hSendThread;
	void *hSendMutex;
	void *hSendKillEvent;
	void *hSendActivateEvent;
	char byReceiveThreadFlags;
	char bySendThreadFlags;
	DWORD sClientListen;
	DWORD sTCPSocket;
	DWORD dwReceivedBytesSecond;
	DWORD dwTotalReceived;
	DWORD dwReceivedPacketsSecond;
	DWORD dwSentBytesSecond;
	DWORD dwTotalSent;
	DWORD dwSentPacketsSecond;
	char bGameServerUpdated;
	char bInited;
	char bConnected;
	char bConnecting;
	char bConnectEvent;
	char byUniquePlayerID;
	DWORD dwGameServerTimeOut;
	void *hMemory;
	char *lpReceiveBuffer;
	int nReceiveBufferIndex;
	char *lpPeekBuffer;
	WORD wReceiveMessageID;
	WORD wSendMessageID;
};
struct GameServer
{
	DWORD wPort;
	DWORD dwTime;
	DWORD wVersion;
	DWORD wFlags;
	DWORD byCurrentPlayers;
	DWORD byMaxPlayers;
	DWORD dwIP;
	DWORD _0;
	STR_W wsGameName;
	DWORD dwUniqueID;
	DWORD wChannelID;
};
struct GameServer_vector//0xC =12
{
	GameServer* buf;
	GameServer* end;
	GameServer* aft;
};
struct MessageHeader
{
  DWORD dwLengthID;
  DWORD dwChecksum;
  WORD wMsgID;
  char byUnique[3];
  char byMessageType;
};
struct MessageHeader_list//0xC =4
{
	MessageHeader* _M_node;
};
struct MessageHeader_vector//0xC =12
{
	MessageHeader** buf;
	MessageHeader** end;
	MessageHeader** aft;
};
struct MessageData
{
	MessageHeader* lpMessage;
	DWORD dwClientIndex;
	char bHighPriority;
	char byReserved[7];
	__int64 qwTime;
};
struct MessageData_vector//0xC =12
{
	MessageData* buf;
	MessageData* end;
	MessageData* aft;
};
struct cGCclass //0x40460 =263264
{
	cGCclassVars vars;
	BYTE _01[263092];
	GameServer oConnectedServer;
	GameServer_vector vGameServers;
	MessageHeader_list lReceiveMessageList;
	BYTE _02[4];
//	MessageData_vector vSendMessageList;
};

struct pktcheck_data
{
	int pkt_size;
	DWORD cmd_key;
	DWORD status;
};
struct PKTCHECK
{
  pktcheck_data *pktcheck_data;
  __int16 cmd_count;
  int msg_startrange;
  int msg_endrange;
};
struct cTinVars
{
	char bGracefulExit;
	char bReserved;
	__int16 wTinCatState;
	__int16 wConnectionState;
	int nPermanentID;
	int nChannel;
	DWORD dwInternetIP;
	GS_MSG_ID dwLastLobbyAction;
	WORD wTinCatPort;
	PKTCHECK *lpPacketCheck;
	void *hReceiveMessageListMutex;
};
struct NETAPI2;
struct NETAPI2Vtbl
{
	void (__thiscall *UserLoggedIN)(NETAPI2*, DWORD);
	BYTE gap4[4];
	void (__thiscall *ConnectionLost)(NETAPI2*, DWORD);
	void (__thiscall *ConnectionClosed)(NETAPI2*, DWORD);
	void (__thiscall *DataReceived)(NETAPI2*, DWORD, DWORD, void *, int);
	void (__thiscall *FileReceived)(NETAPI2*, DWORD, DWORD, char *);
	void (__thiscall *ERROR_FileReceived)(NETAPI2*, DWORD, DWORD, char *);
	void (__thiscall *GroupDataReceived)(NETAPI2*, DWORD, DWORD, DWORD, void *, int);
	void (__thiscall *MAINLOOP)(NETAPI2*);
};
struct NETAPI2
{
	NETAPI2Vtbl *vfptr;
	struct netdrv_ctrl *drv;
};
struct mutx
{
	__int16 lock;
	void *oshandle;
};
struct log_system
{
	DWORD status;
	mutx *mutex;
	DWORD msgtype_filter;
	DWORD level_filter;
	DWORD output;
	char *filename;
	__int16 filehandle;
	char header[128];
	char tmpspace[128];
	void (__cdecl *customprint)(char *);
};
struct STATUS
{
	DWORD status;
};
struct IPADR
{
	STATUS status;
	char adr[4];
};
struct NET_ADDRESS
{
	WORD port;
	char key[16];
	char host[64];
	DWORD netid;
	IPADR ipadr;
};
struct TNS_CONTROL
{
	NETAPI2 netapi;
	DWORD tns_ctrl_state;
	log_system *syslog;
	char trilib_required;
	DWORD ts;
	WORD dm_logins;
	char connected;
	NET_ADDRESS netadr;
	struct usrlst *usr;
	struct PROGFLOW_NET *flownet;
	WORD module_code;
	char logdir[1000];
};
struct cTinCat
{
	TNS_CONTROL ctrl;
	cTinVars vars;
	MessageHeader_vector vReceiveMessageList;
};
struct cTinCatLobby
{
	void* vpfn;
	BYTE _0[76];
};




struct sRectangle
{
	int x;
	int y;
	int w;
	int h;
};
struct sRectangleMod
{
	cRectangle can;
	int ox;
	int oy;
	DWORD _ref;
	DWORD data;
};
struct sRectangleMod_vector //0xC =12
{
	sRectangleMod* beg;
	sRectangleMod* end;
	sRectangleMod* aft;
};
struct cRectangleInfo
{
	sRectangle canvas;
	sRectangleMod_vector rects;
	WORD deviation;
	WORD un1;
};


struct cViewObject//0x18
{
	DWORD flags;
	DWORD Ref;
	float x;
	float y;
	int px;
	int py;
};
struct cViewObject_vector //0xC =12
{
	cViewObject* buf;
	cViewObject* end;
	cViewObject* aft;
};
struct cRectangleRef
{
	DWORD id;
	cRectangle objRect;
	cRectangle textRect;
};
struct cRectangleRef_vector //0xC =12
{
	cRectangleRef* buf;
	cRectangleRef* end;
	cRectangleRef* aft;
};

struct Vec2
{
	float x;
	float y;
};

struct cDrawTLVertex//0x4FC4
{
	D3DTLVERTEX vertexBuffer[600];
	WORD indexBuffer[600];
	DWORD curVertexID;
	DWORD curIndexID;
	DWORD anzBatches;
	DWORD anzTris;
	DWORD curTextureID;
};
struct cDrawTLVertexNew
{
	D3DTLVERTEX vertexBuffer[2048];
	WORD indexBuffer[2048];
	DWORD curVertexID;
	DWORD curIndexID;
	DWORD anzBatches;
	DWORD anzTris;
	DWORD curTextureID;
};

struct TL2TC_VERTEX//=36
{
	float x;
	float y;
	float z;
	float rhw;
	DWORD diffuse;
	float tu1;
	float tv1;
	float tu2;
	float tv2;
};
struct cDrawTL2Vertex //0x5928
{
	TL2TC_VERTEX vertexBuffer[600];//21600=600*sizeof(TL2TC_VERTEX)//36
	WORD indexBuffer[600];//1200=600*sizeof(WORD)//2
	DWORD curVertexID;
	DWORD curIndexID;
	DWORD anzBatches;
	DWORD anzTris;
	DWORD curTextureID;
	DWORD curTextureID2;
};
struct SecBuffer// =12
{
	cSector* buf;
	cSector* end;
	cSector* aft;
};

struct AVcWorldView2
{
	cWorldView2* (__thiscall *cWorldView2_vecDelDtor)(cWorldView2* pWView, char flags);
	void (__thiscall *cWorldView2_Update)(cWorldView2* pWView, cSubject* theChangedSubject);
	void (__thiscall *cWorldView2_OnActivate)(cWorldView2* pWView);
	void (__fastcall *cWorldView2_ValidateView)(cWorldView2* pWView, cWorld* world);
	int (__thiscall *cWorldView2_ShowPatch)(cWorldView2* pWView, IDirect3DDevice7** device, int id, int sx, int sy);
	void (__thiscall *cWorldView2_ShowWorld)(cWorldView2* pWView, IDirect3DDevice7** device);
	BOOL (__thiscall *cWorldView2_Mouse2World)(cWorldView2* pWView, int x, int y, cWorldPosition* iso);
	int (__thiscall *cWorldView2_Save)(cWorldView2* pWView, FileRam* fr, int save);
};
struct sDrawParam
{
	float sxox;
	float syoy;
	WORD tile;
	WORD indexSector;
	DWORD tilesToLoop;
};
struct sDotTransData
{
	WORD x;
	WORD y;
	DWORD cntr;
	float trans;
};
struct sDiffuse
{
	DWORD v1;
	DWORD v2;
	DWORD v3;
	DWORD v4;
};
struct sDiffuse_vector//0xC =12
{
	sDiffuse* buf;
	sDiffuse* end;
	sDiffuse* aft;
};

//-----------------------------------
struct STL_hash_DWORD
{
};
struct STL_equal_to_DWORD
{
};
struct STL_Identity_DWORD
{
};
struct STL_alloc_proxy_void_DWORD
{
	void** _M_data;
};
struct STL_vector_void_DWORD
{
	void** _M_start;
	void** _M_finish;
	STL_alloc_proxy_void_DWORD _M_end_of_storage;
};
struct STL_alloc_proxy_DWORD
{
	DWORD _M_data;
};
struct STL_hashtable_DWORD
{
	STL_hash_DWORD _M_hash;
	STL_equal_to_DWORD _M_equals;
	STL_Identity_DWORD _M_get_key;
	STL_vector_void_DWORD _M_buckets;
	STL_alloc_proxy_DWORD _M_num_elements;
};
struct STL_hash_set_DWORD
{
	STL_hashtable_DWORD _M_ht;
};
//-----------------------------------
struct STL_equal_to_sTexture
{
};
struct STL_Select1st_sTexture
{
};
struct STL_hashtable_sTexture
{
	STL_hash_DWORD _M_hash;
	STL_equal_to_sTexture _M_equals;
	STL_Select1st_sTexture _M_get_key;
	STL_vector_void_DWORD _M_buckets;
	STL_alloc_proxy_DWORD _M_num_elements;
};
struct STL_hash_multimap_sTexture
{
	STL_hashtable_sTexture _M_ht;
};
//-----------------------------------
struct cLayer
{
	STL_hash_set_DWORD m_Quads;
	STL_hash_multimap_sTexture m_TextureToQuad;
};
struct cLayer_vector//0xC =12
{
	cLayer* buf;
	cLayer* end;
	cLayer* aft;
};
struct cRenderer//0x3C
{
	cLayer_vector m_Layers;
	IDirect3DVertexBuffer7* m_pVB;
	TL2TC_VERTEX* m_pVertices;
	DWORD m_CurVtx;
	DWORD m_Layer0;
	sDiffuse_vector m_Even;
	sDiffuse_vector m_Odd;
	eRendererMode m_Mode;
	DWORD m_CacheStatus;
};
struct sWaterCache//=152
{
	cPatchIso* iso;
	POINTFLOAT crd;
	POINT tle;
	DWORD sid;
	D3DTLVERTEX vtx[4];//32
};
struct sViewStatistics//=48
{
	DWORD overlays;
	DWORD overlaysDA;
	DWORD overlaysIA;
	DWORD overlaysToggle;
	DWORD patches;
	DWORD miniobjs;
	DWORD objects;
	DWORD mixobjects;
	DWORD water;
	DWORD creatures;
	DWORD objshadows;
	DWORD shadows;
};
struct cWorldView2 //0x970F4 =618740
{
	// cObserver
	AVcWorldView2* pFunc;

	// cWorldView
	cWorld* pWorld;//subject
	cSector* currentSector;
	cSector* previousSector;
	DWORD flags;
	int wxx;//viewX
	int wyy;//viewY
	int viewXn;
	int viewYn;
	int viewXo;
	int viewYo;
	WORD scrollstep[2];
	float shadowUV[256][2];//[512]
	sUV uvCoords[18][4];//[144]
	POINTFLOAT zOrgVerts[4];
	POINTFLOAT zwOrgVerts[4];
	POINT oOrgVerts[4];
	TL2TC_VERTEX Verts[4];//36
	float viewFactor;

	TL2TC_VERTEX overlayVertCache[1750][4];//252000=1750*4*sizeof(TL2TC_VERTEX)//36
	DWORD overlayRefCache[1750];//7000=1750*sizeof(DWORD)//4
	DWORD overlayCacheCount;

	DWORD_vector ovlPatTexPerFrame;// vector DWORD

	sWaterCache waterCache[1750];//266000=1750*152; 1245182=8192*sizeof(sWaterCache)//152
	DWORD waterCacheCount;
	
	D3DTLVERTEX waterVerts[64];
	D3DTLVERTEX caustVerts[16];
	DWORD caustTexIDList[32];

	cDrawTLVertex wtrPatBatch;
	cPatchPosition_vector footcache;
	cDrawTL2Vertex bsePatBatch;//tiles =cDrawTL2Vertex::AddStripQuad
	DWORD_vector bsePatTexPerFrame;	
	cDrawTL2Vertex ovlPatBatch;//overlays =cDrawTL2Vertex::AddStripQuad
	cDrawTLVertex mixObjBatch;//+mix =cDrawTLVertex::AddStripQuad2
	
	Vec2 viewportSize;
	DWORD mapBL;
	DWORD mapBR;
	DWORD mapBT;
	DWORD mapBB;
	DWORD mapVX;
	DWORD mapVY;

	cViewObject_vector renderStuff[5];
	
	cMutex rectRefMutex;//24
	cRectangleRef_vector arrItemAll;
	cRectangleRef_vector arrItemViewed;
	sDotTransData dotListTrans[100];
	DWORD dotListAnz;
	D3DVERTEX shadowVerts[4];
	int shadowTexID;
	void* pDx7LightMgr;
	DWORD mainLightID;
	sViewStatistics stats;
	float cameraDist;

	// cWorldView2
	cSector* sectorMap[9];
	sDrawParam drawParam1;
	sDrawParam drawParam2;
};

struct PointAB
{
	float A;
	float B;
	float N;
};
struct PointCD
{
	float C;
	float D;
	float N;
};

struct SHORT_vector//0xC =12
{
	short* buf;
	short* end;
	short* aft;
};
struct sInterval
{
	int m_Pos;
	SHORT_vector m_Lights;
};
struct sInterval_vector//0xC =12
{
	sInterval* buf;
	sInterval* end;
	sInterval* aft;
};
struct sLight
{
	int Pos;
	int LightIdx;
};
struct sLight_vector//0xC =12
{
	sLight* buf;
	sLight* end;
	sLight* aft;
};
struct cLightCollision
{
	sInterval_vector m_Interval;
	int update;
};


struct Timer // 0x60 =96
{
	DWORD pauseSim;
	float fTicksPerSec;
	float fFramesPerSec; // 60.0
	float fSecsPerFrame; // 1.0/60.0 = 0,01666667
	LARGE_INTEGER qwTicks;
	LARGE_INTEGER qwStartTicks;
	LARGE_INTEGER qwTicksPerSec;
	LARGE_INTEGER qwTicksPerFrame; // frequency.QuadPart / 60
	LARGE_INTEGER frameNum;
	LARGE_INTEGER prevSysSec;
	DWORD freezeFrame;
	DWORD unk1;
	LARGE_INTEGER qwHQTicks;
	DWORD pauseSec;
	DWORD pauseDelta;
	HANDLE hTimerKillEvent;
	DWORD bTimerFlag;
};

/*
Dx7Light
{
	_BYTE gap0[104];
	int lightID;
	_BYTE gap6C[35];
	char field_0;
};
*/

//0060EB8D

struct XSpell
{
	WORD spell;
	BYTE chars;
	BYTE _1;
};
struct WSpell
{
	XSpell xs[8];
};
struct WeapByClass //0x48
{
	WORD BonusT[8];//wClass[8];
	WSpell BonusG;//ws;
	WORD BonusP[8];
	BYTE minOld[7];
	BYTE blacksmithLevel;
};
struct sWeaponInfo // 0x82 =130
{
	eItemType nPak;
	DWORD dwFlag;
	DWORD price;
	BYTE slot[8];
	BYTE minLVL;
	BYTE minST;
	BYTE minGS;
	BYTE minCH;
	BYTE minRES;
	BYTE spawn;
	BYTE nSkill_Type;
	BYTE nSkill_Min;
	WORD PhisMin;//MPD
	WORD FireMin;//MFD
	WORD ManaMin;//MMD
	WORD PoisonMin;//MGD
	WORD PhisMax;//PD
	WORD FireMax;//FD
	WORD ManaMax;//MD
	WORD PoisonMax;//GD
	WORD Attack;//AW
	WORD Protect;//PW
	WORD w9;//BW
	WORD PhisRes;//PR
	WORD FireRes;//FR
	WORD ManaRes;//MR
	WORD PoisonRes;//GR
	WeapByClass wbc;//
};
struct sWeaponInfo_vector
{
	sWeaponInfo* beg;
	sWeaponInfo* end;
	sWeaponInfo* aft;
};

struct sWeaponInfoShared // 0x102 =258
{
	float fScale;
	float fRotateX;
	float fRotateY;
	float fRotateZ;
	float fTransX;
	float fTransY;
	float fTransZ;
	BYTE wcx;
	BYTE wcy;
	BYTE WeaponClass;
	BYTE SoundSet;
	BYTE _S2;
	BYTE _S1;
	BYTE LolSet;
	BYTE SetType;

	eItemType CloneOf;
	char szName[64];
	BYTE MissSet;
	BYTE _S3;
	WORD isSet;
	eItemType slotDefault[5];
	sWeaponInfo ws;//130
};
struct sWeaponInfoShared_vector//0xC =12
{
	sWeaponInfoShared* buf;
	sWeaponInfoShared* end;
	sWeaponInfoShared* aft;
};

struct LIGHT_DATA
{
	D3DLIGHT7 light;
	DWORD ID;
	WORD prio;
	WORD type;
	D3DCOLORVALUE orgColor;
	D3DCOLORVALUE intensity;
};
struct cDX7LightMgr//0x164
{
	IDirect3DDevice7** d3ddev;
	DWORD maxAnzLights;
	LIGHT_DATA* lightData;
	DWORD curID;
	D3DMATERIAL7 whiteMat;
	D3DMATERIAL7 redMat;
	D3DMATERIAL7 blueMat;
	D3DMATERIAL7 yellowMat;
	D3DMATERIAL7 rottenMat;
};

struct sWeaponMod
{
	eItemType e[5];
	int anz;
	int mod;
	int var;
	int ph[3];
	int fe[3];
	int ma[3];
	int gi[3];
	int pR[3];
	int fR[3];
	int mR[3];
	int gR[3];
	int aw[3];
	int vw[3];
	WORD BonusChangse[8];
	WORD BonusT[8];
	DWORD BonusG[8];
	short BonusP[8];
	short BonusP2[8];
	WORD Spell[2];
	int WeaponType;
	int minlev;
	int bedi[3][3];
	int beditype[3];
};

struct sStatEnemy//0x24 =36
{
	eItemType type;
	DWORD resid;
	WORD chance;
	WORD chance2;
	WORD stufe;
	WORD health;
	WORD damage;
	WORD resist;
	char resproc[4];
	char dmgproc[4];
	WORD aw;
	WORD vw;
	DWORD reserved;
};
struct sStatHero//0x24 =36
{
	DWORD Gold;
	DWORD Dmg[4];
	DWORD Res[4];
};
struct sStatHistory//0x10 =16
{
	eItemType type;
	DWORD count;
	WORD stufe;
	char chance;
	char chance2;
	DWORD reserved;
};
struct StatsDate
{
	BYTE nYear;
	BYTE nMonth;
	BYTE nDay;
};

struct cStats//0x5788
{
	sStatHistory top10[768];//768*16=12288
	sStatHistory top10pre[10];//10*16=160
	BYTE recalcTop10;
	BYTE xx[3];
	sStatEnemy enemy[16];//16*36=576
	sStatHero anstieg[256];//256*36=9216
	DWORD Gold;
	DWORD Mstufe;
	DWORD revealed;
	DWORD totalKills;
	DWORD respawned;
	DWORD sz_h;
	DWORD sz_m;
	DWORD sz_ms;
	BYTE gameLevels[6]; //bronze,silver,gold,platinum,niobium
	BYTE _0[2];
	DWORD timestamp;
	DWORD wUpgradeDrop;
	DWORD H;
	DWORD M;
	DWORD mS;
	StatsDate date;
	BYTE n1;
	BYTE QBit[100];
};
struct User //0x5788
{
	BYTE _000[760];
	DWORD dwHeroClass;
	BYTE _001[556];
	D3POINT pos;
	BYTE _002[160];
	D3DMATRIX mat;//64
	BYTE _003[10896];
	BYTE buf01[576];
	BYTE buf02[9216];
	BYTE _010[8];
	DWORD dwWelt;
	DWORD dwKilled;
	DWORD dwDeathCounter;
	DWORD dwH;
	DWORD dwM;
	DWORD dwS;
	BYTE levels[5]; //bronze,silver,gold,platinum,niobium
	BYTE _01110[3];
	DWORD dw02;
	BYTE _011110[4];
	DWORD dwH2;
	DWORD dwM2;
	DWORD dwS2;
	StatsDate date;
	BYTE _011111[57];
	BYTE _0112[44];
};

/*
struct CoordTile
{
	int sectorId;
	DWORD x;
	DWORD y;
	DWORD z;
};
*/
struct ByWeapon//0x9A =154
{
	sWeaponInfo_vector slots;
	DWORD x;
	DWORD y;
	DWORD a3;
	sWeaponInfo ws; //130
};

struct HeroInfo// =22
{
	DWORD dwType;
	WORD wSpell;
	BYTE nLevel1;
	BYTE nLevel2;
	BYTE _0[14];
};
struct HIBuffer// =12
{
	HeroInfo* beg;
	HeroInfo* end;
	HeroInfo* aft;
};

struct ByHero//0x9A =154 = 152+2
{
//000000FC _rc_6           dw ?
//000000FE            dw ?
	BYTE a[2];
	HIBuffer hi;
	BYTE b[10];
	BYTE _7[56];

	WORD wState;
	WORD wCase;
	DWORD dwID1;
	DWORD dwID2;
	int nFuncNPCIndex;
	int nFunction;
	int nTooltipIndex;
	BYTE _8[12];
	DWORD dwSpell;
	BYTE _9[34];
};
/*
struct sStateMachine//84 smKi
{
	WORD state; _rc_6
	WORD substate; _rc_7
	DWORD params1; 
	DWORD params2; 
	DWORD params3; 
	DWORD params4; 
	DWORD params5; 
	DWORD params6; 
	DWORD params7; 
	DWORD params8; 
	DWORD params9; 
	DWORD params10; 
	DWORD params11; 
	DWORD params12; 
	DWORD params13; 
	DWORD params14; 
	DWORD params15; 
	DWORD params16; 
	DWORD debug1; 
	DWORD debug2; 
	DWORD debug3; 
	DWORD debug4; 
};
struct sStateMachine//84 smEi
{
	WORD state;		WORD wState;
	WORD substate; 	WORD wCase;
	DWORD params1; 	DWORD dwID1;
	DWORD params2; 	DWORD dwID2;
	DWORD params3; 	int nFuncNPCIndex;
	DWORD params4; 	int nFunction;
	DWORD params5; 	int nTooltipIndex;
	DWORD params6; 	BYTE _8[12];
	DWORD params7; 
	DWORD params8; 
	DWORD params9;	DWORD dwSpell;
	DWORD params10; 
	DWORD params11; 
	DWORD params12; 
	DWORD params13; 
	DWORD params14; 
	DWORD params15; 
	DWORD params16; 
	DWORD debug1; 
	DWORD debug2; 
	DWORD debug3; 
	DWORD debug4; 
};
*/
//00000000 hero            ByHero ?
//00000000 weap            ByWeapon ?

struct cObjectFactory
{
	BYTE in1;
};
//--------------------------------------- cTimerListener
struct cTimerListener_base// =8
{
	DWORD timer_interval;
	BYTE timer_prio;
	BYTE timer_freq;
	WORD un1;
};
struct cTimerListener//0xC =12
{
	AVcTimerListener* vfptr;
	cTimerListener_base _tlst;
};
//--------------------------------------- cObject ::cTimerListener
struct cObject_base//0x34 =52
{
	DWORD dwObjID;
	eItemType type;
	DWORD dwFlags;
	cWorldPosition wpos;
	cObjectQ q;
	DWORD container;
	DWORD next_item;
	DWORD trigger;
	char icount;
	char byClientOwner;
	WORD wClientFlags;
	DWORD nameRes;
};
// FAMILY_OBJECT
struct cObject//0x40 =64
{
	AVcObject* vfptr;
	cTimerListener_base _tlst;
	cObject_base _obj;
};
struct cObject_vector// =12
{
	cObject** buf;
	cObject** end;
	cObject** aft;
};
//--------------------------------------- cObject3D ::cObject ::cTimerListener
struct sTypeID
{
	DWORD id;
	eItemType type;
};
struct sTypeID_vector//0xC =12
{
	sTypeID* buf;
	sTypeID* end;
	sTypeID* aft;
};
struct cObject3D_base//0xBC =188
{
	HSEQUENCE grnSequence;
	HCONTROL grnControl;
	DWORD lastFrameRendered;
	DWORD lastFrameAdvTime;
	DWORD damageBits;
	eGrannyRenderSfx sfxState;
	eMotionType currentMotion;
	float sfxDat1;
	DWORD sfxDat2;
	D3DVECTOR facing;//12
	D3DVECTOR MyPosition;
	D3DVECTOR rootPos;
	WORD QuestNummer;
	WORD QuestFX;
	D3DVECTOR updated3dvec;
	sTypeID_vector tid;
	DWORD Flags3D;
	D3DVECTOR Velo;
	D3DVECTOR Rot;
	D3DVECTOR mPos;
	D3DVECTOR box[2];
	float Height;//////////////
	float LocTimer;
	DWORD dwMotionFlag;
};
// FAMILY_DOOR, FAMILY_TRAP, FAMILY_KEY
struct cObject3D//0xFC =252
{
	AVcObject3D* vfptr;
	cTimerListener_base _tlst;
	cObject_base _obj;
	cObject3D_base _o3d;
};
//--------------------------------------- cItemBase ::cObject3D ::cObject ::cTimerListener
struct cItemBase_base//0xE8
{
	DWORD groupResource;
	sWeaponInfo_vector wiMerged;//slots
	SBuffer wiSeqCache;//_STL::vector<granny_sequence,_STL::allocator<granny_sequence> > wiSeqCache;
	sWeaponInfo wiTotals;//ws
	WORD un1;
	DWORD fxRefTorch;
	DWORD fxRefMagicStaff;
	DWORD fxRefMagicWhip;
	DWORD fxRefMagicWorms;
	DWORD fxRefMagicFire;
	float fxIntMagicFire;
	DWORD fxRefMagicGift;
	float fxIntMagicGift;
	DWORD fxRefMagicGlow;
	float fxIntMagicGlow;
	DWORD_vector fxRefStreaks;
	DWORD_vector fxStdGlowBoneIndex;
	float fxVisibilityBias;
	DWORD invOwner;
};
struct cItemBase//0x1E4
{
	AVcItemBase* vfptr;
	cTimerListener_base _tlst;
	cObject_base _obj;
	cObject3D_base _o3d;
	cItemBase_base _ib;
};
//--------------------------------------- cArmor3D ::cItemBase ::cObject3D ::cObject ::cTimerListener
// cWeapon3D, cItemUpgrade, cSpecial3D, cShield3D, cScroll3D, cRing3D, cPotion3D, cBsItem3D
struct cArmor3D//0x1E4
{
	AVcArmor3D* vfptr;
	cTimerListener_base _tlst;
	cObject_base _obj;
	cObject3D_base _o3d;
	cItemBase_base _ib;
};
/*

struct __cppobj cChest3D : cItemBase
{
  _STL::vector<DWORD,_STL::allocator<DWORD> > items;
};
struct __cppobj cArrow3D : cItemBase
{
	WORD arrowFlags;
	cMutex mutex;
	vector3d position;
	vector3d direction;
	float speed;
	DWORD targetRef;
	DWORD senderRef;
	eItemType bowType;
	eItemType arrowType;
	sDamageParams dmgParams;
	float flyTime;
	float lifeTime;
	float arrowSeconds;
	float damageTime;
	float rayLength;
	char dmgTypeID;
	char smLevel;
	float efxLength;
	vector3d efxPosition;
	DWORD stickyRef;
	char stickyIC;
	vector3d stickyPos;
	vector3d stickyOri;
};
*/
//--------------------------------------- cStars
// 0x100
//--------------------------------------- cObjectFX ::cObject ::cTimerListener
struct cMathLineair
{
	WORD base;
	WORD mod;
};
struct cMagicEntry //0x94 =148
{
	DWORD spellid;//dwID;
	DWORD nameid;
	DWORD descid;
	char textureName[32];
	DWORD textureID;
	eUITextureDef uitex[3];
	WORD launchType;
	cMathLineair manacost;
	cMathLineair physDmg;
	cMathLineair fireDmg;
	cMathLineair magcDmg;
	cMathLineair posnDmg;
	cMathLineair AW;
	cMathLineair VW;
	cMathLineair phRes;
	cMathLineair fiRes;
	cMathLineair maRes;
	cMathLineair poRes;
	cMathLineair Speed;
	cMathLineair MagRegen;
	cMathLineair HPRegen;
	cMathLineair linearParams[3];
	WORD paramsMax[3];
	DWORD elementType;
	DWORD caster;
	char Flags[4];
};
struct cObjectFX//0x120
{
	AVcObject* vfptr;//??_7cObjectFX@@6B@
	cTimerListener_base _tlst;
	cObject_base _obj;

	DWORD fxType;
	DWORD sfxFlags;
	DWORD nwFlags;
	float nwLastUpdate;
	DWORD sfxLife;
	DWORD casterRef;
	DWORD casterIC;
	DWORD casterType;
	DWORD destRef;
	DWORD destIC;
	DWORD wearerRef;
	WORD wearerIC;
	WORD particleRef;
	DWORD attachBone;
	DWORD attachAddBones[3];
	D3DVECTOR moveDir;
	float duration;
	float systemSeconds;
	float rotationOfDir;
	D3DVECTOR wearingBoneOffset;
	int iData1;
	int iData2;
	int iData3;
	float fData1;
	float fData2;
	float fData3;
	float fData4;
	D3DVECTOR vData1;
	D3DVECTOR vData2;
	DWORD_vector rData1;
	sEventFXData fxData;
	float remainingRechargeTime;
};
//--------------------------------------- cCreature ::cObject3D ::cObject ::cTimerListener
struct sCreatureSLAnim
{
	eMotionType anim;
	DWORD loop;
	char dir;
	float speed;
	float x;
	float y;
};
struct sCreatureAddAnim
{
	DWORD Flag;
};
struct sCreatureBlend
{
	__int64 time;
	HCONTROL control;
	eMotionType anim;
};
struct sCreatureData
{
	eCreatureClass cls;
	DWORD Verhalten;//behavior,
	eCreatureMotionType motionType;
	DWORD dwInventoryID;
	DWORD dwFlags;
	float LokalUpdate;
	float LokalTimer;
	float BaseTimer;
	float KlickSpeed;
	sCreatureSLAnim SLAnim;
	sCreatureAddAnim AddA;
	sCreatureBlend BlAnim;
	int Dlg;
	int Group;
	int Pending;
	int Follow;
	int GroupRad;
	DWORD PathRef;
	WORD anzRefs;
	WORD TaktikFlag;
	WORD wInheadImageEmotion;
	WORD Refs[40];
	char ComboCount;
	char ComboNum;
	char byOwnerRefs;
	char Spellpref;
	WORD MoreFlags;
	cWorldPosition HomePos;
	float BaseSpeed;
};
struct sEquipment
{
	DWORD ref;
};
struct sMercenary
{
  DWORD ref;
  int type;
  char ShowPort;
};
struct sMercenary_vector// =12
{
	sMercenary* buf;
	sMercenary* end;
	sMercenary* aft;
};
struct sMove
{
	int WalkList[16][2];
	int WLpos;
	int WLmax;
	int pps;
	int PixOvl;
	int PixOvlX;
	int PixOvlY;
	int Moved;
	float dps;
	float FaceingP;
	int ZielX;
	int ZielY;
	char map_use_scan_no;
};
struct sStateMachineKi
{
	WORD state;
	WORD substate;
	DWORD params0; 
	DWORD params1; 
	DWORD params2; 
	DWORD params3; 
	DWORD params4; 
	DWORD params5; 
	DWORD params6; 
	DWORD params7; 
	DWORD params8; 
	DWORD params9; 
	DWORD params10; 
	DWORD params11; 
	DWORD params12; 
	DWORD params13; 
	DWORD params14; 
	DWORD params15; 
	DWORD debug0; 
	DWORD debug1; 
	DWORD debug2; 
	DWORD debug3; 
};
struct sStateMachineEi
{
	WORD state;
	WORD substate;
	DWORD params0; 
	DWORD params1;
	DWORD params2;
	DWORD params3;
	DWORD params4;
	DWORD params5; 
	DWORD params6; 
	DWORD params7; 
	DWORD params8; 
	DWORD params9; 
	DWORD params10; 
	DWORD params11; 
	DWORD params12; 
	DWORD params13; 
	DWORD params14; 
	DWORD params15; 
	DWORD debug0; 
	DWORD debug1; 
	DWORD debug2; 
	DWORD debug3; 
};
struct cCreatureHeroVtbl
{
	DWORD (__thiscall *createPacket)(cCreatureHero*, cFile*, char, DWORD);
};

struct sCharValHero//0xEE
{
	int nPak;
	DWORD dwExp;
	WORD minST;
	WORD minRES;
	WORD minGS;
	WORD minRP;
	WORD minRM;
	WORD minCH;
	BYTE nStatBonus[8];
	BYTE SkillID[8];
	BYTE SkillLevel[8];
	BYTE SkillBonus[8];
	WORD AttackSpeed;
	WORD CastSpeed;
	WORD WalkSpeed;
	WORD skillPointsRemaining;
	WORD skillLearn;
	DWORD dwGold;
	WORD wBasis[6];
	WORD minLVL;
	BYTE Horseclass;
	BYTE wDummy;
	DWORD AngriffsWert;
	DWORD VerteidigungsWert;
	DWORD Lebensenergie;
	DWORD ResistenzPhysisch;
	DWORD ResistenzFeuer;
	DWORD ResistenzMagisch;
	DWORD ResistenzGift;
	DWORD SchadenPhysisch;
	DWORD SchadenFeuer;
	DWORD SchadenMagisch;
	DWORD SchadenGift;
	DWORD MSchadenPhysisch;
	DWORD MSchadenFeuer;
	DWORD MSchadenMagisch;
	DWORD MSchadenGift;
	DWORD BonusPh;
	DWORD BonusFe;
	DWORD BonusMa;
	DWORD BonusGi;
	DWORD BonusWPh;
	DWORD BonusWFe;
	DWORD BonusWMa;
	DWORD BonusWGi;
	DWORD BonusMPh;
	DWORD BonusMFe;
	DWORD BonusMMa;
	DWORD BonusMGi;
	DWORD BonusMWasser;
	DWORD BonusMLuft;
	DWORD BonusMErde;
	DWORD BonusMLost;
	DWORD BonusRPh;
	DWORD BonusRFe;
	DWORD BonusRMa;
	DWORD BonusRGi;
	DWORD BonusAW;
	DWORD BonusVW;
	DWORD BonusRegMag;
	DWORD BonusRegSpM;
};
struct sBonusExtra
{
	eBonusType type;
	int XValu;
	WORD p[4];
	float Prozent;
	DWORD time;
	WORD spellID;
	BYTE _1[2];
	eItemType itype;
};
struct sBonusExtra_vector// =12
{
	sBonusExtra* buf;
	sBonusExtra* end;
	sBonusExtra* aft;
};
struct sAnimation
{
	eAnimType type;
	DWORD param32[16];
};
struct sAnimation_vector// =12
{
	sAnimation* buf;
	sAnimation* end;
	sAnimation* aft;
};
struct sPushbackData
{
	cWorldPosition wNewPos;
	float fFacingAngle;
	char bUsePushback;
};
struct FightValues
{
	float dp;
	float df;
	float dm;
	float dg;
	float rp;
	float rf;
	float rm;
	float rg;
	float b[3][4];
	float aw;
	float vw;
};
struct Life
{
	DWORD dwLife01;
	DWORD dwLifeMax;
	DWORD dwLifeCurr;
	DWORD dwLife04;
	DWORD dwHealthRegen;
	DWORD _02;
};
struct sEnemyList
{
	DWORD ref;
	DWORD Dist;
};

struct cCreatureHero //0x1BC
{
	cCreatureHeroVtbl* vfptr;
	cCreature* parent;
	sCharValHero Data;

	STR_W dingsda;
	sSpellEntry_vector Spells;
	sComboEntry_vector Combos;
	sBonusExtra_vector ExtraBonus;
	BYTE entry;
	BYTE bUpdateNetwork;
	Life life;//int TP[6]
	float TimerRammen;
	float RammenMax;
	DWORD _31;
	DWORD dwSize;
	BYTE* arrCrHero;
	BYTE _3[104];
};
struct cCreature //0x5AC =1452
{
	AVcCreature* vfptr;
	cTimerListener_base _tlst;
	cObject_base _obj;
	cObject3D_base _o3d;

	sStateMachineKi smKi;
	sStateMachineEi smEi;
	sEquipment vEquip[19];
	sCreatureData data;
	BYTE _1[32];
	sMove Move;
	BYTE _2[2];
	sMercenary_vector mercs;
	cCreatureHero aspell;
	float footStepLastAnimTime;
	DWORD dwHeroCreationTime;
	DWORD dwLastUpdateTime;
	DWORD horseRef;
	DWORD wBodyCut;
	DWORD portals;
	char bUpdateEnemyList;
	char bReserved;
	BYTE _5[10];
	sAnimation_vector vAnim;
	sPushbackData oPushback;
	BYTE _83[3];
};

struct cCreature_vector//0xC =12
{
	cCreature** buf;
	cCreature** end;
	cCreature** aft;
};

struct Detail
{
	BYTE detail;
	BYTE network;
	BYTE fsaa_filter;
	BYTE _2;
	BYTE force_black_shadow;
	BYTE _4;
	BYTE _5;
	BYTE _6;
	float warning_level;
	BYTE _7;
	BYTE _8;
	BYTE _9;
	BYTE _0;
};

struct STR_B // =16
{
	BYTE _0[3];
	DWORD dwID;
	STR_A astr;
};

struct cInventoryItem // =12
{
	DWORD Ref;
	BYTE slotFlags;
	BYTE w;
	BYTE h;
	BYTE cachstate;
	DWORD reserved;
};
struct cTaskbarItem
{
	DWORD Ref;
	HSEQUENCE Sequence;
};
struct cTaskbarSpell
{
	WORD mddType;
	WORD type;
	DWORD param[4];
};
struct qiDef
{
	DWORD t;
	DWORD rid;
};
struct qiDef_vector// =12
{
	qiDef* buf;
	qiDef* end;
	qiDef* aft;
};
struct sInventoryFX
{
	int x;
	int y;
	float w;
	float h;
	float tal;
};
struct sInventoryFX_vector// =12
{
	sInventoryFX* buf;
	sInventoryFX* end;
	sInventoryFX* aft;
};

struct cInventoryEntry//0x1180 =4480
{
	qiDef_vector questItems;
	DWORD_vector scrollItems;
	cInventoryItem items[256];
	cTaskbarItem tbItems[5][2];
	cTaskbarSpell tbSpells[5][2];
	WORD activeSlot[2];
	DWORD keyRing[256];
	WORD iw;//icx; // 20
	WORD ih;//; // 8
	WORD self;
	WORD flags;
	WORD ix;
	WORD iy;
	DWORD ownerRef;
	sInventoryFX_vector invFX;
	IDirectDrawSurface7** cach;
	DWORD refrech;
};

struct sActiveMerchant
{
  DWORD Ref;
  DWORD level;
};
struct Inventory // 0x23008 =143368
{
	cInventoryEntry ie[32];//4480
	sActiveMerchant activeMerchant;
};


struct Obj12 // 288 = 0x120
{
	DWORD* pFn;
	BYTE _00[8];
	DWORD dwID;
	int nType;
	BYTE _010[40];
	DWORD dwStrID;
	BYTE _011[220];
	float f01;
};


struct cObjectSounds//0xB8 =184
{
	char name[32];
	DWORD type;
	DWORD flags;
	DWORD params[4];
	WORD soundID[8][8];
};



struct cObjectShared //0x80 =128
{
	DWORD dwFlag;
	DWORD textureID;
	DWORD texture3D;
	DWORD argb;
	DWORD pakGfxID;
	DWORD blockRadius;
	WORD weaponEntry;
	WORD creatureEntry;
	DWORD bookText;
	int nPak;
	DWORD dwSoundProfileId;
	WORD anchorX;
	WORD anchorY;
	WORD aniNum;
	BYTE nFamily;
	BYTE layer;
	BYTE aniMsFrame;
	BYTE gfxFileID;
	WORD radius;
	BYTE lwh3d[3];
	char szModelGrn[32];
	float angle3D;
	WORD shadowSub;
	short shadowOffsetX;
	short shadowOffsetY;
	BYTE bookEntry[2];
	BYTE shadowShear;
	WORD shadowSize;
	DWORD textureFX;
	WORD upgradeItemType;
	WORD upgradeFlags;
	BYTE textureFX_ID;
	BYTE goreType;
	DWORD modelID;
	WORD switchType;
	BYTE res[10];
};


struct sObjectMix // =16
{
	DWORD numTextures;
	short x;
	short y;
	short sx;
	short sy;
	DWORD reserved;
};
struct sObjectMix_vector // =12
{
	sObjectMix* buf;
	sObjectMix* end;
	sObjectMix* aft;
};

struct sTextureSubFloat // =36
{
	DWORD texture;
	float sizeX;
	float sizeY;
	float x;
	float y;
	float u0;
	float v0;
	float u1;
	float v1;
};
struct sTextureSubFloat_vector // =12
{
	sTextureSubFloat* buf;
	sTextureSubFloat* end;
	sTextureSubFloat* aft;
};
struct sTextureSubFloat_vvector // =12
{
	sTextureSubFloat_vector* buf;
	sTextureSubFloat_vector* end;
	sTextureSubFloat_vector* aft;
};

struct cMixLoader // =24
{
	sObjectMix_vector entries;
	sTextureSubFloat_vvector subentries;
};





struct Deque
{
	DWORD _0;
	DWORD _1;
	DWORD _2;
	DWORD _3;
	DWORD _4;
	DWORD _5;
	DWORD _6;
	DWORD _7;
	DWORD _8;
	DWORD _9;
};
struct DWORD_vector_vector//0xC =12
{
	DWORD_vector* buf;
	DWORD_vector* end;
	DWORD_vector* aft;
};
struct cObjectManager
{
	cWorld* pWorld;
	cObject_vector objects;
	DWORD_vector_vector SectorObjects;
	DWORD_vector qiRefs;
	Deque freeSlots;
	cMutex mutex;	
	FileRam rf;
};





/*
struct CObjectManager
{
	CWorld *world;
	SBuffer sbuff_entitiyPointers;
	int field_10;
	_BYTE gap14[20];
	int field_28[4];
	_BYTE gap38[24];
	CRITICAL_SECTION critSection;
	_BYTE gap68[20];
	int field_7C;
};
*/



struct sRegionData//0x18
{
	WORD regionID;
	BYTE status;
	BYTE statusRequired;
	DWORD resourceName;
	DWORD flags;
	float regionsFix;
	float storyFix;
	float regionDyna;
};
struct cRegion//0x1800
{
	sRegionData regions[256];
};


struct QuestStru //0x124
{
	int nQuestID;
	char name[256];
	int Start;
	int Len;
	DWORD FuTrigger;
	DWORD FuOnEnter;
	DWORD FuSetUp;
	DWORD FuOnExit;
	DWORD FuOnLose;
	DWORD Flags;
};
struct QuestStru_vector// =12
{
	QuestStru* buf;
	QuestStru* end;
	QuestStru* aft;
};




struct PoolHeader// =36
{
	int PoolNummer;
	int TriggerType;
	int Grad;
	eQuestTypes QuestType;
	char QuestParams[8];
	DWORD_vector ToDo2;
};
struct PoolHeader_vector// =12
{
	PoolHeader* buf;
	PoolHeader* end;
	PoolHeader* aft;
};


struct QuestPoolStru// =136
{
	int Nummer;
	char name[64];
	int Start;
	int len;
	DWORD MaxOffen;
	DWORD IstOffen;
	DWORD Delay;
	PoolHeader_vector PH;
	DWORD_vector ToDo;
	DWORD_vector Belohnung;
	DWORD_vector Strafe;
};
struct QuestPoolStru_vector// =12
{
	QuestPoolStru* buf;
	QuestPoolStru* end;
	QuestPoolStru* aft;
};


struct cFunkStru //0x54 =84
{
	char name[64];
	int Start;//pos
	int Size;//size
	int Quest;//argum
	int Nummer;//todo
	int Deleted;//deleted
};
struct cFunkStru_vector// =12
{
	cFunkStru* buf;
	cFunkStru* end;
	cFunkStru* aft;
};


struct sMouseOver// =88
{
	WORD x;
	WORD y;
	WORD z;
	WORD cnt;
	short dx;
	short dy;
	WORD cx;
	WORD cy;
	DWORD nStrID;
	DWORD mode;
	char func[64];
};
struct sMouseOver_vector// =12
{
	sMouseOver* buf;
	sMouseOver* end;
	sMouseOver* aft;
};

struct BPak// =76
{
	int nPak;
	int n;
	BYTE a[68];
};

struct BpBuffer// =12
{
	BPak* buf;
	BPak* end;
	BPak* aft;
};

struct BCak// =12
{
	BYTE a[12];
};

struct BcBuffer// =12
{
	BCak* buf;
	BCak* end;
	BCak* aft;
};

struct sDeath
{
	DWORD r;
	char fun[64];
};
struct sDeath_vector// =12
{
	sDeath* buf;
	sDeath* end;
	sDeath* aft;
};

struct DlgStru// =80
{
	DWORD Nummer;
	char szFunction[64];
	int nFunction;
	int nInheadImage;
	DWORD dwObjID;
};

struct DlgStru_vector// =12
{
	DlgStru* buf;
	DlgStru* end;
	DlgStru* aft;
};

struct DlgStruRgn// =88
{
	int Nummer;
	char name[64];
	DWORD FuDlg;
	DWORD Icon;
	DWORD owner;
	eItemType type;
	DWORD RegionID;
};

struct DlgStruRgn_vector// =12
{
	DlgStruRgn* buf;
	DlgStruRgn* end;
	DlgStruRgn* aft;
};

//-----------------------Teleport???
struct AVL_DWORD_node
{
	WORD m_Balance;
	WORD m_Depth;
	DWORD m_Key;
	DWORD m_Data;
	AVL_DWORD_node* m_pLeft;
	AVL_DWORD_node* m_pRight;
	AVL_DWORD_node* m_pPrev;
};
struct AVL_DWORD// =8 AVL
{
	AVL_DWORD_node* m_pRoot;
	AVL_DWORD_node* m_pCurrT;
};
//-------------------------------
struct sQuestRegion
{
	DWORD ID;
	char Init;
	char Aktive;
	BYTE un[2];
};
struct AVL_sQuestRegion_node
{
	WORD m_Balance;
	WORD m_Depth;
	DWORD m_Key;
	sQuestRegion m_Data;
	AVL_sQuestRegion_node* m_pLeft;
	AVL_sQuestRegion_node* m_pRight;
	AVL_sQuestRegion_node* m_pPrev;
};
struct AVL_sQuestRegion// =8 AVL
{
	AVL_sQuestRegion_node* m_pRoot;
	AVL_sQuestRegion_node* m_pCurrT;
};
//--------------------------------------
struct sRegion
{
	int x1;
	int y1;
	int x2;
	int y2;
	DWORD res;
	DWORD Type;
	DWORD Sound;
	DWORD Timest;
};
struct sRegion_vector// =12
{
	sRegion* buf;
	sRegion* end;
	sRegion* aft;
};
struct AVL_sRegion_vector_node
{
	WORD m_Balance;
	WORD m_Depth;
	DWORD m_Key;
	sRegion_vector m_Data;
	AVL_sRegion_vector_node* m_pLeft;
	AVL_sRegion_vector_node* m_pRight;
	AVL_sRegion_vector_node* m_pPrev;
};
struct AVL_sRegion_vector
{
	AVL_sRegion_vector_node* m_pRoot;
	AVL_sRegion_vector_node* m_pCurrT;
};
//--------------------------------------
struct AVL_DWORD_vector_node
{
	WORD m_Balance;
	WORD m_Depth;
	DWORD m_Key;
	DWORD_vector m_Data;
	AVL_DWORD_vector_node* m_pLeft;
	AVL_DWORD_vector_node* m_pRight;
	AVL_DWORD_vector_node* m_pPrev;
};
struct AVL_DWORD_vector
{
	AVL_DWORD_vector_node* m_pRoot;
	AVL_DWORD_vector_node* m_pCurrT;
};
//--------------------------------------
struct sName
{
	char szName[128];
};
struct sName_vector//0xC =12
{
	sName* buf;
	sName* end;
	sName* aft;
};
struct AVL_sName_node
{
	WORD m_Balance;
	WORD m_Depth;
	sName m_Key;
	DWORD m_Data;
	AVL_sName_node* m_pLeft;
	AVL_sName_node* m_pRight;
	AVL_sName_node* m_pPrev;
};
struct AVL_sName
{
	AVL_sName_node* m_pRoot;
	AVL_sName_node* m_pCurrT;
};
//--------------------------------------
struct sQPool
{
	WORD p[4];
};
struct sQPool_vector// =12
{
	sQPool* buf;
	sQPool* end;
	sQPool* aft;
};
struct AVL_sQPool_vector_node
{
	__int16 m_Balance;
	__int16 m_Depth;
	DWORD m_Key;
	sQPool_vector m_Data;
	AVL_sQPool_vector_node* m_pLeft;
	AVL_sQPool_vector_node* m_pRight;
	AVL_sQPool_vector_node* m_pPrev;
};
struct AVL_sQPool_vector
{
	AVL_sQPool_vector_node* m_pRoot;
	AVL_sQPool_vector_node* m_pCurrT;
};
//--------------------------------------
struct sVar// =36
{
	char szVar[32];
	DWORD dwValue;
};
struct sVar_vector// =12
{
	sVar* buf;
	sVar* end;
	sVar* aft;
};

struct sMarker
{
	DWORD flags;
	DWORD referent;
	DWORD resource;
	cPatchPosition staticPos;
};
struct sQuestVre
{
	int Book;
	int Chapter;
	int Region;
};
struct cQuestBookRes //0x174
{
	eQuestTypes type;
	eQuestState state;
	int Quest;
	DWORD Flags;
	DWORD Kompass[5];
	DWORD ResHeadLine;
	DWORD ResText[10];
	sMarker Marker[10];
	sQuestVre QuestVre;
};
struct cQuestBookRes_vector// =12
{
	cQuestBookRes* buf;
	cQuestBookRes* end;
	cQuestBookRes* aft;
};


struct DefStru
{
	eDefTypes id;
	char name[64];
	int x;
	int y;
	int _1;
	int z;
	DWORD _2[4];
};
struct DefStru_vector// =12
{
	DefStru* buf;
	DefStru* end;
	DefStru* aft;
};



struct sActualQuest
{
	DWORD dwMainQuest;
	DWORD dwSideQuest;
};
struct sActualQuest_vector// =12
{
	sActualQuest* buf;
	sActualQuest* end;
	sActualQuest* aft;
};

struct sMapIcon
{
	cPatchPosition pos;
	DWORD gfxid;
	DWORD res;
};
struct sMapIcon_vector// =12
{
	sMapIcon* buf;
	sMapIcon* end;
	sMapIcon* aft;
};

struct ResStru
{
	char Statement[256];
	char StrUI[256];
	char _bA[256];
	char _bB[256];
	int data[8];
	DWORD u[8];
};

struct sSaveChest
{
	eItemType e;
	int x;
	int y;
	int z;
	int map;
	int dir;
	char ot[128];
	char tr[128];
};
struct sSaveChest_vector// =12
{
	sSaveChest* buf;
	sSaveChest* end;
	sSaveChest* aft;
};

struct Chances
{
	_FAMILY f;
	DWORD chance;
};

struct sWeaponPool
{
	eItemType w;
};
struct sWeaponPool_vector// =12
{
	sWeaponPool* buf;
	sWeaponPool* end;
	sWeaponPool* aft;
};
struct sRegionChange //0xAC =172
{
	DWORD ver;
	int enemy;
	int used;
	eItemType ch[20][2];
};
struct sPferdeHaendler
{
	DWORD Merc;
	DWORD Pferd[6];
	DWORD Zaum[6];
	char lev[6];
	char type[6];
	char anz;
	eItemType e[6];
	cWorldPosition w[6];
};
struct sPferdeHaendler_vector// =12
{
	sPferdeHaendler* buf;
	sPferdeHaendler* end;
	sPferdeHaendler* aft;
};
struct sTrgNamNumRef
{
	char TrgNam[64];
	DWORD TrgNum;
	DWORD _ref;
};
struct sTrgNamNumRef_vector// =12
{
	sTrgNamNumRef* buf;
	sTrgNamNumRef* end;
	sTrgNamNumRef* aft;
};

struct sCreQue
{
	DWORD ref;
	DWORD Flag;
	DWORD Quest;
	DWORD vars[8];
};
struct sCreQue_vector// =12
{
	sCreQue* buf;
	sCreQue* end;
	sCreQue* aft;
};
struct sQuestDB
{
	char Qtype;
	char Questpool;
	char Header;
	char Todo;
	char Belohnung;
	char Strafe;
	char p1;
	char p2;
	char Qp8[8];
	DWORD Flag;
	DWORD ID;
	DWORD SolveTime;
	sCreQue_vector vCre;
	DWORD_vector HToDO;
};
struct sQuestDB_vector// =12
{
	sQuestDB* buf;
	sQuestDB* end;
	sQuestDB* aft;
};
struct sIconRegion
{
	int r;
	int x;
	int y;
	int icon;
};
struct sIconRegion_vector// =12
{
	sIconRegion* buf;
	sIconRegion* end;
	sIconRegion* aft;
};
struct sSpawnReNew
{
	WORD x;
	WORD y;
	DWORD region;
	eItemType t[4];
	eItemType tn[4];
	WORD w[4];
	char p[4];
	DWORD ver;
	int IsEnemy;
};
struct sSpawnReNew_vector// =12
{
	sSpawnReNew* buf;
	sSpawnReNew* end;
	sSpawnReNew* aft;
};
struct sObjStates
{
	char na[64];
	DWORD state;
};
struct sObjStates_vector// =12
{
	sObjStates* buf;
	sObjStates* end;
	sObjStates* aft;
};
struct sTimer //0x4C =76
{
	DWORD dwObjID;
	DWORD dwPeriodicity;
	DWORD dwTimestamp;
	char function[64];
};
struct sTimer_vector// =12
{
	sTimer* buf;
	sTimer* end;
	sTimer* aft;
};
struct sNPCState //0x15C 0x11C
{
	int bpos;
	int dlg;
	int SetDir;
	int ores;
	int resnum;
	int IsEnemy;
	int vx;
	int vy;
	int vz;
	int LV;
	int GroupRad;
	int godmode;
	char name[64];
	char SetOwner[64];
	char OnDeath[64];
	BYTE See[64];
	DWORD VerFlag;
	DWORD spFlag;
	DWORD Group;
	DWORD Spellpref;
	DWORD Taktik;
	int Questnum;
	int todo;
	int Sterne;
	int Drunken;
	WORD dmgps;
	WORD dmgse;
	DWORD HorseClass;
};
struct SP_Spell
{
	DWORD ref;
	DWORD map;
	int TOx;
	int TOy;
	DWORD ToRef;
	int TOz;
	DWORD res2;
	DWORD res3;
	eCreatureSpell spell;
	WORD Combo;
	WORD Combonum;
	DWORD res4;
	DWORD res5;
	DWORD res6;
	DWORD res7;
	DWORD res8;
	DWORD res9;
};
struct sHaendler
{
	DWORD haendler;
	eItemType ding;
};
struct sHaendler_vector//0xC =12
{
	sHaendler* buf;
	sHaendler* end;
	sHaendler* aft;
};

struct InterpretSQW //0xA8A0 =43168
{
	FILE* fpStart;
	FILE* fpFunk;
	FILE* fpQuest;
	FILE* fpQuestPool;
	BYTE EnterRegion;
	BYTE InitRegion;
	BYTE EnterSector;
	BYTE InitSector;
	BYTE IsStartup;
	BYTE AppendText;
	BYTE _a11[2];
	DWORD QuestInProgess;//argum;
	cWorldPosition oPlayerStartPos[48];
	sQuestDB_vector QuestDB;
	sName_vector FunkNames;
	DefStru_vector Defs;
	AVL_sQPool_vector AVL_CreatureQuestPool;
	AVL_sRegion_vector AVL_Region;
	AVL_sQuestRegion AVL_QuestRegion;
	sDeath_vector vDeath;
	sSaveChest_vector vSaveChest;
	sMouseOver_vector vSaveMouse;
	cPatchPosition_vector vTrPatch;
	sIconRegion_vector vIconRegion;//merc.bin
	sSpawnReNew_vector vSpawnReNew;
	eItemType StartHero;
	sActualQuest ActualQuests[16];
	cQuestBookRes_vector vQuestMeta;//
	sMapIcon_vector vMapIcon;
	DWORD Mouseoversize;
	AVL_DWORD AVL_Mouseover;
	sWeaponPool_vector vWeaponPool[256];
	sRegionChange aRegionC1[70];//=12040
	sRegionChange aRegionC2[80];//=13760
	AVL_DWORD_vector AVL_Group;
	AVL_DWORD AVL_Treppe;
	sObjStates_vector vObjStates;
	AVL_DWORD_vector AVL_MOF;
	AVL_sName AVL_SECTOR;
	DWORD_vector HashToFu;	
	AVL_DWORD AVL_Trigger;
	sVar_vector Varis;//script variables
	DlgStru_vector Dlgs;//fnb;//NPC dialogs
	DlgStruRgn_vector RgnDlgs;
	DlgStru ActiveDlg;
	DlgStru LastDlg;
	sTimer_vector vTimer;
	sTimer_vector tm;
	cSpell_vector spell;
	sMouseOver_vector vMouseOver;//bob
	DWORD_vector vPendingSideQuest;
	sHaendler_vector vHaendler;
	sTrgNamNumRef_vector vTrgNamNumRef;
	BST ObjResToRef;
	cWorldPosition userMarker;
	BYTE _b111[8];
	int BalanceSpawn[32];
	int Kompass[10];
	DWORD SpawnLevel[9];
	DWORD tr_ar[150];//=600 tr_ar[N]=RndVal  atmo_rg N
	char ui[64];
	sPferdeHaendler_vector vPH;
	char MyText[8192];//text
	DWORD_vector vMyTextIDs;//
	DWORD ButtonID[5];
	char Buttons[5][2][256];
	DWORD ButtonPressed;
	char Soundname[64];//
	int WorkDlg;//nFuncNPCIndex;
	int IntFlags;
	ResStru RetVal;
};

struct MESSAGEHEADER
{
	DWORD dwLengthID;
	DWORD dwChecksum;
	WORD wMsgID;
	char byUnique[3];
	char byMessageType;
};

struct cNetworkToolsVars //0xF8
{
	__int64 qwStartTimeMS;
	__int64 qwCurrentTimeMS;
	__int64 qwRunningTimeMS;
	DWORD dwTime;
	DWORD _008;
	DWORD dwDeltaTime;
	DWORD dwHour;
	DWORD dwMin;
	DWORD dwSec;
	DWORD dwMilSec;
	FILE* fLogFile;
	HANDLE hMemory;
	DWORD dwMemoryPoolSize;
	DWORD dwUsedMemoryPool;
	HANDLE hMemoryPoolMutex;
	char* lpMemoryPool;
	char* lpMemoryPool2;
	DWORD dwUsedMemoryPool2;
	HANDLE hMemoryPool2Mutex;
	char bDedicatedMode;
	char bPackingLogfile;
	WORD wVersion;
	void* hZipMutex;
	void* hUnzipMutex;
	char* lpCompressMemory;
	char* lpUncompressMemory;
	DWORD dwCompressMemorySize;
	DWORD _0[24];
};
struct PBYTE_vector//0xC =12
{
	BYTE* buf;
	BYTE* end;
	BYTE* aft;
};
struct STRA_vector// =12
{
	STR_A* buf;
	STR_A* end;
	STR_A* aft;
};
struct cNetworkTools//0xF8 =248
{
	cNetworkToolsVars vars;
	STR_A sVersion;
	PBYTE_vector vMemoryHandles;
	STRA_vector vTimerUp;
	DWORD _0;
};

struct cScriptResource;
struct cScriptResourceVtbl
{
	void *(__thiscall *vecDelDtor)(cScriptResource* sres, DWORD);
	DWORD (__thiscall *save)(cScriptResource* sres, _iobuf*);
	DWORD (__thiscall *load)(cScriptResource* sres, _iobuf*);
	void (__thiscall *debug)(cScriptResource* sres);
};
struct cScriptResource
{
	cScriptResourceVtbl* vfptr;
	DWORD type;
};
struct cScriptResource_vector//0xC =12
{
	cScriptResource** buf;
	cScriptResource** end;
	cScriptResource** aft;
};
struct sNRLookup
{
	DWORD hash1;
	DWORD hash2;
	DWORD chunkid;
	DWORD pad;
};
struct sNRLookup_vector//0xC =12
{
	sNRLookup* buf;
	sNRLookup* end;
	sNRLookup* aft;
};
struct cScriptLoader // 0x24 =36
{
	cScriptResource_vector entries;
	STR_W emptyResource;
	sNRLookup_vector nrLookup;
};
struct cScriptResourceDlg // 0x40 =64
{
	cScriptResource sres;
	STR_W wtext;
	STR_W wsound;
	STR_A text;
	STR_A sound;
	DWORD hashval1;
	DWORD hashval2;
};
struct cScriptResourceDlg_pair
{
	DWORD key;
	cScriptResourceDlg* rres;
};

struct Entrie // =16
{
	DWORD dwHash;
	DWORD dwOffset;
	DWORD dwFormats;
	DWORD dwChars;
};
struct Entries
{
	DWORD dwEntries;
	Entrie ent[1]; // = sizeof(Entrie)*dwEntries
};


//----------------------------------------------------------------------
struct grNode //0x18 =24
{
	DWORD data;
	grNode* parent;
	grNode* left;
	grNode* right;
	cScriptResourceDlg_pair value;
//	DWORD key;
//	cScriptResourceDlg* rres;
};
struct grTree //0xC =12
{
	grNode* root;
	DWORD node_count;
	DWORD key_compare;
};
struct cResourceLoader //0x14 =20
{
	Entries* pEnts;
	DWORD dwSize;
	grTree tree;
};

//----------------------------------------------------------------------
struct scEntBST //
{
	DWORD dw1;
	scEntBST* node;
	scEntBST* left;
	scEntBST* right;
	STR_A str1;
	STR_A str2;
};
struct SettingsCfg_BST //0xC =12
{
	scEntBST* root;
	DWORD dw1;
	DWORD dw2;
};


struct SettingsCfg_pair
{
	STR_A first;
	STR_A second;
};
struct SettingsCfg_tree_node
{
	BST_base base;
	SettingsCfg_pair _M_value_field;
};
struct SettingsCfg_alloc_proxy
{
	SettingsCfg_tree_node* _M_data;
};
struct SettingsCfg_tree_base
{
	SettingsCfg_alloc_proxy _M_header;
};
struct SettingsCfg_binary_function
{
};
struct SettingsCfg_less
{
	SettingsCfg_binary_function base;
};
struct SettingsCfg_tree
{
	SettingsCfg_tree_base base;
	DWORD _M_node_count;
	SettingsCfg_less _M_key_compare;
};
struct SettingsCfg_multimap
{
	SettingsCfg_tree _M_t;
};

struct cConfigFile //0x24 =36
{
	STR_A cfgfile;
	SettingsCfg_multimap mSettings;
};

//----------------------------------------------------------------------

struct Balance //0x1378 =4984
{
	float fBalanceDmg;
	float fBalanceRes;
	float fBalanceMag;
	float fBalanceResPh;
	float fBalanceResFe;
	float fBalanceResMa;
	float fBalanceResGi;
	float fBalStatOff;
	float fBalCharPD;
	float fBalCharFD;
	float fBalCharMD;
	float fBalCharGD;
	float fBalCharPR;
	float fBalCharFR;
	float fBalCharMR;
	float fBalCharGR;

	float fWKoff;
	float fWK_s;
	float fWK_w;
	float fMKoff;
	float fMK_s;
	float fMK_w;
	float fFKoffAW;
	float fFK_s_AW;
	float fFK_w_AW;
	float fFKoffSP;
	float fFK_s_SP;
	float fFK_w_SP;
	float fSKoffAW;
	float fSK_s_AW;
	float fSK_w_AW;
	float fSKoffSP;
	float fSK_s_SP;
	float fSK_w_SP;
	float fAKoffAW;
	float fAK_s_AW;
	float fAK_w_AW;
	float fAKoffSP;
	float fAK_s_SP;
	float fAK_w_SP;
	float fKKoffAW;
	float fKK_s_AW;
	float fKK_w_AW;
	float fKKoffSP;
	float fKK_s_SP;
	float fKK_w_SP;
	float fSTKoffAW;
	float fSTK_s_AW;
	float fSTK_w_AW;
	float fSTKoffSP;
	float fSTK_s_SP;
	float fSTK_w_SP;
	float fBKoffAW;
	float fBK_s_AW;
	float fBK_w_AW;
	float fBKoffSP;
	float fBK_s_SP;
	float fBK_w_SP;
	float fFEKoffAW;
	float fFEK_s_AW;
	float fFEK_w_AW;
	float fFEKoffSP;
	float fFEK_s_SP;
	float fFEK_w_SP;

	float fHMoff;
	float fHM__s[2];
	float fFMoff;
	float fFM__s[2];
	float fEMoff;
	float fEM__s[2];
	float fWMoff;
	float fWM__s[2];
	float fLMoff;
	float fLM__s[2];
	float fMMoff;
	float fMM__s[2];
	float fBAoff;
	float fBA__s[2];
	float fBLoff;
	float fBL__s[2];
	float fKOoff;
	float fKO__s[2];
	float fMedoff;
	float fMed__s[2];
	float fWoffAW;
	float fW__sAW;
	float fW__wAW;
	float fWoffVW;
	float fW__sVW[2];
	float fHRoffAW;
	float fHR__sAW;
	float fHR__wAW;
	float fHPoffVW;
	float fHP__sVW[2];
	float fPoff;
	float fP__s[2];
	float fPoffS;
	float fP__sS[2];
	float fRoffPh;
	float fR__sPh;
	float fR__wPh;
	float fRoffFe;
	float fR__sFe[2];
	float fRoffMa;
	float fR__sMa;
	float fR__wMa;
	float fRoffGi;
	float fR__sGi;
	float fR__wGi;
	float fRoffSP;
	float fR_s_SP;
	float fR_w_SP;

	float fSpawnWeaponMin;
	float fSpawnWeaponMax;
	float fPriceDmg[3];
	float fPriceRes[3];
	float fPriceBoni[7];
	float fPrieUnic[4];
	float fPriceSlot[5];
	float fPriceLevel[3];
	float fPriceAwVw[6];

	float fPriceDFe[3];
	float fPriceRFe[3];
	float fPriceDMa[3];
	float fPriceRMa[3];
	float fPriceDGi[3];
	float fPriceRGi[3];
	float fPriceDPh[3];
	float fPriceRPh[3];

	float fHP_s1;
	float fHP_w1;
	float fHP_s2;
	float fHP_w2;
	float fHP_s3;
	float fHP_w3;
	float fHP_s4;
	float fHP_w4;
	float fHP_s5;
	float fHP_w5;

	DWORD skilllearn[6];

	DWORD nEquip[160];//640 160=20*8(class)
	DWORD nInventory[63];//252 64=8*8(class)
	
	DWORD lottoPreis[5];
	DWORD nNewSkill[6];
	DWORD IncSkillPoints[6][2];

	float fUpgradeDrop;
	float fGameSpeed;
	float fWurfWarsch;
	float fWurfMulti;
	float fWurfBoss;
	float fHarteSau;
		
	float fProzAW[6];
	float fProzHP[6];
	float fProzDmg[6];
	float fProzRes[6];
	float fProzExp[6];
	float fOffLevel[6];

	float fRespawn;
	float fRegFakHero;
	float fDropAll;

	float fWaffenAll[5];
	float fFernAll[5];
	float fRuestAll[5];
	float fMagieAll[5];
	float fAllOverLv[5];

	float fRunenProLevel_G;
	float fRunenProLevel_S;
	float fRunenProLevel_E;
	float fRunenProLevel_D;
	float fRunenProLevel_M;
	float fRunenProLevel_V;
	float fRunenProLevel_T;
	float fRunenProLevel_Z;

	float fBasisPferd[9][3];//27 = (1+1+1)*9

	DWORD nDropWaffe;
	DWORD nDropRuestung;
	DWORD nDropGold;
	DWORD nDropSonst;
	DWORD nGoldProLevel[2];
	DWORD nDropSaft;
	DWORD dwLevelUpBoss;
	DWORD dwLevelUpChamp;

	float fHPFakBoss;
	float fHPFakChamp;
	float fVWFakBoss;
	float fVWFakChamp;
	float fAWFakBoss;
	float fAWFakChamp;

	DWORD nHealthbar;
	DWORD nHealthborder;
	DWORD nFernAWMin;
	DWORD nFernAWMax;
	DWORD nFernAWProz;

	float fRegInFight;
	float fRegEnemyNear;
	float fRegNoEnemy;
	float fGoldXLev;
	float fGoldX2Lev;

	DWORD n840_Glckskind;
	DWORD n841_Blutdurst;
	DWORD n842_Schmerz;
	DWORD n843_Erkenntniss;
	DWORD n846_Zerteilen;
	DWORD n852_Schreken;
	DWORD n853_Weitsicht;
	DWORD n854_Knockback;
	DWORD n855_Fluggegner;
	DWORD n856_Diebesgut;
	DWORD n857_OffeneWunden;
	DWORD n859_Kritischer;
	DWORD n865_Licht;
	DWORD n866_GoldStattLeben;
	DWORD n867_Tollwut;
	DWORD n864_Metzger;
	DWORD n849_Erprobung;
	DWORD n845_Konzentration;
	DWORD n844_Weisheit;
	DWORD n847_Schutzgeist;
	DWORD n848_Agilitat;
	DWORD n850_Nachtschicht;
	DWORD n851_Tag;

	DWORD nARGBInfoText;

	float fTransSize;
	float fTransValu;
	float shaddar_slave_dmg_ph;
	float shaddar_slave_dmg_ma;
	float shaddar_slave_dmg_fi;
	float shaddar_slave_dmg_po;
	float shaddar_slave_speed;
	float fSpawnAnimalsSP;
	float fSpawnAnimalsMP;
	float fSpawnEnemysSP;
	float fSpawnEnemysMP;

	DWORD nLevelKap[6];

	float fObereEXPAnteil;
	float fUnterExpAnteil;
	float fObereEXPVoll;

	DWORD nUnterExpVoll;
	DWORD nStartLevMulti[6];

	float fDungeonRespawn;
	float fRareGegen;
	float fRareHeroReiter;
	float fRareDurch;
	BYTE Rare[1800];//1800=[24]*75

	float fRareSlotBronze;
	float fRareSlotSilber;
	float fRareSlotGold;
	float fMultipfeil;
	float dragonfire_dmg_ph;
	float dragonfire_dmg_fi;
	float dragonfire_dmg_po;
	float dragonfire_dmg_ma;
	float dryadghost_dmg_ph;
	float dryadghost_dmg_fi;
	float dryadghost_dmg_po;
	float dryadghost_dmg_ma;
	float fMultipfeilSP;
	float fTeambonus;
	float fMinLevelFactor;

	float fPotionOfMentorPercent;
	float fBluePotionSmallDur[5];
	float fBluePotionMediumDur[5];
	float fBluePotionLargeDur[5];
	float fPotionOfUndeadDeathPercent;
	float fBlackPotionSmallDur[5];
	float fBlackPotionMediumDur[5];
	float fBlackPotionLargeDur[5];

	float fBalanceGeschick;
	float fRuneInventoryFactor;
	float fRunesPerBoss;
	float fRuneChanceFactorMax;

	DWORD nSlotFeasibility;
	DWORD nSlotFeasibility2;
	DWORD nOffLevelProz[6];
	DWORD nBaseOffLevel[6];

	DWORD nWurfAnzahl;
	float fPricePromille;
	DWORD nHealingPotion[3];
	DWORD nPotionDiv[5];

	float fSpellFakBoss;
	float fSpellFakChamp;
	float fItemThrowFactor;
	float fLongivityFactor;
	float fLongivityCombatFactor;

	DWORD nITBonus_BIG_DEMON;
	DWORD nITBonus_DRAGON;
	DWORD nITBonus_DRAGON_ICE;
	DWORD nITBonus_DRAGON_UNDEAD;
	DWORD nITBonus_DRAGON_ICE03;
	DWORD nITBonus_DRAGON_LOROMIR;
	DWORD nITBonus_DRAGON_SIRITHCAM;
	DWORD nITBonus_DRAGON_SWAMP02;
	DWORD nITBonus_MEDUSA;
	DWORD nITBonus_;//??
	DWORD nITBonus_GIANT_SPIDER;

	DWORD nITThrowCountBonusChamp;
	DWORD nITThrowCountBonusBoss;
	DWORD nITBonusBoss;
	DWORD nITBonusChamp;
	DWORD nSlotProbBonusMerchant;

	float fEXPBonusPerPlayer;
	float fTollwutFactor;
	float fMPThrowfactor;
	float fKampfdaemonbremse;
	float fHorseOverrideTime;

	DWORD nSchreckenBase;

	float fHOMoff;
	float fHOM__w[2];
	float fWToff;
	float fWT__s;
	float fZK__w;
	
	float fWToffAW;
	float fWT_s_AW;
	float fWT_w_AW;
	float fWToffSP;
	float fWT_s_SP;
	float fWT_w_SP;

	float unkAD46BC[3];
	float fPainkiller;
	float fLeechfactor[3];
	
	DWORD nLeechWithDist;

	float spiderpuke_dmg_ph;
	float spiderpuke_dmg_fi;
	float spiderpuke_dmg_ma;
	float spiderpuke_dmg_po;

	DWORD demonspiderpuke_dmg_ph;
	DWORD demonspiderpuke_dmg_fi;
	DWORD demonspiderpuke_dmg_ma;
	DWORD demonspiderpuke_dmg_po;

	DWORD nSleepIdleSetIdleChance;

	float fJumboComboCocktail;
	float fComboCocktail;
	float fDriversComboCocktail;

	DWORD nReitenSkOff;
	DWORD nReitenSKLev;
	DWORD nReitenSKMW;

	float fHandGunRange;
	float fHandGunFalloff;
	float fRifleRange;
	float fRifleFalloff;
	float fDropQuality;
	float fDaemonDamageBonus;

	BST_tree _1;
	BST_tree ItemThrowProbabilities;
	BST_tree RareTranslationMap;
	BST_tree HorseData;
	BST_tree _5;
	BST_tree MerchantParts;
	BYTE _7[16];
};




struct CPItemBonus
{
	BYTE nBonusStufe;
	BYTE nBonusTyp;
};
struct sHeroEntry //0x56 =86
{
	eItemType dwID;
	BYTE cls;
	BYTE horseClass;
	WORD nFlags;
	// exp = A+level*B 
	WORD wExpA; //A
	WORD wExpB; //B
	BYTE nBasisStr; //  
	BYTE nBasisWied; //  
	BYTE nBasisGesch; //  
	BYTE nBasisPhysReg; //   
	BYTE nBasisMentReg; //   
	BYTE nBasisCharism; //  
	BYTE nBasis_21;
	BYTE nBasis_22;
	BYTE skills[2];
	BYTE skillsX[16];
	WORD WalkSpeed; //  
	WORD RunSpeed; //  
	CPItemBonus cpiBonus[6];
	BYTE BonusPro[6];
	BYTE BonusX[6];//CL_
	BYTE nRP[5];
	BYTE nRF[5];
	BYTE nRM[5];
	BYTE nRG[5];


};
struct sHeroEntry_vector // =12
{
	sHeroEntry* buf;
	sHeroEntry* end;
	sHeroEntry* aft;
};

struct sSwitchItem
{
	eItemType user;
	eItemType item;
};
struct sSwitchItem_vector// =12
{
	sSwitchItem* buf;
	sSwitchItem* end;
	sSwitchItem* aft;
};
struct sSwitchItem_vvector// =12
{
	sSwitchItem_vector* buf;
	sSwitchItem_vector* end;
	sSwitchItem_vector* aft;
};

struct sSetList
{
	eItemType items[10];
	DWORD res;
	char Anz;
	char SetType;
	char pad[2];
	char x[64];
};
struct sSetList_vector// =12
{
	sSetList* buf;
	sSetList* end;
	sSetList* aft;
};

struct cTypeManager // 0x5632E8 =5649128
{
	cObjectShared m_types[32352]; // 128 * 32352(cnt) = 4141056		Items.pak			cTypeManager::LoadItemTypes
	cObjectSounds m_sounds[8192]; // 184 * 8192(cnt) = 1507328		sndProfiles.pak		cTypeManager::LoadSoundProfiles
	DWORD dwWeaponCount;
	sWeaponInfoShared* pWeaponPak; // dwWeaponCount * 258			weapon.pak			cTypeManager::LoadWeaponInfo
	sHeroEntry_vector sCreature;//									creature.pak		cTypeManager::LoadCreatureInfo

	sWeaponInfo_vector slot[35];
	BYTE _040[140];
	sSetList_vector vSetList;
	STR_W wstr2;//cTypeManager_GetWeaponMod
	sSwitchItem_vvector vSwitchItem;
	DWORD m_bOnlyMakePAKs;
	DWORD dirtTexID[7][4];
	BST_tree tree;
/*
  int WeaponAnz;
  _STL::vector<sWeaponInfoShared,_STL::allocator<sWeaponInfoShared> > sWI;
  _STL::vector<sHeroEntry,_STL::allocator<sHeroEntry> > sCreature;
  _STL::vector<enum eItemType,_STL::allocator<enum eItemType> > itemFamCache[32];
  _STL::vector<sSetList,_STL::allocator<sSetList> > vSetList;
  _STL::vector<sWeaponMod,_STL::allocator<sWeaponMod> > vWeaponMod;
  _STL::vector<_STL::vector<sSwitchItem,_STL::allocator<sSwitchItem> >,_STL::allocator<_STL::vector<sSwitchItem,_STL::allocator<sSwitchItem> > > > vSwitchItem;
  char m_bOnlyMakePAKs;
  DWORD dirtTexID[7][4];
*/
};




struct sTextureEntry // 80
{
	char name[32];//strFilename[32];
	WORD width;//wCx;
	WORD height;//wCy;
	BYTE type;//nTypeID;
	DWORD RLEsize;//dwCompressedSize;
	BYTE nNumberN;
	DWORD dwOffset;
	BYTE _1[34];
};
struct sTextureEntry_vector// =12
{
	sTextureEntry* buf;
	sTextureEntry* end;
	sTextureEntry* aft;
};

//struct FileTX //0x10 =16//
//struct FileTP //0x1414 =5140

struct sHashTableEntry
{
	DWORD flags;
	DWORD nHashA;
	DWORD nHashB;
	DWORD data;
};
struct sHashTableEntry_vector// =12
{
	sHashTableEntry* buf;
	sHashTableEntry* end;
	sHashTableEntry* aft;
};
struct cCryptTable
{
	DWORD cryptTable[1280];
};
struct cHashString //0x1414 =5140
{
	DWORD usedEntries;
	DWORD hashTableSize;
	sHashTableEntry_vector hashTable;
	cCryptTable cryptTable;
};



struct cTextureLoader //0x14B4 =5300
{
	FILE* fileTexturePak;
	FILE* fileTexturePak_N[16];
	DWORD dwEntries;
	DWORD dwEntriesN[16];
	sTextureEntry_vector entries;
	cHashString hashtable;
	DWORD dwSizePak0;
	DWORD dwRnd;
	DWORD dwSizePaksAll;
};


struct cDxDisplayMode //0x84 =132
{
	DDSURFACEDESC2 ddsd;
	eDisplayType type;
	DWORD depth;
};
struct LfbInfo
{
	void* lfbPtr;
	DWORD pitch;
};
struct D3DTRANSFORMCAPS
{
	DWORD dwSize;
	DWORD dwCaps;
};
struct D3DLIGHTINGCAPS
{
	DWORD dwSize;
	DWORD dwCaps;
	DWORD dwLightingModel;
	DWORD dwNumLights;
};
struct D3DPrimCaps
{
	DWORD dwSize;
	DWORD dwMiscCaps;
	DWORD dwRasterCaps;
	DWORD dwZCmpCaps;
	DWORD dwSrcBlendCaps;
	DWORD dwDestBlendCaps;
	DWORD dwAlphaCmpCaps;
	DWORD dwShadeCaps;
	DWORD dwTextureCaps;
	DWORD dwTextureFilterCaps;
	DWORD dwTextureBlendCaps;
	DWORD dwTextureAddressCaps;
	DWORD dwStippleWidth;
	DWORD dwStippleHeight;
};
struct D3DDeviceDesc //0xFC =252
{
	DWORD dwSize;
	DWORD dwFlags;
	DWORD dcmColorModel;
	DWORD dwDevCaps;
	D3DTRANSFORMCAPS dtcTransformCaps;
	DWORD bClipping;
	D3DLIGHTINGCAPS dlcLightingCaps;
	D3DPRIMCAPS dpcLineCaps;
	D3DPRIMCAPS dpcTriCaps;
	DWORD dwDeviceRenderBitDepth;
	DWORD dwDeviceZBufferBitDepth;
	DWORD dwMaxBufferSize;
	DWORD dwMaxVertexCount;
	DWORD dwMinTextureWidth;
	DWORD dwMinTextureHeight;
	DWORD dwMaxTextureWidth;
	DWORD dwMaxTextureHeight;
	DWORD dwMinStippleWidth;
	DWORD dwMaxStippleWidth;
	DWORD dwMinStippleHeight;
	DWORD dwMaxStippleHeight;
	DWORD dwMaxTextureRepeat;
	DWORD dwMaxTextureAspectRatio;
	DWORD dwMaxAnisotropy;
	float dvGuardBandLeft;
	float dvGuardBandTop;
	float dvGuardBandRight;
	float dvGuardBandBottom;
	float dvExtentsAdjust;
	DWORD dwStencilCaps;
	DWORD dwFVFCaps;
	DWORD dwTextureOpCaps;
	WORD wMaxTextureBlendStages;
	WORD wMaxSimultaneousTextures;
};
struct cDxDeviceVtbl
{
	void* (__thiscall *vecDelDtor)(cDxDevice*, DWORD);
};
struct cDxDevice //0x8898 =34968
{
	cDxDeviceVtbl* vfptr;
	GUID* pDeviceGUID;
	D3DDEVICEDESC7 ddDeviceDesc;
	DWORD bHardware;
	GUID* pDriverGUID;
	DDCAPS_DX7 ddHALCaps;
	DDCAPS_DX7 ddHELCaps;
	GUID guidDevice;//16
	GUID guidDriver;//16
	DWORD bDesktopCompatible;
	char DriverName[128];
	char DeviceDesc[128];
	cDxDisplayMode DeviceMode[255];
	DWORD DeviceNumModes;
};
struct cDxDevices
{
	int dxNumDevices;
	cDxDevice dxDriver;
	cDxDevice dxDevice[8];
};
struct dxDriver7Vtbl
{
	void* (__thiscall *vecDelDtor)(dxDriver7*, DWORD);
};
struct FindTextureData
{
	DWORD bpp;
	DDPIXELFORMAT ddpf;
};

struct dxDriver7 //0x8B2C =35628
{
	dxDriver7Vtbl* vfptr;
	GUID guid3d;
	cDxDisplayMode mode;
	LfbInfo lfbFront;
	LfbInfo lfbBack;
	DWORD captureFrames;
	DWORD frameNum;
	HWND hWnd;
	IDirectDraw7** lpDD;
	IDirectDrawSurface7** front;
	IDirectDrawSurface7** back;
	IDirectDrawSurface7** off;
	IDirectDrawSurface7** zbuff;
	IDirect3D7** d3d;
	IDirect3DDevice7** device;
	D3DDeviceDesc ddDeviceDesc;
	DWORD dwDeviceMemType;
	DWORD dwTextureCaps;
	DWORD mode3d;
	DWORD mode3d_count;
	RECT rcSrc;
	RECT rcDest;
	DWORD stencilDepth;
	HANDLE curLoadBmp;
	HANDLE progBarFull;
	HANDLE progBarEmpty;
	HFONT progBarFont; //20pt FW_NORMAL
	D3DMATRIX viewMatrix;
	D3DMATRIX invViewMatrix;
	DWORD VerticalBlankCount;
	cDxDevice dev;
};



struct StrDrv
{
	wchar_t* _01;
	wchar_t* _02;
	wchar_t* _03;
};

struct TranslitVertex // 0x24 =36 MB_PRECOMPOSED
{
	float x; // screen position
	float y; // screen position
	float z; // Z-buffer depth
	float rhw; // reciprocal homogeneous W
	DWORD dwDiffuseRGBA; // diffuse color
	DWORD dwSpecularRGBA; // specular color
	float u; // texture coordinates
	float v; // texture coordinates
	float t; // texture coordinates VERTRES
};


struct cSMoveEntry //0x78 =120
{
	DWORD spellid;//dwID;
	DWORD nameid;
	DWORD descid;
	char textureName[32];
	DWORD textureID;
	eUITextureDef uitex[3];
	DWORD resName;
	float regenTime;
	float regenMod;
	int approach;
	DWORD launchType;
	float SpFloat[4];
	int SpInt[4];
	DWORD caster;
	char Flags[4];
};

struct ComboTGA //0x30 =48
{
	char szNameTga[36];
	DWORD dwIcon1;
	DWORD dwIcon2;
	DWORD dwIcon3;
};



struct UiTGA // 0x54 =84 sUITextureDef
{
	eUITextureDef dwID;
	eUIType type;
	char szNameTga[32];
	DWORD dwItem;
	TexUV uv;
	TexUV av;
	DWORD fcx;
	DWORD fcy;
};

// UiTGA* ui = g_UiTGA_0121[0]; // 009F0B70
// crTexture* ri = fncResourceMgr_GetResItem(*g_ResourceMgr, ui->dwItem, 0);
// if(ri) {
// IDirect3DDevice7** device = g_dxDriver7->device;
// (*device)->SetTexture(device, 0, ri->surf);
// fncDirect_DrawIcons(g_dxDriver7, x0,y0,x1,y1, clr,0, ui->uv.u0, ui->uv.v0, ui->uv.u1, ui->uv.v1)
// 

struct ResItemFunc
{
	crTexture* (__thiscall *fncResItem_Free)(crTexture* pRi, char isHeapFree);
	void (__thiscall *fncResItem_Initialize)(crTexture* pRi);
	void* sub_769690;
	void* nullsub_19;
	char (__thiscall *fncResItem_LoadTextures)(crTexture* pRi);
	IDirectDrawSurface7** (__thiscall *fncResItem_Release)(crTexture* pRi);
	DWORD (__thiscall *fncResItem_GetSize)(crTexture* pRi);
	BOOL (__thiscall *fncResItem_IsNoSurface)(crTexture* pRi);
	bool (__thiscall *fncResItem_Compare)(crTexture* pRi, crTexture* pRi2);
};
/*
  void *(__thiscall *__vecDelDtor)(iResource *this, DWORD);
  _BYTE gap4[4];
  char (__thiscall *create)(iResource *this);
  void (__thiscall *destroy)(iResource *this);
  char (__thiscall *recreate)(iResource *this);
  void (__thiscall *dispose)(iResource *this);
  DWORD (__thiscall *getSize)(iResource *this);
  char (__thiscall *isDisposed)(iResource *this);
  char (__thiscall *operator<)(iResource *this, iResource *);
*/

struct iResource
{
	ResItemFunc* vfptr;
	ePriority m_Priority;
	int m_nRefCount;
	DWORD m_LastAccess;
};

struct crTexture //0x20 =32
{
	iResource ires;
	DWORD pakid;//dwResEnt;
	IDirectDrawSurface7** surf;
	DWORD size;//dwSize;
	WORD width;//wCx;
	WORD height;//wCy;
};
struct ResItemBuffer// =12
{
	crTexture* buf;
	crTexture* end;
	crTexture* aft;
};
struct ResourceMgr //0xC002C =786476
{
	void* pFn;
	ResItemBuffer resource;
	DWORD_vector m_freeList;
	DWORD m_search[65536];
	DWORD m_insert[65536];
	DWORD m_request[65536];
	DWORD dwCurrentUsedMemory;
	DWORD dwMaximumMemory;
	DWORD dwDisposeMemorySize;
	DWORD bResourceReserved;
};

struct FontInfData //0x44 =68
{
	char szName[64];
	WORD nHeight;
	BYTE isAntialiasedQuality;
	BYTE isFontFilter;
};

struct FontFS //0x1024 =4132
{
	AVcFontFS* pFunc;
	BYTE _0[4128];
};
struct FontTTF //0x2D0 =720
{
	AVcFontTTF* pFunc;
	BYTE _0[716];
};

struct fontBg
{
	DWORD backgroundTexID;
	DWORD align;
	float bgrTexOffsetX;
	float bgrTexOffsetY;
	float _0;
	float fAngle;
};
struct ttfChar
{
	DWORD texid;
	WORD x;
	WORD y;
	WORD w;
	WORD h;
	float tu;
	float tv;
	float tu2;
	float tv2;
	__int64 timestamp;
	WORD charCode;
};
struct ttfChar_vector// =12
{
	ttfChar* buf;
	ttfChar* end;
	ttfChar* aft;
};
struct jInfo
{
	DWORD first;
	DWORD second;
	WORD pps;
	WORD dummy1;
	DWORD dummy2;
};
struct jInfo_vector//0xC =12
{
	jInfo* buf;
	jInfo* end;
	jInfo* aft;
};
struct cRrectangleInfo
{
	WORD textureSizeX;
	WORD textureSizeY;
	WORD patchSizeX;
	WORD patchSizeY;
	__int16 currentPos;
	WORD rows;
	WORD cols;
	WORD count;
};
struct sRectangleNode
{
	sRectangleNode* child[2];
	sRectangle rc;
	DWORD imageID;
};
struct cRectangleTree
{
	sRectangleNode root;
};
struct STL_pair_DWORD_int//=8
{
	DWORD first;
	int second;
};
struct STL_pair_DWORD_int_vector//0xC =12
{
	STL_pair_DWORD_int* buf;
	STL_pair_DWORD_int* end;
	STL_pair_DWORD_int* aft;
};
struct cFontTTF2 //0x20124 =131364
{
	AVcFontTEX* pFunc;
	fontBg fbg;
	TranslitVertex vtx[4];
	jInfo_vector justifyInfo;
	ttfChar_vector theChars;
	WORD idxArray[65536];
	WORD tmNewLineHeight;
	WORD tmHeight;
	WORD tmMaxCharWidth;
	WORD tmSpaceWidth;
	DWORD dwFlag;
	WORD spacesOnLine;
	WORD justifyLinePix;
	HFONT* hFont;
	cRectangleTree* rectTree;
	cRectangleInfo* rectInfo;
	int nTgaID;
	DWORD_vector lockedTex;
	int nLogPixelsX;
	KERNINGPAIR* kerningPairs;
	STL_pair_DWORD_int_vector kerningVector;
	STL_pair_DWORD_int* kerningIter;
	STL_pair_DWORD_int referencePair;
	int numTexturePages;
	DWORD cacheSize;
	LPWSTR converterBuffer;
	DWORD oldFlags;
	DWORD oldLength;
};
struct cFontTTF2_vector // =12
{
	cFontTTF2** buf;
	cFontTTF2** end;
	cFontTTF2** aft;
};

struct TgaID// =8
{
	int textureid;
	int second;
};
struct TgaID_vector// =8
{
	TgaID* buf;
	TgaID* end;
	TgaID* aft;
};

struct cFontMgr // 0x24 =36
{
	cFontTTF2_vector theFonts;
	STL_pair_DWORD_int_vector fontPool;
	STRA_vector regFonts;
};

// in script Balance.txt
// regionkill = nRegionID : dwKillMax = szRegNameUI (nAreaID1, nAreaID2, ...)

struct cRegionInfo // 0x40 =64
{
	BYTE areas[16];
	char szRegionNameUI[32];
	DWORD dwKillMax;
	BOOL isFinalBoss;
	DWORD dwKillCurr;
	DWORD dwRegionID;
};


// fnOnAlt < sub_6303E0:00632155 < sub_6325C0:00632D29 < fncEngine_ThreadFuncA:0060EB8D

struct CL_info
{
	DWORD dwID;
	char szNameCL[32];
	DWORD dwStrID;
};

struct Granny  // 0xFC =252
{
	DWORD flushTime;
	DWORD flushInterval;
	HGRANNY hGranny;
	D3DMATRIX* pWorldMatrix;
	cMutex destroyLock; // 24
	GrannySequenceBuf destroySequences;
	DWORD overideTexture;
	DWORD advTimePerFrame;
	DWORD lastFrame;
	GrannySequenceBuf grannyControlsData;
	GrannySequenceBuf grannyControls;
	GrannySequenceBuf grannySequences;
	GrannySequenceBuf grannySeqString;
	HPOSE grnPoseLArmAb; //Bip01 L UpperArm
	HPOSE grnPoseRArmAb; //Bip01 R UpperArm
	HPOSE grnPoseKopfAb; //Bip01 Head
	HPOSE grnPoseLBeinAb; //Bip01 L Thigh
	HPOSE grnPoseRBeinAb; //Bip01 R Thigh
	int tex_fx_multitexglow01;
	int tex_weather_rain01;
	int tex_fx_opaque;
	int tex_grn_shadertexture03;
	int tex_shadowdot;
	int tex_ui_Display_groundsymbol01;
	int tex_ui_Display_groundsymbol02;
	int tex_ui_Display_groundsymbol03;
	int tex_ui_Display_groundsymbol04;
	int tex_particle_spark04;
	int tex_particle_spark07;
	int tex_fx_sacredlogo;
	int tex_fx_aura01;
	int tex_grn_shadertexture02;
	int tex_grn_shadertexture04;
	int tex_particle_glow01;
	int tex_particle_glow03;
	int tex_grn_shadertexture05;
	int tex_particle_sera03;
	int tex_laserbeampart;
	int tex_grn_shadertexture06;
	int tex_grn_shadertexture07;
	int tex_grn_shadertexture08;
	int tex_particle_lighting01;
	int tex_grn_shadertexture09;

};

struct cGrannyMotion //0x14 =20
{
	HMODEL mod;
	HANIMATION anim;
	DWORD dwMotionType;
};
struct cGrannyMotion_vector
{
	cGrannyMotion* buf;
	cGrannyMotion* end;
	cGrannyMotion* aft;
};
struct cGrannyModel //0x10 =16
{
	HMODEL mod;
	DWORD dwCat;
	DWORD instances;
};
struct cGrannyModel_vector
{
	cGrannyModel* buf;
	cGrannyModel* end;
	cGrannyModel* aft;
};
struct cGrannyModelChunk //0x4AA =1194
{
	char grnFile[32];
	sFile_chunk grnData;
	DWORD flags;
	DWORD params[16];
	DWORD motions[256];
	float Sx;
	float Sy;
	float Sz;
	DWORD index;
	DWORD _2[10];
	WORD fileEntry;
};
struct cGrannyModelChunk_vector
{
	cGrannyModelChunk* buf;
	cGrannyModelChunk* end;
	cGrannyModelChunk* aft;
};

struct MotionParamEnt // =192
{
	DWORD dw[16];
	float param[32]; // 7=speed
};

struct cGrannyMotionChunk //0x100 =256
{
	char grnFile[32];
	sFile_chunk grnData;
	WORD flags;
	WORD fileEntry;
	DWORD paramsD[4];
	MotionParamEnt mpe;//paramsX[48];
};
struct cGrannyMotionChunk_vector
{
	cGrannyMotionChunk* buf;
	cGrannyMotionChunk* end;
	cGrannyMotionChunk* aft;
};


struct cGrannyStatistics
{
	DWORD modelsLoaded;
	DWORD modelsCached;
	DWORD modelsFreed;
	DWORD motionsLoaded;
	DWORD motionsCached;
	DWORD motionsFreed;
};

struct GrannyModelManager //0x1A338 =107320
{
	FILE* pakFile;//==pFile[0];
	FILE* pFile[16];
	BYTE usingPAK;
	BYTE usingExternals;
	BYTE _01[2];
	cGrannyModelChunk_vector pakModels;
	cGrannyMotionChunk_vector pakMotions;
	cGrannyModel_vector models;
	cGrannyMotion_vector motions;
	DWORD tpSize;
	DWORD tpRand1;
	DWORD tpRand2;
	DWORD lastUsed[4];
	cHashString hashtable;
	cGrannyStatistics stats;
	DWORD readA;
	DWORD readB;
	char readBuffer[102000];
};



struct cMouseCursor //0x2C =44
{
	WORD flags;// &2 = item cur; 
	WORD dx;
	WORD dy;
	WORD ddx;
	WORD ddy;
	WORD w32;
	DWORD texEntry;
	float u1;
	float v1;
	float u2;
	float v3;
	HSEQUENCE Sequence;
	DWORD itemType;
};

struct CurBuffer// =12
{
	cMouseCursor* buf;
	cMouseCursor* end;
	cMouseCursor* aft;
};

struct cMouse //0x70 =112
{
	DWORD flags;
	DWORD currX;
	DWORD currY;
	DWORD prevX;
	DWORD prevY;
	DWORD minX;
	DWORD minY;
	DWORD maxX;
	DWORD maxY;
	cMutex mouseStackLock; // 24
	Deque mouseStack;
	cMouseCursor* activeCursor;
	cMouseDragDrop* dragDrop;
	DWORD lastDet;
};



/*
fncTexture_DrawPopUpText

1) 006E76D8 > 006E7B45 > 006514B5 -   1111/2222
2) 0060ECC4 > 00759230 > 00758B19 > 006E77C6 > 006514B5

1) 006E76D8 > 006E7B45 > 006514B5 - hero info
2) 0060ECC4 > 00759230 > 00758B19 > 006E77C6 > 006514B5

006514B5 - curr exp popup
006514B5 - 
006514B5 - WilliamA
006514B5 -    
006514B5 -  
006514B5 - Spell popup
006514B5 - Weapon popup
006514B5 - kill exp flay-popup
006514B5 - 



////////////////////
:
////////////////////
1) 006AA4EF
2)	0060ECC4(fncEngine_ThreadFuncA) >
		00759121(fnUI_Manager_Draw) >
			006AA5B0(fnsUI_WND_STATS_CHAR_Draw)
				fncTexture_DrawPopUpText : Williana

1)	0072885B(fnsUI_TabControl_Draw) >
		0065153E(fncTexture_DrawPopUpText2)
			fncTexture_DrawPopUpText : 
2)	007288DD(fnsUI_TabControl_Draw) >
		0065153E(fncTexture_DrawPopUpText2)
			fncTexture_DrawPopUpText : 

1) 0072885B > 0065153E
2) 007288DD > 0065153E - fncTexture_DrawPopUpText : 

1) 0072885B > 0065153E
2)	00759109(fnUI_Manager_Draw) >
		006C64C3(fnsUI_WND_INVENTORY_DrawChest) >
			007292FE(fnsUI_TABSHEET_INVENTORY_Draw) >
				007288DD(fnsUI_TabControl_Draw) >
					0065153E(fncTexture_DrawPopUpText2)
						fncTexture_DrawPopUpText : 

////////////////////
:
////////////////////
1) 006BB76B > 00753F85 - 
2) 006BB7AC > 00753F85

1) 006BB76B > 00753F85 - 
2) 006BB7AC > 00753F85

1) - 
2)

1) - 
2)

1) 006BB76B > 00753F85 - 
2) 0060ECC4(fncEngine_ThreadFuncA) > 0075925A > 006BB7AC > 00753F85

////////////////////
weapoint popup:
spell popup:
hero info popup:
////////////////////
1) 006E76D8 > 006E7B45
2) 0060ECC4(fncEngine_ThreadFuncA) > 00759230 > 00758B19 > 006E77C6

////////////////////
life killed mons popup:
////////////////////
1)0060EBEE > 0041E75A
2)0060EBEE > 0041E75A



00612A87 - item in ground popup
00627FE4 - Alt popup
0075C29F - monster popup

00628073 call    dword ptr [edx+18h] = 57


006C71F3 - : 

-----------
006AA611 - . 00648F34 - 190
006A9CD3 - 
006A9F3A - 
006A9F3A -  00648F34 - 
006AB18A -  / - 006AB1BC
006AB21A -  00648E24 - 
006AB301 -  00648E24 - 
006AB39F -  00648F34 - 
006AB4E4 -  006AB519 - 63%
006AB8F8 -  006AB92A - -
006ABB61 -  006ABB96 - -
006ABDCF -  006ABE04 - 
006ABE9A -  
006A913D - 
006A9254 -  00648F34 - 746
006A92B8 -  00648F34 - 426
006A931E -  ==468
006A9382 -  ==363
006A93E8 -  ==573
006A944F -  ==301
006A94BB -  00648E24 - 
006A951F -  ==


:
006DE8DB - 
006DF062 - 
006DF0EA -  006DF14C - 
006DF1F2 -  006DF229 - ::
006DF2BF -  006DF2F5 - . 006DF332 - %
006DF39F -  00648E24 - 
006DF44B -  00648E24 - 


00612CD9 -  

:
0073964C - 

007218D2 - 
0072BD94 - , 

*/
struct cParticle //0x40 =64
{
	D3DVECTOR position;
	D3DVECTOR oldpos;
	D3DVECTOR velocity;
	float mass;
	float size;
	float energy;
	float phi;
	DWORD color;
	float moment;
	BYTE frame;
	BYTE id;
	BYTE _0[2];
};
struct cParticle_vector //0xC =12
{
	cParticle* buf;
	cParticle* end;
	cParticle* aft;
};
struct cParticleSystem //0x20A0
{
	cParticleSystemVtbl* pFunc;
	DWORD systemType;
	D3DVECTOR position;
	float orientation[3][3];
	D3DVECTOR bonePos[3];
	D3DVECTOR localPos;
	cParticle_vector particles;
	DWORD requestFlags;
	DWORD requestData;
	DWORD Flags;
	DWORD ActionFlags;
	DWORD ActionDat1;
	DWORD ActionDat2;
	D3DVECTOR ActionPos1;
	DWORD userData;
	int lightRadius;
	DWORD lightingCol;
	float heightAboveGround;
	char anzBlocks;
	char version;
	BYTE _0[2];
	DWORD objFXref;
	DWORD loopSndID;
	DWORD lightID;
	cDX7RenderState* rsMgr; 
	D3DLVERTEX* stdLVertexList;
	D3DLVERTEX stdLVertex[4];//32
	D3DLVERTEX stdHelixVertexN[100];
	D3DLVERTEX stdHelixVertexT[100];
	DWORD emptyParticle[400];
	DWORD anzEmptyParticle;
	float lastCreationTime;
	D3DVECTOR lastPosition;
	D3DVECTOR lastPosition2;
};
struct cParticleSystem_vector //0xC =12
{
	cParticleSystem** buf;
	cParticleSystem** end;
	cParticleSystem** aft;
};
struct cParticleSystemManager // 0xC24 =3108
{
	cMutex systemsLock; // 24
	cParticleSystem_vector systems;
	D3DVECTOR random[256];//[12]x256
};
struct cParticleSystem_kamikaze //0x253C =
{
	cParticleSystem base;
	BYTE _0[1180];
};

struct sSystemInfo
{
	float time;
	DWORD alive;
	DWORD state;
	DWORD ranBits;
	float su[5];
	float sv[5];
	float faderTime;
};
struct cParticleSystem_flash
{
	cParticleSystem base;
	sSystemInfo si;
	D3DLVERTEX spriteVertsTop[4];
	D3DLVERTEX spriteVertsBot[4];
	DWORD texIDtop;
	DWORD texIDbot;
};













struct Exception
{
	DWORD dwExceptionCode;
	DWORD dwExceptionFlags;
	DWORD _01;
	DWORD _02;
	DWORD dwNumberOfArguments;
	DWORD Arguments[3];
}; 

struct _type
{
	DWORD dwType;
	char szType[64];
};
struct _motion
{
	DWORD dwType;
	char szType[32];
};


struct cCalendarDate // =8
{
	DWORD year;
	WORD month;
	WORD day;
};
struct cCalendarTime //0x18 // CalendarTime
{
	WORD hours;
	WORD minutes;
	WORD seconds;
	WORD un1;
	float miliseconds;
	sTimer_vector vTimer;
};
struct cCalendar //0x38 =56
{
	cTimerListener tlst;
	float timeFactor;
	float timeFactor_Day;
	float timeFactor_Night;
	cCalendarDate date;
	cCalendarTime time;
};
struct CalendarBuffer// =12
{
	cCalendar* buf;
	cCalendar* end;
	cCalendar* aft;
};

struct cTimerNode//0x20
{
	cTimerListener* listener;
	DWORD flags;
	double lastTimeNotified;
	double nextTimeNotified;
	DWORD numUpdates;
};
struct cTimerNode_vector// =12
{
	cTimerNode* buf;
	cTimerNode* end;
	cTimerNode* aft;
};
struct cTimer //0x50 =80
{
	eTimerUpdatePriority minPriority;
	cMutex lFrameLock;
	cMutex lCustomLock;
	cTimerNode_vector lFrame;
	cTimerNode_vector lCustom;
	DWORD numRegistered;
};


struct sWaterAnimData//0xD8 =216
{
	DWORD waterTexID[50];
	DWORD anzWaterFrames;
	DWORD renderCaustics;
	int trans;
	DWORD hasGlow;
};
struct sHighlightPos//=12
{
	int x;
	int y;
	int radius;
};


struct cWeatherManager //0x12E6C =77420
{
	DWORD bDoCalcWeather;
	DWORD cameraX;
	DWORD cameraY;
	float cameraZoom;
	DWORD currentWeather; // !0x20= IsDay; 0x20= IsNight
	float maxX;
	float maxY;
	int AnzRainParticles;
	int sollAnzRainParticles;
	D3DTLVERTEX pline[2];//=32
	DWORD rainSndChannel;//4
	D3DVECTOR wind;
	float windForce;
	D3DTLVERTEX pquad[4];
	D3DTLVERTEX pquadMM[4];
	int sollFogColor;
	int fogColor;
	float offsetU1;
	float offsetV1;
	float offsetU2;
	float offsetV2;
	D3DTLVERTEX pfquad[4];
	int sollGroundfogColor;
	int groundfogColor;
	float gfOffset[50];
	float gfSpeed[50];
	D3DTLVERTEX pblquad[4];
	float timeToNextFlash;
	float flashTime;
	int doSingleFlash;
	D3DTLVERTEX psnquad[4];
	D3DVECTOR snowFlakes[3000];
	int anzSnowFlakes;
	int sollAnzSnowFlakes;
	D3DTLVERTEX pRainDrops[4];
	float rainDropsCntr;
	float rainDropsX;
	float rainDropsY;

	sWaterAnimData BWater1;
	sWaterAnimData BWater2;
	sWaterAnimData CWater1;
	sWaterAnimData CWater2;
	sWaterAnimData ALava1;
	sWaterAnimData BLava1;
	sWaterAnimData CLava1;
	sWaterAnimData ASchwefel;
	sWaterAnimData DLava1;
	sWaterAnimData EWater2;
	sWaterAnimData FWater2;
	sWaterAnimData GWater2;
	sWaterAnimData ELava1;
	sWaterAnimData BWater3;

	float quakeStrength;
	float quakeStomp;
	DWORD quakeOffsetX;
	DWORD quakeOffsetY;
	DWORD natureTypeCol[16];
	float lavaBurstTimer;
	DWORD dungeonNight;
	sHighlightPos hiliPosList[1024];
	int anzHiliPosList;
	sHighlightPos hiliPosTemp[1024];
	int anzHiliPosTemp;
	DWORD hiliNightR[256];
	DWORD hiliNightG[256];
	DWORD hiliNightB[256];
	DWORD hiliDungeonR[256];
	DWORD hiliDungeonG[256];
	DWORD hiliDungeonB[256];
	char hiliMap[3072];
	char hiliMapTemp[3072];
	char hiliMapDot[50];
	WORD tg_200;//dawn[2];
	WORD tg_320;
	WORD tg_1220;//dusk[2];
	WORD tg_1340;
	BYTE _3[2];
	DWORD nightValue;
	D3DCOLORVALUE intensity;
	DWORD dwNetworkSectorID;
};

struct TypesData //12
{
	WORD fxFlags;
	WORD fxFire;
	WORD fxGift;
	WORD fxMagic;
	WORD reserved[2];
};

struct SaveHeroData //0x22C =556
{
	int nMinLVL;
	int nPak;
	wchar_t szUser[64];
	DWORD numTypes; //19
	DWORD types[24];
	BYTE nDifficulty;
	BYTE bronze;
	BYTE silver;
	BYTE gold;
	BYTE platinum;
	BYTE niobium;
	BYTE _04;
	BYTE isHardcore;
	BYTE _03[5];
	BYTE nDeathCounter;
	BYTE nFlags;
	BYTE nSlotCount;
	DWORD dwExp;
	DWORD dwGold;
	StatsDate date;
	BYTE _000[5];
	TypesData fxTypes[24];
};




enum eInHeadImage
{
	HI_000_NPC_DIALOG_01 = 0,
	HI_001_NPC_DIALOG_02 = 1,
	HI_004_NPC_DIALOG_05 = 4,
	HI_005_NPC_DIALOG_07 = 5,
	HI_010_NPC_DIALOG_01 = 10,
	HI_011_NPC_DIALOG_02 = 11,
	HI_014_NPC_DIALOG_05 = 14,
	HI_015_NPC_DIALOG_07 = 15,
	HI_032_NPC_DIALOG_SMITH = 32,
	HI_033_NPC_DIALOG_TRADER = 33,
	HI_034_NPC_DIALOG_COMBO = 34,
	HI_035_NPC_DIALOG_TRADER = 35,
	HI_064_SIM_TALK = 64,
	HI_065_SIM_TALK_ROMANCE = 65,
	HI_066_SIM_TALK_MUSIC = 66,
	HI_067_SIM_TALK_WEATHER = 67,
	HI_068_SIM_TALK_POLITICS = 68,
	HI_069_SIM_TALK_MONEY = 69,
	HI_070_SIM_TALK_WAR = 70,
	HI_071_SIM_TALK_GAMBLE = 71,
	HI_072_SIM_LISTEN = 72,
	HI_073_SIM_FIGHT = 73,
	HI_074_SIM_GUARD = 74,
	HI_075_SIM_QUEST = 75,
	HI_076_SIM_SLEEP = 76,
	HI_077_SIM_PANIC = 77,
	HI_078_SIM_DOOR_WHERE = 78,
	HI_079_SIM_DOOR_PANIC = 79,
	HI_080_SIM_WALK = 80,
	HI_081_SIM_NERVOUS = 81,
	HI_082_SIM_ROMANCE = 82,
	HI_083_SIM_ANIMAL_WHERE = 83,
	HI_084_SIM_VISIT = 84,
	HI_085_SIM_GOING_HOME = 85,
	HI_086_SIM_BBQ = 86,
	HI_087_SIM_DOOR_LOCKED = 87,
	HI_088_SIM_DOOR_WRONG = 88,
	HI_089_SIM_FARM = 89,
	HI_090_SIM_FOLLOW = 90,
	HI_126_NO_DRAW = 126,
	HI_127_NPC_DIALOG_02 = 127,
	HI_128_SIM_PHYSICAL = 128,
	HI_129_SIM_FIRE = 129,
	HI_130_SIM_MAGIC = 130,
	HI_131_SIM_POISON = 131,
};

struct InHeadImage
{
	DWORD _000_npc_dialog_01; // color = 0xFFFFFF00
	DWORD _001_npc_dialog_02;
	DWORD un1[2];
	DWORD _004_npc_dialog_05;
	DWORD _005_npc_dialog_07;
	DWORD un2[4];
	DWORD _010_npc_dialog_01; // color = 0xFF3F3F3F
	DWORD _011_npc_dialog_02;
	DWORD un3[2];
	DWORD _014_npc_dialog_05;
	DWORD _015_npc_dialog_07;
	DWORD un4[16];
	DWORD _032_npc_dialog_smith; // color = 0xFFFFFF00
	DWORD _033_npc_dialog_trader;
	DWORD _034_npc_dialog_combo;
	DWORD _035_npc_dialog_trader;
	DWORD un5[28];
	DWORD _064_sim_talk; // color = 0xFFFFFFFF
	DWORD _065_sim_talk_romance;
	DWORD _066_sim_talk_music;
	DWORD _067_sim_talk_weather;
	DWORD _068_sim_talk_politics;
	DWORD _069_sim_talk_money;
	DWORD _070_sim_talk_war;
	DWORD _071_sim_talk_gamble;
	DWORD _072_sim_listen;
	DWORD _073_sim_fight;
	DWORD _074_sim_guard;
	DWORD _075_sim_quest;
	DWORD _076_sim_sleep;
	DWORD _077_sim_panic;
	DWORD _078_sim_door_where;
	DWORD _079_sim_door_panic;
	DWORD _080_sim_walk;
	DWORD _081_sim_nervous;
	DWORD _082_sim_romance;
	DWORD _083_sim_animal_where;
	DWORD _084_sim_visit;
	DWORD _085_sim_going_home;
	DWORD _086_sim_bbq;
	DWORD _087_sim_door_locked;
	DWORD _088_sim_door_wrong;
	DWORD _089_sim_farm;
	DWORD _090_sim_follow;
	DWORD un6[35];
	DWORD _126; // no_draw;
	DWORD _127_npc_dialog_02; // color = 0xFFFF0000
	DWORD _128_sim_physical; // color = 0xFFFFFFFF
	DWORD _129_sim_fire;
	DWORD _130_sim_magic;
	DWORD _131_sim_poison;
};


//0055ECAA
// 0055F260
//0055F281


struct Portals
{
	int portal_00;
	int portal_01;
	int portal_02;
	int portal_03;
	int portal_04;
	int portal_05;
	int portal_06;
	int portal_07;
	int portal_08;
	int portal_09;
	int portal_10;
	int portal_11;
	int portal_12;
	int portal_13;
};

struct Teleport// =16
{
	DWORD id;
	DWORD x;
	DWORD y;
	WORD cx;
	WORD cy;
};

struct TPBuffer// =12
{
	Teleport* buf;
	Teleport* end;
	Teleport* aft;
};

struct Cmd
{
	char cmd[32];
	DWORD _1;
	DWORD _2;
	DWORD _3;
	DWORD _4;
	DWORD _5;
	DWORD _6;
};

struct HandleGDI
{
	HGDIOBJ hObj1;
	HGDIOBJ hObj2;
};

struct HandleGDIBuffer// =12
{
	HandleGDI* buf;
	HandleGDI* end;
	HandleGDI* aft;
};


struct RECTFLOAT
{
	float left;
	float right;
	float top;
	float bottom;
};
struct vector_RECTFLOAT
{
	RECTFLOAT* buf;
	RECTFLOAT* end;
	RECTFLOAT* aft;
};


struct CONFX_WATER_SURFACE
{
	DWORD height;
	float velocity;
};
struct CONFX_WATER_REFRACT// =12
{
	DWORD refract;
	DWORD refractNorm;
	DWORD diffuse;
};


struct ConsoleFX//0x1A84 =6788
{
	float size;
	float scaleTex;
	DWORD avgHeight;
	DWORD waterShift;
	DWORD waterSize;
	DWORD waterArea;
	DWORD waterMask;
	DWORD anzVertices;
	DWORD anzIndices;
	CONFX_WATER_REFRACT refract[512];
	CONFX_WATER_REFRACT* pRefract;
	DWORD lutTable[16];
	float timeTillNextDrop;
	CONFX_WATER_SURFACE* pSurface;
	D3POINT vecPos;
	D3POINT vecLight;
	float fov;
	float alpha;
	float distance;
	float height;
	D3DMATRIX matWorld;
	D3DMATRIX matView;
	D3DMATRIX matProj;
	WORD* pIndices;
	D3DVERTEX* pVertices;
	D3DLVERTEX* pCaustics;
	float timeTilNext;
	DWORD type;
	vector_RECTFLOAT calmAreas;
	D3DTLVERTEX tlVert[4];
	float staticRnd[32];
	DWORD texIDbasin;
	DWORD texIDref;
	DWORD isInCave;
};


////////////////////////////////////////////
struct MSS120
{
	BYTE _0[120];
};
struct MSS16
{
	DWORD _01;
	DWORD _02;
	DWORD _03;
	DWORD _04;
};
struct MSS48
{
	MSS16 m016;
	MSS16 m116;
	MSS120* b120;
	DWORD dwCount;
};
//-------------------------------
struct mssEntBST //0x18 =24
{
	DWORD dw1;
	BST_base* node;
	BST_base* left;
	BST_base* right;
};
struct MSS_BST //0xC =12
{
	mssEntBST* root;
	DWORD dw1;
	DWORD dw2;
	MSS48 m48;
	DWORD dw3;
	DWORD dw4;
};

struct mss_sample //0x30 =48
{
	HSAMPLE sample;
	HSAMPLE sample3d;
	DWORD dwSoundChunk;
	float volume;
	float distanceVolume;
	DWORD pan;
	DWORD ingameZoom;
	DWORD oid;
	float radScale;
	BYTE* buff;
	DWORD dwSize;
	void* wav;
};
struct mss_stream //0x1C =28
{
	HSTREAM stream;
	DWORD dwMusic; // g_SOUND_FX: _type.dwType
	float fVol;
	float distanceVolume;
	float pan;
	DWORD ingameZoom;
	DWORD objectId;
};
struct mss_volume //0x08 =8
{
	DWORD dwSnd;
	float volume;
};
struct mss_chunk //0x14 =20
{
	DWORD dwSoundChunk;
	DWORD dwCompressedSize;
	DWORD dwCnt;
	DWORD isUsed;
	BYTE* pChunkData;
};
struct mssCreatureInfo//0x88
{
	DWORD flags;
	DWORD creatureID;
	DWORD creatureType;
	int x;
	int y;
	int r;
	eCreatureStatus creatureStatus;
	WORD creatureMotion;
	WORD creatureFacing;
	D3DVECTOR cFacing;

	WORD creatureHitPoints;
	WORD creatureHitPoints_Max;
	DWORD creatureLevel;
	eSoundStatus soundStatus;
	WORD currentUsedChannel;
	WORD motionStorage[16];
	WORD chancesOf[6];
	WORD facingStorage[16];
	WORD un1;
};

struct mssStreamInfo
{
	int StreamMSPosition;
	int StreamMSLength;
	int SID;
};
struct mssLogicInfo
{
	DWORD creatureHitpointSum;
	DWORD creatureLevelSum;
	__int64 levelFactor;
	__int64 hitpointFactor;
};

struct cMSS //0xBDA0 =48544
{
	BYTE _001[17];
	BYTE isSoundDistabled;
	BYTE _002[2];
	MSS_BST mss_bst;

	HDIGDRIVER mssDIG;//hDigDriver;
	HPROVIDER mss3DProvider;
	HDIGDRIVER mss3DListener;
	BYTE _1[4];
	HANDLE hSound;
	DWORD mssFlags;//dwFlag;
	DWORD digitalRate;
	DWORD digitalBits;
	DWORD digitalChans;
	float volume_speech;
	float volume_sfx;
	float volume_music;
	BYTE is3DSound;
	BYTE _u001;
	WORD soundquality;
	float zoomfactor;
	BYTE _113_1;
	BYTE _113_2;
	BYTE _113_3;
	BYTE _113_4;
	int nLangNo;
	mss_sample smp[28]; //=48
	DWORD num_voices;
	mss_stream streamchannels[6]; //=28
	DWORD num_streams;
	DWORD osSoundProfile;
	BYTE _a11[8];
	WORD currentMusic;
	WORD currentJingle;
	WORD lastMusic;
	WORD currentSectorMusic;
	WORD lastSectorMusic[2];
	WORD currentSoundMode;
	BYTE _a21[2];
	WORD isTaskSwitched;
	BYTE _a2211[6];
	BYTE isFadingAfterFight;
	BYTE fadeOutMainStreams;
	BYTE _a2212[2];
	DWORD atmoSpotStatus;
	WORD currentAtmoSpot;
	WORD lastAtmoSpot;
	BYTE isAtmoSpotOnly;
	BYTE _a222[3];
	mss_volume specialVolume[65]; //=8
	BYTE _01a1[376]; //[12]x32
	WORD m_envDayStatus;
	WORD currentPatchType;
	BYTE _01a2[4];
	BYTE _01b[20];
	mssLogicInfo logicInfo[32];
	BYTE _01d[84];
	mssCreatureInfo creatureInfo[32];//[136]x32
	mssCreatureInfo NPCInfo[256];//[136]x256
	mssCreatureInfo staticFXInfo[16];//[136]x16
	DWORD currentAction;
	DWORD musicAction;
	int viewX;
	int viewY;
	DWORD creatureAnz;
	DWORD NPCAnz;
	DWORD staticFXAnz;
	WORD heroID;
	WORD heroType;
	WORD heroOnHorse;
	WORD heroHorseID;
	BYTE _01i121[2];
	BYTE isFightMusicPlaying;
	BYTE _01k11[1];
	DWORD waterCacheCount;
	DWORD carX;
	DWORD carY;
	BYTE _01k12[4];
	__int64 jingleBanTime_Danger;
	__int64 jingleBanTime_FightNormal;
	__int64 jingleBanTime_FightHard;
	__int64 fightBanTime;
	BYTE _01k2[12];
	BYTE timeBan[2048];//[16]*128 cMSS::mssTimeBan
	int posHeroX;
	int posHeroY;
	DWORD fj1;//0
	float volumering_max;//4.5859375
	DWORD fj3;//0
	float absorppanring_max;//3.7539062
	float volumeEnvX1;//0.5
	float volumeEnvY1;//0.5
	float volumeEnvX2;//0.89999998
	float volumeEnvY2;//0.1
	float delta_t;
	BYTE _01j111[4];
	__int64 delta_t2;
	BYTE _01j112[32];
	WORD speechchannel;
	WORD speechchannel_self;
	BYTE _01j12[12];
	FILE* sound_pak;
	mss_chunk chk[64];
	STR_A m_FootStepSetHumans;
	STR_A m_FootStepSetNature;
	STR_A m_FootStepSetZombieNStuff;
	STR_A m_FootStepSetMassive;
	STR_A m_NonSilentObjects;
	STR_A s04[9];
	DWORD _3;
	
};





//------------------------------------------------------------------------- JPG
enum _IJL_COLOR
{
	IJL_RGB = 0x1,
	IJL_BGR = 0x2,
	IJL_YCBCR = 0x3,
	IJL_G = 0x4,
	IJL_RGBA_FPX = 0x5,
	IJL_YCBCRA_FPX = 0x6,
	IJL_OTHER = 0xFF,
};
enum _IJL_JPGSUBSAMPLING
{
	IJL_NONE = 0x0,
	IJL_411 = 0x1,
	IJL_422 = 0x2,
	IJL_4114 = 0x3,
	IJL_4224 = 0x4,
};
enum _IJLIOTYPE
{
	IJL_SETUP = 0xFFFFFFFF,
	IJL_JFILE_READPARAMS = 0x0,
	IJL_JBUFF_READPARAMS = 0x1,
	IJL_JFILE_READWHOLEIMAGE = 0x2,
	IJL_JBUFF_READWHOLEIMAGE = 0x3,
	IJL_JFILE_READHEADER = 0x4,
	IJL_JBUFF_READHEADER = 0x5,
	IJL_JFILE_READENTROPY = 0x6,
	IJL_JBUFF_READENTROPY = 0x7,
	IJL_JFILE_WRITEWHOLEIMAGE = 0x8,
	IJL_JBUFF_WRITEWHOLEIMAGE = 0x9,
	IJL_JFILE_WRITEHEADER = 0xA,
	IJL_JBUFF_WRITEHEADER = 0xB,
	IJL_JFILE_WRITEENTROPY = 0xC,
	IJL_JBUFF_WRITEENTROPY = 0xD,
	IJL_JFILE_READONEHALF = 0xE,
	IJL_JBUFF_READONEHALF = 0xF,
	IJL_JFILE_READONEQUARTER = 0x10,
	IJL_JBUFF_READONEQUARTER = 0x11,
	IJL_JFILE_READONEEIGHTH = 0x12,
	IJL_JBUFF_READONEEIGHTH = 0x13,
	IJL_JFILE_READTHUMBNAIL = 0x14,
	IJL_JBUFF_READTHUMBNAIL = 0x15,
};
struct _IJL_RECT
{
	int left;
	int top;
	int right;
	int bottom;
};
enum _DCTTYPE
{
	IJL_AAN = 0x0,
	IJL_IPP = 0x1,
};
enum _FAST_MCU_PROCESSING_TYPE
{
	IJL_NO_CC_OR_US = 0x0,
	IJL_111_YCBCR_111_RGB = 0x1,
	IJL_111_YCBCR_111_BGR = 0x2,
	IJL_411_YCBCR_111_RGB = 0x3,
	IJL_411_YCBCR_111_BGR = 0x4,
	IJL_422_YCBCR_111_RGB = 0x5,
	IJL_422_YCBCR_111_BGR = 0x6,
	IJL_111_YCBCR_1111_RGBA_FPX = 0x7,
	IJL_411_YCBCR_1111_RGBA_FPX = 0x8,
	IJL_422_YCBCR_1111_RGBA_FPX = 0x9,
	IJL_1111_YCBCRA_FPX_1111_RGBA_FPX = 0xA,
	IJL_4114_YCBCRA_FPX_1111_RGBA_FPX = 0xB,
	IJL_4224_YCBCRA_FPX_1111_RGBA_FPX = 0xC,
	IJL_111_RGB_1111_RGBA_FPX = 0xD,
	IJL_1111_RGBA_FPX_1111_RGBA_FPX = 0xE,
	IJL_111_OTHER_111_OTHER = 0xF,
	IJL_411_OTHER_111_OTHER = 0x10,
	IJL_422_OTHER_111_OTHER = 0x11,
	IJL_YCBYCR_YCBCR = 0x12,
	IJL_YCBCR_YCBYCR = 0x13,
	IJL_1_G_1_G = 0x14,
};
struct _QUANT_TABLE
{
	int precision;
	int ident;
	__int16 *elements;
	__int16 elarray[84];
};
struct _HUFFMAN_TABLE
{
	int huff_class;
	int ident;
	DWORD huffelem[256];
	WORD huffval[256];
	WORD mincode[17];
	__int16 maxcode[18];
	WORD valptr[17];
};
struct _JPEGQuantTable
{
	char *quantizer;
	char ident;
	BYTE un[3];
};
struct _JPEGHuffTable
{
	char *bits;
	char *vals;
	char hclass;
	char ident;
	BYTE un[2];
};
struct _FRAME_COMPONENT
{
	int ident;
	int hsampling;
	int vsampling;
	int quant_sel;
};
struct _FRAME
{
	int precision;
	int width;
	int height;
	int MCUheight;
	int MCUwidth;
	int max_hsampling;
	int max_vsampling;
	int ncomps;
	int horMCU;
	int totalMCU;
	_FRAME_COMPONENT *comps;
	int restart_interv;
	int SeenAllDCScans;
	int SeenAllACScans;
};
struct _SCAN_COMPONENT
{
	int comp;
	int hsampling;
	int vsampling;
	_HUFFMAN_TABLE *dc_table;
	_HUFFMAN_TABLE *ac_table;
	_QUANT_TABLE *quant_table;
};
struct _SCAN
{
	int ncomps;
	int gray_scale;
	int start_spec;
	int end_spec;
	int approx_high;
	int approx_low;
	DWORD restart_interv;
	int curxMCU;
	int curyMCU;
	int dc_diff[4];
	_SCAN_COMPONENT *comps;
};
enum _PROCESSOR_TYPE
{
	IJL_OTHER_PROC = 0x0,
	IJL_PENTIUM_PROC = 0x1,
	IJL_PENTIUM_PRO_PROC = 0x2,
	IJL_PENTIUM_PROC_MMX_TECH = 0x3,
	IJL_PENTIUM_II_PROC = 0x4,
	IJL_PENTIUM_III_PROC = 0x5,
	IJL_PENTIUM_4_PROC = 0x6,
	IJL_NEW_PROCESSOR = 0x7,
};
struct _STATE
{
	unsigned __int64 bit_buffer_64;
	void *ctx;
	int bitbuf_bits_valid;
	char *cur_entropy_ptr;
	char *start_entropy_ptr;
	char *end_entropy_ptr;
	int entropy_bytes_processed;
	int entropy_buf_maxsize;
	int entropy_bytes_left;
	int Prog_EndOfBlock_Run;
	char *DIB_ptr;
	char unread_marker;
	_PROCESSOR_TYPE processor_type;
	int cur_scan_comp;
	void *file;
	char JPGBuffer[4096];
};
struct _ENTROPYSTRUCT
{
	DWORD offset;
	int dcval1;
	int dcval2;
	int dcval3;
	int dcval4;
	unsigned __int64 bit_buffer_64;
	int bitbuf_bits_valid;
	char unread_marker;
	BYTE un[3];
};
struct _RAW_DATA_TYPES_STATE
{
	int data_type;
	WORD *raw_ptrs[4];
};
enum _UPSAMPLING_TYPE
{
	IJL_BOX_FILTER = 0x0,
	IJL_TRIANGLE_FILTER = 0x1,
};
struct _SAMPLING_STATE
{
	__int16 *top_row;
	__int16 *cur_row;
	__int16 *bottom_row;
	__int16 *last_row;
	int cur_row_number;
};
struct _JPEG_PROPERTIES
{
	_IJLIOTYPE iotype;
	_IJL_RECT roi;
	_DCTTYPE dcttype;
	_FAST_MCU_PROCESSING_TYPE fast_processing;
	int _interrupt;
	char* DIBBytes;
	int DIBWidth;
	int DIBHeight;
	int DIBPadBytes;
	int DIBChannels;
	_IJL_COLOR DIBColor;
	_IJL_JPGSUBSAMPLING DIBSubsampling;
	int DIBLineBytes;
	const char *JPGFile;
	char *JPGBytes;
	int JPGSizeBytes;
	int JPGWidth;
	int JPGHeight;
	int JPGChannels;
	_IJL_COLOR JPGColor;
	_IJL_JPGSUBSAMPLING JPGSubsampling;
	int JPGThumbWidth;
	int JPGThumbHeight;
	int cconversion_reqd;
	int upsampling_reqd;
	int jquality;
	int jinterleaveType;
	int numxMCUs;
	int numyMCUs;
	int nqtables;
	int maxquantindex;
	int nhuffActables;
	int nhuffDctables;
	int maxhuffindex;
	_QUANT_TABLE jFmtQuant[4];
	_HUFFMAN_TABLE jFmtAcHuffman[4];
	_HUFFMAN_TABLE jFmtDcHuffman[4];
	__int16 *jEncFmtQuant[4];
	_HUFFMAN_TABLE *jEncFmtAcHuffman[4];
	_HUFFMAN_TABLE *jEncFmtDcHuffman[4];
	int use_external_qtables;
	int use_external_htables;
	_JPEGQuantTable rawquanttables[4];
	_JPEGHuffTable rawhufftables[8];
	char HuffIdentifierAC[4];
	char HuffIdentifierDC[4];
	_FRAME jframe;
	int needframe;
	_SCAN *jscan;
	DWORD un1;
	_STATE state;
	int SawAdobeMarker;
	int AdobeXform;
	_ENTROPYSTRUCT *rowoffsets;
	char *MCUBuf;
	char tMCUBuf[1440];
	_PROCESSOR_TYPE processor_type;
	_RAW_DATA_TYPES_STATE *raw_coefs;
	int progressive_found;
	__int16 *coef_buffer;
	_UPSAMPLING_TYPE upsampling_type;
	_SAMPLING_STATE *sampling_state_ptr;
	WORD AdobeVersion;
	WORD AdobeFlags0;
	WORD AdobeFlags1;
	WORD uh2;
	int jfif_app0_detected;
	WORD jfif_app0_version;
	char jfif_app0_units;
	BYTE un3;
	WORD jfif_app0_Xdensity;
	WORD jfif_app0_Ydensity;
	char *jpeg_comment;
	WORD jpeg_comment_size;
	BYTE un4[6];
};
struct _JPEG_CORE_PROPERTIES
{
	int UseJPEGPROPERTIES;
	char* DIBBytes;
	int DIBWidth;
	int DIBHeight;
	int DIBPadBytes;
	int DIBChannels;
	_IJL_COLOR DIBColor;
	_IJL_JPGSUBSAMPLING DIBSubsampling;
	const char *JPGFile;
	char* JPGBytes;
	int JPGSizeBytes;
	int JPGWidth;
	int JPGHeight;
	int JPGChannels;
	_IJL_COLOR JPGColor;
	_IJL_JPGSUBSAMPLING JPGSubsampling;
	int JPGThumbWidth;
	int JPGThumbHeight;
	int cconversion_reqd;
	int upsampling_reqd;
	int jquality;
  _JPEG_PROPERTIES jprops;
};

//------------------------------------------------------------------------- GZIP
struct internal_state
{
	int dummy;
};
struct config_s
{
	unsigned __int16 good_length;
	unsigned __int16 max_lazy;
	unsigned __int16 nice_length;
	unsigned __int16 max_chain;
	int (__cdecl *func)(internal_state*, int);
};
struct z_stream_s
{
	char* next_in;
	DWORD avail_in;
	DWORD total_in;
	char* next_out;
	DWORD avail_out;
	DWORD total_out;
	char* msg;
	internal_state* state;
	void* (__cdecl *zalloc)(void* opaque, DWORD items, DWORD size);
	void* (__cdecl *zfree)(void* opaque, void* address);
	void* opaque;
	int data_type;
	DWORD adler;
	DWORD reserved;
};
struct code
{
	char op;
	char bits;
	WORD val;
};
struct gz_stream
{
	z_stream_s stream;
	int z_err;
	int z_eof;
	_iobuf* file;
	char* inbuf;
	char* outbuf;
	DWORD crc;
	char* msg;
	char* path;
	int transparent;
	int mode;
	int start;
	int in;
	int out;
	int back;
	int last;
};


struct cProfileNode
{
	const char* Name;
	int TotalCalls;
	float TotalTime;
	__int64 StartTime;
	int RecursionCounter;
	cProfileNode* Parent;
	cProfileNode* Child;
	cProfileNode* Sibling;
	cProfileNode* Next;
};


////////////////////////////////////////////////////////////////////////////

struct TinCat //0x5F58 =24408
{
	void* pFunc;
	BYTE _0[12];
	TinCatAPI* pTinCatAPI;
	HWND hDlg;
	WSADATA WSAData; //=400
	BYTE _11[4];
	SOCKET socket;
	BYTE _12[22384];
	HANDLE hMutex0;
	HANDLE hMutex1;
	HANDLE hMutex2[16];
	HANDLE hMutex3;
	BYTE _2[1516];
};

struct TinLobby //0x10 =16
{
	DWORD _1;
	DWORD _2;
	DWORD _3;
	DWORD _4;
};

struct TinCatLobby //0x50 =80
{
	void* pFunc;
	BYTE _0[40];
	DWORD port;
	BYTE _2[8];
	TinLobby* tlb;
	HANDLE hMutex;
	TinCatAPI* pTinCatAPI;
	BYTE _1[12];
};

struct cServTypeManager // 0x1702EC =1508076
{
	cObjectShared* m_types;
	BYTE _0[1507328];
	DWORD dwWeaponCount;
	sWeaponInfoShared* pWeaponPak;
	sHeroEntry_vector sCreature;
	sWeaponInfo_vector slot[35];
	BYTE _1[164];
	sSwitchItem_vvector vSwitchItem;
	BYTE _2[116];
	BST tree;
	BYTE _3[8];
};

struct Gameserver//0x3AA0 =15008
{
	BYTE _011;
	BYTE isGameName;
	BYTE isPortTCP;
	BYTE _013[2];
	BYTE bNetworkNoconfirmation;
	BYTE _012;
	BYTE isSysCommand;
	BYTE _021[8];
	DWORD dwProgress;
	DWORD _022;
	HWND hWnd;
	BYTE _2[4];
	HWND hDlgInitializing;
	HMENU hMenu;
	HWND hWndProgress;
	HFONT hFont;
	HINSTANCE hInstance;
	BOOL isInternetMode;
	DWORD portListen;
	DWORD portTCP;
	TinCat* tincat;
	BYTE _3[14182];
	sCalendarData cdata;
	BYTE _41[498];
	DWORD player_info;
	HANDLE hThread;
	HANDLE hEvent;
	BYTE _42[4];
	NOTIFYICONDATA nidat;//88
	DWORD number_of_players;
	BYTE _51[64];
	STR_W strGameName;
	STR_W strSacredGameserver;
	STR_W strPassword;
	STR_A strNetworkLobby;
	STR_W s5;
	STR_W s6;
};


#pragma pack(push, 8)
struct TDispatch;
struct IDispatchVtbl
{
	HRESULT (__stdcall *QueryInterface)(TDispatch *This, const IID *const riid, void **ppvObject);
	ULONG (__stdcall *AddRef)(TDispatch *This);
	ULONG (__stdcall *Release)(TDispatch *This);
	HRESULT (__stdcall *GetTypeInfoCount)(TDispatch *This, UINT *pctinfo);
	HRESULT (__stdcall *GetTypeInfo)(TDispatch *This, UINT iTInfo, LCID lcid, ITypeInfo **ppTInfo);
	HRESULT (__stdcall *GetIDsOfNames)(TDispatch *This, const IID *const riid, LPOLESTR *rgszNames, UINT cNames, LCID lcid, DISPID *rgDispId);
	HRESULT (__stdcall *Invoke)(TDispatch *This, DISPID dispIdMember, const IID *const riid, LCID lcid, WORD wFlags, DISPPARAMS *pDispParams, VARIANT *pVarResult, EXCEPINFO *pExcepInfo, UINT *puArgErr);
};
struct TDispatch
{
	IDispatchVtbl *lpVtbl;
};
#pragma pack(pop)

struct COleCmd
{
	TDispatch* m_pDisp;
	DWORD _0;
	tagVARIANT m_Variant;
};

struct sBalance
{
	DWORD horsePrices[9];
	WORD horseSkill[9];
};

struct SP_Fight
{
	DWORD res1x;
	DWORD ref;
	int TaPoX;
	int TaPoY;
	DWORD res4x;
	DWORD res5x;
	DWORD res6x;
	DWORD res7x;
	DWORD res8x;
	char Onceonly;
	char free9_2;
	char free9_3;
	char free9_4;
	char Taktik;
	char TakInfo1;
	char TakInfo2;
	char TakInfo3;
	DWORD res11x;
	DWORD res12x;
	DWORD res13x;
	char ReEnter;
	char ActionTrigger;
	char SpMove;
	char free15_4;
	float Mult;
};

struct SlotsForLevel
{
	WORD lvl;
	WORD slot;
};












////////////////////////////////////////////////////////////////////////////
#pragma pack()


/*
105 DIALOGEX 0, 0, 480, 403, 0
STYLE DS_SETFONT | DS_MODALFRAME | WS_POPUPWINDOW | WS_DLGFRAME
EXSTYLE = WS_EX_TOOLWINDOW
CAPTION "Attribute Editor"
FONT 8, "MS Sans Serif", 0, TRUE
{
 DEFPUSHBUTTON "OK", 1, 407, 365, 61, 14
 PUSHBUTTON "Cancel", 2, 408, 381, 61, 14
 LTEXT "Control name :", 1002, 19, 21, 46, 8
 LTEXT "Control type :", 1003, 19, 36, 42, 8
 EDITTEXT 1004, 67, 21, 195, 12, ES_READONLY
 EDITTEXT 1005, 67, 36, 195, 12, ES_READONLY
 GROUPBOX "Layout", 1006, 13, 10, 454, 77
 EDITTEXT 1007, 67, 55, 30, 12, ES_RIGHT | ES_AUTOHSCROLL | ES_NUMBER
 EDITTEXT 1008, 67, 70, 30, 12, ES_RIGHT | ES_AUTOHSCROLL | ES_NUMBER
 EDITTEXT 1009, 130, 55, 30, 12, ES_RIGHT | ES_AUTOHSCROLL | ES_NUMBER
 EDITTEXT 1010, 129, 70, 30, 12, ES_RIGHT | ES_AUTOHSCROLL | ES_NUMBER
 LTEXT "xpos :", 1011, 45, 55, 20, 8
 LTEXT "ypos :", 1012, 45, 69, 20, 8
 LTEXT "width :", 1013, 106, 55, 22, 8
 LTEXT "height :", 1014, 103, 70, 24, 8
 EDITTEXT 1015, 354, 21, 39, 12, ES_RIGHT | ES_AUTOHSCROLL | ES_READONLY | ES_NUMBER
 EDITTEXT 1016, 422, 21, 39, 12, ES_RIGHT | ES_READONLY | ES_NUMBER
 EDITTEXT 1017, 354, 36, 39, 12, ES_RIGHT | ES_AUTOHSCROLL | ES_READONLY | ES_NUMBER
 EDITTEXT 1018, 422, 36, 39, 12, ES_RIGHT | ES_READONLY | ES_NUMBER
 LTEXT "Tu1_1 :", 1020, 328, 23, 26, 8
 LTEXT "Tu1_2 :", 1021, 328, 38, 26, 8
 LTEXT "Tv1_1 :", 1022, 395, 23, 26, 8
 LTEXT "Tv1_2 :", 1023, 395, 38, 26, 8
 EDITTEXT 1019, 354, 54, 39, 12, ES_RIGHT | ES_AUTOHSCROLL | ES_READONLY | ES_NUMBER
 EDITTEXT 1024, 423, 54, 39, 12, ES_RIGHT | ES_READONLY | ES_NUMBER
 EDITTEXT 1025, 354, 70, 39, 12, ES_RIGHT | ES_AUTOHSCROLL | ES_READONLY | ES_NUMBER
 EDITTEXT 1026, 423, 70, 39, 12, ES_RIGHT | ES_READONLY | ES_NUMBER
 LTEXT "Tu2_1 :", 1027, 328, 56, 26, 8
 LTEXT "Tu2_2 :", 1028, 328, 71, 26, 8
 LTEXT "Tv2_1 :", 1029, 395, 56, 26, 8
 LTEXT "Tv2_2 :", 1030, 395, 71, 26, 8
 EDITTEXT 1031, 222, 55, 40, 12, ES_RIGHT | ES_UPPERCASE
 LTEXT "color :", 1032, 200, 56, 20, 8
 EDITTEXT 1038, 421, 100, 40, 12, ES_RIGHT | ES_AUTOHSCROLL | ES_NUMBER
 LTEXT "fade :", 1039, 353, 103, 19, 8
 GROUPBOX "Tooltips", -1, 325, 91, 142, 65
 EDITTEXT 1040, 421, 115, 40, 12, ES_RIGHT | ES_AUTOHSCROLL | ES_NUMBER
 LTEXT "delay :", 1041, 350, 117, 22, 8
 EDITTEXT 1042, 330, 137, 131, 12, ES_AUTOHSCROLL | WS_DISABLED
 LTEXT "Resource string :", 1043, 331, 127, 54, 8
 GROUPBOX "Flags", 1044, 14, 91, 248, 116
 AUTOCHECKBOX "VISIBLE", 1045, 21, 102, 43, 10
 AUTOCHECKBOX "RESERVE01", 1046, 21, 111, 58, 10
 AUTOCHECKBOX "ENABLED", 1047, 21, 120, 49, 10
 AUTOCHECKBOX "SHOWBORDER", 1048, 21, 129, 69, 10
 AUTOCHECKBOX "STATE01", 1049, 21, 138, 47, 10
 AUTOCHECKBOX "STATE02", 1050, 21, 147, 47, 10
 AUTOCHECKBOX "STATE_ANY", 1051, 21, 156, 58, 10
 AUTOCHECKBOX "RESERVE3", 1052, 21, 165, 54, 10
 AUTOCHECKBOX "WHEEL_FORCE", 1053, 21, 174, 70, 10
 AUTOCHECKBOX "GHOST", 1054, 21, 183, 41, 10
 AUTOCHECKBOX "HILIGHT", 1055, 21, 192, 45, 10
 AUTOCHECKBOX "BACKGROUND", 1056, 96, 102, 67, 10
 AUTOCHECKBOX "SELECTABLE", 1057, 96, 111, 61, 10
 AUTOCHECKBOX "CENTERED", 1058, 96, 120, 55, 10
 AUTOCHECKBOX "DDCOLOR", 1059, 96, 129, 51, 10
 AUTOCHECKBOX "HASFOCUS", 1060, 96, 138, 55, 10
 AUTOCHECKBOX "PASSWORD", 1061, 96, 147, 58, 10
 AUTOCHECKBOX "NOTICEME", 1062, 96, 156, 53, 10
 AUTOCHECKBOX "FONT_AL", 1063, 96, 165, 48, 10
 AUTOCHECKBOX "FONT_AR", 1064, 96, 174, 49, 10
 AUTOCHECKBOX "HELP1ST", 1065, 96, 192, 48, 10
 AUTOCHECKBOX "FONT_AC", 1066, 96, 183, 49, 10
 AUTOCHECKBOX "GLOW", 1067, 169, 102, 38, 10
 AUTOCHECKBOX "READONLY", 1068, 169, 111, 55, 10
 AUTOCHECKBOX "AUTOSCROLL", 1069, 169, 120, 64, 10
 AUTOCHECKBOX "NOSELECTION", 1070, 169, 129, 67, 10
 AUTOCHECKBOX "TOUPPER", 1071, 169, 138, 51, 10
 AUTOCHECKBOX "MOUSEHOVER", 1072, 169, 147, 67, 10
 AUTOCHECKBOX "MOUSEHOVER_R", 1073, 169, 156, 77, 10
 EDITTEXT 1076, 222, 69, 40, 12, ES_RIGHT | ES_UPPERCASE | ES_AUTOHSCROLL
 LTEXT "TextColor :", 1077, 185, 70, 35, 8
 LTEXT "Tex pushed :", -1, 211, 236, 42, 8
 LTEXT "Tex released :", -1, 20, 236, 46, 8
 LISTBOX 1087, 69, 233, 141, 38, LBS_NOINTEGRALHEIGHT | WS_VSCROLL | WS_TABSTOP
 LISTBOX 1088, 254, 234, 142, 38, LBS_NOINTEGRALHEIGHT | WS_VSCROLL | WS_TABSTOP
 LISTBOX 1089, 69, 284, 142, 20, LBS_NOINTEGRALHEIGHT | WS_VSCROLL | WS_TABSTOP
 LISTBOX 1091, 69, 306, 142, 20, LBS_NOINTEGRALHEIGHT | WS_VSCROLL | WS_TABSTOP
 GROUPBOX "Texturing", -1, 13, 224, 389, 113
 EDITTEXT 1035, 336, 162, 126, 12, ES_AUTOHSCROLL
 LTEXT "Resource String :", 1036, 278, 164, 56, 8
 EDITTEXT 1074, 336, 176, 28, 12, ES_RIGHT | ES_AUTOHSCROLL | ES_NUMBER
 LTEXT "Font ID :", 1075, 305, 177, 28, 8
 EDITTEXT 1080, 336, 191, 48, 12, ES_RIGHT | ES_UPPERCASE | ES_AUTOHSCROLL
 LTEXT "Base Color :", -1, 294, 192, 39, 8
 EDITTEXT 1081, 336, 205, 48, 12, ES_RIGHT | ES_UPPERCASE | ES_AUTOHSCROLL
 LTEXT "Highlight Color :", -1, 283, 206, 50, 8
 EDITTEXT 1082, 421, 191, 40, 12, ES_RIGHT | ES_AUTOHSCROLL
 LTEXT "Intensity :", -1, 387, 192, 31, 8
 LISTBOX 1094, 253, 284, 142, 20, LBS_NOINTEGRALHEIGHT | WS_VSCROLL | WS_TABSTOP
 LISTBOX 1095, 253, 306, 142, 20, LBS_NOINTEGRALHEIGHT | WS_VSCROLL | WS_TABSTOP
 LTEXT "border left released :", -1, 27, 285, 36, 19
 LTEXT "border right released :", -1, 27, 305, 36, 19
 LTEXT "border left pushed :", -1, 215, 284, 36, 19
 LTEXT "border right pushed :", -1, 215, 306, 36, 19
 PUSHBUTTON "Frame Settings...", 1090, 13, 343, 75, 17
}

106 DIALOGEX 0, 0, 543, 369, 0
STYLE DS_SETFONT | DS_MODALFRAME | WS_POPUPWINDOW | WS_DLGFRAME
EXSTYLE = WS_EX_TOOLWINDOW
CAPTION "Frame Texture Settings"
FONT 8, "MS Sans Serif", 0, TRUE
{
 DEFPUSHBUTTON "OK", 1, 486, 333, 50, 14
 PUSHBUTTON "Cancel", 2, 486, 348, 50, 14
 LISTBOX 1092, 39, 58, 97, 57, LBS_NOINTEGRALHEIGHT | WS_VSCROLL | WS_TABSTOP
 LISTBOX 1093, 407, 254, 96, 57, LBS_NOINTEGRALHEIGHT | WS_VSCROLL | WS_TABSTOP
 LISTBOX 1095, 39, 118, 97, 135, LBS_NOINTEGRALHEIGHT | WS_VSCROLL | WS_TABSTOP
 LISTBOX 1097, 139, 58, 265, 57, LBS_NOINTEGRALHEIGHT | WS_VSCROLL | WS_TABSTOP
 LISTBOX 1098, 139, 254, 265, 57, LBS_NOINTEGRALHEIGHT | WS_VSCROLL | WS_TABSTOP
 LISTBOX 1099, 39, 254, 97, 57, LBS_NOINTEGRALHEIGHT | WS_VSCROLL | WS_TABSTOP
 LISTBOX 1100, 407, 58, 96, 57, LBS_NOINTEGRALHEIGHT | WS_VSCROLL | WS_TABSTOP
 LISTBOX 1101, 407, 117, 97, 135, LBS_NOINTEGRALHEIGHT | WS_VSCROLL | WS_TABSTOP
 LTEXT "Frame texturing", -1, 247, 180, 49, 8
}




*/



























